(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[   2520323,      60724]
NotebookOptionsPosition[   2391224,      58186]
NotebookOutlinePosition[   2435342,      59069]
CellTagsIndexPosition[   2435299,      59066]
WindowTitle->TestSuite.nb
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Frontmatter", "Section",
 CellChangeTimes->{{3.748201937644354*^9, 3.748201945789996*^9}},
 CellID->139676244,ExpressionUUID->"2ece5787-1c98-49c3-af72-87ee1160e5aa"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"<<", "StateMint`"}]}], "Input",
 CellChangeTimes->{{3.747498882598418*^9, 3.747498913474389*^9}, 
   3.747498970385573*^9, {3.747499000484343*^9, 3.747499002756703*^9}, {
   3.7520747501000032`*^9, 3.752074750495648*^9}, {3.753199136751329*^9, 
   3.753199137830591*^9}},
 CellID->1608041939,ExpressionUUID->"f78a615a-c66e-44a7-95e5-c627ef3bf2e8"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test System 1", "Section",
 CellChangeTimes->{{3.7481692698005457`*^9, 3.748169273381559*^9}, 
   3.7481693114624357`*^9, {3.748169361271824*^9, 3.748169361361087*^9}},
 CellID->1552110904,ExpressionUUID->"3e7deeaf-d666-4f63-8d99-e2a377827b67"],

Cell[CellGroupData[{

Cell["System model", "Subsection",
 CellChangeTimes->{{3.751243736232489*^9, 3.751243737956749*^9}},
 CellID->1170065825,ExpressionUUID->"ab42a3d8-0eca-47ba-ba7b-e42ff20da355"],

Cell["Garbini\[CloseCurlyQuote]s Test Suite Quarter Car Model", "Text",
 CellChangeTimes->{{3.748169314267838*^9, 3.748169333731399*^9}, {
  3.748169368971754*^9, 3.748169377466568*^9}},
 CellID->1280424743,ExpressionUUID->"a1a98d7d-9680-48c7-8c80-a9704c85d82f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"vS", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primaryVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vMB", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"vMW", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"fKS", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"fKT", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"fBS", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"fBT", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outExps", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vMB", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"vMW", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"fKS", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"fKT", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"fBS", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"fBT", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"elementalEqs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"vMB", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"fMB", "[", "t", "]"}], "/", "MB"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"vMW", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"fMW", "[", "t", "]"}], "/", "MW"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"fKS", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{"KS", " ", 
       RowBox[{"vKS", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"fKT", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{"KT", " ", 
       RowBox[{"vKT", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"fBS", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"BS", " ", 
       RowBox[{"vBS", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"fBT", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"BT", " ", 
       RowBox[{"vBT", "[", "t", "]"}]}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"constraintEqs", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"fMB", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"fKS", "[", "t", "]"}], "+", 
       RowBox[{"fBS", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"fMW", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"fKT", "[", "t", "]"}], "+", 
       RowBox[{"fBT", "[", "t", "]"}], "-", 
       RowBox[{"fKS", "[", "t", "]"}], "-", 
       RowBox[{"fBS", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vKS", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vMW", "[", "t", "]"}], "-", 
       RowBox[{"vMB", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vKT", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vS", "[", "t", "]"}], "-", 
       RowBox[{"vMW", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vBS", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vMW", "[", "t", "]"}], "-", 
       RowBox[{"vMB", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vBT", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vS", "[", "t", "]"}], "-", 
       RowBox[{"vMW", "[", "t", "]"}]}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.701879330284309*^9, 3.701879660950363*^9}, {
   3.701880285301148*^9, 3.7018803030252666`*^9}, {3.701880400142194*^9, 
   3.701880421252101*^9}, {3.701881015135788*^9, 3.701881024466584*^9}, {
   3.7018810571925173`*^9, 3.701881064665015*^9}, 3.701881128549124*^9, {
   3.7018814064848127`*^9, 3.701881406610351*^9}, {3.7018818955750027`*^9, 
   3.701881895973692*^9}, {3.701882041604972*^9, 3.701882043898466*^9}, {
   3.701890951609749*^9, 3.701891036596726*^9}, {3.701891110013006*^9, 
   3.7018911421065598`*^9}, 3.701891254664562*^9, {3.701912692557547*^9, 
   3.701912692913946*^9}, {3.701913999527768*^9, 3.701914002907909*^9}, {
   3.701920784327176*^9, 3.701920816820257*^9}, {3.701920864317401*^9, 
   3.701920893297846*^9}, {3.701921572449317*^9, 3.7019215739835567`*^9}, {
   3.7019226039015083`*^9, 3.7019226531531467`*^9}, {3.70192315382204*^9, 
   3.701923156891535*^9}, 3.701923613698826*^9, {3.701923800106831*^9, 
   3.7019238302912283`*^9}, 3.7027575143672447`*^9, {3.7031742778388443`*^9, 
   3.703174285565423*^9}, {3.703174458866447*^9, 3.703174460064361*^9}, {
   3.703180809918516*^9, 3.7031808280531054`*^9}, {3.703180858262231*^9, 
   3.703180913922073*^9}, 3.7031826517552*^9, {3.7031826975271263`*^9, 
   3.70318270752733*^9}, {3.703183940887985*^9, 3.7031839503266783`*^9}, {
   3.7031884872933693`*^9, 3.703188573098453*^9}, {3.7031886146086063`*^9, 
   3.7031886158777733`*^9}, 3.703193196973493*^9, {3.703193285995222*^9, 
   3.703193287971056*^9}, {3.703193325700066*^9, 3.703193379598803*^9}, 
   3.703193688573254*^9, 3.7031938570476313`*^9, {3.703193952781344*^9, 
   3.703193953018237*^9}, {3.7031941583007307`*^9, 3.703194158707346*^9}, {
   3.703196384489192*^9, 3.703196388542574*^9}, 3.7031964455264177`*^9, {
   3.703196834182725*^9, 3.7031968464458933`*^9}, 3.703201465712611*^9, 
   3.703201526222664*^9, {3.703201603886011*^9, 3.7032016821817427`*^9}, {
   3.7032020550576687`*^9, 3.7032020896178093`*^9}, {3.70321266914992*^9, 
   3.703212707867943*^9}, 3.703213699014924*^9, {3.727580673942416*^9, 
   3.727580802457814*^9}, {3.72758087228631*^9, 3.72758166120536*^9}, {
   3.727581754157309*^9, 3.7275817642595587`*^9}, 3.727582035769696*^9, {
   3.750351911198407*^9, 3.750351934658189*^9}, {3.750351970738987*^9, 
   3.750352134911746*^9}, {3.750352301114173*^9, 3.75035230368528*^9}, 
   3.75112430604972*^9, {3.751157268784148*^9, 3.7511572981095533`*^9}, 
   3.7512408705444117`*^9, {3.751240983504064*^9, 3.751241009900724*^9}, {
   3.751241068909904*^9, 3.751241210779131*^9}, {3.751241248522109*^9, 
   3.751241254532956*^9}, 3.751245193330091*^9, {3.751757947661084*^9, 
   3.751758009443482*^9}},
 CellLabel->"In[34]:=",
 CellID->1771228406,ExpressionUUID->"c3626026-dd9f-47af-b7c7-c0fcd9ba93ee"],

Cell["Find state equation.", "Text",
 CellChangeTimes->{{3.702757751780126*^9, 3.7027577578425713`*^9}, {
  3.702757790122506*^9, 3.7027577915609007`*^9}, {3.727581684624194*^9, 
  3.727581686707095*^9}},
 CellID->617504928,ExpressionUUID->"88ae39df-ffe2-472e-839f-70e2f27858b8"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stateSolution", "=", 
   RowBox[{
    RowBox[{"stateEquations", "[", 
     RowBox[{
     "inVars", ",", "primaryVars", ",", "elementalEqs", ",", 
      "constraintEqs"}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateVars", " ", "=", " ", 
   RowBox[{"\"\<state variables\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateEqList", " ", "=", " ", 
   RowBox[{"\"\<RHS\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\"\<state equations\>\"", "/.", "stateSolution"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.7018797195836763`*^9, 3.7018797204767036`*^9}, {
   3.701879810803969*^9, 3.701879844544981*^9}, {3.7018942050184517`*^9, 
   3.701894566874161*^9}, 3.701898020551093*^9, {3.701903282327601*^9, 
   3.701903283500523*^9}, {3.701911200698804*^9, 3.701911202601316*^9}, {
   3.701915682054678*^9, 3.701915720675168*^9}, {3.701915759772274*^9, 
   3.7019157927706213`*^9}, {3.701915923602686*^9, 3.701915923900078*^9}, 
   3.7019209193048553`*^9, 3.701920950145496*^9, {3.701921306764739*^9, 
   3.701921308673313*^9}, {3.701921408184596*^9, 3.7019214156809187`*^9}, 
   3.7019220747800493`*^9, {3.701922189786292*^9, 3.701922218088579*^9}, {
   3.701922248592429*^9, 3.701922251876824*^9}, 3.701922322852202*^9, {
   3.701922383801173*^9, 3.7019224315654707`*^9}, {3.701922463501308*^9, 
   3.7019224895050097`*^9}, 3.7019225472984467`*^9, {3.701922594846767*^9, 
   3.701922598092758*^9}, {3.701922662563005*^9, 3.701922735877761*^9}, {
   3.7019231046383343`*^9, 3.701923105684675*^9}, {3.7019639715923243`*^9, 
   3.7019639718841667`*^9}, {3.7019642654040737`*^9, 3.701964352167139*^9}, {
   3.701964387110903*^9, 3.7019644147887087`*^9}, {3.702757419429731*^9, 
   3.7027575039883213`*^9}, {3.7511302149210863`*^9, 3.751130222225973*^9}, 
   3.751131245052647*^9, {3.751758020590618*^9, 3.7517580314940643`*^9}, {
   3.751758096034569*^9, 3.751758150178234*^9}, {3.751858834585458*^9, 
   3.751858867892303*^9}, {3.7518589221835537`*^9, 3.7518590012649117`*^9}, {
   3.751859049763453*^9, 3.75185909971*^9}, {3.7518592622618513`*^9, 
   3.75185926422972*^9}, {3.751859306929682*^9, 3.751859367871738*^9}, {
   3.7518594346930857`*^9, 3.751859464138123*^9}, {3.751859792301899*^9, 
   3.7518598121041403`*^9}, {3.7518598489196587`*^9, 3.751859923477129*^9}, 
   3.75186099185213*^9, 3.751937475686306*^9},
 CellID->1449591737,ExpressionUUID->"cf668524-82aa-4f2b-b67c-ed90114e332d"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["vMB", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       FractionBox[
        RowBox[{"fKS", "[", "t", "]"}], "MB"], "-", 
       FractionBox[
        RowBox[{"BS", " ", 
         RowBox[{"vMB", "[", "t", "]"}]}], "MB"], "+", 
       FractionBox[
        RowBox[{"BS", " ", 
         RowBox[{"vMW", "[", "t", "]"}]}], "MB"]}]}]},
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["vMW", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"fKS", "[", "t", "]"}], "MW"]}], "+", 
       FractionBox[
        RowBox[{"fKT", "[", "t", "]"}], "MW"], "+", 
       FractionBox[
        RowBox[{"BS", " ", 
         RowBox[{"vMB", "[", "t", "]"}]}], "MW"], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "BS"}], "-", "BT"}], ")"}], " ", 
         RowBox[{"vMW", "[", "t", "]"}]}], "MW"], "+", 
       FractionBox[
        RowBox[{"BT", " ", 
         RowBox[{"vS", "[", "t", "]"}]}], "MW"]}]}]},
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["fKS", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "KS"}], " ", 
        RowBox[{"vMB", "[", "t", "]"}]}], "+", 
       RowBox[{"KS", " ", 
        RowBox[{"vMW", "[", "t", "]"}]}]}]}]},
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["fKT", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "KT"}], " ", 
        RowBox[{"vMW", "[", "t", "]"}]}], "+", 
       RowBox[{"KT", " ", 
        RowBox[{"vS", "[", "t", "]"}]}]}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.7518593365167*^9, 3.751859368149544*^9}, 
   3.751859469567102*^9, 3.751859641381487*^9, 3.751859929862179*^9, 
   3.751859981942204*^9, {3.751861010775159*^9, 3.75186103657938*^9}},
 CellLabel->"Out[42]//TableForm=",
 CellID->593268746,ExpressionUUID->"9ad236ca-e22f-428e-b9b0-4e5655510741"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"outEqList", "=", 
   RowBox[{"outEquations", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outExps", ",", 
     RowBox[{"elementalEqs", "~", "Join", "~", "constraintEqs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outEqList", "//", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"y", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "outExps", "]"}]}], "}"}]}], "]"}], 
      "\[Equal]", "#"}], "]"}], "&"}]}], "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.75115407229806*^9, 3.7511540907068577`*^9}, {
   3.7511541283727303`*^9, 3.751154145140655*^9}, {3.751154185947949*^9, 
   3.751154186454541*^9}, {3.75115440553708*^9, 3.751154408241644*^9}, {
   3.751157061478198*^9, 3.75115706228808*^9}, {3.751157258647379*^9, 
   3.751157263470278*^9}, {3.751157318329653*^9, 3.751157382599204*^9}, 
   3.751243546881419*^9, 3.7512446518094807`*^9, {3.751758233817813*^9, 
   3.75175824703872*^9}},
 CellLabel->"In[43]:=",
 CellID->168493274,ExpressionUUID->"bf698411-8407-4880-ab17-4536821e0f9f"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{"y", "[", "1", "]"}], "\[Equal]", 
       RowBox[{"vMB", "[", "t", "]"}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "2", "]"}], "\[Equal]", 
       RowBox[{"vMW", "[", "t", "]"}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "3", "]"}], "\[Equal]", 
       RowBox[{"fKS", "[", "t", "]"}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "4", "]"}], "\[Equal]", 
       RowBox[{"fKT", "[", "t", "]"}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "5", "]"}], "\[Equal]", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "BS"}], " ", 
         RowBox[{"vMB", "[", "t", "]"}]}], "+", 
        RowBox[{"BS", " ", 
         RowBox[{"vMW", "[", "t", "]"}]}]}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "6", "]"}], "\[Equal]", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "BT"}], " ", 
         RowBox[{"vMW", "[", "t", "]"}]}], "+", 
        RowBox[{"BT", " ", 
         RowBox[{"vS", "[", "t", "]"}]}]}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751154146341402*^9, {3.7511541874520807`*^9, 3.75115421035389*^9}, 
   3.751154409289606*^9, 3.751155063159431*^9, 3.7511551578703537`*^9, {
   3.751155631171876*^9, 3.7511556669733973`*^9}, 3.751156831153225*^9, {
   3.7511570444961233`*^9, 3.751157063011318*^9}, 3.7511573845757217`*^9, 
   3.7511576929574337`*^9, 3.751237248545403*^9, 3.75123731846103*^9, 
   3.751237558009218*^9, 3.75124126512782*^9, 3.751241341691312*^9, 
   3.7512414602930183`*^9, {3.7512415890389347`*^9, 3.751241614550478*^9}, 
   3.751243391757332*^9, {3.751243525864511*^9, 3.7512435473077707`*^9}, 
   3.7512436090180597`*^9, 3.751243754645124*^9, 3.751243860169832*^9, 
   3.751244182055914*^9, 3.751244399162704*^9, 3.751244486514542*^9, 
   3.751244523619996*^9, 3.7512445593242817`*^9, {3.751244640162719*^9, 
   3.7512446526642714`*^9}, 3.7512450693463917`*^9, 3.751245129916429*^9, 
   3.751245199944006*^9, 3.7517581589332533`*^9, 3.751758247484844*^9, 
   3.7518117541350803`*^9, 3.7518120056910477`*^9, {3.7518120796408854`*^9, 
   3.751812087500362*^9}, {3.751812187588044*^9, 3.751812209829607*^9}, 
   3.751824464419462*^9, 3.751827255574244*^9, 3.751859641437621*^9, 
   3.7518599517115088`*^9, 3.751859982075001*^9, {3.751861010824903*^9, 
   3.75186103667798*^9}},
 CellLabel->"Out[44]//TableForm=",
 CellID->301241001,ExpressionUUID->"41ae329b-e6b3-448e-9341-e3234ada850d"]
}, Open  ]],

Cell["\<\
Linearize the state and output equations about operating point.\
\>", "Text",
 CellChangeTimes->{{3.7027577023090067`*^9, 3.7027577064193897`*^9}, {
  3.702757795179463*^9, 3.702757797848589*^9}, {3.702758517676444*^9, 
  3.702758517969734*^9}, {3.751157404122614*^9, 3.751157407793623*^9}},
 CellID->1243308122,ExpressionUUID->"308ac7ac-eafd-400f-8076-c53ae2252dfd"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"abe", "=", 
   RowBox[{"linearizeState", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "stateEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdf", "=", 
   RowBox[{"linearizeOutput", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"e", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"d", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"f", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<A = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<B = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<E = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<C = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<D = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<F = \>\"", ",", "#"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.7027439116175957`*^9, 3.702744033267743*^9}, {
   3.702744268313121*^9, 3.702744305447536*^9}, {3.702756777004896*^9, 
   3.70275678344866*^9}, {3.702756831990849*^9, 3.702756860110464*^9}, {
   3.702757530029274*^9, 3.702757693348208*^9}, {3.70275831097122*^9, 
   3.702758346655436*^9}, {3.702758404323063*^9, 3.7027584657658863`*^9}, {
   3.702759733356806*^9, 3.702760026609954*^9}, {3.70276007934348*^9, 
   3.702760085749899*^9}, {3.702760162502097*^9, 3.7027602713332367`*^9}, {
   3.7031743380777597`*^9, 3.703174365043808*^9}, {3.7032126025366993`*^9, 
   3.703212608677622*^9}, {3.7275822132423773`*^9, 3.727582355849462*^9}, 
   3.751154035567876*^9, {3.751157216290072*^9, 3.751157229742868*^9}, {
   3.751157416529111*^9, 3.751157421062249*^9}, {3.7511576066364393`*^9, 
   3.751157656881137*^9}, {3.7511577043529177`*^9, 3.7511577145152082`*^9}, {
   3.7512372971265383`*^9, 3.7512373336944847`*^9}, {3.751237381927462*^9, 
   3.751237410777441*^9}},
 CellLabel->"In[45]:=",
 CellID->1263721144,ExpressionUUID->"07833039-69c6-4257-b744-75db67945d48"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox["BS", "MB"]}], 
        FractionBox["BS", "MB"], 
        FractionBox["1", "MB"], "0"},
       {
        FractionBox["BS", "MW"], 
        FractionBox[
         RowBox[{
          RowBox[{"-", "BS"}], "-", "BT"}], "MW"], 
        RowBox[{"-", 
         FractionBox["1", "MW"]}], 
        FractionBox["1", "MW"]},
       {
        RowBox[{"-", "KS"}], "KS", "0", "0"},
       {"0", 
        RowBox[{"-", "KT"}], "0", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["A = ", 
   MatrixForm[{{-$CellContext`BS/$CellContext`MB, \
$CellContext`BS/$CellContext`MB, $CellContext`MB^(-1), 
      0}, {$CellContext`BS/$CellContext`MW, (-$CellContext`BS - \
$CellContext`BT)/$CellContext`MW, (-1)/$CellContext`MW, \
$CellContext`MW^(-1)}, {-$CellContext`KS, $CellContext`KS, 0, 0}, {
     0, -$CellContext`KT, 0, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751758253230949*^9, 3.751811754203699*^9, 3.751812005763603*^9, {
   3.751812079703279*^9, 3.751812087609988*^9}, {3.751812187660625*^9, 
   3.751812209901985*^9}, 3.751824464483783*^9, 3.751827255619883*^9, 
   3.7518596414861507`*^9, 3.751859982209362*^9, {3.751861010877256*^9, 
   3.7518610367788982`*^9}},
 CellLabel->"During evaluation of In[45]:=",
 CellID->1338547828,ExpressionUUID->"e07ccda9-d76e-4eed-82fe-2a934d421bae"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"B = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {
        FractionBox["BT", "MW"]},
       {"0"},
       {"KT"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["B = ", 
   MatrixForm[{{0}, {$CellContext`BT/$CellContext`MW}, {
     0}, {$CellContext`KT}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751758253230949*^9, 3.751811754203699*^9, 3.751812005763603*^9, {
   3.751812079703279*^9, 3.751812087609988*^9}, {3.751812187660625*^9, 
   3.751812209901985*^9}, 3.751824464483783*^9, 3.751827255619883*^9, 
   3.7518596414861507`*^9, 3.751859982209362*^9, {3.751861010877256*^9, 
   3.751861036792861*^9}},
 CellLabel->"During evaluation of In[45]:=",
 CellID->2082142871,ExpressionUUID->"500da608-f9b6-4b3a-8db0-196acf5d9b59"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"E = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"},
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["E = ", 
   MatrixForm[{{0}, {0}, {0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751758253230949*^9, 3.751811754203699*^9, 3.751812005763603*^9, {
   3.751812079703279*^9, 3.751812087609988*^9}, {3.751812187660625*^9, 
   3.751812209901985*^9}, 3.751824464483783*^9, 3.751827255619883*^9, 
   3.7518596414861507`*^9, 3.751859982209362*^9, {3.751861010877256*^9, 
   3.7518610368028316`*^9}},
 CellLabel->"During evaluation of In[45]:=",
 CellID->1329205032,ExpressionUUID->"1f68596b-8e0d-4867-a65b-9c89ae1cd9ef"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0", "0", "0"},
       {"0", "1", "0", "0"},
       {"0", "0", "1", "0"},
       {"0", "0", "0", "1"},
       {
        RowBox[{"-", "BS"}], "BS", "0", "0"},
       {"0", 
        RowBox[{"-", "BT"}], "0", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 
     1}, {-$CellContext`BS, $CellContext`BS, 0, 0}, {
     0, -$CellContext`BT, 0, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751758253230949*^9, 3.751811754203699*^9, 3.751812005763603*^9, {
   3.751812079703279*^9, 3.751812087609988*^9}, {3.751812187660625*^9, 
   3.751812209901985*^9}, 3.751824464483783*^9, 3.751827255619883*^9, 
   3.7518596414861507`*^9, 3.751859982209362*^9, {3.751861010877256*^9, 
   3.751861036808145*^9}},
 CellLabel->"During evaluation of In[45]:=",
 CellID->1824076730,ExpressionUUID->"a6b5114d-e883-429f-b2e5-947997ec7633"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"},
       {"0"},
       {"0"},
       {"0"},
       {"BT"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{0}, {0}, {0}, {0}, {0}, {$CellContext`BT}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751758253230949*^9, 3.751811754203699*^9, 3.751812005763603*^9, {
   3.751812079703279*^9, 3.751812087609988*^9}, {3.751812187660625*^9, 
   3.751812209901985*^9}, 3.751824464483783*^9, 3.751827255619883*^9, 
   3.7518596414861507`*^9, 3.751859982209362*^9, {3.751861010877256*^9, 
   3.751861036813397*^9}},
 CellLabel->"During evaluation of In[45]:=",
 CellID->1928540185,ExpressionUUID->"bc36a636-cc1b-4614-9d83-5191922bbd6e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"},
       {"0"},
       {"0"},
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0}, {0}, {0}, {0}, {0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751758253230949*^9, 3.751811754203699*^9, 3.751812005763603*^9, {
   3.751812079703279*^9, 3.751812087609988*^9}, {3.751812187660625*^9, 
   3.751812209901985*^9}, 3.751824464483783*^9, 3.751827255619883*^9, 
   3.7518596414861507`*^9, 3.751859982209362*^9, {3.751861010877256*^9, 
   3.751861036818869*^9}},
 CellLabel->"During evaluation of In[45]:=",
 CellID->1004205124,ExpressionUUID->"ac0b80a7-5f9d-449a-8b00-f205aca39995"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.7517583923296127`*^9, 3.751758394904726*^9}},
 CellLabel->"In[55]:=",
 CellID->885220549,ExpressionUUID->"f4563a53-ce0d-41ff-b56e-d09e365eaffa"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"-", 
       FractionBox["BS", "MB"]}], 
      FractionBox["BS", "MB"], 
      FractionBox["1", "MB"], "0"},
     {
      FractionBox["BS", "MW"], 
      FractionBox[
       RowBox[{
        RowBox[{"-", "BS"}], "-", "BT"}], "MW"], 
      RowBox[{"-", 
       FractionBox["1", "MW"]}], 
      FractionBox["1", "MW"]},
     {
      RowBox[{"-", "KS"}], "KS", "0", "0"},
     {"0", 
      RowBox[{"-", "KT"}], "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.7517583952684383`*^9, 3.751811754378551*^9, 3.7518120058775473`*^9, {
   3.751812079830145*^9, 3.751812087724695*^9}, {3.75181218779867*^9, 
   3.751812210005847*^9}, 3.75182446464423*^9, 3.7518272557357903`*^9, 
   3.751859641603692*^9, 3.751859982392057*^9, {3.751861010978807*^9, 
   3.751861036927244*^9}},
 CellLabel->"Out[55]//MatrixForm=",
 CellID->601537295,ExpressionUUID->"2aac9252-9ced-4588-a9e2-e6eddfaa79f4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["stateVars"], "Input",
 CellChangeTimes->{{3.751758419595049*^9, 3.751758421444378*^9}},
 CellLabel->"In[56]:=",
 CellID->1340322197,ExpressionUUID->"6c4cc0a0-3948-4400-9d6a-fc8c4a83993c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"vMB", "[", "t", "]"}], ",", 
   RowBox[{"vMW", "[", "t", "]"}], ",", 
   RowBox[{"fKS", "[", "t", "]"}], ",", 
   RowBox[{"fKT", "[", "t", "]"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.751758421865048*^9, 3.751811754448344*^9, 3.751812005927927*^9, {
   3.7518120798955593`*^9, 3.751812087795699*^9}, {3.751812187854177*^9, 
   3.751812210055953*^9}, 3.751824464716688*^9, 3.751827255785193*^9, 
   3.7518596416538277`*^9, 3.751859982626667*^9, {3.75186101102254*^9, 
   3.751861037078452*^9}},
 CellLabel->"Out[56]=",
 CellID->1831790636,ExpressionUUID->"6af53751-7b5b-482d-9928-a76f2bb6a06f"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.751243705713728*^9, 3.751243706940173*^9}, {
  3.7512447617278233`*^9, 3.751244762830553*^9}},
 CellID->1980104077,ExpressionUUID->"54f286a2-a4b5-4e3c-8c06-1a069bdc43d2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.747505552707037*^9, {3.7475057578295593`*^9, 3.747505759222794*^9}, {
   3.747505842150148*^9, 3.7475058458319883`*^9}, {3.747505896191999*^9, 
   3.74750589728131*^9}, {3.748124150238531*^9, 3.748124150517943*^9}, 
   3.748169029221862*^9, 3.748173192659827*^9, {3.75175836051581*^9, 
   3.751758367755122*^9}},
 CellLabel->"In[57]:=",
 CellID->2042467455,ExpressionUUID->"0791b85e-5b13-4e41-a244-5d387dbe4800"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "BS"}], "/", "MB"}], ",", 
      RowBox[{"BS", "/", "MB"}], ",", 
      RowBox[{"1", "/", "MB"}], ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"BS", "/", "MW"}], ",", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{"BS", "+", "BT"}], ")"}]}], "/", "MW"}], ",", 
      RowBox[{
       RowBox[{"-", "1"}], "/", "MW"}], ",", 
      RowBox[{"1", "/", "MW"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "KS"}], ",", "KS", ",", "0", ",", "0"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{"-", "KT"}], ",", "0", ",", "0"}], "}"}]}], "}"}], 
  "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.747505555643032*^9, 3.7475055867312613`*^9}, {
   3.747505761476728*^9, 3.747505764318122*^9}, {3.747505847665118*^9, 
   3.7475058502692757`*^9}, {3.747505898843794*^9, 3.74750590124069*^9}, {
   3.7475063255823507`*^9, 3.747506334276267*^9}, {3.7481241530496283`*^9, 
   3.748124156712919*^9}, 3.7481690353265944`*^9, {3.748169641556839*^9, 
   3.748169730141844*^9}, {3.748173340029819*^9, 3.748173370731758*^9}, {
   3.748173564952298*^9, 3.748173577245845*^9}},
 CellID->29485513,ExpressionUUID->"4affd5b9-6103-4508-9a70-400b86f18119"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"BS\\\", \
\\\"MB\\\"]}], \\\",\\\", FractionBox[\\\"BS\\\", \\\"MB\\\"], \\\",\\\", \
FractionBox[\\\"1\\\", \\\"MB\\\"], \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \
\\\",\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \\\"2\\\", \\\"\[RightSkeleton]\\\
\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
RowBox[{\\\"\[LeftSkeleton]\\\", \\\"2\\\", \\\"\[RightSkeleton]\\\"}], \\\",\
\\\", \\\"0\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"BS\", \"MB\"]}], \",\", FractionBox[\"BS\
\", \"MB\"], \",\", FractionBox[\"1\", \"MB\"], \",\", \"0\"}], \"}\"}], \
\",\", RowBox[{\"\[LeftSkeleton]\", \"2\", \"\[RightSkeleton]\"}], \",\", \
RowBox[{\"{\", RowBox[{\"0\", \",\", RowBox[{\"\[LeftSkeleton]\", \"2\", \"\
\[RightSkeleton]\"}], \",\", \"0\"}], \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"BS\\\", \
\\\"MB\\\"]}], \\\",\\\", FractionBox[\\\"BS\\\", \\\"MB\\\"], \\\",\\\", \
FractionBox[\\\"1\\\", \\\"MB\\\"], \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \
\\\",\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \\\"2\\\", \\\"\[RightSkeleton]\\\
\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
RowBox[{\\\"\[LeftSkeleton]\\\", \\\"2\\\", \\\"\[RightSkeleton]\\\"}], \\\",\
\\\", \\\"0\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"BS\", \"MB\"]}], \",\", FractionBox[\"BS\
\", \"MB\"], \",\", FractionBox[\"1\", \"MB\"], \",\", \"0\"}], \"}\"}], \
\",\", RowBox[{\"\[LeftSkeleton]\", \"2\", \"\[RightSkeleton]\"}], \",\", \
RowBox[{\"{\", RowBox[{\"0\", \",\", RowBox[{\"\[LeftSkeleton]\", \"2\", \"\
\[RightSkeleton]\"}], \",\", \"0\"}], \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001879999999996329`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001879999999996329`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->579655860,ExpressionUUID->"5747743e-6260-40c3-9561-ca770ddd6e0c"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1290216228,ExpressionUUID->"6c59a323-9046-4b5b-a47d-76c6f2843200"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169118881194*^9, 3.7481731967687407`*^9},
 CellLabel->"In[58]:=",
 CellID->83003778,ExpressionUUID->"5a7bc859-6632-4268-8f95-3251c181c44d"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"BT", "/", "MW"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "KT", "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169152633688*^9, 3.748169166417688*^9}, 
   3.74816961437001*^9, {3.748169735895432*^9, 3.74816976416591*^9}, {
   3.7481733599114637`*^9, 3.748173365547867*^9}, {3.7481735845528507`*^9, 
   3.748173591621296*^9}},
 CellID->170346871,ExpressionUUID->"d112b320-c557-4649-966e-d0ac77b917bd"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", FractionBox[\\\"BT\\\", \\\"MW\\\"], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
\\\"KT\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", FractionBox[\"BT\", \"MW\"], \"}\"}], \",\", \
RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"KT\", \"}\"}]}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", FractionBox[\\\"BT\\\", \\\"MW\\\"], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
\\\"KT\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", FractionBox[\"BT\", \"MW\"], \"}\"}], \",\", \
RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"KT\", \"}\"}]}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00016700000000025028`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00016700000000025028`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1521760237,ExpressionUUID->"f2f55624-aa92-43e9-b4d0-4e026009fa16"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1841551136,ExpressionUUID->"acb236a0-ae70-4f56-a46e-d436e3518efc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169171923123*^9, 3.748173198517178*^9},
 CellLabel->"In[59]:=",
 CellID->1287863259,ExpressionUUID->"da2312ec-723d-46a2-a7d2-9f611bb142dc"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "BS"}], ",", "BS", ",", "0", ",", "0"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{"-", "BT"}], ",", "0", ",", "0"}], "}"}]}], "}"}], 
  "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481691806324472`*^9, 3.748169184126515*^9}, {
   3.7481697745097303`*^9, 3.7481698177840567`*^9}, 3.748170212558292*^9, {
   3.748173374404573*^9, 3.7481733746755257`*^9}, {3.748173599526976*^9, 
   3.7481736068192577`*^9}},
 CellID->436570979,ExpressionUUID->"49b41064-6923-4893-a696-854c7a92b5ff"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"\[LeftSkeleton]\\\", \\\"4\\\", \\\"\[RightSkeleton]\\\"}], \\\",\
\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", RowBox[{\\\"-\\\", \
\\\"BT\\\"}], \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}]}], \\\
\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"1\", \
\",\", \"0\", \",\", \"0\", \",\", \"0\"}], \"}\"}], \",\", RowBox[{\"\
\[LeftSkeleton]\", \"4\", \"\[RightSkeleton]\"}], \",\", RowBox[{\"{\", \
RowBox[{\"0\", \",\", RowBox[{\"-\", \"BT\"}], \",\", \"0\", \",\", \"0\"}], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"0\\\", \
\\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"\[LeftSkeleton]\\\", \\\"4\\\", \\\"\[RightSkeleton]\\\"}], \\\",\
\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", RowBox[{\\\"-\\\", \
\\\"BT\\\"}], \\\",\\\", \\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}]}], \\\
\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"1\", \
\",\", \"0\", \",\", \"0\", \",\", \"0\"}], \"}\"}], \",\", RowBox[{\"\
\[LeftSkeleton]\", \"4\", \"\[RightSkeleton]\"}], \",\", RowBox[{\"{\", \
RowBox[{\"0\", \",\", RowBox[{\"-\", \"BT\"}], \",\", \"0\", \",\", \"0\"}], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00014200000000119672`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00014200000000119672`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1415622188,ExpressionUUID->"f7cb2c9a-b4f9-48ed-8dc4-d454646599b1"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->390788603,ExpressionUUID->"7b0db278-dac5-4e04-9aea-c25498c85cd6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169187965559*^9, 3.748173202318899*^9},
 CellLabel->"In[60]:=",
 CellID->115560600,ExpressionUUID->"6c8fb4e8-0139-44cb-95d6-c33512124575"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "BT", "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169193927287*^9, 3.748169194789258*^9}, {
  3.748169826851533*^9, 3.7481698714627047`*^9}, {3.748173377715177*^9, 
  3.748173377983773*^9}, {3.748173635060968*^9, 3.748173640381646*^9}},
 CellID->1067147800,ExpressionUUID->"791f0c5b-7af7-451e-b6aa-258fdb0eef32"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
\\\"BT\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"BT\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
\\\"BT\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"BT\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015799999999988046`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015799999999988046`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->979058095,ExpressionUUID->"7c01f9d3-4753-4f96-b4f5-21b6689070f0"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1009699351,ExpressionUUID->"05a4fb3a-7df8-4012-93d0-b14a2ab89c7f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"e", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.74816921143508*^9, 3.748173204095607*^9},
 CellLabel->"In[61]:=",
 CellID->795695155,ExpressionUUID->"926cafef-4200-4d16-acf5-e84d9b3bb7be"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "b", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692120543423`*^9, 3.748169217153222*^9}, 
   3.748169620186891*^9, {3.7481699674394503`*^9, 3.7481699868030443`*^9}, {
   3.748173385172969*^9, 3.748173385520602*^9}, 3.7481734401846237`*^9},
 CellID->1391789614,ExpressionUUID->"da37f63d-06e0-461b-9043-6e8f0c587559"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}]}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}]}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
000128000000000128`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.000128000000000128`\", \"\\\"s\\\
\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->601213663,ExpressionUUID->"1b44b5a6-aa24-460e-8dce-c7a16261d13f"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->687474906,ExpressionUUID->"888f7696-4746-4b2a-aa84-1237f5063b3a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169221684237*^9, 3.748173215720984*^9},
 CellLabel->"In[62]:=",
 CellID->249536683,ExpressionUUID->"c045e6cd-2d28-45fd-ad58-3788f40d39c4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "d", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692270490217`*^9, 3.748169230838327*^9}, {
   3.748169991971572*^9, 3.748170004254684*^9}, {3.748173382387341*^9, 
   3.7481733826291323`*^9}, 3.748173437321972*^9},
 CellID->244679970,ExpressionUUID->"308d9f81-07ac-4027-b8a2-26921e8d165a"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
\\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
\\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00013400000000096668`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00013400000000096668`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->928724282,ExpressionUUID->"df512f0f-25fe-4c3b-ab2d-39d01ba83e64"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1157861178,ExpressionUUID->"bbe2194b-8607-4acc-86e8-071a97e94958"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Test System 2", "Section",
 CellChangeTimes->{{3.7481692698005457`*^9, 3.748169273381559*^9}, 
   3.7481693114624357`*^9, {3.748169361271824*^9, 3.748169361361087*^9}, {
   3.748170308281064*^9, 3.7481703083633633`*^9}},
 CellID->1535036385,ExpressionUUID->"79e7c282-6bf5-45c6-a4b7-08ede19907c6"],

Cell[CellGroupData[{

Cell["System model", "Subsection",
 CellChangeTimes->{{3.751243736232489*^9, 3.751243737956749*^9}},
 CellID->1779275761,ExpressionUUID->"88a29ac9-4e27-4501-b94d-208a8e7533a3"],

Cell["Garbini\[CloseCurlyQuote]s Test Suite DC Motor/Pulley", "Text",
 CellChangeTimes->{{3.748169314267838*^9, 3.748169333731399*^9}, {
   3.748169368971754*^9, 3.748169377466568*^9}, 3.751245536163187*^9},
 CellID->577930652,ExpressionUUID->"456df054-98f9-4dfc-b5ef-45bdf6b8f95a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"vI", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primaryVars", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"oJM", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"iR", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"v1", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"t2", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"tB", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"t3", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"o4", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"tJL", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outExps", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"oJM", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"oJL", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"iR", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"vR", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"elementalEqs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"oJM", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"tJM", "[", "t", "]"}], "/", "JM"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"iR", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vR", "[", "t", "]"}], "/", "R"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"v1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", "Km"}], " ", 
       RowBox[{"o2", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"t2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"Km", " ", 
       RowBox[{"i1", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tB", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"B", " ", 
       RowBox[{"oB", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"t3", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"t4", "[", "t", "]"}]}], "/", "n"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"o4", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"o3", "[", "t", "]"}], "/", "n"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tJL", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"JL", " ", 
       RowBox[{
        RowBox[{"oJL", "'"}], "[", "t", "]"}]}]}]}], "\[IndentingNewLine]", 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"constraintEqs", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"(*", " ", 
     RowBox[{"continuity", " ", "and", " ", "compatibility"}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"tJM", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"t2", "[", "t", "]"}]}], "-", 
       RowBox[{"tB", "[", "t", "]"}], "-", 
       RowBox[{"t3", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vR", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vI", "[", "t", "]"}], "-", 
       RowBox[{"v1", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"o2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"oJM", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"i1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"iR", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"oB", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"oJM", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"t4", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"-", 
       RowBox[{"tJL", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"o3", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"oJM", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"oJL", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"o4", "[", "t", "]"}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.751245552597632*^9, 3.751245767026341*^9}, {
  3.751245836673361*^9, 3.751245868875806*^9}, {3.751812488310609*^9, 
  3.7518125645107822`*^9}, {3.751822336601007*^9, 3.7518223601079483`*^9}},
 CellLabel->"In[63]:=",
 CellID->59658601,ExpressionUUID->"fdfed571-47d7-4092-aa34-959adedb7698"],

Cell["Find state equation.", "Text",
 CellChangeTimes->{{3.702757751780126*^9, 3.7027577578425713`*^9}, {
  3.702757790122506*^9, 3.7027577915609007`*^9}, {3.727581684624194*^9, 
  3.727581686707095*^9}},
 CellID->1426397155,ExpressionUUID->"f4fb8173-33a6-491e-835d-a11ddd298929"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stateSolution", "=", 
   RowBox[{
    RowBox[{"stateEquations", "[", 
     RowBox[{
     "inVars", ",", "primaryVars", ",", "elementalEqs", ",", 
      "constraintEqs"}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateVars", " ", "=", " ", 
   RowBox[{"\"\<state variables\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateEqList", " ", "=", " ", 
   RowBox[{"\"\<RHS\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\"\<state equations\>\"", "/.", "stateSolution"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.7018797195836763`*^9, 3.7018797204767036`*^9}, {
   3.701879810803969*^9, 3.701879844544981*^9}, {3.7018942050184517`*^9, 
   3.701894566874161*^9}, 3.701898020551093*^9, {3.701903282327601*^9, 
   3.701903283500523*^9}, {3.701911200698804*^9, 3.701911202601316*^9}, {
   3.701915682054678*^9, 3.701915720675168*^9}, {3.701915759772274*^9, 
   3.7019157927706213`*^9}, {3.701915923602686*^9, 3.701915923900078*^9}, 
   3.7019209193048553`*^9, 3.701920950145496*^9, {3.701921306764739*^9, 
   3.701921308673313*^9}, {3.701921408184596*^9, 3.7019214156809187`*^9}, 
   3.7019220747800493`*^9, {3.701922189786292*^9, 3.701922218088579*^9}, {
   3.701922248592429*^9, 3.701922251876824*^9}, 3.701922322852202*^9, {
   3.701922383801173*^9, 3.7019224315654707`*^9}, {3.701922463501308*^9, 
   3.7019224895050097`*^9}, 3.7019225472984467`*^9, {3.701922594846767*^9, 
   3.701922598092758*^9}, {3.701922662563005*^9, 3.701922735877761*^9}, {
   3.7019231046383343`*^9, 3.701923105684675*^9}, {3.7019639715923243`*^9, 
   3.7019639718841667`*^9}, {3.7019642654040737`*^9, 3.701964352167139*^9}, {
   3.701964387110903*^9, 3.7019644147887087`*^9}, {3.702757419429731*^9, 
   3.7027575039883213`*^9}, {3.7511302149210863`*^9, 3.751130222225973*^9}, 
   3.751131245052647*^9, {3.75181257990794*^9, 3.751812652884736*^9}, {
   3.751812715054282*^9, 3.751812716659523*^9}, {3.75182232005653*^9, 
   3.751822349846747*^9}, 3.7518595719979963`*^9, 3.751859962368793*^9, 
   3.751860991867573*^9, 3.7519374526177273`*^9},
 CellID->1097032624,ExpressionUUID->"ce787ae6-e68c-471b-b2ef-de36916e00d4"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["oJM", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["n", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["Km", "2"], "+", 
            RowBox[{"B", " ", "R"}]}], ")"}], " ", 
          RowBox[{"oJM", "[", "t", "]"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"JL", "+", 
            RowBox[{"JM", " ", 
             SuperscriptBox["n", "2"]}]}], ")"}], " ", "R"}]]}], "-", 
       FractionBox[
        RowBox[{"Km", " ", 
         SuperscriptBox["n", "2"], " ", 
         RowBox[{"vI", "[", "t", "]"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"JL", "+", 
           RowBox[{"JM", " ", 
            SuperscriptBox["n", "2"]}]}], ")"}], " ", "R"}]]}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751131246142264*^9, 3.751131562228766*^9, 3.751154207578877*^9, 
   3.751155061538066*^9, 3.7511551539969883`*^9, 3.7511556539137783`*^9, 
   3.751156830900199*^9, 3.751157044451893*^9, 3.751157305712584*^9, 
   3.751157692923893*^9, 3.751237248504381*^9, 3.7512373121455393`*^9, 
   3.751237557961287*^9, {3.7512412411479073`*^9, 3.751241257691305*^9}, 
   3.7512413334070673`*^9, 3.751241455823284*^9, 3.751241611586341*^9, 
   3.7512433878599854`*^9, 3.751243524307231*^9, 3.751243608962484*^9, 
   3.7512437545853853`*^9, 3.751243860047454*^9, 3.7512441819725847`*^9, 
   3.751244399097206*^9, 3.751244486437664*^9, 3.75124455927641*^9, 
   3.75124464012558*^9, 3.75124506931707*^9, 3.751245129883816*^9, 
   3.751245199900049*^9, 3.751245786492696*^9, 3.7512458405736723`*^9, 
   3.751245872204157*^9, 3.751812659623021*^9, 3.7518127275977173`*^9, {
   3.7518127996167803`*^9, 3.75181281567822*^9}, 3.7518129087126923`*^9, 
   3.751813024251314*^9, 3.751813093964695*^9, 3.751821183735201*^9, 
   3.751821248994925*^9, 3.751821292491517*^9, 3.751821373838191*^9, 
   3.7518214390566177`*^9, 3.7518215246917763`*^9, 3.751821603947466*^9, 
   3.751821940974938*^9, 3.751821984201557*^9, 3.751822022046051*^9, {
   3.751822070179757*^9, 3.751822089798585*^9}, 3.751822131634933*^9, 
   3.751822220427194*^9, 3.751822394561487*^9, 3.751824476471623*^9, 
   3.75182727439786*^9, 3.751859649116275*^9, 3.75186000624244*^9, 
   3.751861049387076*^9},
 CellLabel->"Out[71]//TableForm=",
 CellID->1823493179,ExpressionUUID->"e58d6762-e26d-44d2-9eff-efbb417c0a8c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"outEqList", "=", 
   RowBox[{"outEquations", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outExps", ",", 
     RowBox[{"elementalEqs", "~", "Join", "~", "constraintEqs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outEqList", "//", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"y", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "outExps", "]"}]}], "}"}]}], "]"}], 
      "\[Equal]", "#"}], "]"}], "&"}]}], "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.75115407229806*^9, 3.7511540907068577`*^9}, {
   3.7511541283727303`*^9, 3.751154145140655*^9}, {3.751154185947949*^9, 
   3.751154186454541*^9}, {3.75115440553708*^9, 3.751154408241644*^9}, {
   3.751157061478198*^9, 3.75115706228808*^9}, {3.751157258647379*^9, 
   3.751157263470278*^9}, {3.751157318329653*^9, 3.751157382599204*^9}, 
   3.751243546881419*^9, 3.7512446518094807`*^9, {3.751813160439826*^9, 
   3.751813163186652*^9}, {3.751813266450152*^9, 3.751813270972951*^9}, {
   3.751822320067109*^9, 3.751822349851709*^9}},
 CellLabel->"In[72]:=",
 CellID->1893766508,ExpressionUUID->"03036d77-0d5f-4f59-b8d9-0ab702ca9392"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{"y", "[", "1", "]"}], "\[Equal]", 
       RowBox[{"oJM", "[", "t", "]"}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "2", "]"}], "\[Equal]", 
       FractionBox[
        RowBox[{"oJM", "[", "t", "]"}], "n"]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "3", "]"}], "\[Equal]", 
       RowBox[{
        FractionBox[
         RowBox[{"Km", " ", 
          RowBox[{"oJM", "[", "t", "]"}]}], "R"], "+", 
        FractionBox[
         RowBox[{"vI", "[", "t", "]"}], "R"]}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "4", "]"}], "\[Equal]", 
       RowBox[{
        RowBox[{"Km", " ", 
         RowBox[{"oJM", "[", "t", "]"}]}], "+", 
        RowBox[{"vI", "[", "t", "]"}]}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751154146341402*^9, {3.7511541874520807`*^9, 3.75115421035389*^9}, 
   3.751154409289606*^9, 3.751155063159431*^9, 3.7511551578703537`*^9, {
   3.751155631171876*^9, 3.7511556669733973`*^9}, 3.751156831153225*^9, {
   3.7511570444961233`*^9, 3.751157063011318*^9}, 3.7511573845757217`*^9, 
   3.7511576929574337`*^9, 3.751237248545403*^9, 3.75123731846103*^9, 
   3.751237558009218*^9, 3.75124126512782*^9, 3.751241341691312*^9, 
   3.7512414602930183`*^9, {3.7512415890389347`*^9, 3.751241614550478*^9}, 
   3.751243391757332*^9, {3.751243525864511*^9, 3.7512435473077707`*^9}, 
   3.7512436090180597`*^9, 3.751243754645124*^9, 3.751243860169832*^9, 
   3.751244182055914*^9, 3.751244399162704*^9, 3.751244486514542*^9, 
   3.751244523619996*^9, 3.7512445593242817`*^9, {3.751244640162719*^9, 
   3.7512446526642714`*^9}, 3.7512450693463917`*^9, 3.751245129916429*^9, 
   3.751245199944006*^9, 3.751245811673089*^9, 3.75124584198965*^9, 
   3.75124587430195*^9, {3.751812799705221*^9, 3.7518128158564463`*^9}, 
   3.751812908776719*^9, 3.751813024310192*^9, 3.751813094024579*^9, 
   3.751813179415744*^9, 3.7518132717696123`*^9, 3.751821183812248*^9, 
   3.7518212490599127`*^9, 3.751821292577516*^9, 3.7518213739347887`*^9, 
   3.751821439141843*^9, 3.751821524774869*^9, 3.751821604039015*^9, 
   3.7518219410608683`*^9, 3.7518219842805157`*^9, 3.751822133769186*^9, 
   3.7518222205053473`*^9, 3.7518223946281347`*^9, 3.751824476570424*^9, 
   3.751827274483148*^9, 3.751859649204294*^9, 3.7518600063477907`*^9, 
   3.751861049469936*^9},
 CellLabel->"Out[73]//TableForm=",
 CellID->710733116,ExpressionUUID->"2937ef0f-5286-4a78-ad30-a26026097d70"]
}, Open  ]],

Cell["\<\
Linearize the state and output equations about operating point.\
\>", "Text",
 CellChangeTimes->{{3.7027577023090067`*^9, 3.7027577064193897`*^9}, {
  3.702757795179463*^9, 3.702757797848589*^9}, {3.702758517676444*^9, 
  3.702758517969734*^9}, {3.751157404122614*^9, 3.751157407793623*^9}},
 CellID->1550328013,ExpressionUUID->"b87087ba-cf91-4560-81c7-bd19c6044a5a"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"abe", "=", 
   RowBox[{"linearizeState", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "stateEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdf", "=", 
   RowBox[{"linearizeOutput", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"e", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"d", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"f", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<A = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<B = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<E = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<C = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<D = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<F = \>\"", ",", "#"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.7027439116175957`*^9, 3.702744033267743*^9}, {
   3.702744268313121*^9, 3.702744305447536*^9}, {3.702756777004896*^9, 
   3.70275678344866*^9}, {3.702756831990849*^9, 3.702756860110464*^9}, {
   3.702757530029274*^9, 3.702757693348208*^9}, {3.70275831097122*^9, 
   3.702758346655436*^9}, {3.702758404323063*^9, 3.7027584657658863`*^9}, {
   3.702759733356806*^9, 3.702760026609954*^9}, {3.70276007934348*^9, 
   3.702760085749899*^9}, {3.702760162502097*^9, 3.7027602713332367`*^9}, {
   3.7031743380777597`*^9, 3.703174365043808*^9}, {3.7032126025366993`*^9, 
   3.703212608677622*^9}, {3.7275822132423773`*^9, 3.727582355849462*^9}, 
   3.751154035567876*^9, {3.751157216290072*^9, 3.751157229742868*^9}, {
   3.751157416529111*^9, 3.751157421062249*^9}, {3.7511576066364393`*^9, 
   3.751157656881137*^9}, {3.7511577043529177`*^9, 3.7511577145152082`*^9}, {
   3.7512372971265383`*^9, 3.7512373336944847`*^9}, {3.751237381927462*^9, 
   3.751237410777441*^9}},
 CellLabel->"In[74]:=",
 CellID->943825440,ExpressionUUID->"5192c78b-e2c5-4a94-b1c4-b8f80264ffdd"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["n", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["Km", "2"], "+", 
             RowBox[{"B", " ", "R"}]}], ")"}]}], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"JL", "+", 
             RowBox[{"JM", " ", 
              SuperscriptBox["n", "2"]}]}], ")"}], " ", "R"}]]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["A = ", 
   MatrixForm[{{-$CellContext`n^2 ($CellContext`JL + $CellContext`JM \
$CellContext`n^2)^(-1) $CellContext`R^(-1) ($CellContext`Km^2 + \
$CellContext`B $CellContext`R)}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751245883802848*^9, {3.751812799772752*^9, 3.7518128159557543`*^9}, 
   3.751812908839438*^9, 3.751813024371874*^9, 3.751813094094748*^9, 
   3.7518132811177588`*^9, 3.751821183883008*^9, 3.751821249135727*^9, 
   3.751821292644603*^9, 3.7518213740230637`*^9, 3.751821439209651*^9, 
   3.7518215248474827`*^9, 3.751821604121758*^9, 3.751821941132279*^9, 
   3.751821984344611*^9, 3.75182217118579*^9, 3.75182222057585*^9, 
   3.751822394703484*^9, 3.751824476688891*^9, 3.751827274562517*^9, 
   3.7518596492881813`*^9, 3.75186000648009*^9, 3.751861049554229*^9},
 CellLabel->"During evaluation of In[74]:=",
 CellID->987435998,ExpressionUUID->"89095902-84ca-40ba-b8d2-3ff505d2c050"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"B = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox[
          RowBox[{"Km", " ", 
           SuperscriptBox["n", "2"]}], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"JL", "+", 
             RowBox[{"JM", " ", 
              SuperscriptBox["n", "2"]}]}], ")"}], " ", "R"}]]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["B = ", 
   MatrixForm[{{-$CellContext`Km $CellContext`n^2 ($CellContext`JL + \
$CellContext`JM $CellContext`n^2)^(-1)/$CellContext`R}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751245883802848*^9, {3.751812799772752*^9, 3.7518128159557543`*^9}, 
   3.751812908839438*^9, 3.751813024371874*^9, 3.751813094094748*^9, 
   3.7518132811177588`*^9, 3.751821183883008*^9, 3.751821249135727*^9, 
   3.751821292644603*^9, 3.7518213740230637`*^9, 3.751821439209651*^9, 
   3.7518215248474827`*^9, 3.751821604121758*^9, 3.751821941132279*^9, 
   3.751821984344611*^9, 3.75182217118579*^9, 3.75182222057585*^9, 
   3.751822394703484*^9, 3.751824476688891*^9, 3.751827274562517*^9, 
   3.7518596492881813`*^9, 3.75186000648009*^9, 3.751861049566123*^9},
 CellLabel->"During evaluation of In[74]:=",
 CellID->83194370,ExpressionUUID->"39bf46f1-4f67-48e9-8546-eb628b8233d8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"E = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["E = ", 
   MatrixForm[{{0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751245883802848*^9, {3.751812799772752*^9, 3.7518128159557543`*^9}, 
   3.751812908839438*^9, 3.751813024371874*^9, 3.751813094094748*^9, 
   3.7518132811177588`*^9, 3.751821183883008*^9, 3.751821249135727*^9, 
   3.751821292644603*^9, 3.7518213740230637`*^9, 3.751821439209651*^9, 
   3.7518215248474827`*^9, 3.751821604121758*^9, 3.751821941132279*^9, 
   3.751821984344611*^9, 3.75182217118579*^9, 3.75182222057585*^9, 
   3.751822394703484*^9, 3.751824476688891*^9, 3.751827274562517*^9, 
   3.7518596492881813`*^9, 3.75186000648009*^9, 3.7518610495763206`*^9},
 CellLabel->"During evaluation of In[74]:=",
 CellID->235922393,ExpressionUUID->"eeb12eb6-44dd-475d-a434-805f991baf7e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1"},
       {
        FractionBox["1", "n"]},
       {
        FractionBox["Km", "R"]},
       {"Km"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{
     1}, {$CellContext`n^(-1)}, {$CellContext`Km/$CellContext`R}, \
{$CellContext`Km}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751245883802848*^9, {3.751812799772752*^9, 3.7518128159557543`*^9}, 
   3.751812908839438*^9, 3.751813024371874*^9, 3.751813094094748*^9, 
   3.7518132811177588`*^9, 3.751821183883008*^9, 3.751821249135727*^9, 
   3.751821292644603*^9, 3.7518213740230637`*^9, 3.751821439209651*^9, 
   3.7518215248474827`*^9, 3.751821604121758*^9, 3.751821941132279*^9, 
   3.751821984344611*^9, 3.75182217118579*^9, 3.75182222057585*^9, 
   3.751822394703484*^9, 3.751824476688891*^9, 3.751827274562517*^9, 
   3.7518596492881813`*^9, 3.75186000648009*^9, 3.751861049581984*^9},
 CellLabel->"During evaluation of In[74]:=",
 CellID->892846789,ExpressionUUID->"f1ab79af-5220-4a8a-8d3e-cc26dacd9dcc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"},
       {
        FractionBox["1", "R"]},
       {"1"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{0}, {0}, {$CellContext`R^(-1)}, {1}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751245883802848*^9, {3.751812799772752*^9, 3.7518128159557543`*^9}, 
   3.751812908839438*^9, 3.751813024371874*^9, 3.751813094094748*^9, 
   3.7518132811177588`*^9, 3.751821183883008*^9, 3.751821249135727*^9, 
   3.751821292644603*^9, 3.7518213740230637`*^9, 3.751821439209651*^9, 
   3.7518215248474827`*^9, 3.751821604121758*^9, 3.751821941132279*^9, 
   3.751821984344611*^9, 3.75182217118579*^9, 3.75182222057585*^9, 
   3.751822394703484*^9, 3.751824476688891*^9, 3.751827274562517*^9, 
   3.7518596492881813`*^9, 3.75186000648009*^9, 3.751861049588397*^9},
 CellLabel->"During evaluation of In[74]:=",
 CellID->1607741134,ExpressionUUID->"6bc20185-fde5-4f14-8a19-a43de290c902"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"},
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0}, {0}, {0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751245883802848*^9, {3.751812799772752*^9, 3.7518128159557543`*^9}, 
   3.751812908839438*^9, 3.751813024371874*^9, 3.751813094094748*^9, 
   3.7518132811177588`*^9, 3.751821183883008*^9, 3.751821249135727*^9, 
   3.751821292644603*^9, 3.7518213740230637`*^9, 3.751821439209651*^9, 
   3.7518215248474827`*^9, 3.751821604121758*^9, 3.751821941132279*^9, 
   3.751821984344611*^9, 3.75182217118579*^9, 3.75182222057585*^9, 
   3.751822394703484*^9, 3.751824476688891*^9, 3.751827274562517*^9, 
   3.7518596492881813`*^9, 3.75186000648009*^9, 3.751861049594058*^9},
 CellLabel->"During evaluation of In[74]:=",
 CellID->1665992584,ExpressionUUID->"5fc46900-4d77-442a-8959-788af07b0401"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.751243705713728*^9, 3.751243706940173*^9}, {
  3.7512447617278233`*^9, 3.751244762830553*^9}},
 CellID->1685561734,ExpressionUUID->"44571f5a-60e3-48be-927e-9a4b0e41b365"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.747505552707037*^9, {3.7475057578295593`*^9, 3.747505759222794*^9}, {
   3.747505842150148*^9, 3.7475058458319883`*^9}, {3.747505896191999*^9, 
   3.74750589728131*^9}, {3.748124150238531*^9, 3.748124150517943*^9}, 
   3.748169029221862*^9, 3.748173223912418*^9},
 CellLabel->"In[84]:=",
 CellID->579825297,ExpressionUUID->"f5bab334-906f-48b0-a49c-ee7bcd62d2a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       SuperscriptBox["n", "2"], 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["Km", "2"], "+", 
         RowBox[{"R", " ", "B"}]}], ")"}]}], 
      RowBox[{"R", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox["n", "2"], "JM"}], "+", "JL"}], ")"}]}]]}], "}"}], 
   "}"}], "//", "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.747505555643032*^9, 3.7475055867312613`*^9}, {
   3.747505761476728*^9, 3.747505764318122*^9}, {3.747505847665118*^9, 
   3.7475058502692757`*^9}, {3.747505898843794*^9, 3.74750590124069*^9}, {
   3.7475063255823507`*^9, 3.747506334276267*^9}, {3.7481241530496283`*^9, 
   3.748124156712919*^9}, 3.7481690353265944`*^9, {3.748169641556839*^9, 
   3.748169730141844*^9}, {3.7481706308795347`*^9, 3.748170648343268*^9}, {
   3.7481713324991817`*^9, 3.748171412017522*^9}, {3.748172606423606*^9, 
   3.74817263047576*^9}, {3.748173395907811*^9, 3.748173425723956*^9}},
 CellID->539182276,ExpressionUUID->"132e31c7-506e-4be7-9ea8-9a3270e04e3d"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"-\\\", \
FractionBox[RowBox[{SuperscriptBox[\\\"n\\\", \\\"2\\\"], \\\" \\\", RowBox[{\
\\\"(\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\[RightSkeleton]\\\
\"}], \\\")\\\"}]}], RowBox[{RowBox[{\\\"(\\\", RowBox[{\\\"JL\\\", \
\\\"+\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\[RightSkeleton]\\\
\"}]}], \\\")\\\"}], \\\" \\\", \\\"R\\\"}]]}], \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"-\", \
FractionBox[RowBox[{SuperscriptBox[\"n\", \"2\"], \" \", RowBox[{\"(\", \
RowBox[{\"\[LeftSkeleton]\", \"1\", \"\[RightSkeleton]\"}], \")\"}]}], \
RowBox[{RowBox[{\"(\", RowBox[{\"JL\", \"+\", RowBox[{\"\[LeftSkeleton]\", \
\"1\", \"\[RightSkeleton]\"}]}], \")\"}], \" \", \"R\"}]]}], \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"-\\\", \
FractionBox[RowBox[{SuperscriptBox[\\\"n\\\", \\\"2\\\"], \\\" \\\", RowBox[{\
\\\"(\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\[RightSkeleton]\\\
\"}], \\\")\\\"}]}], RowBox[{RowBox[{\\\"(\\\", RowBox[{\\\"JL\\\", \
\\\"+\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\[RightSkeleton]\\\
\"}]}], \\\")\\\"}], \\\" \\\", \\\"R\\\"}]]}], \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"-\", \
FractionBox[RowBox[{SuperscriptBox[\"n\", \"2\"], \" \", RowBox[{\"(\", \
RowBox[{\"\[LeftSkeleton]\", \"1\", \"\[RightSkeleton]\"}], \")\"}]}], \
RowBox[{RowBox[{\"(\", RowBox[{\"JL\", \"+\", RowBox[{\"\[LeftSkeleton]\", \
\"1\", \"\[RightSkeleton]\"}]}], \")\"}], \" \", \"R\"}]]}], \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
003304000000000862`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.003304000000000862`\", \"\\\"s\\\
\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1445569702,ExpressionUUID->"e838d47a-82ff-4942-a4bf-ed4f67971055"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1207483003,ExpressionUUID->"619f7b9d-37f9-459d-b42f-f3add73b8480"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169118881194*^9, 3.74817322800281*^9},
 CellLabel->"In[85]:=",
 CellID->1652478564,ExpressionUUID->"e46f3256-0d82-49b7-9717-fa40e235ea27"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       SuperscriptBox["n", "2"], "Km"}], 
      RowBox[{"R", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox["n", "2"], "JM"}], "+", "JL"}], ")"}]}]]}], "}"}], 
   "}"}], "//", "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169152633688*^9, 3.748169166417688*^9}, 
   3.74816961437001*^9, {3.748169735895432*^9, 3.74816976416591*^9}, {
   3.7481714534342337`*^9, 3.748171524401494*^9}, {3.748172636135901*^9, 
   3.748172653599022*^9}, {3.7481734038922367`*^9, 3.748173429493685*^9}, {
   3.749568242171578*^9, 3.749568243026031*^9}},
 CellID->632170420,ExpressionUUID->"1ff6c5cf-14dd-48d8-837d-5a6f1b2e65dd"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"-\\\", FractionBox[RowBox[{\\\"Km\\\", \\\" \\\
\", SuperscriptBox[\\\"n\\\", \\\"2\\\"]}], RowBox[{RowBox[{\\\"JL\\\", \\\" \
\\\", \\\"R\\\"}], \\\"+\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \
\\\"\[RightSkeleton]\\\"}]}]]}], \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"-\", \
FractionBox[RowBox[{\"Km\", \" \", SuperscriptBox[\"n\", \"2\"]}], \
RowBox[{RowBox[{\"JL\", \" \", \"R\"}], \"+\", RowBox[{\"\[LeftSkeleton]\", \
\"1\", \"\[RightSkeleton]\"}]}]]}], \"}\"}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"-\\\", FractionBox[RowBox[{\\\"Km\\\", \\\" \\\
\", SuperscriptBox[\\\"n\\\", \\\"2\\\"]}], RowBox[{RowBox[{\\\"JL\\\", \\\" \
\\\", \\\"R\\\"}], \\\"+\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \
\\\"\[RightSkeleton]\\\"}]}]]}], \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"-\", \
FractionBox[RowBox[{\"Km\", \" \", SuperscriptBox[\"n\", \"2\"]}], \
RowBox[{RowBox[{\"JL\", \" \", \"R\"}], \"+\", RowBox[{\"\[LeftSkeleton]\", \
\"1\", \"\[RightSkeleton]\"}]}]]}], \"}\"}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
001972000000001195`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.001972000000001195`\", \"\\\"s\\\
\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->446367271,ExpressionUUID->"0aa2856a-7121-47e5-81da-605e179fe6aa"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->934344726,ExpressionUUID->"46c6cfe1-6669-488d-8b7e-534b7405837f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169171923123*^9, 3.748173229385552*^9},
 CellLabel->"In[86]:=",
 CellID->1632785011,ExpressionUUID->"7ae92245-a60b-464b-b81d-2e38caf9a1ed"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "1", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"1", "/", "n"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"Km", "/", "R"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "Km", "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481691806324472`*^9, 3.748169184126515*^9}, {
   3.7481697745097303`*^9, 3.7481698177840567`*^9}, 3.748170212558292*^9, {
   3.74817153653963*^9, 3.748171557948637*^9}, {3.748173400643174*^9, 
   3.74817340096135*^9}, {3.748173656138906*^9, 3.748173662055806*^9}},
 CellID->295221976,ExpressionUUID->"0fea616d-ab90-457f-af71-1c8043f7cf38"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"1\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", FractionBox[\\\"1\\\", \\\"n\\\"], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", FractionBox[\\\"Km\\\", \\\"R\\\"], \\\"}\\\"}], \
\\\",\\\", RowBox[{\\\"{\\\", \\\"Km\\\", \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"1\", \"}\"}], \
\",\", RowBox[{\"{\", FractionBox[\"1\", \"n\"], \"}\"}], \",\", \
RowBox[{\"{\", FractionBox[\"Km\", \"R\"], \"}\"}], \",\", RowBox[{\"{\", \
\"Km\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"1\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", FractionBox[\\\"1\\\", \\\"n\\\"], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", FractionBox[\\\"Km\\\", \\\"R\\\"], \\\"}\\\"}], \
\\\",\\\", RowBox[{\\\"{\\\", \\\"Km\\\", \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"1\", \"}\"}], \
\",\", RowBox[{\"{\", FractionBox[\"1\", \"n\"], \"}\"}], \",\", \
RowBox[{\"{\", FractionBox[\"Km\", \"R\"], \"}\"}], \",\", RowBox[{\"{\", \
\"Km\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0003279999999996619`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0003279999999996619`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1131383018,ExpressionUUID->"e7e95278-ab93-404e-9d18-36638ced1954"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1334172988,ExpressionUUID->"55a903b5-920a-4074-85e0-9f5f40c40393"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169187965559*^9, 3.748173233440237*^9},
 CellLabel->"In[87]:=",
 CellID->993902552,ExpressionUUID->"d1348039-fa9f-4000-9506-99ee54269f25"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"1", "/", "R"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "1", "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169193927287*^9, 3.748169194789258*^9}, {
  3.748169826851533*^9, 3.7481698714627047`*^9}, {3.748171572452416*^9, 
  3.748171580237145*^9}, {3.7481734124398193`*^9, 3.748173412764402*^9}, {
  3.748173667119259*^9, 3.748173672718726*^9}},
 CellID->2097280005,ExpressionUUID->"24bde1a5-8813-4f47-8c3e-b4b3b2777e42"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", FractionBox[\\\"1\\\
\", \\\"R\\\"], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"1\\\", \\\"}\\\
\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \
FractionBox[\"1\", \"R\"], \"}\"}], \",\", RowBox[{\"{\", \"1\", \"}\"}]}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", FractionBox[\\\"1\\\
\", \\\"R\\\"], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"1\\\", \\\"}\\\
\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \
FractionBox[\"1\", \"R\"], \"}\"}], \",\", RowBox[{\"{\", \"1\", \"}\"}]}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00013500000000021828`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00013500000000021828`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1568650989,ExpressionUUID->"9768f71d-37fe-4d01-9784-5b01cc044287"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1807921551,ExpressionUUID->"e6672f2a-f804-4108-b40d-b3210ab4007c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"e", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.74816921143508*^9, 3.748173235108005*^9},
 CellLabel->"In[88]:=",
 CellID->482876599,ExpressionUUID->"b461d11c-735a-49d8-9508-f896e3cbdc1f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "b", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692120543423`*^9, 3.748169217153222*^9}, 
   3.748169620186891*^9, {3.7481699674394503`*^9, 3.7481699868030443`*^9}, {
   3.748173417367937*^9, 3.748173418798951*^9}},
 CellID->256108941,ExpressionUUID->"0e366c46-69c9-4fc2-a4c7-83e0cfc01f20"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00012599999999984846`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00012599999999984846`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->991386254,ExpressionUUID->"5d996416-f070-4213-8a05-ccf53fd3296e"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->2050637552,ExpressionUUID->"c9877885-b1b7-4d0f-9ae2-06b0f917cc08"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169221684237*^9, 3.748173239710012*^9},
 CellLabel->"In[89]:=",
 CellID->2128865875,ExpressionUUID->"64620c11-d6f1-4fb8-bf33-e615025ca6b7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "d", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692270490217`*^9, 3.748169230838327*^9}, {
   3.748169991971572*^9, 3.748170004254684*^9}, 3.748173420278555*^9},
 CellID->618603978,ExpressionUUID->"2a60b7e5-fbe4-41fd-a943-71794fab3361"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}]}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}]}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001550000000003493`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001550000000003493`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->100285761,ExpressionUUID->"1322b026-dec1-47c0-ad69-526d1527b171"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1875605879,ExpressionUUID->"b9d9a0cd-059e-4c3d-b3b2-e59b8ead13fc"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Test System 3", "Section",
 CellChangeTimes->{{3.7481692698005457`*^9, 3.748169273381559*^9}, 
   3.7481693114624357`*^9, {3.748169361271824*^9, 3.748169361361087*^9}, {
   3.748170308281064*^9, 3.7481703083633633`*^9}, {3.748171876095627*^9, 
   3.748171876178361*^9}},
 CellID->337961518,ExpressionUUID->"8a7e7995-31ec-40d8-bc1d-34ed4eea1436"],

Cell[CellGroupData[{

Cell["System model", "Subsection",
 CellChangeTimes->{{3.751246840578682*^9, 3.751246843410171*^9}},
 CellID->1963009032,ExpressionUUID->"065958ba-cd09-4a35-9f13-7d90f573d30f"],

Cell["Garbini\[CloseCurlyQuote]s Test Suite Inertial Actuator", "Text",
 CellChangeTimes->{{3.748169314267838*^9, 3.748169333731399*^9}, {
  3.748169368971754*^9, 3.748169377466568*^9}, {3.74817032089456*^9, 
  3.748170327324637*^9}, {3.748171903869137*^9, 3.748171911436009*^9}},
 CellID->556431460,ExpressionUUID->"3501198d-02f5-4ee5-bd64-7a1d2111aee7"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ec", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"vs", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primaryVars", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vM", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"fK", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"fB", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"iR", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"e1", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"f2", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outExps", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"fM", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"elementalEqs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"vM", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"fM", "[", "t", "]"}], "/", "M"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"fK", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{"k", " ", 
       RowBox[{"vK", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"fB", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"B", " ", 
       RowBox[{"vB", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"iR", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vR", "[", "t", "]"}], "/", "R"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"e1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", "Km"}], " ", 
       RowBox[{"V2", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"f2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"Km", " ", 
       RowBox[{"i1", "[", "t", "]"}]}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"constraintEqs", " ", "=", " ", 
   RowBox[{"{", " ", 
    RowBox[{"(*", " ", 
     RowBox[{"continuity", " ", "and", " ", "compatibility"}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"fM", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"f2", "[", "t", "]"}]}], "-", 
       RowBox[{"fB", "[", "t", "]"}], "-", 
       RowBox[{"fK", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vK", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vM", "[", "t", "]"}], "-", 
       RowBox[{"vs", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vB", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vM", "[", "t", "]"}], "-", 
       RowBox[{"vs", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vR", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"ec", "[", "t", "]"}], "-", 
       RowBox[{"e1", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"V2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vM", "[", "t", "]"}], "-", 
       RowBox[{"vs", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"i1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"iR", "[", "t", "]"}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.747499218184157*^9, 3.74749931067735*^9}, {
   3.7474997703057547`*^9, 3.747499862953096*^9}, {3.7475000427164516`*^9, 
   3.7475001179609213`*^9}, 3.747500172506531*^9, {3.7475052421578627`*^9, 
   3.7475052437525806`*^9}, {3.7475052792870703`*^9, 3.747505305743517*^9}, {
   3.7475054395550127`*^9, 3.74750549238805*^9}, {3.748169383980278*^9, 
   3.748169603265369*^9}, {3.748170115690106*^9, 3.748170132266461*^9}, {
   3.748170333165715*^9, 3.7481705921461983`*^9}, {3.748171917577342*^9, 
   3.74817195326005*^9}, {3.748171995123074*^9, 3.7481720024895773`*^9}, {
   3.748172035662871*^9, 3.7481721909688787`*^9}, {3.7512469048305483`*^9, 
   3.751247019008057*^9}, {3.7512470817294073`*^9, 3.751247088233301*^9}, {
   3.75124712806741*^9, 3.7512471437041407`*^9}, {3.7518224340823383`*^9, 
   3.7518224971298532`*^9}},
 CellLabel->"In[90]:=",
 CellID->1156856462,ExpressionUUID->"c4d9d8e0-9dc5-474e-8d80-cb475776cbea"],

Cell["Find state equation.", "Text",
 CellChangeTimes->{{3.702757751780126*^9, 3.7027577578425713`*^9}, {
  3.702757790122506*^9, 3.7027577915609007`*^9}, {3.727581684624194*^9, 
  3.727581686707095*^9}},
 CellID->1724112944,ExpressionUUID->"cf5555bf-1763-416c-9f05-fdd0cc2ef937"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stateSolution", "=", 
   RowBox[{
    RowBox[{"stateEquations", "[", 
     RowBox[{
     "inVars", ",", "primaryVars", ",", "elementalEqs", ",", 
      "constraintEqs"}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateVars", " ", "=", " ", 
   RowBox[{"\"\<state variables\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateEqList", " ", "=", " ", 
   RowBox[{"\"\<RHS\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\"\<state equations\>\"", "/.", "stateSolution"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.7018797195836763`*^9, 3.7018797204767036`*^9}, {
   3.701879810803969*^9, 3.701879844544981*^9}, {3.7018942050184517`*^9, 
   3.701894566874161*^9}, 3.701898020551093*^9, {3.701903282327601*^9, 
   3.701903283500523*^9}, {3.701911200698804*^9, 3.701911202601316*^9}, {
   3.701915682054678*^9, 3.701915720675168*^9}, {3.701915759772274*^9, 
   3.7019157927706213`*^9}, {3.701915923602686*^9, 3.701915923900078*^9}, 
   3.7019209193048553`*^9, 3.701920950145496*^9, {3.701921306764739*^9, 
   3.701921308673313*^9}, {3.701921408184596*^9, 3.7019214156809187`*^9}, 
   3.7019220747800493`*^9, {3.701922189786292*^9, 3.701922218088579*^9}, {
   3.701922248592429*^9, 3.701922251876824*^9}, 3.701922322852202*^9, {
   3.701922383801173*^9, 3.7019224315654707`*^9}, {3.701922463501308*^9, 
   3.7019224895050097`*^9}, 3.7019225472984467`*^9, {3.701922594846767*^9, 
   3.701922598092758*^9}, {3.701922662563005*^9, 3.701922735877761*^9}, {
   3.7019231046383343`*^9, 3.701923105684675*^9}, {3.7019639715923243`*^9, 
   3.7019639718841667`*^9}, {3.7019642654040737`*^9, 3.701964352167139*^9}, {
   3.701964387110903*^9, 3.7019644147887087`*^9}, {3.702757419429731*^9, 
   3.7027575039883213`*^9}, {3.7511302149210863`*^9, 3.751130222225973*^9}, 
   3.751131245052647*^9, 3.7518224212768917`*^9, 3.7518595720056343`*^9, 
   3.75185996237741*^9, 3.751860991872775*^9, 3.751937452679734*^9},
 CellID->1169400837,ExpressionUUID->"2e105646-9196-4a03-a81f-f7b32874db42"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["vM", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"fK", "[", "t", "]"}], "M"]}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["Km", "2"]}], "-", 
           RowBox[{"B", " ", "R"}]}], ")"}], " ", 
         RowBox[{"vM", "[", "t", "]"}]}], 
        RowBox[{"M", " ", "R"}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "Km"}], " ", 
          RowBox[{"ec", "[", "t", "]"}]}], "+", 
         RowBox[{
          SuperscriptBox["Km", "2"], " ", 
          RowBox[{"vs", "[", "t", "]"}]}], "+", 
         RowBox[{"B", " ", "R", " ", 
          RowBox[{"vs", "[", "t", "]"}]}]}], 
        RowBox[{"M", " ", "R"}]]}]}]},
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["fK", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"k", " ", 
        RowBox[{"vM", "[", "t", "]"}]}], "-", 
       RowBox[{"k", " ", 
        RowBox[{"vs", "[", "t", "]"}]}]}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751131246142264*^9, 3.751131562228766*^9, 3.751154207578877*^9, 
   3.751155061538066*^9, 3.7511551539969883`*^9, 3.7511556539137783`*^9, 
   3.751156830900199*^9, 3.751157044451893*^9, 3.751157305712584*^9, 
   3.751157692923893*^9, 3.751237248504381*^9, 3.7512373121455393`*^9, 
   3.751237557961287*^9, {3.7512412411479073`*^9, 3.751241257691305*^9}, 
   3.7512413334070673`*^9, 3.751241455823284*^9, 3.751241611586341*^9, 
   3.7512433878599854`*^9, 3.751243524307231*^9, 3.751243608962484*^9, 
   3.7512437545853853`*^9, 3.751243860047454*^9, 3.7512441819725847`*^9, 
   3.751244399097206*^9, 3.751244486437664*^9, 3.75124455927641*^9, 
   3.75124464012558*^9, 3.75124506931707*^9, 3.751245129883816*^9, 
   3.751245199900049*^9, 3.751245786492696*^9, 3.7512458405736723`*^9, 
   3.751245872204157*^9, {3.7512470996055098`*^9, 3.751247133340377*^9}, 
   3.751822506215632*^9, {3.751822707767754*^9, 3.751822723484655*^9}, 
   3.751822800835991*^9, 3.7518235244045973`*^9, 3.751823574246002*^9, 
   3.75182394710122*^9, 3.751824050485718*^9, {3.751824086094249*^9, 
   3.7518241542062597`*^9}, 3.751824200734988*^9, 3.7518272987327147`*^9, 
   3.7518596570510683`*^9, 3.751861065834032*^9},
 CellLabel->"Out[98]//TableForm=",
 CellID->395554040,ExpressionUUID->"a2b4c311-f9b3-4f12-926d-afd4473d5e94"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"outEqList", "=", 
   RowBox[{"outEquations", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outExps", ",", 
     RowBox[{"elementalEqs", "~", "Join", "~", "constraintEqs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outEqList", "//", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"y", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "outExps", "]"}]}], "}"}]}], "]"}], 
      "\[Equal]", "#"}], "]"}], "&"}]}], "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.75115407229806*^9, 3.7511540907068577`*^9}, {
   3.7511541283727303`*^9, 3.751154145140655*^9}, {3.751154185947949*^9, 
   3.751154186454541*^9}, {3.75115440553708*^9, 3.751154408241644*^9}, {
   3.751157061478198*^9, 3.75115706228808*^9}, {3.751157258647379*^9, 
   3.751157263470278*^9}, {3.751157318329653*^9, 3.751157382599204*^9}, 
   3.751243546881419*^9, 3.7512446518094807`*^9, {3.7518241789029417`*^9, 
   3.751824190813037*^9}},
 CellLabel->"In[99]:=",
 CellID->1184868260,ExpressionUUID->"80b3a806-6969-4734-bde0-60a6a0987da5"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{"y", "[", "1", "]"}], "\[Equal]", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"fK", "[", "t", "]"}]}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             SuperscriptBox["Km", "2"]}], "-", 
            RowBox[{"B", " ", "R"}]}], ")"}], " ", 
          RowBox[{"vM", "[", "t", "]"}]}], "R"], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "Km"}], " ", 
           RowBox[{"ec", "[", "t", "]"}]}], "+", 
          RowBox[{
           SuperscriptBox["Km", "2"], " ", 
           RowBox[{"vs", "[", "t", "]"}]}], "+", 
          RowBox[{"B", " ", "R", " ", 
           RowBox[{"vs", "[", "t", "]"}]}]}], "R"]}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751154146341402*^9, {3.7511541874520807`*^9, 3.75115421035389*^9}, 
   3.751154409289606*^9, 3.751155063159431*^9, 3.7511551578703537`*^9, {
   3.751155631171876*^9, 3.7511556669733973`*^9}, 3.751156831153225*^9, {
   3.7511570444961233`*^9, 3.751157063011318*^9}, 3.7511573845757217`*^9, 
   3.7511576929574337`*^9, 3.751237248545403*^9, 3.75123731846103*^9, 
   3.751237558009218*^9, 3.75124126512782*^9, 3.751241341691312*^9, 
   3.7512414602930183`*^9, {3.7512415890389347`*^9, 3.751241614550478*^9}, 
   3.751243391757332*^9, {3.751243525864511*^9, 3.7512435473077707`*^9}, 
   3.7512436090180597`*^9, 3.751243754645124*^9, 3.751243860169832*^9, 
   3.751244182055914*^9, 3.751244399162704*^9, 3.751244486514542*^9, 
   3.751244523619996*^9, 3.7512445593242817`*^9, {3.751244640162719*^9, 
   3.7512446526642714`*^9}, 3.7512450693463917`*^9, 3.751245129916429*^9, 
   3.751245199944006*^9, 3.751245811673089*^9, 3.75124584198965*^9, 
   3.75124587430195*^9, {3.751247099662253*^9, 3.751247148020466*^9}, {
   3.751824169273649*^9, 3.751824200839072*^9}, 3.7518272988309402`*^9, 
   3.751859657137192*^9, 3.751861065917005*^9},
 CellLabel->"Out[100]//TableForm=",
 CellID->1614862815,ExpressionUUID->"f8a4b8f5-b915-432e-a3c5-6d04e887ab7a"]
}, Open  ]],

Cell["\<\
Linearize the state and output equations about operating point.\
\>", "Text",
 CellChangeTimes->{{3.7027577023090067`*^9, 3.7027577064193897`*^9}, {
  3.702757795179463*^9, 3.702757797848589*^9}, {3.702758517676444*^9, 
  3.702758517969734*^9}, {3.751157404122614*^9, 3.751157407793623*^9}},
 CellID->346694090,ExpressionUUID->"982154be-f21a-4e24-acc2-8113efb57b46"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"abe", "=", 
   RowBox[{"linearizeState", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "stateEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdf", "=", 
   RowBox[{"linearizeOutput", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"e", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"d", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"f", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<A = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<B = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<E = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<C = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<D = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<F = \>\"", ",", "#"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.7027439116175957`*^9, 3.702744033267743*^9}, {
   3.702744268313121*^9, 3.702744305447536*^9}, {3.702756777004896*^9, 
   3.70275678344866*^9}, {3.702756831990849*^9, 3.702756860110464*^9}, {
   3.702757530029274*^9, 3.702757693348208*^9}, {3.70275831097122*^9, 
   3.702758346655436*^9}, {3.702758404323063*^9, 3.7027584657658863`*^9}, {
   3.702759733356806*^9, 3.702760026609954*^9}, {3.70276007934348*^9, 
   3.702760085749899*^9}, {3.702760162502097*^9, 3.7027602713332367`*^9}, {
   3.7031743380777597`*^9, 3.703174365043808*^9}, {3.7032126025366993`*^9, 
   3.703212608677622*^9}, {3.7275822132423773`*^9, 3.727582355849462*^9}, 
   3.751154035567876*^9, {3.751157216290072*^9, 3.751157229742868*^9}, {
   3.751157416529111*^9, 3.751157421062249*^9}, {3.7511576066364393`*^9, 
   3.751157656881137*^9}, {3.7511577043529177`*^9, 3.7511577145152082`*^9}, {
   3.7512372971265383`*^9, 3.7512373336944847`*^9}, {3.751237381927462*^9, 
   3.751237410777441*^9}},
 CellLabel->"In[101]:=",
 CellID->764436319,ExpressionUUID->"faa4bdfd-089b-4706-a967-ecc50792eaf0"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["Km", "2"]}], "-", 
          RowBox[{"B", " ", "R"}]}], 
         RowBox[{"M", " ", "R"}]], 
        RowBox[{"-", 
         FractionBox["1", "M"]}]},
       {"k", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["A = ", 
   MatrixForm[{{$CellContext`M^(-1) $CellContext`R^(-1) (-$CellContext`Km^2 - \
$CellContext`B $CellContext`R), (-1)/$CellContext`M}, {$CellContext`k, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751245883802848*^9, 3.7512470997286158`*^9, 3.75124715551344*^9, {
   3.751824195810413*^9, 3.7518242009418716`*^9}, 3.751827298918947*^9, 
   3.751859657222745*^9, 3.751861066018854*^9},
 CellLabel->"During evaluation of In[101]:=",
 CellID->1101000919,ExpressionUUID->"d10fe061-b97c-4d60-bfcb-a9c22dc506d3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"B = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox["Km", 
          RowBox[{"M", " ", "R"}]]}], 
        FractionBox[
         RowBox[{
          SuperscriptBox["Km", "2"], "+", 
          RowBox[{"B", " ", "R"}]}], 
         RowBox[{"M", " ", "R"}]]},
       {"0", 
        RowBox[{"-", "k"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["B = ", 
   MatrixForm[{{-$CellContext`Km $CellContext`M^(-1)/$CellContext`R, \
$CellContext`M^(-1) $CellContext`R^(-1) ($CellContext`Km^2 + $CellContext`B \
$CellContext`R)}, {0, -$CellContext`k}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751245883802848*^9, 3.7512470997286158`*^9, 3.75124715551344*^9, {
   3.751824195810413*^9, 3.7518242009418716`*^9}, 3.751827298918947*^9, 
   3.751859657222745*^9, 3.751861066033033*^9},
 CellLabel->"During evaluation of In[101]:=",
 CellID->1803343081,ExpressionUUID->"588f4a84-6ee3-4154-adee-ea27d70fc0fd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"E = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "0"},
       {"0", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["E = ", 
   MatrixForm[{{0, 0}, {0, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751245883802848*^9, 3.7512470997286158`*^9, 3.75124715551344*^9, {
   3.751824195810413*^9, 3.7518242009418716`*^9}, 3.751827298918947*^9, 
   3.751859657222745*^9, 3.751861066043548*^9},
 CellLabel->"During evaluation of In[101]:=",
 CellID->1350452256,ExpressionUUID->"94ebd210-e04b-4e49-9d54-efe020247b9a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["Km", "2"]}], "-", 
          RowBox[{"B", " ", "R"}]}], "R"], 
        RowBox[{"-", "1"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{$CellContext`R^(-1) (-$CellContext`Km^2 - $CellContext`B \
$CellContext`R), -1}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751245883802848*^9, 3.7512470997286158`*^9, 3.75124715551344*^9, {
   3.751824195810413*^9, 3.7518242009418716`*^9}, 3.751827298918947*^9, 
   3.751859657222745*^9, 3.7518610660490427`*^9},
 CellLabel->"During evaluation of In[101]:=",
 CellID->296401449,ExpressionUUID->"ca1ddb40-a5bb-46c8-af76-9e7d9a98b4e6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox["Km", "R"]}], 
        FractionBox[
         RowBox[{
          SuperscriptBox["Km", "2"], "+", 
          RowBox[{"B", " ", "R"}]}], "R"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{-$CellContext`Km/$CellContext`R, $CellContext`R^(-1) \
($CellContext`Km^2 + $CellContext`B $CellContext`R)}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751245883802848*^9, 3.7512470997286158`*^9, 3.75124715551344*^9, {
   3.751824195810413*^9, 3.7518242009418716`*^9}, 3.751827298918947*^9, 
   3.751859657222745*^9, 3.7518610660544233`*^9},
 CellLabel->"During evaluation of In[101]:=",
 CellID->1604575950,ExpressionUUID->"21f94789-2397-4ba7-a5cf-ffdc991def39"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75124360906213*^9, 3.7512437547528667`*^9, 3.751243860273984*^9, 
   3.751244182134783*^9, 3.751244399232733*^9, 3.751244486581511*^9, 
   3.75124455936265*^9, 3.7512446402133417`*^9, 3.751244670741263*^9, 
   3.751245069381319*^9, 3.751245129946912*^9, 3.7512451999957867`*^9, 
   3.751245883802848*^9, 3.7512470997286158`*^9, 3.75124715551344*^9, {
   3.751824195810413*^9, 3.7518242009418716`*^9}, 3.751827298918947*^9, 
   3.751859657222745*^9, 3.751861066059636*^9},
 CellLabel->"During evaluation of In[101]:=",
 CellID->8352624,ExpressionUUID->"b288bcf5-c21a-4709-b2b2-7ea0e71fc7f3"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.7512470384575253`*^9, 3.751247039130054*^9}},
 CellID->807677320,ExpressionUUID->"0b3f267e-d304-4426-89b0-5e92d8bffbf9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.747505552707037*^9, {3.7475057578295593`*^9, 3.747505759222794*^9}, {
   3.747505842150148*^9, 3.7475058458319883`*^9}, {3.747505896191999*^9, 
   3.74750589728131*^9}, {3.748124150238531*^9, 3.748124150517943*^9}, 
   3.748169029221862*^9, 3.748173244647019*^9},
 CellLabel->"In[111]:=",
 CellID->243180492,ExpressionUUID->"986cba12-62c5-4cee-950d-50dcb55b6745"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SuperscriptBox["Km", "2"], "+", 
         RowBox[{"B", " ", "R"}]}], 
        RowBox[{"M", " ", "R"}]]}], ",", 
      RowBox[{"-", 
       FractionBox["1", "M"]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"k", ",", "0"}], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.747505555643032*^9, 3.7475055867312613`*^9}, {
   3.747505761476728*^9, 3.747505764318122*^9}, {3.747505847665118*^9, 
   3.7475058502692757`*^9}, {3.747505898843794*^9, 3.74750590124069*^9}, {
   3.7475063255823507`*^9, 3.747506334276267*^9}, {3.7481241530496283`*^9, 
   3.748124156712919*^9}, 3.7481690353265944`*^9, {3.748169641556839*^9, 
   3.748169730141844*^9}, {3.7481706308795347`*^9, 3.748170648343268*^9}, {
   3.7481713324991817`*^9, 3.748171412017522*^9}, {3.7481722117935038`*^9, 
   3.748172266534639*^9}, {3.748172557215331*^9, 3.748172586783577*^9}, 
   3.748172811167288*^9, {3.748173455617723*^9, 3.748173456202003*^9}, {
   3.748173684193961*^9, 3.7481736910145693`*^9}},
 CellID->1032740090,ExpressionUUID->"ea8c1a94-61dd-4808-a6a0-c45d57f56dbb"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", \
FractionBox[RowBox[{SuperscriptBox[RowBox[{\\\"\[LeftSkeleton]\\\", \
\\\"2\\\", \\\"\[RightSkeleton]\\\"}], \\\"2\\\"], \\\"+\\\", RowBox[{\\\"\
\[LeftSkeleton]\\\", \\\"1\\\", \\\"\[RightSkeleton]\\\"}]}], RowBox[{\\\"M\\\
\", \\\" \\\", \\\"R\\\"}]]}], \\\",\\\", RowBox[{\\\"-\\\", \
FractionBox[\\\"1\\\", \\\"M\\\"]}]}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"k\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}]}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[RowBox[{SuperscriptBox[RowBox[{\"\
\[LeftSkeleton]\", \"2\", \"\[RightSkeleton]\"}], \"2\"], \"+\", RowBox[{\"\
\[LeftSkeleton]\", \"1\", \"\[RightSkeleton]\"}]}], RowBox[{\"M\", \" \", \"R\
\"}]]}], \",\", RowBox[{\"-\", FractionBox[\"1\", \"M\"]}]}], \"}\"}], \",\", \
RowBox[{\"{\", RowBox[{\"k\", \",\", \"0\"}], \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", \
FractionBox[RowBox[{SuperscriptBox[RowBox[{\\\"\[LeftSkeleton]\\\", \
\\\"2\\\", \\\"\[RightSkeleton]\\\"}], \\\"2\\\"], \\\"+\\\", RowBox[{\\\"\
\[LeftSkeleton]\\\", \\\"1\\\", \\\"\[RightSkeleton]\\\"}]}], RowBox[{\\\"M\\\
\", \\\" \\\", \\\"R\\\"}]]}], \\\",\\\", RowBox[{\\\"-\\\", \
FractionBox[\\\"1\\\", \\\"M\\\"]}]}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"k\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}]}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[RowBox[{SuperscriptBox[RowBox[{\"\
\[LeftSkeleton]\", \"2\", \"\[RightSkeleton]\"}], \"2\"], \"+\", RowBox[{\"\
\[LeftSkeleton]\", \"1\", \"\[RightSkeleton]\"}]}], RowBox[{\"M\", \" \", \"R\
\"}]]}], \",\", RowBox[{\"-\", FractionBox[\"1\", \"M\"]}]}], \"}\"}], \",\", \
RowBox[{\"{\", RowBox[{\"k\", \",\", \"0\"}], \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00166999999999895`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00166999999999895`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->796114513,ExpressionUUID->"3a1de372-1af3-4887-bb7e-53220dfd2d16"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1473499181,ExpressionUUID->"e7320cf5-5f0f-48a7-a645-ec042480d550"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.748169118881194*^9, {3.748173109584269*^9, 3.748173111317824*^9}},
 CellLabel->"In[112]:=",
 CellID->793943167,ExpressionUUID->"f0ce0e58-52af-4a91-a311-f164f6743198"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      FractionBox[
       RowBox[{"-", "Km"}], 
       RowBox[{"M", " ", "R"}]], ",", 
      FractionBox[
       RowBox[{
        SuperscriptBox["Km", "2"], "+", 
        RowBox[{"B", " ", "R"}]}], 
       RowBox[{"M", " ", "R"}]]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"0", ",", " ", 
      RowBox[{"-", "k"}]}], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169152633688*^9, 3.748169166417688*^9}, 
   3.74816961437001*^9, {3.748169735895432*^9, 3.74816976416591*^9}, {
   3.7481714534342337`*^9, 3.748171524401494*^9}, {3.748172277994993*^9, 
   3.748172388840468*^9}, {3.748173070786932*^9, 3.7481730730294323`*^9}, {
   3.748173117430595*^9, 3.7481731307454023`*^9}, {3.748173458595439*^9, 
   3.74817345887745*^9}, {3.748173695194269*^9, 3.748173699950642*^9}},
 CellID->942693365,ExpressionUUID->"46c8a590-9e7a-4095-abfd-fe8081bd21d0"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"Km\\\", \
RowBox[{\\\"M\\\", \\\" \\\", \\\"R\\\"}]]}], \\\",\\\", \
FractionBox[RowBox[{RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\
\[RightSkeleton]\\\"}], \\\"+\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \
\\\"1\\\", \\\"\[RightSkeleton]\\\"}]}], RowBox[{\\\"M\\\", \\\" \\\", \
\\\"R\\\"}]]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \
\\\",\\\", RowBox[{\\\"-\\\", \\\"k\\\"}]}], \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"Km\", RowBox[{\"M\", \" \", \"R\"}]]}], \
\",\", FractionBox[RowBox[{RowBox[{\"\[LeftSkeleton]\", \"1\", \"\
\[RightSkeleton]\"}], \"+\", RowBox[{\"\[LeftSkeleton]\", \"1\", \"\
\[RightSkeleton]\"}]}], RowBox[{\"M\", \" \", \"R\"}]]}], \"}\"}], \",\", \
RowBox[{\"{\", RowBox[{\"0\", \",\", RowBox[{\"-\", \"k\"}]}], \"}\"}]}], \"}\
\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"Km\\\", \
RowBox[{\\\"M\\\", \\\" \\\", \\\"R\\\"}]]}], \\\",\\\", \
FractionBox[RowBox[{RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\
\[RightSkeleton]\\\"}], \\\"+\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \
\\\"1\\\", \\\"\[RightSkeleton]\\\"}]}], RowBox[{\\\"M\\\", \\\" \\\", \
\\\"R\\\"}]]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \
\\\",\\\", RowBox[{\\\"-\\\", \\\"k\\\"}]}], \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"Km\", RowBox[{\"M\", \" \", \"R\"}]]}], \
\",\", FractionBox[RowBox[{RowBox[{\"\[LeftSkeleton]\", \"1\", \"\
\[RightSkeleton]\"}], \"+\", RowBox[{\"\[LeftSkeleton]\", \"1\", \"\
\[RightSkeleton]\"}]}], RowBox[{\"M\", \" \", \"R\"}]]}], \"}\"}], \",\", \
RowBox[{\"{\", RowBox[{\"0\", \",\", RowBox[{\"-\", \"k\"}]}], \"}\"}]}], \"}\
\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0012319999999998998`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0012319999999998998`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->319317863,ExpressionUUID->"da2fd692-84f0-41c6-a405-f0777ebdd8a3"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->213689588,ExpressionUUID->"74bac65f-2154-427a-917e-f63c545f8052"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169171923123*^9, 3.748173146603053*^9},
 CellLabel->"In[113]:=",
 CellID->1656134055,ExpressionUUID->"10200a55-b1c2-49cd-a929-934a912d075b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["Km", "2"]}], "-", 
       RowBox[{"B", " ", "R"}]}], "R"], ",", 
     RowBox[{"-", "1"}]}], "}"}], "}"}], "//", "Simplify"}]], "ExpectedOutput",\

 CellChangeTimes->{{3.7481691806324472`*^9, 3.748169184126515*^9}, {
   3.7481697745097303`*^9, 3.7481698177840567`*^9}, 3.748170212558292*^9, {
   3.74817153653963*^9, 3.748171557948637*^9}, {3.748172403638979*^9, 
   3.748172459180491*^9}, 3.748173461553569*^9},
 CellID->525944430,ExpressionUUID->"17869727-2f0a-4cf1-ac75-4fb1b1c61d36"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", \
FractionBox[RowBox[{SuperscriptBox[\\\"Km\\\", \\\"2\\\"], \\\"+\\\", \
RowBox[{\\\"B\\\", \\\" \\\", \\\"R\\\"}]}], \\\"R\\\"]}], \\\",\\\", \
RowBox[{\\\"-\\\", \\\"1\\\"}]}], \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{RowBox[{\"-\", \
FractionBox[RowBox[{SuperscriptBox[\"Km\", \"2\"], \"+\", RowBox[{\"B\", \" \
\", \"R\"}]}], \"R\"]}], \",\", RowBox[{\"-\", \"1\"}]}], \"}\"}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", \
FractionBox[RowBox[{SuperscriptBox[\\\"Km\\\", \\\"2\\\"], \\\"+\\\", \
RowBox[{\\\"B\\\", \\\" \\\", \\\"R\\\"}]}], \\\"R\\\"]}], \\\",\\\", \
RowBox[{\\\"-\\\", \\\"1\\\"}]}], \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{RowBox[{\"-\", \
FractionBox[RowBox[{SuperscriptBox[\"Km\", \"2\"], \"+\", RowBox[{\"B\", \" \
\", \"R\"}]}], \"R\"]}], \",\", RowBox[{\"-\", \"1\"}]}], \"}\"}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0011679999999998358`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0011679999999998358`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->888247732,ExpressionUUID->"6feaf8e1-a973-4c4a-b2ab-964259e1e129"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1620801427,ExpressionUUID->"73fd4021-e9a1-43e3-beb8-2b2887a39951"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169187965559*^9, 3.748173150905864*^9},
 CellLabel->"In[114]:=",
 CellID->986467167,ExpressionUUID->"268483ea-b266-496d-8f85-370d4b254cae"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      RowBox[{"-", "Km"}], "R"], ",", 
     FractionBox[
      RowBox[{
       SuperscriptBox["Km", "2"], "+", 
       RowBox[{"B", " ", "R"}]}], "R"]}], "}"}], "}"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169193927287*^9, 3.748169194789258*^9}, {
   3.748169826851533*^9, 3.7481698714627047`*^9}, {3.748171572452416*^9, 
   3.748171580237145*^9}, {3.748172509134172*^9, 3.7481725445555677`*^9}, {
   3.748172960660345*^9, 3.7481729614507627`*^9}, 3.7481734650745153`*^9},
 CellID->832557140,ExpressionUUID->"7d1f0534-6577-45f0-8909-b7df02087b3d"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"Km\\\", \\\"R\\\
\"]}], \\\",\\\", RowBox[{\\\"B\\\", \\\"+\\\", FractionBox[SuperscriptBox[\\\
\"Km\\\", \\\"2\\\"], \\\"R\\\"]}]}], \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{RowBox[{\"-\", \
FractionBox[\"Km\", \"R\"]}], \",\", RowBox[{\"B\", \"+\", \
FractionBox[SuperscriptBox[\"Km\", \"2\"], \"R\"]}]}], \"}\"}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"Km\\\", \\\"R\\\
\"]}], \\\",\\\", RowBox[{\\\"B\\\", \\\"+\\\", FractionBox[SuperscriptBox[\\\
\"Km\\\", \\\"2\\\"], \\\"R\\\"]}]}], \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{RowBox[{\"-\", \
FractionBox[\"Km\", \"R\"]}], \",\", RowBox[{\"B\", \"+\", \
FractionBox[SuperscriptBox[\"Km\", \"2\"], \"R\"]}]}], \"}\"}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0016449999999998965`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0016449999999998965`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->2127005041,ExpressionUUID->"01df7196-0407-4d9e-b821-0174413f8951"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1560936125,ExpressionUUID->"e01c06da-862d-4e14-a0ec-77019a97fd09"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"e", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.74816921143508*^9, 3.74817315251501*^9},
 CellLabel->"In[115]:=",
 CellID->41001967,ExpressionUUID->"2b59b02a-909e-4c49-9978-dc8b1b84186d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "b", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692120543423`*^9, 3.748169217153222*^9}, 
   3.748169620186891*^9, {3.7481699674394503`*^9, 3.7481699868030443`*^9}, 
   3.748173467456937*^9},
 CellID->316979101,ExpressionUUID->"78224247-9509-4a3d-978c-c03c0b980695"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\
\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"0\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"0\", \
\",\", \"0\"}], \"}\"}], \",\", RowBox[{\"{\", RowBox[{\"0\", \",\", \"0\"}], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\
\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"0\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"0\", \
\",\", \"0\"}], \"}\"}], \",\", RowBox[{\"{\", RowBox[{\"0\", \",\", \"0\"}], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001619999999995514`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001619999999995514`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->993221123,ExpressionUUID->"aedb21f3-904f-4908-9814-8e89af0a2527"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->677026130,ExpressionUUID->"c9e728f1-8711-4dc3-a657-fb714c045c1d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169221684237*^9, 3.7481731563003674`*^9},
 CellLabel->"In[116]:=",
 CellID->1221270702,ExpressionUUID->"f09a933f-9e3b-4ebd-9390-b4b00828e5ad"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "d", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692270490217`*^9, 3.748169230838327*^9}, {
   3.748169991971572*^9, 3.748170004254684*^9}, 3.748173469973262*^9},
 CellID->1856114390,ExpressionUUID->"3cbb3d8a-593f-4d44-8286-2300d7c34d06"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\
\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"0\", \",\", \
\"0\"}], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\
\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"0\", \",\", \
\"0\"}], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015299999999918157`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015299999999918157`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1409805104,ExpressionUUID->"4f640f3f-9ba1-4480-8028-805a26933e9d"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1407305577,ExpressionUUID->"34f33b04-5bee-48f6-b3c8-8343131e4b91"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Test System 4", "Section",
 CellChangeTimes->{{3.7481692698005457`*^9, 3.748169273381559*^9}, 
   3.7481693114624357`*^9, {3.748169361271824*^9, 3.748169361361087*^9}, {
   3.748170308281064*^9, 3.7481703083633633`*^9}, {3.748171876095627*^9, 
   3.748171876178361*^9}, {3.748173822514773*^9, 3.748173822575068*^9}},
 CellID->463695855,ExpressionUUID->"73583882-eaeb-44c5-80ca-351ef5f46205"],

Cell[CellGroupData[{

Cell["System model", "Subsection",
 CellChangeTimes->{{3.751247220688859*^9, 3.751247222137885*^9}},
 CellID->1719208034,ExpressionUUID->"91760916-3696-437d-82e3-fd3e9f13ca1e"],

Cell["Garbini\[CloseCurlyQuote]s Test Suite ME 471 Problem", "Text",
 CellChangeTimes->{{3.748169314267838*^9, 3.748169333731399*^9}, {
  3.748169368971754*^9, 3.748169377466568*^9}, {3.74817032089456*^9, 
  3.748170327324637*^9}, {3.748171903869137*^9, 3.748171911436009*^9}, {
  3.748173840454677*^9, 3.748173847774159*^9}},
 CellID->35029913,ExpressionUUID->"60a2751e-8ce9-49cf-8ef0-4d9d71c61bb5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"vs", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primaryVars", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"oJ", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"tK", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"iR", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"v1", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"t2", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outExps", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tK", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"oJ", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"elementalEqs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"oJ", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"tJ", "[", "t", "]"}], "/", "J"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"tK", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{"k", " ", 
       RowBox[{"oK", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"iR", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vR", "[", "t", "]"}], "/", "R"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"v1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"Km", " ", 
       RowBox[{"o2", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"t2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", "Km"}], " ", 
       RowBox[{"i1", "[", "t", "]"}]}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"constraintEqs", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"tJ", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"t2", "[", "t", "]"}]}], "-", 
       RowBox[{"tK", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"oK", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"oJ", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vR", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vs", "[", "t", "]"}], "-", 
       RowBox[{"v1", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"o2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"oJ", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"i1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"iR", "[", "t", "]"}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.747499218184157*^9, 3.74749931067735*^9}, {
   3.7474997703057547`*^9, 3.747499862953096*^9}, {3.7475000427164516`*^9, 
   3.7475001179609213`*^9}, 3.747500172506531*^9, {3.7475052421578627`*^9, 
   3.7475052437525806`*^9}, {3.7475052792870703`*^9, 3.747505305743517*^9}, {
   3.7475054395550127`*^9, 3.74750549238805*^9}, {3.748169383980278*^9, 
   3.748169603265369*^9}, {3.748170115690106*^9, 3.748170132266461*^9}, {
   3.748170333165715*^9, 3.7481705921461983`*^9}, {3.748171917577342*^9, 
   3.74817195326005*^9}, {3.748171995123074*^9, 3.7481720024895773`*^9}, {
   3.748172035662871*^9, 3.7481721909688787`*^9}, {3.748173852472159*^9, 
   3.7481740097196913`*^9}, {3.75124722602767*^9, 3.751247360919095*^9}, {
   3.751824524917959*^9, 3.751824583437105*^9}},
 CellLabel->"In[117]:=",
 CellID->132546791,ExpressionUUID->"a77a8b0f-d451-4889-8878-97822df72689"],

Cell["Find state equation.", "Text",
 CellChangeTimes->{{3.702757751780126*^9, 3.7027577578425713`*^9}, {
  3.702757790122506*^9, 3.7027577915609007`*^9}, {3.727581684624194*^9, 
  3.727581686707095*^9}},
 CellID->931588782,ExpressionUUID->"96eef973-ae4e-4c05-b81a-9dcdcbab25cb"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stateSolution", "=", 
   RowBox[{
    RowBox[{"stateEquations", "[", 
     RowBox[{
     "inVars", ",", "primaryVars", ",", "elementalEqs", ",", 
      "constraintEqs"}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateVars", " ", "=", " ", 
   RowBox[{"\"\<state variables\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateEqList", " ", "=", " ", 
   RowBox[{"\"\<RHS\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\"\<state equations\>\"", "/.", "stateSolution"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.7018797195836763`*^9, 3.7018797204767036`*^9}, {
   3.701879810803969*^9, 3.701879844544981*^9}, {3.7018942050184517`*^9, 
   3.701894566874161*^9}, 3.701898020551093*^9, {3.701903282327601*^9, 
   3.701903283500523*^9}, {3.701911200698804*^9, 3.701911202601316*^9}, {
   3.701915682054678*^9, 3.701915720675168*^9}, {3.701915759772274*^9, 
   3.7019157927706213`*^9}, {3.701915923602686*^9, 3.701915923900078*^9}, 
   3.7019209193048553`*^9, 3.701920950145496*^9, {3.701921306764739*^9, 
   3.701921308673313*^9}, {3.701921408184596*^9, 3.7019214156809187`*^9}, 
   3.7019220747800493`*^9, {3.701922189786292*^9, 3.701922218088579*^9}, {
   3.701922248592429*^9, 3.701922251876824*^9}, 3.701922322852202*^9, {
   3.701922383801173*^9, 3.7019224315654707`*^9}, {3.701922463501308*^9, 
   3.7019224895050097`*^9}, 3.7019225472984467`*^9, {3.701922594846767*^9, 
   3.701922598092758*^9}, {3.701922662563005*^9, 3.701922735877761*^9}, {
   3.7019231046383343`*^9, 3.701923105684675*^9}, {3.7019639715923243`*^9, 
   3.7019639718841667`*^9}, {3.7019642654040737`*^9, 3.701964352167139*^9}, {
   3.701964387110903*^9, 3.7019644147887087`*^9}, {3.702757419429731*^9, 
   3.7027575039883213`*^9}, {3.7511302149210863`*^9, 3.751130222225973*^9}, 
   3.751131245052647*^9, 3.7518224212768917`*^9, 3.7518595720130587`*^9, 
   3.7518599623889027`*^9, 3.7518609918778057`*^9, 3.751937452738615*^9},
 CellID->1061798999,ExpressionUUID->"a8b3f72a-c41c-499b-85c4-a41282d890bb"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["oJ", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["Km", "2"], " ", 
          RowBox[{"oJ", "[", "t", "]"}]}], 
         RowBox[{"J", " ", "R"}]]}], "-", 
       FractionBox[
        RowBox[{"tK", "[", "t", "]"}], "J"], "+", 
       FractionBox[
        RowBox[{"Km", " ", 
         RowBox[{"vs", "[", "t", "]"}]}], 
        RowBox[{"J", " ", "R"}]]}]}]},
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["tK", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{"k", " ", 
       RowBox[{"oJ", "[", "t", "]"}]}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751131246142264*^9, 3.751131562228766*^9, 3.751154207578877*^9, 
   3.751155061538066*^9, 3.7511551539969883`*^9, 3.7511556539137783`*^9, 
   3.751156830900199*^9, 3.751157044451893*^9, 3.751157305712584*^9, 
   3.751157692923893*^9, 3.751237248504381*^9, 3.7512373121455393`*^9, 
   3.751237557961287*^9, {3.7512412411479073`*^9, 3.751241257691305*^9}, 
   3.7512413334070673`*^9, 3.751241455823284*^9, 3.751241611586341*^9, 
   3.7512433878599854`*^9, 3.751243524307231*^9, 3.751243608962484*^9, 
   3.7512437545853853`*^9, 3.751243860047454*^9, 3.7512441819725847`*^9, 
   3.751244399097206*^9, 3.751244486437664*^9, 3.75124455927641*^9, 
   3.75124464012558*^9, 3.75124506931707*^9, 3.751245129883816*^9, 
   3.751245199900049*^9, 3.751245786492696*^9, 3.7512458405736723`*^9, 
   3.751245872204157*^9, {3.7512470996055098`*^9, 3.751247133340377*^9}, 
   3.751822506215632*^9, {3.751822707767754*^9, 3.751822723484655*^9}, 
   3.751822800835991*^9, 3.7518235244045973`*^9, 3.751823574246002*^9, 
   3.75182394710122*^9, 3.751824050485718*^9, {3.751824086094249*^9, 
   3.7518241542062597`*^9}, 3.751824200734988*^9, {3.75182459292976*^9, 
   3.751824605529318*^9}, 3.751827326967689*^9, 3.751859665866448*^9, 
   3.751861084416471*^9},
 CellLabel->"Out[125]//TableForm=",
 CellID->199944581,ExpressionUUID->"19847368-8d31-4693-af0e-573845131ae5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"outEqList", "=", 
   RowBox[{"outEquations", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outExps", ",", 
     RowBox[{"elementalEqs", "~", "Join", "~", "constraintEqs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outEqList", "//", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"y", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "outExps", "]"}]}], "}"}]}], "]"}], 
      "\[Equal]", "#"}], "]"}], "&"}]}], "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.75115407229806*^9, 3.7511540907068577`*^9}, {
   3.7511541283727303`*^9, 3.751154145140655*^9}, {3.751154185947949*^9, 
   3.751154186454541*^9}, {3.75115440553708*^9, 3.751154408241644*^9}, {
   3.751157061478198*^9, 3.75115706228808*^9}, {3.751157258647379*^9, 
   3.751157263470278*^9}, {3.751157318329653*^9, 3.751157382599204*^9}, 
   3.751243546881419*^9, 3.7512446518094807`*^9, {3.7518241789029417`*^9, 
   3.751824190813037*^9}},
 CellLabel->"In[126]:=",
 CellID->1677373674,ExpressionUUID->"67498dd3-7708-457d-8a49-12b76158b7cc"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{"y", "[", "1", "]"}], "\[Equal]", 
       RowBox[{"tK", "[", "t", "]"}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "2", "]"}], "\[Equal]", 
       RowBox[{"oJ", "[", "t", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751154146341402*^9, {3.7511541874520807`*^9, 3.75115421035389*^9}, 
   3.751154409289606*^9, 3.751155063159431*^9, 3.7511551578703537`*^9, {
   3.751155631171876*^9, 3.7511556669733973`*^9}, 3.751156831153225*^9, {
   3.7511570444961233`*^9, 3.751157063011318*^9}, 3.7511573845757217`*^9, 
   3.7511576929574337`*^9, 3.751237248545403*^9, 3.75123731846103*^9, 
   3.751237558009218*^9, 3.75124126512782*^9, 3.751241341691312*^9, 
   3.7512414602930183`*^9, {3.7512415890389347`*^9, 3.751241614550478*^9}, 
   3.751243391757332*^9, {3.751243525864511*^9, 3.7512435473077707`*^9}, 
   3.7512436090180597`*^9, 3.751243754645124*^9, 3.751243860169832*^9, 
   3.751244182055914*^9, 3.751244399162704*^9, 3.751244486514542*^9, 
   3.751244523619996*^9, 3.7512445593242817`*^9, {3.751244640162719*^9, 
   3.7512446526642714`*^9}, 3.7512450693463917`*^9, 3.751245129916429*^9, 
   3.751245199944006*^9, 3.751245811673089*^9, 3.75124584198965*^9, 
   3.75124587430195*^9, {3.751247099662253*^9, 3.751247148020466*^9}, {
   3.751824169273649*^9, 3.751824200839072*^9}, {3.75182459943651*^9, 
   3.751824605625972*^9}, 3.751827327107465*^9, 3.751859665951426*^9, 
   3.751861084498328*^9},
 CellLabel->"Out[127]//TableForm=",
 CellID->1804148959,ExpressionUUID->"bddfdb66-f90f-4ad3-a554-0530adab07a1"]
}, Open  ]],

Cell["\<\
Linearize the state and output equations about operating point.\
\>", "Text",
 CellChangeTimes->{{3.7027577023090067`*^9, 3.7027577064193897`*^9}, {
  3.702757795179463*^9, 3.702757797848589*^9}, {3.702758517676444*^9, 
  3.702758517969734*^9}, {3.751157404122614*^9, 3.751157407793623*^9}},
 CellID->1697172553,ExpressionUUID->"8f345be9-ee88-42d4-84d6-67a45c200444"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"abe", "=", 
   RowBox[{"linearizeState", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "stateEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdf", "=", 
   RowBox[{"linearizeOutput", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"e", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"d", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"f", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<A = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<B = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<E = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<C = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<D = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<F = \>\"", ",", "#"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.7027439116175957`*^9, 3.702744033267743*^9}, {
   3.702744268313121*^9, 3.702744305447536*^9}, {3.702756777004896*^9, 
   3.70275678344866*^9}, {3.702756831990849*^9, 3.702756860110464*^9}, {
   3.702757530029274*^9, 3.702757693348208*^9}, {3.70275831097122*^9, 
   3.702758346655436*^9}, {3.702758404323063*^9, 3.7027584657658863`*^9}, {
   3.702759733356806*^9, 3.702760026609954*^9}, {3.70276007934348*^9, 
   3.702760085749899*^9}, {3.702760162502097*^9, 3.7027602713332367`*^9}, {
   3.7031743380777597`*^9, 3.703174365043808*^9}, {3.7032126025366993`*^9, 
   3.703212608677622*^9}, {3.7275822132423773`*^9, 3.727582355849462*^9}, 
   3.751154035567876*^9, {3.751157216290072*^9, 3.751157229742868*^9}, {
   3.751157416529111*^9, 3.751157421062249*^9}, {3.7511576066364393`*^9, 
   3.751157656881137*^9}, {3.7511577043529177`*^9, 3.7511577145152082`*^9}, {
   3.7512372971265383`*^9, 3.7512373336944847`*^9}, {3.751237381927462*^9, 
   3.751237410777441*^9}},
 CellLabel->"In[128]:=",
 CellID->1501298817,ExpressionUUID->"230f82eb-1f21-444e-a14f-39daa0e99d3e"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox[
          SuperscriptBox["Km", "2"], 
          RowBox[{"J", " ", "R"}]]}], 
        RowBox[{"-", 
         FractionBox["1", "J"]}]},
       {"k", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["A = ", 
   MatrixForm[{{-$CellContext`J^(-1) $CellContext`Km^2/$CellContext`R, \
(-1)/$CellContext`J}, {$CellContext`k, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.75124360906213*^9, 3.7512437547528667`*^9, 
  3.751243860273984*^9, 3.751244182134783*^9, 3.751244399232733*^9, 
  3.751244486581511*^9, 3.75124455936265*^9, 3.7512446402133417`*^9, 
  3.751244670741263*^9, 3.751245069381319*^9, 3.751245129946912*^9, 
  3.7512451999957867`*^9, 3.751245883802848*^9, 3.7512470997286158`*^9, 
  3.75124715551344*^9, 3.7512474425075607`*^9, 3.7518246057256308`*^9, 
  3.751827327235841*^9, 3.751859666053739*^9, 3.7518610846024427`*^9},
 CellLabel->"During evaluation of In[128]:=",
 CellID->2009941920,ExpressionUUID->"31b6736c-17ed-418a-ba64-ea0a18658057"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"B = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["Km", 
         RowBox[{"J", " ", "R"}]]},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["B = ", 
   MatrixForm[{{$CellContext`J^(-1) $CellContext`Km/$CellContext`R}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.75124360906213*^9, 3.7512437547528667`*^9, 
  3.751243860273984*^9, 3.751244182134783*^9, 3.751244399232733*^9, 
  3.751244486581511*^9, 3.75124455936265*^9, 3.7512446402133417`*^9, 
  3.751244670741263*^9, 3.751245069381319*^9, 3.751245129946912*^9, 
  3.7512451999957867`*^9, 3.751245883802848*^9, 3.7512470997286158`*^9, 
  3.75124715551344*^9, 3.7512474425075607`*^9, 3.7518246057256308`*^9, 
  3.751827327235841*^9, 3.751859666053739*^9, 3.751861084617572*^9},
 CellLabel->"During evaluation of In[128]:=",
 CellID->1176082130,ExpressionUUID->"aa977b27-a8f3-484d-8b3e-7655fad3378e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"E = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["E = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.75124360906213*^9, 3.7512437547528667`*^9, 
  3.751243860273984*^9, 3.751244182134783*^9, 3.751244399232733*^9, 
  3.751244486581511*^9, 3.75124455936265*^9, 3.7512446402133417`*^9, 
  3.751244670741263*^9, 3.751245069381319*^9, 3.751245129946912*^9, 
  3.7512451999957867`*^9, 3.751245883802848*^9, 3.7512470997286158`*^9, 
  3.75124715551344*^9, 3.7512474425075607`*^9, 3.7518246057256308`*^9, 
  3.751827327235841*^9, 3.751859666053739*^9, 3.751861084628607*^9},
 CellLabel->"During evaluation of In[128]:=",
 CellID->972871922,ExpressionUUID->"e1ce394e-9466-45c9-8f08-6716753505fd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "1"},
       {"1", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{0, 1}, {1, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.75124360906213*^9, 3.7512437547528667`*^9, 
  3.751243860273984*^9, 3.751244182134783*^9, 3.751244399232733*^9, 
  3.751244486581511*^9, 3.75124455936265*^9, 3.7512446402133417`*^9, 
  3.751244670741263*^9, 3.751245069381319*^9, 3.751245129946912*^9, 
  3.7512451999957867`*^9, 3.751245883802848*^9, 3.7512470997286158`*^9, 
  3.75124715551344*^9, 3.7512474425075607`*^9, 3.7518246057256308`*^9, 
  3.751827327235841*^9, 3.751859666053739*^9, 3.751861084633986*^9},
 CellLabel->"During evaluation of In[128]:=",
 CellID->117904796,ExpressionUUID->"a18b9dbf-7e4a-4d2d-9f0f-5c971ebe43f3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.75124360906213*^9, 3.7512437547528667`*^9, 
  3.751243860273984*^9, 3.751244182134783*^9, 3.751244399232733*^9, 
  3.751244486581511*^9, 3.75124455936265*^9, 3.7512446402133417`*^9, 
  3.751244670741263*^9, 3.751245069381319*^9, 3.751245129946912*^9, 
  3.7512451999957867`*^9, 3.751245883802848*^9, 3.7512470997286158`*^9, 
  3.75124715551344*^9, 3.7512474425075607`*^9, 3.7518246057256308`*^9, 
  3.751827327235841*^9, 3.751859666053739*^9, 3.751861084639291*^9},
 CellLabel->"During evaluation of In[128]:=",
 CellID->1645983838,ExpressionUUID->"d2eb88a5-e64d-441a-8023-999cb9ec3633"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.75124360906213*^9, 3.7512437547528667`*^9, 
  3.751243860273984*^9, 3.751244182134783*^9, 3.751244399232733*^9, 
  3.751244486581511*^9, 3.75124455936265*^9, 3.7512446402133417`*^9, 
  3.751244670741263*^9, 3.751245069381319*^9, 3.751245129946912*^9, 
  3.7512451999957867`*^9, 3.751245883802848*^9, 3.7512470997286158`*^9, 
  3.75124715551344*^9, 3.7512474425075607`*^9, 3.7518246057256308`*^9, 
  3.751827327235841*^9, 3.751859666053739*^9, 3.751861084644679*^9},
 CellLabel->"During evaluation of In[128]:=",
 CellID->166024612,ExpressionUUID->"09750b18-e696-4667-a904-d394ad777892"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.751247349951558*^9, 3.751247350614678*^9}},
 CellID->197977086,ExpressionUUID->"b9988d23-a6a4-4119-9e6b-077f1da10edb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.747505552707037*^9, {3.7475057578295593`*^9, 3.747505759222794*^9}, {
   3.747505842150148*^9, 3.7475058458319883`*^9}, {3.747505896191999*^9, 
   3.74750589728131*^9}, {3.748124150238531*^9, 3.748124150517943*^9}, 
   3.748169029221862*^9, 3.748173244647019*^9},
 CellLabel->"In[138]:=",
 CellID->1659838998,ExpressionUUID->"68152773-6370-46a9-9577-5d604805972e"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        SuperscriptBox["Km", "2"], 
        RowBox[{"J", " ", "R"}]]}], ",", 
      RowBox[{"-", 
       FractionBox["1", "J"]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"k", ",", "0"}], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.747505555643032*^9, 3.7475055867312613`*^9}, {
   3.747505761476728*^9, 3.747505764318122*^9}, {3.747505847665118*^9, 
   3.7475058502692757`*^9}, {3.747505898843794*^9, 3.74750590124069*^9}, {
   3.7475063255823507`*^9, 3.747506334276267*^9}, {3.7481241530496283`*^9, 
   3.748124156712919*^9}, 3.7481690353265944`*^9, {3.748169641556839*^9, 
   3.748169730141844*^9}, {3.7481706308795347`*^9, 3.748170648343268*^9}, {
   3.7481713324991817`*^9, 3.748171412017522*^9}, {3.7481722117935038`*^9, 
   3.748172266534639*^9}, {3.748172557215331*^9, 3.748172586783577*^9}, 
   3.748172811167288*^9, {3.748173455617723*^9, 3.748173456202003*^9}, {
   3.748173684193961*^9, 3.7481736910145693`*^9}, {3.748174023178488*^9, 
   3.748174074694357*^9}},
 CellID->2035920903,ExpressionUUID->"955d2db3-5d56-45cb-a1e5-f560fe0857e6"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", \
FractionBox[SuperscriptBox[\\\"Km\\\", \\\"2\\\"], RowBox[{\\\"J\\\", \\\" \\\
\", \\\"R\\\"}]]}], \\\",\\\", RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \
\\\"J\\\"]}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"k\\\", \
\\\",\\\", \\\"0\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[SuperscriptBox[\"Km\", \"2\"], RowBox[{\"J\
\", \" \", \"R\"}]]}], \",\", RowBox[{\"-\", FractionBox[\"1\", \"J\"]}]}], \
\"}\"}], \",\", RowBox[{\"{\", RowBox[{\"k\", \",\", \"0\"}], \"}\"}]}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", \
FractionBox[SuperscriptBox[\\\"Km\\\", \\\"2\\\"], RowBox[{\\\"J\\\", \\\" \\\
\", \\\"R\\\"}]]}], \\\",\\\", RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \
\\\"J\\\"]}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"k\\\", \
\\\",\\\", \\\"0\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[SuperscriptBox[\"Km\", \"2\"], RowBox[{\"J\
\", \" \", \"R\"}]]}], \",\", RowBox[{\"-\", FractionBox[\"1\", \"J\"]}]}], \
\"}\"}], \",\", RowBox[{\"{\", RowBox[{\"k\", \",\", \"0\"}], \"}\"}]}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0006140000000005585`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0006140000000005585`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->794396431,ExpressionUUID->"7cc285e7-2137-4b8e-beb0-afccc3e237bd"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->514982418,ExpressionUUID->"244dcb19-1fd3-40a4-b31f-8f26fac67cce"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.748169118881194*^9, {3.748173109584269*^9, 3.748173111317824*^9}},
 CellLabel->"In[139]:=",
 CellID->240770846,ExpressionUUID->"9e8df048-ac93-41b8-b4f9-ea0a09c93d94"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     FractionBox["Km", 
      RowBox[{"J", " ", "R"}]], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169152633688*^9, 3.748169166417688*^9}, 
   3.74816961437001*^9, {3.748169735895432*^9, 3.74816976416591*^9}, {
   3.7481714534342337`*^9, 3.748171524401494*^9}, {3.748172277994993*^9, 
   3.748172388840468*^9}, {3.748173070786932*^9, 3.7481730730294323`*^9}, {
   3.748173117430595*^9, 3.7481731307454023`*^9}, {3.748173458595439*^9, 
   3.74817345887745*^9}, {3.748173695194269*^9, 3.748173699950642*^9}, {
   3.748214557340369*^9, 3.748214574621276*^9}},
 CellID->1935570068,ExpressionUUID->"a395add5-a1e3-4760-9bdd-b705b09ad153"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", FractionBox[\\\"Km\\\", RowBox[{\\\"J\\\", \\\" \\\
\", \\\"R\\\"}]], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\
\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
FractionBox[\"Km\", RowBox[{\"J\", \" \", \"R\"}]], \"}\"}], \",\", \
RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", FractionBox[\\\"Km\\\", RowBox[{\\\"J\\\", \\\" \\\
\", \\\"R\\\"}]], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\
\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
FractionBox[\"Km\", RowBox[{\"J\", \" \", \"R\"}]], \"}\"}], \",\", \
RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00044300000000063733`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00044300000000063733`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->950401916,ExpressionUUID->"ffafdfe7-5320-42cf-9f59-d3bc389298ff"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->421635826,ExpressionUUID->"a737cf81-f33d-4d0d-a317-a7d8d7ec4d3b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169171923123*^9, 3.748173146603053*^9},
 CellLabel->"In[140]:=",
 CellID->308626153,ExpressionUUID->"d9c56077-40ec-44e7-9736-41832ad0057b"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481691806324472`*^9, 3.748169184126515*^9}, {
   3.7481697745097303`*^9, 3.7481698177840567`*^9}, 3.748170212558292*^9, {
   3.74817153653963*^9, 3.748171557948637*^9}, {3.748172403638979*^9, 
   3.748172459180491*^9}, 3.748173461553569*^9, {3.7482146277608356`*^9, 
   3.748214641638563*^9}},
 CellID->903885071,ExpressionUUID->"8fe2d2e1-24ef-4642-9b36-5cc5c865e471"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \\\"1\\\"}], \\\"}\\\
\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \
\\\"0\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"0\", \
\",\", \"1\"}], \"}\"}], \",\", RowBox[{\"{\", RowBox[{\"1\", \",\", \"0\"}], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \\\"1\\\"}], \\\"}\\\
\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \
\\\"0\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"0\", \
\",\", \"1\"}], \"}\"}], \",\", RowBox[{\"{\", RowBox[{\"1\", \",\", \"0\"}], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001600000000010482`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001600000000010482`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1884776129,ExpressionUUID->"86d37889-bf1a-432a-aaa8-77e4c95d290e"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->2048606853,ExpressionUUID->"fd83d6bf-3bed-4d79-b2b2-e189040d2666"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169187965559*^9, 3.748173150905864*^9},
 CellLabel->"In[141]:=",
 CellID->29019256,ExpressionUUID->"ad176e77-5a07-472e-bc73-de67f297f9cd"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169193927287*^9, 3.748169194789258*^9}, {
   3.748169826851533*^9, 3.7481698714627047`*^9}, {3.748171572452416*^9, 
   3.748171580237145*^9}, {3.748172509134172*^9, 3.7481725445555677`*^9}, {
   3.748172960660345*^9, 3.7481729614507627`*^9}, 3.7481734650745153`*^9, {
   3.7482146606993*^9, 3.748214690757587*^9}},
 CellID->1636965545,ExpressionUUID->"1e840152-f2e7-4333-aee6-82d572391ef3"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015700000000151704`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015700000000151704`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->330066020,ExpressionUUID->"7848846b-1227-4ae6-925d-ca04146d938f"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->469337939,ExpressionUUID->"cd2c70c5-76f1-4715-a4d0-78a5b96a313e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"e", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.74816921143508*^9, 3.74817315251501*^9},
 CellLabel->"In[142]:=",
 CellID->1806999093,ExpressionUUID->"370c08f6-470c-4b6c-87c1-79a4b4876924"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "b", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692120543423`*^9, 3.748169217153222*^9}, 
   3.748169620186891*^9, {3.7481699674394503`*^9, 3.7481699868030443`*^9}, 
   3.748173467456937*^9},
 CellID->242148617,ExpressionUUID->"6a50089c-f51a-4de6-821e-78c2179708f9"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015499999999946112`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015499999999946112`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->455305342,ExpressionUUID->"9e5eda04-ae38-4570-99b6-e3ece0e51fe5"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->832648733,ExpressionUUID->"e33af765-2ca9-4c67-976f-a799f636b684"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169221684237*^9, 3.7481731563003674`*^9},
 CellLabel->"In[143]:=",
 CellID->1647391173,ExpressionUUID->"4d78c4e3-c3b9-4b20-8cf8-4d8ab02a44b5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "d", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692270490217`*^9, 3.748169230838327*^9}, {
   3.748169991971572*^9, 3.748170004254684*^9}, 3.748173469973262*^9},
 CellID->703811211,ExpressionUUID->"363016a0-56bc-46a2-ab11-ad0cc6519d81"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001619999999995514`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001619999999995514`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1323811679,ExpressionUUID->"b27cb3b0-5987-4fec-a3bb-549c165fe2e5"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1372306033,ExpressionUUID->"080e885a-536b-4203-8f2f-775daa3198c4"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Test System 5", "Section",
 CellChangeTimes->{{3.7481692698005457`*^9, 3.748169273381559*^9}, 
   3.7481693114624357`*^9, {3.748169361271824*^9, 3.748169361361087*^9}, {
   3.748170308281064*^9, 3.7481703083633633`*^9}, {3.748171876095627*^9, 
   3.748171876178361*^9}, {3.748173822514773*^9, 3.748173822575068*^9}, {
   3.748201957095229*^9, 3.748201957209919*^9}},
 CellID->1785023302,ExpressionUUID->"56d21efe-bb41-4cb4-89e2-80b7b95c8a15"],

Cell[CellGroupData[{

Cell["System model", "Subsection",
 CellChangeTimes->{{3.751247564359151*^9, 3.751247569753175*^9}},
 CellID->62897900,ExpressionUUID->"37f935b0-66e6-4fcb-b43b-57a900b97acf"],

Cell["Rowell and Wormley Example 5.1", "Text",
 CellChangeTimes->{{3.748169314267838*^9, 3.748169333731399*^9}, {
  3.748169368971754*^9, 3.748169377466568*^9}, {3.74817032089456*^9, 
  3.748170327324637*^9}, {3.748171903869137*^9, 3.748171911436009*^9}, {
  3.748173840454677*^9, 3.748173847774159*^9}, {3.748201999818125*^9, 
  3.748202000841951*^9}},
 CellID->2086613689,ExpressionUUID->"c87dff30-af1f-4984-b503-3626dcf8e477"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"Vs", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primaryVars", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vC", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"iL", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"iR", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outExps", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"iR", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"vR", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"vL", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"iC", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"elementalEqs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"vC", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"iC", "[", "t", "]"}], "/", "CC"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"iL", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vL", "[", "t", "]"}], "/", "L"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"iR", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vR", "[", "t", "]"}], "/", "R"}]}]}], "\[IndentingNewLine]", 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"constraintEqs", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"iC", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"iR", "[", "t", "]"}], "-", 
       RowBox[{"iL", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vL", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"vC", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vR", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Vs", "[", "t", "]"}], "-", 
       RowBox[{"vC", "[", "t", "]"}]}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.747499218184157*^9, 3.74749931067735*^9}, {
   3.7474997703057547`*^9, 3.747499862953096*^9}, {3.7475000427164516`*^9, 
   3.7475001179609213`*^9}, 3.747500172506531*^9, {3.7475052421578627`*^9, 
   3.7475052437525806`*^9}, {3.7475052792870703`*^9, 3.747505305743517*^9}, {
   3.7475054395550127`*^9, 3.74750549238805*^9}, {3.748169383980278*^9, 
   3.748169603265369*^9}, {3.748170115690106*^9, 3.748170132266461*^9}, {
   3.748170333165715*^9, 3.7481705921461983`*^9}, {3.748171917577342*^9, 
   3.74817195326005*^9}, {3.748171995123074*^9, 3.7481720024895773`*^9}, {
   3.748172035662871*^9, 3.7481721909688787`*^9}, {3.748173852472159*^9, 
   3.7481740097196913`*^9}, {3.7482022679021463`*^9, 3.748202298767332*^9}, {
   3.748202329707706*^9, 3.748202426597817*^9}, {3.7512475742284727`*^9, 
   3.751247678789716*^9}, {3.7518246470416927`*^9, 3.7518246669672117`*^9}, {
   3.75182469927206*^9, 3.751824704025951*^9}},
 CellLabel->"In[3]:=",
 CellID->603372099,ExpressionUUID->"9b1d2b64-bdc9-40db-9a4b-48915892516f"],

Cell["Find state equation.", "Text",
 CellChangeTimes->{{3.702757751780126*^9, 3.7027577578425713`*^9}, {
  3.702757790122506*^9, 3.7027577915609007`*^9}, {3.727581684624194*^9, 
  3.727581686707095*^9}},
 CellID->1198604992,ExpressionUUID->"b9e499f3-fc0d-469a-9031-ce751f7fdd06"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stateSolution", "=", 
   RowBox[{
    RowBox[{"stateEquations", "[", 
     RowBox[{
     "inVars", ",", "primaryVars", ",", "elementalEqs", ",", 
      "constraintEqs"}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateVars", " ", "=", " ", 
   RowBox[{"\"\<state variables\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateEqList", " ", "=", " ", 
   RowBox[{"\"\<RHS\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\"\<state equations\>\"", "/.", "stateSolution"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.7018797195836763`*^9, 3.7018797204767036`*^9}, {
   3.701879810803969*^9, 3.701879844544981*^9}, {3.7018942050184517`*^9, 
   3.701894566874161*^9}, 3.701898020551093*^9, {3.701903282327601*^9, 
   3.701903283500523*^9}, {3.701911200698804*^9, 3.701911202601316*^9}, {
   3.701915682054678*^9, 3.701915720675168*^9}, {3.701915759772274*^9, 
   3.7019157927706213`*^9}, {3.701915923602686*^9, 3.701915923900078*^9}, 
   3.7019209193048553`*^9, 3.701920950145496*^9, {3.701921306764739*^9, 
   3.701921308673313*^9}, {3.701921408184596*^9, 3.7019214156809187`*^9}, 
   3.7019220747800493`*^9, {3.701922189786292*^9, 3.701922218088579*^9}, {
   3.701922248592429*^9, 3.701922251876824*^9}, 3.701922322852202*^9, {
   3.701922383801173*^9, 3.7019224315654707`*^9}, {3.701922463501308*^9, 
   3.7019224895050097`*^9}, 3.7019225472984467`*^9, {3.701922594846767*^9, 
   3.701922598092758*^9}, {3.701922662563005*^9, 3.701922735877761*^9}, {
   3.7019231046383343`*^9, 3.701923105684675*^9}, {3.7019639715923243`*^9, 
   3.7019639718841667`*^9}, {3.7019642654040737`*^9, 3.701964352167139*^9}, {
   3.701964387110903*^9, 3.7019644147887087`*^9}, {3.702757419429731*^9, 
   3.7027575039883213`*^9}, {3.7511302149210863`*^9, 3.751130222225973*^9}, 
   3.751131245052647*^9, 3.7518224212768917`*^9, 3.751859572077701*^9, 
   3.751859962401185*^9, 3.751860991882702*^9, {3.751937300733726*^9, 
   3.751937302457316*^9}, {3.7519373460365458`*^9, 3.75193734643993*^9}},
 CellLabel->"In[12]:=",
 CellID->405558399,ExpressionUUID->"4ad85d0c-1bc8-4d28-bfa5-234448eafefc"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{
        SuperscriptBox["vC", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"iL", "[", "t", "]"}], "CC"]}], "-", 
        FractionBox[
         RowBox[{"vC", "[", "t", "]"}], 
         RowBox[{"CC", " ", "R"}]], "+", 
        FractionBox[
         RowBox[{"Vs", "[", "t", "]"}], 
         RowBox[{"CC", " ", "R"}]]}]}]},
     {
      RowBox[{
       RowBox[{
        SuperscriptBox["iL", "\[Prime]",
         MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
       FractionBox[
        RowBox[{"vC", "[", "t", "]"}], "L"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751131246142264*^9, 3.751131562228766*^9, 3.751154207578877*^9, 
   3.751155061538066*^9, 3.7511551539969883`*^9, 3.7511556539137783`*^9, 
   3.751156830900199*^9, 3.751157044451893*^9, 3.751157305712584*^9, 
   3.751157692923893*^9, 3.751237248504381*^9, 3.7512373121455393`*^9, 
   3.751237557961287*^9, {3.7512412411479073`*^9, 3.751241257691305*^9}, 
   3.7512413334070673`*^9, 3.751241455823284*^9, 3.751241611586341*^9, 
   3.7512433878599854`*^9, 3.751243524307231*^9, 3.751243608962484*^9, 
   3.7512437545853853`*^9, 3.751243860047454*^9, 3.7512441819725847`*^9, 
   3.751244399097206*^9, 3.751244486437664*^9, 3.75124455927641*^9, 
   3.75124464012558*^9, 3.75124506931707*^9, 3.751245129883816*^9, 
   3.751245199900049*^9, 3.751245786492696*^9, 3.7512458405736723`*^9, 
   3.751245872204157*^9, {3.7512470996055098`*^9, 3.751247133340377*^9}, 
   3.751822506215632*^9, {3.751822707767754*^9, 3.751822723484655*^9}, 
   3.751822800835991*^9, 3.7518235244045973`*^9, 3.751823574246002*^9, 
   3.75182394710122*^9, 3.751824050485718*^9, {3.751824086094249*^9, 
   3.7518241542062597`*^9}, 3.751824200734988*^9, 3.751824672382347*^9, {
   3.751824706847102*^9, 3.7518247282984877`*^9}, 3.75182736056944*^9, 
   3.7518596754986486`*^9, 3.751861104352148*^9, {3.751937303732099*^9, 
   3.751937309845083*^9}, {3.7519373412683973`*^9, 3.751937347049357*^9}},
 CellLabel->"Out[15]//TableForm=",
 CellID->323165683,ExpressionUUID->"4e4b0344-5c21-4b68-8e82-33ffac712baa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"outEqList", "=", 
   RowBox[{"outEquations", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outExps", ",", 
     RowBox[{"elementalEqs", "~", "Join", "~", "constraintEqs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outEqList", "//", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"y", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "outExps", "]"}]}], "}"}]}], "]"}], 
      "\[Equal]", "#"}], "]"}], "&"}]}], "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.75115407229806*^9, 3.7511540907068577`*^9}, {
   3.7511541283727303`*^9, 3.751154145140655*^9}, {3.751154185947949*^9, 
   3.751154186454541*^9}, {3.75115440553708*^9, 3.751154408241644*^9}, {
   3.751157061478198*^9, 3.75115706228808*^9}, {3.751157258647379*^9, 
   3.751157263470278*^9}, {3.751157318329653*^9, 3.751157382599204*^9}, 
   3.751243546881419*^9, 3.7512446518094807`*^9, {3.7518241789029417`*^9, 
   3.751824190813037*^9}},
 CellLabel->"In[16]:=",
 CellID->1647858013,ExpressionUUID->"e769d23c-9292-4893-bae4-89e10670a9c3"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{"y", "[", "1", "]"}], "\[Equal]", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"vC", "[", "t", "]"}], "R"]}], "+", 
        FractionBox[
         RowBox[{"Vs", "[", "t", "]"}], "R"]}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "2", "]"}], "\[Equal]", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"vC", "[", "t", "]"}]}], "+", 
        RowBox[{"Vs", "[", "t", "]"}]}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "3", "]"}], "\[Equal]", 
       RowBox[{"vC", "[", "t", "]"}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "4", "]"}], "\[Equal]", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"iL", "[", "t", "]"}]}], "-", 
        FractionBox[
         RowBox[{"vC", "[", "t", "]"}], "R"], "+", 
        FractionBox[
         RowBox[{"Vs", "[", "t", "]"}], "R"]}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751154146341402*^9, {3.7511541874520807`*^9, 3.75115421035389*^9}, 
   3.751154409289606*^9, 3.751155063159431*^9, 3.7511551578703537`*^9, {
   3.751155631171876*^9, 3.7511556669733973`*^9}, 3.751156831153225*^9, {
   3.7511570444961233`*^9, 3.751157063011318*^9}, 3.7511573845757217`*^9, 
   3.7511576929574337`*^9, 3.751237248545403*^9, 3.75123731846103*^9, 
   3.751237558009218*^9, 3.75124126512782*^9, 3.751241341691312*^9, 
   3.7512414602930183`*^9, {3.7512415890389347`*^9, 3.751241614550478*^9}, 
   3.751243391757332*^9, {3.751243525864511*^9, 3.7512435473077707`*^9}, 
   3.7512436090180597`*^9, 3.751243754645124*^9, 3.751243860169832*^9, 
   3.751244182055914*^9, 3.751244399162704*^9, 3.751244486514542*^9, 
   3.751244523619996*^9, 3.7512445593242817`*^9, {3.751244640162719*^9, 
   3.7512446526642714`*^9}, 3.7512450693463917`*^9, 3.751245129916429*^9, 
   3.751245199944006*^9, 3.751245811673089*^9, 3.75124584198965*^9, 
   3.75124587430195*^9, {3.751247099662253*^9, 3.751247148020466*^9}, {
   3.751824169273649*^9, 3.751824200839072*^9}, {3.751824715614212*^9, 
   3.751824728417693*^9}, 3.7518273607033243`*^9, 3.751859675584629*^9, 
   3.751861104452363*^9, 3.751986709711075*^9},
 CellLabel->"Out[17]//TableForm=",
 CellID->2087221808,ExpressionUUID->"1285a025-fce1-4686-8d01-723da77aee77"]
}, Open  ]],

Cell["\<\
Linearize the state and output equations about operating point.\
\>", "Text",
 CellChangeTimes->{{3.7027577023090067`*^9, 3.7027577064193897`*^9}, {
  3.702757795179463*^9, 3.702757797848589*^9}, {3.702758517676444*^9, 
  3.702758517969734*^9}, {3.751157404122614*^9, 3.751157407793623*^9}},
 CellID->722145470,ExpressionUUID->"c5cc61b6-ff86-42be-9ac2-2965757b6dfa"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"abe", "=", 
   RowBox[{"linearizeState", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "stateEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdf", "=", 
   RowBox[{"linearizeOutput", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "e"}], "}"}], " ", "=", " ", "abe"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"c", ",", "d", ",", "f"}], "}"}], " ", "=", " ", "cdf"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<A = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<B = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<E = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<C = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<D = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<F = \>\"", ",", "#"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.7027439116175957`*^9, 3.702744033267743*^9}, {
   3.702744268313121*^9, 3.702744305447536*^9}, {3.702756777004896*^9, 
   3.70275678344866*^9}, {3.702756831990849*^9, 3.702756860110464*^9}, {
   3.702757530029274*^9, 3.702757693348208*^9}, {3.70275831097122*^9, 
   3.702758346655436*^9}, {3.702758404323063*^9, 3.7027584657658863`*^9}, {
   3.702759733356806*^9, 3.702760026609954*^9}, {3.70276007934348*^9, 
   3.702760085749899*^9}, {3.702760162502097*^9, 3.7027602713332367`*^9}, {
   3.7031743380777597`*^9, 3.703174365043808*^9}, {3.7032126025366993`*^9, 
   3.703212608677622*^9}, {3.7275822132423773`*^9, 3.727582355849462*^9}, 
   3.751154035567876*^9, {3.751157216290072*^9, 3.751157229742868*^9}, {
   3.751157416529111*^9, 3.751157421062249*^9}, {3.7511576066364393`*^9, 
   3.751157656881137*^9}, {3.7511577043529177`*^9, 3.7511577145152082`*^9}, {
   3.7512372971265383`*^9, 3.7512373336944847`*^9}, {3.751237381927462*^9, 
   3.751237410777441*^9}, {3.751986719763986*^9, 3.751986732013526*^9}},
 CellLabel->"In[52]:=",
 CellID->1668825093,ExpressionUUID->"c086abee-b68a-461e-9773-8d74d48baba3"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox["1", 
          RowBox[{"CC", " ", "R"}]]}], 
        RowBox[{"-", 
         FractionBox["1", "CC"]}]},
       {
        FractionBox["1", "L"], "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["A = ", 
   MatrixForm[{{-$CellContext`CC^(-1)/$CellContext`R, (-1)/$CellContext`CC}, \
{$CellContext`L^(-1), 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.751247698406947*^9, {3.751824723997218*^9, 3.751824728552346*^9}, 
   3.751827360860033*^9, 3.751859675688052*^9, 3.751861104552845*^9, {
   3.751986732840271*^9, 3.7519867584519444`*^9}, 3.751996359927178*^9},
 CellLabel->"During evaluation of In[52]:=",
 CellID->737638985,ExpressionUUID->"41ad8d64-eabe-4fc6-b289-8e233cde71b9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"B = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["1", 
         RowBox[{"CC", " ", "R"}]]},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["B = ", 
   MatrixForm[{{$CellContext`CC^(-1)/$CellContext`R}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.751247698406947*^9, {3.751824723997218*^9, 3.751824728552346*^9}, 
   3.751827360860033*^9, 3.751859675688052*^9, 3.751861104552845*^9, {
   3.751986732840271*^9, 3.7519867584519444`*^9}, 3.7519963599380417`*^9},
 CellLabel->"During evaluation of In[52]:=",
 CellID->75326764,ExpressionUUID->"ea17eac7-4d17-47f4-b5b9-856a107354b8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"E = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["E = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.751247698406947*^9, {3.751824723997218*^9, 3.751824728552346*^9}, 
   3.751827360860033*^9, 3.751859675688052*^9, 3.751861104552845*^9, {
   3.751986732840271*^9, 3.7519867584519444`*^9}, 3.751996359948853*^9},
 CellLabel->"During evaluation of In[52]:=",
 CellID->1149054465,ExpressionUUID->"2947e0a1-5835-4eca-9d04-f7b76f8e9526"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox["1", "R"]}], "0"},
       {
        RowBox[{"-", "1"}], "0"},
       {"1", "0"},
       {
        RowBox[{"-", 
         FractionBox["1", "R"]}], 
        RowBox[{"-", "1"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{(-1)/$CellContext`R, 0}, {-1, 0}, {1, 
     0}, {(-1)/$CellContext`R, -1}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.751247698406947*^9, {3.751824723997218*^9, 3.751824728552346*^9}, 
   3.751827360860033*^9, 3.751859675688052*^9, 3.751861104552845*^9, {
   3.751986732840271*^9, 3.7519867584519444`*^9}, 3.751996359956221*^9},
 CellLabel->"During evaluation of In[52]:=",
 CellID->1985439431,ExpressionUUID->"cb9dfd7b-4502-4cb7-9578-3f74e30a40c4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["1", "R"]},
       {"1"},
       {"0"},
       {
        FractionBox["1", "R"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{$CellContext`R^(-1)}, {1}, {0}, {$CellContext`R^(-1)}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.751247698406947*^9, {3.751824723997218*^9, 3.751824728552346*^9}, 
   3.751827360860033*^9, 3.751859675688052*^9, 3.751861104552845*^9, {
   3.751986732840271*^9, 3.7519867584519444`*^9}, 3.75199635996315*^9},
 CellLabel->"During evaluation of In[52]:=",
 CellID->1679609731,ExpressionUUID->"8500658c-f3b4-465c-8943-36f9c16da56d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"},
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0}, {0}, {0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.751247698406947*^9, {3.751824723997218*^9, 3.751824728552346*^9}, 
   3.751827360860033*^9, 3.751859675688052*^9, 3.751861104552845*^9, {
   3.751986732840271*^9, 3.7519867584519444`*^9}, 3.751996359969822*^9},
 CellLabel->"During evaluation of In[52]:=",
 CellID->528209102,ExpressionUUID->"7493b52e-bce9-4003-beed-1f8ce0387911"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<C\>\"", ",", "\"\<D\>\"", ",", "\"\<F\>\""}], "}"}], 
        "[", 
        RowBox[{"[", "i", "]"}], "]"}], " ", "<>", " ", "\"\< = \>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"cdf", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "//", "MatrixForm"}]}], 
     "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "3"}], "}"}]}], "\[IndentingNewLine]", "]"}],
   ";"}]], "Input",
 CellChangeTimes->{{3.7519969556193933`*^9, 3.7519971719928293`*^9}, {
  3.75199749022119*^9, 3.751997535383114*^9}, {3.751997728203465*^9, 
  3.751997734757102*^9}},
 CellLabel->"In[93]:=",
 CellID->1295314612,ExpressionUUID->"5576cc55-5315-4ff3-860b-3d3a7bdfe69b"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox["1", "R"]}], "0"},
       {
        RowBox[{"-", "1"}], "0"},
       {"1", "0"},
       {
        RowBox[{"-", 
         FractionBox["1", "R"]}], 
        RowBox[{"-", "1"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{(-1)/$CellContext`R, 0}, {-1, 0}, {1, 
     0}, {(-1)/$CellContext`R, -1}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7519970704602613`*^9, 3.751997094704208*^9}, 
   3.7519971282920647`*^9, 3.7519971747948093`*^9, 3.751997535914221*^9, 
   3.751997735408049*^9},
 CellLabel->"During evaluation of In[93]:=",
 CellID->362799389,ExpressionUUID->"1e9cd687-e4c4-460b-9b36-b785bfaf2884"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["1", "R"]},
       {"1"},
       {"0"},
       {
        FractionBox["1", "R"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{$CellContext`R^(-1)}, {1}, {0}, {$CellContext`R^(-1)}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7519970704602613`*^9, 3.751997094704208*^9}, 
   3.7519971282920647`*^9, 3.7519971747948093`*^9, 3.751997535914221*^9, 
   3.751997735420713*^9},
 CellLabel->"During evaluation of In[93]:=",
 CellID->863257090,ExpressionUUID->"7142c05e-c66c-4318-bba7-8b399bedf6a8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"},
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0}, {0}, {0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7519970704602613`*^9, 3.751997094704208*^9}, 
   3.7519971282920647`*^9, 3.7519971747948093`*^9, 3.751997535914221*^9, 
   3.751997735432671*^9},
 CellLabel->"During evaluation of In[93]:=",
 CellID->362392498,ExpressionUUID->"0d1eb3ca-e8dc-4f7b-8483-6f2d38e2748d"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.751247518170266*^9, 3.751247518785733*^9}},
 CellID->1806908231,ExpressionUUID->"84b0f8cb-e02a-409d-9be6-2f359427f1dc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.747505552707037*^9, {3.7475057578295593`*^9, 3.747505759222794*^9}, {
   3.747505842150148*^9, 3.7475058458319883`*^9}, {3.747505896191999*^9, 
   3.74750589728131*^9}, {3.748124150238531*^9, 3.748124150517943*^9}, 
   3.748169029221862*^9, 3.748173244647019*^9},
 CellLabel->"In[165]:=",
 CellID->71676832,ExpressionUUID->"eb2e96f7-19eb-4bb1-a4bf-56fad086f4f3"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", 
        RowBox[{"R", " ", "CC"}]]}], ",", 
      RowBox[{"-", 
       FractionBox["1", "CC"]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      FractionBox["1", "L"], ",", "0"}], "}"}]}], "}"}], 
  "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.747505555643032*^9, 3.7475055867312613`*^9}, {
   3.747505761476728*^9, 3.747505764318122*^9}, {3.747505847665118*^9, 
   3.7475058502692757`*^9}, {3.747505898843794*^9, 3.74750590124069*^9}, {
   3.7475063255823507`*^9, 3.747506334276267*^9}, {3.7481241530496283`*^9, 
   3.748124156712919*^9}, 3.7481690353265944`*^9, {3.748169641556839*^9, 
   3.748169730141844*^9}, {3.7481706308795347`*^9, 3.748170648343268*^9}, {
   3.7481713324991817`*^9, 3.748171412017522*^9}, {3.7481722117935038`*^9, 
   3.748172266534639*^9}, {3.748172557215331*^9, 3.748172586783577*^9}, 
   3.748172811167288*^9, {3.748173455617723*^9, 3.748173456202003*^9}, {
   3.748173684193961*^9, 3.7481736910145693`*^9}, {3.748174023178488*^9, 
   3.748174074694357*^9}, {3.7482024431310062`*^9, 3.7482024882994432`*^9}},
 CellID->862007093,ExpressionUUID->"175490de-8827-4558-a562-6da5db3c6260"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \
RowBox[{\\\"CC\\\", \\\" \\\", \\\"R\\\"}]]}], \\\",\\\", RowBox[{\\\"-\\\", \
FractionBox[\\\"1\\\", \\\"CC\\\"]}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\
\\\", RowBox[{FractionBox[\\\"1\\\", \\\"L\\\"], \\\",\\\", \\\"0\\\"}], \
\\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"1\", RowBox[{\"CC\", \" \", \"R\"}]]}], \
\",\", RowBox[{\"-\", FractionBox[\"1\", \"CC\"]}]}], \"}\"}], \",\", \
RowBox[{\"{\", RowBox[{FractionBox[\"1\", \"L\"], \",\", \"0\"}], \"}\"}]}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \
RowBox[{\\\"CC\\\", \\\" \\\", \\\"R\\\"}]]}], \\\",\\\", RowBox[{\\\"-\\\", \
FractionBox[\\\"1\\\", \\\"CC\\\"]}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\
\\\", RowBox[{FractionBox[\\\"1\\\", \\\"L\\\"], \\\",\\\", \\\"0\\\"}], \
\\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"1\", RowBox[{\"CC\", \" \", \"R\"}]]}], \
\",\", RowBox[{\"-\", FractionBox[\"1\", \"CC\"]}]}], \"}\"}], \",\", \
RowBox[{\"{\", RowBox[{FractionBox[\"1\", \"L\"], \",\", \"0\"}], \"}\"}]}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0006039999999991608`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0006039999999991608`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1985991374,ExpressionUUID->"db7394d6-31b6-45cc-9443-213f9e105ce1"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->218697497,ExpressionUUID->"aafa0907-3755-479a-aafe-8757e8a95d7b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.748169118881194*^9, {3.748173109584269*^9, 3.748173111317824*^9}},
 CellLabel->"In[166]:=",
 CellID->339233762,ExpressionUUID->"76649db4-73f1-4e41-b765-f30c8b76dc81"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     FractionBox["1", 
      RowBox[{"R", " ", "CC"}]], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169152633688*^9, 3.748169166417688*^9}, 
   3.74816961437001*^9, {3.748169735895432*^9, 3.74816976416591*^9}, {
   3.7481714534342337`*^9, 3.748171524401494*^9}, {3.748172277994993*^9, 
   3.748172388840468*^9}, {3.748173070786932*^9, 3.7481730730294323`*^9}, {
   3.748173117430595*^9, 3.7481731307454023`*^9}, {3.748173458595439*^9, 
   3.74817345887745*^9}, {3.748173695194269*^9, 3.748173699950642*^9}, {
   3.748202504888515*^9, 3.7482025270319357`*^9}},
 CellID->994211324,ExpressionUUID->"ee7f4c10-c568-4517-807e-8c5b51e75c37"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", FractionBox[\\\"1\\\", RowBox[{\\\"CC\\\", \\\" \\\
\", \\\"R\\\"}]], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\
\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", FractionBox[\"1\
\", RowBox[{\"CC\", \" \", \"R\"}]], \"}\"}], \",\", RowBox[{\"{\", \"0\", \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", FractionBox[\\\"1\\\", RowBox[{\\\"CC\\\", \\\" \\\
\", \\\"R\\\"}]], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\
\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", FractionBox[\"1\
\", RowBox[{\"CC\", \" \", \"R\"}]], \"}\"}], \",\", RowBox[{\"{\", \"0\", \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00039300000000075386`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00039300000000075386`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1304312062,ExpressionUUID->"066f9c2d-f210-490c-81a6-a93930152e14"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->59757458,ExpressionUUID->"393fc72e-546f-41ad-b527-6b5f5f3bf244"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169171923123*^9, 3.748173146603053*^9},
 CellLabel->"In[167]:=",
 CellID->2010502978,ExpressionUUID->"02b304fb-2e6c-4e44-93cd-68fe1c6ef695"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "/", "R"}], ",", "0"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "/", "R"}], ",", 
      RowBox[{"-", "1"}]}], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481691806324472`*^9, 3.748169184126515*^9}, {
   3.7481697745097303`*^9, 3.7481698177840567`*^9}, 3.748170212558292*^9, {
   3.74817153653963*^9, 3.748171557948637*^9}, {3.748172403638979*^9, 
   3.748172459180491*^9}, 3.748173461553569*^9, {3.748202537450017*^9, 
   3.748202581324718*^9}},
 CellID->1355423925,ExpressionUUID->"1821d0c4-3c32-4da5-a205-d42bcda0fa5c"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \
\\\"R\\\"]}], \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", RowBox[{RowBox[{\\\"-\\\", \\\"1\\\"}], \\\",\\\", \\\"0\\\"}], \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \
\\\"0\\\"}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\
\\\", FractionBox[\\\"1\\\", \\\"R\\\"]}], \\\",\\\", RowBox[{\\\"-\\\", \
\\\"1\\\"}]}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"1\", \"R\"]}], \",\", \"0\"}], \"}\"}], \
\",\", RowBox[{\"{\", RowBox[{RowBox[{\"-\", \"1\"}], \",\", \"0\"}], \
\"}\"}], \",\", RowBox[{\"{\", RowBox[{\"1\", \",\", \"0\"}], \"}\"}], \",\", \
RowBox[{\"{\", RowBox[{RowBox[{\"-\", FractionBox[\"1\", \"R\"]}], \",\", \
RowBox[{\"-\", \"1\"}]}], \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \
\\\"R\\\"]}], \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", RowBox[{RowBox[{\\\"-\\\", \\\"1\\\"}], \\\",\\\", \\\"0\\\"}], \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \
\\\"0\\\"}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\
\\\", FractionBox[\\\"1\\\", \\\"R\\\"]}], \\\",\\\", RowBox[{\\\"-\\\", \
\\\"1\\\"}]}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"1\", \"R\"]}], \",\", \"0\"}], \"}\"}], \
\",\", RowBox[{\"{\", RowBox[{RowBox[{\"-\", \"1\"}], \",\", \"0\"}], \
\"}\"}], \",\", RowBox[{\"{\", RowBox[{\"1\", \",\", \"0\"}], \"}\"}], \",\", \
RowBox[{\"{\", RowBox[{RowBox[{\"-\", FractionBox[\"1\", \"R\"]}], \",\", \
RowBox[{\"-\", \"1\"}]}], \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00035399999999796705`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00035399999999796705`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1468733457,ExpressionUUID->"e45e987a-770d-4c13-abcf-4d8d9d513d8c"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1826173181,ExpressionUUID->"c0350e9a-f907-48ab-b2ea-fcac3847f2b2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169187965559*^9, 3.748173150905864*^9},
 CellLabel->"In[168]:=",
 CellID->463206704,ExpressionUUID->"ebe52bf4-0da8-4569-83f8-7a9074fc7915"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", "/", "R"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "1", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"1", "/", "R"}], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169193927287*^9, 3.748169194789258*^9}, {
   3.748169826851533*^9, 3.7481698714627047`*^9}, {3.748171572452416*^9, 
   3.748171580237145*^9}, {3.748172509134172*^9, 3.7481725445555677`*^9}, {
   3.748172960660345*^9, 3.7481729614507627`*^9}, 3.7481734650745153`*^9, {
   3.7482025915862713`*^9, 3.748202630873435*^9}},
 CellID->1950835585,ExpressionUUID->"4afb4ad7-abaf-4515-a36d-9acc4be50287"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", FractionBox[\\\"1\\\", \\\"R\\\"], \\\"}\\\"}], \\\
\",\\\", RowBox[{\\\"{\\\", \\\"1\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
FractionBox[\\\"1\\\", \\\"R\\\"], \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", FractionBox[\"1\
\", \"R\"], \"}\"}], \",\", RowBox[{\"{\", \"1\", \"}\"}], \",\", RowBox[{\"{\
\", \"0\", \"}\"}], \",\", RowBox[{\"{\", FractionBox[\"1\", \"R\"], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", FractionBox[\\\"1\\\", \\\"R\\\"], \\\"}\\\"}], \\\
\",\\\", RowBox[{\\\"{\\\", \\\"1\\\", \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
FractionBox[\\\"1\\\", \\\"R\\\"], \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", FractionBox[\"1\
\", \"R\"], \"}\"}], \",\", RowBox[{\"{\", \"1\", \"}\"}], \",\", RowBox[{\"{\
\", \"0\", \"}\"}], \",\", RowBox[{\"{\", FractionBox[\"1\", \"R\"], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00016399999999983095`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00016399999999983095`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->656370143,ExpressionUUID->"48e5f637-7e86-476e-b398-458c3b9bb028"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->2136982409,ExpressionUUID->"7808cad7-0f5c-47e0-b0be-5675f96beaf1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"e", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.74816921143508*^9, 3.74817315251501*^9},
 CellLabel->"In[169]:=",
 CellID->1713910284,ExpressionUUID->"76b3e4d7-27b2-4403-b7de-4ee5b7c824f9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "b", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692120543423`*^9, 3.748169217153222*^9}, 
   3.748169620186891*^9, {3.7481699674394503`*^9, 3.7481699868030443`*^9}, 
   3.748173467456937*^9},
 CellID->1536895706,ExpressionUUID->"3136a4f4-5cd8-40e1-96a6-7180ce7a5973"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015699999999974068`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015699999999974068`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1746835635,ExpressionUUID->"f3066f1f-47de-400d-b9ab-bacc2ee41887"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->817579308,ExpressionUUID->"ea4b795f-33be-4be8-be16-02c7f0afec42"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169221684237*^9, 3.7481731563003674`*^9},
 CellLabel->"In[170]:=",
 CellID->887622295,ExpressionUUID->"7f9c719c-aa63-4072-b540-ecf808cfd113"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "d", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692270490217`*^9, 3.748169230838327*^9}, {
   3.748169991971572*^9, 3.748170004254684*^9}, 3.748173469973262*^9},
 CellID->852270963,ExpressionUUID->"71c984e0-f272-40b5-947f-60df84f2b2aa"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}]}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}]}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001650000000008589`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001650000000008589`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1455056050,ExpressionUUID->"1a1fa901-f502-4c3d-bbb1-b602900156bb"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1730743961,ExpressionUUID->"8ef07169-52ba-4b4c-839b-f5fbb20ed45c"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test System 6", "Section",
 CellChangeTimes->{{3.7481692698005457`*^9, 3.748169273381559*^9}, 
   3.7481693114624357`*^9},
 CellID->451857424,ExpressionUUID->"46187148-15b3-404a-9e01-00baac692e0a"],

Cell[CellGroupData[{

Cell["System model", "Subsection",
 CellChangeTimes->{{3.751247787262232*^9, 3.751247788719122*^9}},
 CellID->1875869356,ExpressionUUID->"dd9d5705-9ddc-411c-a5df-92a3664856d2"],

Cell["Rowell and Wormley Example 5.2", "Text",
 CellChangeTimes->{{3.748169314267838*^9, 3.748169333731399*^9}},
 CellID->142666285,ExpressionUUID->"309e01b4-7d75-4cba-a33c-2aa9cef4e7b8"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"Fs", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primaryVars", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vm", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Fk", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outExps", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"vm", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"elementalEqs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"vm", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"fm", "[", "t", "]"}], "/", "m"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Fk", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{"k", " ", 
       RowBox[{"Vk", "[", "t", "]"}]}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"constraintEqs", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"fm", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Fs", "[", "t", "]"}], "-", 
       RowBox[{"Fk", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Vk", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"vm", "[", "t", "]"}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.747499218184157*^9, 3.74749931067735*^9}, {
   3.7474997703057547`*^9, 3.747499862953096*^9}, {3.7475000427164516`*^9, 
   3.7475001179609213`*^9}, 3.747500172506531*^9, {3.7475052421578627`*^9, 
   3.7475052437525806`*^9}, {3.7475052792870703`*^9, 3.747505305743517*^9}, {
   3.7475054395550127`*^9, 3.74750549238805*^9}, {3.751247791818668*^9, 
   3.751247867894322*^9}, {3.7518247738437643`*^9, 3.751824803635873*^9}},
 CellLabel->"In[171]:=",
 CellID->397079176,ExpressionUUID->"0ce74805-71cc-4c40-b1c6-35633b5821ab"],

Cell["Find state equation.", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.75124789335491*^9}},
 CellID->2068155801,ExpressionUUID->"68df1e0f-e7cb-40a8-93bb-e2163c5a4efc"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stateSolution", "=", 
   RowBox[{
    RowBox[{"stateEquations", "[", 
     RowBox[{
     "inVars", ",", "primaryVars", ",", "elementalEqs", ",", 
      "constraintEqs"}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateVars", " ", "=", " ", 
   RowBox[{"\"\<state variables\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateEqList", " ", "=", " ", 
   RowBox[{"\"\<RHS\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\"\<state equations\>\"", "/.", "stateSolution"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.7018797195836763`*^9, 3.7018797204767036`*^9}, {
   3.701879810803969*^9, 3.701879844544981*^9}, {3.7018942050184517`*^9, 
   3.701894566874161*^9}, 3.701898020551093*^9, {3.701903282327601*^9, 
   3.701903283500523*^9}, {3.701911200698804*^9, 3.701911202601316*^9}, {
   3.701915682054678*^9, 3.701915720675168*^9}, {3.701915759772274*^9, 
   3.7019157927706213`*^9}, {3.701915923602686*^9, 3.701915923900078*^9}, 
   3.7019209193048553`*^9, 3.701920950145496*^9, {3.701921306764739*^9, 
   3.701921308673313*^9}, {3.701921408184596*^9, 3.7019214156809187`*^9}, 
   3.7019220747800493`*^9, {3.701922189786292*^9, 3.701922218088579*^9}, {
   3.701922248592429*^9, 3.701922251876824*^9}, 3.701922322852202*^9, {
   3.701922383801173*^9, 3.7019224315654707`*^9}, {3.701922463501308*^9, 
   3.7019224895050097`*^9}, 3.7019225472984467`*^9, {3.701922594846767*^9, 
   3.701922598092758*^9}, {3.701922662563005*^9, 3.701922735877761*^9}, {
   3.7019231046383343`*^9, 3.701923105684675*^9}, {3.7019639715923243`*^9, 
   3.7019639718841667`*^9}, {3.7019642654040737`*^9, 3.701964352167139*^9}, {
   3.701964387110903*^9, 3.7019644147887087`*^9}, {3.702757419429731*^9, 
   3.7027575039883213`*^9}, {3.7511302149210863`*^9, 3.751130222225973*^9}, 
   3.751131245052647*^9, 3.7518224212768917`*^9, 3.751859572140081*^9, 
   3.7518599624125957`*^9, 3.751860991888299*^9, 3.7519374017598047`*^9},
 CellID->1472217929,ExpressionUUID->"12f68d30-d998-4c89-9299-e697e5639067"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["vm", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"Fk", "[", "t", "]"}], "m"]}], "+", 
       FractionBox[
        RowBox[{"Fs", "[", "t", "]"}], "m"]}]}]},
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["Fk", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{"k", " ", 
       RowBox[{"vm", "[", "t", "]"}]}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751131246142264*^9, 3.751131562228766*^9, 3.751154207578877*^9, 
   3.751155061538066*^9, 3.7511551539969883`*^9, 3.7511556539137783`*^9, 
   3.751156830900199*^9, 3.751157044451893*^9, 3.751157305712584*^9, 
   3.751157692923893*^9, 3.751237248504381*^9, 3.7512373121455393`*^9, 
   3.751237557961287*^9, {3.7512412411479073`*^9, 3.751241257691305*^9}, 
   3.7512413334070673`*^9, 3.751241455823284*^9, 3.751241611586341*^9, 
   3.7512433878599854`*^9, 3.751243524307231*^9, 3.751243608962484*^9, 
   3.7512437545853853`*^9, 3.751243860047454*^9, 3.7512441819725847`*^9, 
   3.751244399097206*^9, 3.751244486437664*^9, 3.75124455927641*^9, 
   3.75124464012558*^9, 3.75124506931707*^9, 3.751245129883816*^9, 
   3.751245199900049*^9, 3.751245786492696*^9, 3.7512458405736723`*^9, 
   3.751245872204157*^9, {3.7512470996055098`*^9, 3.751247133340377*^9}, 
   3.751822506215632*^9, {3.751822707767754*^9, 3.751822723484655*^9}, 
   3.751822800835991*^9, 3.7518235244045973`*^9, 3.751823574246002*^9, 
   3.75182394710122*^9, 3.751824050485718*^9, {3.751824086094249*^9, 
   3.7518241542062597`*^9}, 3.751824200734988*^9, {3.751824814324128*^9, 
   3.751824842311005*^9}, 3.7518274011641006`*^9, 3.751859686202426*^9, 
   3.7518611250358*^9},
 CellLabel->"Out[179]//TableForm=",
 CellID->947753912,ExpressionUUID->"96ee793d-026f-4532-b012-5ef7846b9ab5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"outEqList", "=", 
   RowBox[{"outEquations", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outExps", ",", 
     RowBox[{"elementalEqs", "~", "Join", "~", "constraintEqs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outEqList", "//", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"y", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "outExps", "]"}]}], "}"}]}], "]"}], 
      "\[Equal]", "#"}], "]"}], "&"}]}], "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.75115407229806*^9, 3.7511540907068577`*^9}, {
   3.7511541283727303`*^9, 3.751154145140655*^9}, {3.751154185947949*^9, 
   3.751154186454541*^9}, {3.75115440553708*^9, 3.751154408241644*^9}, {
   3.751157061478198*^9, 3.75115706228808*^9}, {3.751157258647379*^9, 
   3.751157263470278*^9}, {3.751157318329653*^9, 3.751157382599204*^9}, 
   3.751243546881419*^9, 3.7512446518094807`*^9, {3.7518241789029417`*^9, 
   3.751824190813037*^9}},
 CellLabel->"In[180]:=",
 CellID->97437691,ExpressionUUID->"5317f8bc-29c8-4334-8350-c5329b8f7e91"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{"y", "[", "1", "]"}], "\[Equal]", 
       RowBox[{"vm", "[", "t", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751154146341402*^9, {3.7511541874520807`*^9, 3.75115421035389*^9}, 
   3.751154409289606*^9, 3.751155063159431*^9, 3.7511551578703537`*^9, {
   3.751155631171876*^9, 3.7511556669733973`*^9}, 3.751156831153225*^9, {
   3.7511570444961233`*^9, 3.751157063011318*^9}, 3.7511573845757217`*^9, 
   3.7511576929574337`*^9, 3.751237248545403*^9, 3.75123731846103*^9, 
   3.751237558009218*^9, 3.75124126512782*^9, 3.751241341691312*^9, 
   3.7512414602930183`*^9, {3.7512415890389347`*^9, 3.751241614550478*^9}, 
   3.751243391757332*^9, {3.751243525864511*^9, 3.7512435473077707`*^9}, 
   3.7512436090180597`*^9, 3.751243754645124*^9, 3.751243860169832*^9, 
   3.751244182055914*^9, 3.751244399162704*^9, 3.751244486514542*^9, 
   3.751244523619996*^9, 3.7512445593242817`*^9, {3.751244640162719*^9, 
   3.7512446526642714`*^9}, 3.7512450693463917`*^9, 3.751245129916429*^9, 
   3.751245199944006*^9, 3.751245811673089*^9, 3.75124584198965*^9, 
   3.75124587430195*^9, {3.751247099662253*^9, 3.751247148020466*^9}, {
   3.751824169273649*^9, 3.751824200839072*^9}, {3.751824834023649*^9, 
   3.751824842421855*^9}, 3.751827401299355*^9, 3.751859686323544*^9, 
   3.7518611251161623`*^9},
 CellLabel->"Out[181]//TableForm=",
 CellID->1013789185,ExpressionUUID->"6efb44e4-174c-4423-a53f-faed0947a940"]
}, Open  ]],

Cell["\<\
Linearize the state and output equations about operating point.\
\>", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.7512479601059103`*^9}},
 CellID->1203125043,ExpressionUUID->"803335eb-e2ce-48e1-9210-39bfcf0a5ca1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"abe", "=", 
   RowBox[{"linearizeState", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "stateEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdf", "=", 
   RowBox[{"linearizeOutput", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"e", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"d", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"f", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<A = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<B = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<E = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<C = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<D = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<F = \>\"", ",", "#"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.751247952610923*^9}},
 CellLabel->"In[182]:=",
 CellID->1625490944,ExpressionUUID->"ecd3e4ad-5904-465e-9124-79fdd630b9eb"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", 
        RowBox[{"-", 
         FractionBox["1", "m"]}]},
       {"k", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["A = ", 
   MatrixForm[{{0, (-1)/$CellContext`m}, {$CellContext`k, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.7512479054789753`*^9, 3.751247981654084*^9, 
  3.75182484252385*^9, 3.751827401428131*^9, 3.751859686436811*^9, 
  3.751861125202643*^9},
 CellLabel->"During evaluation of In[182]:=",
 CellID->619576997,ExpressionUUID->"75ef5450-1e81-4842-806a-3f462f818e96"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"B = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["1", "m"]},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["B = ", 
   MatrixForm[{{$CellContext`m^(-1)}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.7512479054789753`*^9, 3.751247981654084*^9, 
  3.75182484252385*^9, 3.751827401428131*^9, 3.751859686436811*^9, 
  3.7518611252163477`*^9},
 CellLabel->"During evaluation of In[182]:=",
 CellID->82384276,ExpressionUUID->"f1828fc1-d591-4f74-8ca9-96d8dceed494"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"E = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["E = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.7512479054789753`*^9, 3.751247981654084*^9, 
  3.75182484252385*^9, 3.751827401428131*^9, 3.751859686436811*^9, 
  3.751861125226799*^9},
 CellLabel->"During evaluation of In[182]:=",
 CellID->1653058064,ExpressionUUID->"734e1e3a-542f-4968-bc56-5184e2d7ae90"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{1, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.7512479054789753`*^9, 3.751247981654084*^9, 
  3.75182484252385*^9, 3.751827401428131*^9, 3.751859686436811*^9, 
  3.751861125232244*^9},
 CellLabel->"During evaluation of In[182]:=",
 CellID->950940409,ExpressionUUID->"83ced470-b4bc-4df3-ae6e-f7b1cb9f448a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.7512479054789753`*^9, 3.751247981654084*^9, 
  3.75182484252385*^9, 3.751827401428131*^9, 3.751859686436811*^9, 
  3.751861125237637*^9},
 CellLabel->"During evaluation of In[182]:=",
 CellID->882153089,ExpressionUUID->"6edb56dc-fad1-4e9e-949c-d396f150c43a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.7512479054789753`*^9, 3.751247981654084*^9, 
  3.75182484252385*^9, 3.751827401428131*^9, 3.751859686436811*^9, 
  3.75186112524302*^9},
 CellLabel->"During evaluation of In[182]:=",
 CellID->119867935,ExpressionUUID->"2e68e59f-573b-4755-8e27-0b8e72f3ba45"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.751247777986847*^9, 3.7512477786142197`*^9}},
 CellID->1491226901,ExpressionUUID->"818ede21-086f-461f-b6ab-18e02693a2e7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.747505552707037*^9, {3.7475057578295593`*^9, 3.747505759222794*^9}, {
   3.747505842150148*^9, 3.7475058458319883`*^9}, {3.747505896191999*^9, 
   3.74750589728131*^9}, {3.748124150238531*^9, 3.748124150517943*^9}, 
   3.748169029221862*^9, 3.748173159140067*^9},
 CellLabel->"In[192]:=",
 CellID->568706413,ExpressionUUID->"ee7dfa62-251b-4a08-8d2b-e65c25474c5a"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{
       RowBox[{"-", "1"}], "/", "m"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"k", ",", "0"}], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.747505555643032*^9, 3.7475055867312613`*^9}, {
   3.747505761476728*^9, 3.747505764318122*^9}, {3.747505847665118*^9, 
   3.7475058502692757`*^9}, {3.747505898843794*^9, 3.74750590124069*^9}, {
   3.7475063255823507`*^9, 3.747506334276267*^9}, {3.7481241530496283`*^9, 
   3.748124156712919*^9}, 3.7481690353265944`*^9, 3.748169636112513*^9, {
   3.748173473839587*^9, 3.748173474126687*^9}, {3.74817371051915*^9, 
   3.748173715241394*^9}},
 CellID->1555578576,ExpressionUUID->"6da55ee6-22a8-4ab8-8095-58f1a903fb20"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", RowBox[{\\\"-\\\", \
FractionBox[\\\"1\\\", \\\"m\\\"]}]}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"k\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}]}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"0\", \
\",\", RowBox[{\"-\", FractionBox[\"1\", \"m\"]}]}], \"}\"}], \",\", RowBox[{\
\"{\", RowBox[{\"k\", \",\", \"0\"}], \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", RowBox[{\\\"-\\\", \
FractionBox[\\\"1\\\", \\\"m\\\"]}]}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"k\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}]}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"0\", \
\",\", RowBox[{\"-\", FractionBox[\"1\", \"m\"]}]}], \"}\"}], \",\", RowBox[{\
\"{\", RowBox[{\"k\", \",\", \"0\"}], \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0004110000000014935`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0004110000000014935`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->280722659,ExpressionUUID->"229230bd-9c0a-4868-94f7-1df7939bb31d"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->84157354,ExpressionUUID->"63539d3f-1cf6-42ca-8d8e-dbfeb7823b03"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169118881194*^9, 3.748173163347743*^9},
 CellLabel->"In[193]:=",
 CellID->828567318,ExpressionUUID->"f3aa0ded-b66e-4ba0-ba9d-8eb6098210ff"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", "/", "m"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169152633688*^9, 3.748169166417688*^9}, 
   3.74816963354661*^9, {3.748173476991599*^9, 3.748173477207234*^9}, {
   3.748173718402317*^9, 3.7481737245612183`*^9}},
 CellID->128945674,ExpressionUUID->"d42cd582-3106-4118-b4e4-2c98a21854f9"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", FractionBox[\\\"1\\\", \\\"m\\\"], \\\"}\\\"}], \\\
\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", FractionBox[\"1\
\", \"m\"], \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", FractionBox[\\\"1\\\", \\\"m\\\"], \\\"}\\\"}], \\\
\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", FractionBox[\"1\
\", \"m\"], \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015299999999918157`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015299999999918157`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1388408952,ExpressionUUID->"211e0e32-201c-488e-822a-4d24c9baa15f"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->431947962,ExpressionUUID->"f52807c6-0a5a-4b2b-aa87-f7452a875aca"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169171923123*^9, 3.748173164911187*^9},
 CellLabel->"In[194]:=",
 CellID->762042712,ExpressionUUID->"2b29f8e6-ef61-416d-a369-e1904dc76977"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], "}"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481691806324472`*^9, 3.748169184126515*^9}, 
   3.748173481202936*^9},
 CellID->1905357201,ExpressionUUID->"d2ffdc76-3788-480e-a407-b5371da9f199"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\
\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"1\", \",\", \
\"0\"}], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\
\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"1\", \",\", \
\"0\"}], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00016599999999833415`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00016599999999833415`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1254670474,ExpressionUUID->"018aa1fc-dcfc-4fcd-b8ed-75f0c66780ca"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1104726625,ExpressionUUID->"14a80396-946c-48e7-ad53-282ed7f9ed0c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169187965559*^9, 3.748173168819294*^9},
 CellLabel->"In[195]:=",
 CellID->874052351,ExpressionUUID->"2ecb5664-43ee-49d6-b964-ef49e30ffb55"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", "0", "}"}], "}"}], "//", "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169193927287*^9, 3.748169194789258*^9}, 
   3.748173483306939*^9},
 CellID->53518265,ExpressionUUID->"a0af1a9f-31c9-4b84-8c0f-5c246714af42"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
000162999999998803`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.000162999999998803`\", \"\\\"s\\\
\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->2144258060,ExpressionUUID->"fde04b53-fa48-4878-b91f-5d42ac1e6180"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1622134113,ExpressionUUID->"19b7400c-dafa-4a81-b26f-a089000b8176"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"e", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.74816921143508*^9, 3.7481731714584217`*^9},
 CellLabel->"In[196]:=",
 CellID->1194284115,ExpressionUUID->"08515548-57ad-4a21-a53d-7faa42e47d9f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "b", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692120543423`*^9, 3.748169217153222*^9}, 
   3.748169629796362*^9, {3.748170254586813*^9, 3.748170264998879*^9}, 
   3.748173488427895*^9},
 CellID->888736535,ExpressionUUID->"6752d434-63cb-4a80-82be-f26182fee20c"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015800000000076864`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015800000000076864`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->903138526,ExpressionUUID->"3cf8a044-09a0-4b40-aa02-12dade3d6f1e"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->634789486,ExpressionUUID->"9bccffeb-a3b9-468c-9460-e89d705961d4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169221684237*^9, 3.748173173209854*^9},
 CellLabel->"In[197]:=",
 CellID->620734353,ExpressionUUID->"85409f48-961a-489a-8e11-b7460147dd4c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "d", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692270490217`*^9, 3.748169230838327*^9}, {
   3.748170267049563*^9, 3.748170276384123*^9}, 3.748173486450492*^9},
 CellID->837014992,ExpressionUUID->"dab89008-23a0-4b7a-a852-ac6d5b6104b8"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001610000000002998`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001610000000002998`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->208132906,ExpressionUUID->"062c1d69-352b-47d8-89d9-b721217ddeb8"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1986373826,ExpressionUUID->"d24ce924-92b7-4c9c-a0f4-c1b13d728c26"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test System 7", "Section",
 CellChangeTimes->{{3.7481692698005457`*^9, 3.748169273381559*^9}, 
   3.7481693114624357`*^9, {3.748169361271824*^9, 3.748169361361087*^9}, {
   3.748170308281064*^9, 3.7481703083633633`*^9}, {3.748171876095627*^9, 
   3.748171876178361*^9}, {3.748173822514773*^9, 3.748173822575068*^9}, {
   3.748201957095229*^9, 3.748201957209919*^9}, {3.748202693602541*^9, 
   3.748202694592355*^9}},
 CellID->807955020,ExpressionUUID->"5fa63185-5d53-4f84-9386-b800c0aed41d"],

Cell["Rowell and Wormley Example 5.3", "Text",
 CellChangeTimes->{{3.748169314267838*^9, 3.748169333731399*^9}, {
  3.748169368971754*^9, 3.748169377466568*^9}, {3.74817032089456*^9, 
  3.748170327324637*^9}, {3.748171903869137*^9, 3.748171911436009*^9}, {
  3.748173840454677*^9, 3.748173847774159*^9}, {3.748201999818125*^9, 
  3.748202000841951*^9}, {3.748202706062766*^9, 3.74820270612952*^9}},
 CellID->1951505576,ExpressionUUID->"d64f6588-bfe9-4694-963c-a971997bc278"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"Fs", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primaryVars", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vm", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Fk", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"FB", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outExps", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vm", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Fk", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"elementalEqs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"vm", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Fm", "[", "t", "]"}], "/", "m"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Fk", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{"k", " ", 
       RowBox[{"vk", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FB", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"B", " ", 
       RowBox[{"vB", "[", "t", "]"}]}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"constraintEqs", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Fm", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Fs", "[", "t", "]"}], "-", 
       RowBox[{"FB", "[", "t", "]"}], "-", 
       RowBox[{"Fk", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vk", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"vm", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vB", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"vm", "[", "t", "]"}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.747499218184157*^9, 3.74749931067735*^9}, {
   3.7474997703057547`*^9, 3.747499862953096*^9}, {3.7475000427164516`*^9, 
   3.7475001179609213`*^9}, 3.747500172506531*^9, {3.7475052421578627`*^9, 
   3.7475052437525806`*^9}, {3.7475052792870703`*^9, 3.747505305743517*^9}, {
   3.7475054395550127`*^9, 3.74750549238805*^9}, {3.748169383980278*^9, 
   3.748169603265369*^9}, {3.748170115690106*^9, 3.748170132266461*^9}, {
   3.748170333165715*^9, 3.7481705921461983`*^9}, {3.748171917577342*^9, 
   3.74817195326005*^9}, {3.748171995123074*^9, 3.7481720024895773`*^9}, {
   3.748172035662871*^9, 3.7481721909688787`*^9}, {3.748173852472159*^9, 
   3.7481740097196913`*^9}, {3.7482022679021463`*^9, 3.748202298767332*^9}, {
   3.748202329707706*^9, 3.748202426597817*^9}, {3.7482027090106783`*^9, 
   3.748202788912438*^9}, {3.751248098456787*^9, 3.7512482034937897`*^9}, {
   3.751824866491272*^9, 3.75182489318155*^9}, {3.751824944032604*^9, 
   3.751824944234847*^9}},
 CellLabel->"In[198]:=",
 CellID->1519740058,ExpressionUUID->"0e5b66ae-6b16-4a40-9857-672d626e7c86"],

Cell["Find state equation.", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.75124789335491*^9}},
 CellID->205081466,ExpressionUUID->"ce2c32f3-5a4f-4724-b195-77ffa8db416c"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stateSolution", "=", 
   RowBox[{
    RowBox[{"stateEquations", "[", 
     RowBox[{
     "inVars", ",", "primaryVars", ",", "elementalEqs", ",", 
      "constraintEqs"}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateVars", " ", "=", " ", 
   RowBox[{"\"\<state variables\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateEqList", " ", "=", " ", 
   RowBox[{"\"\<RHS\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\"\<state equations\>\"", "/.", "stateSolution"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.7018797195836763`*^9, 3.7018797204767036`*^9}, {
   3.701879810803969*^9, 3.701879844544981*^9}, {3.7018942050184517`*^9, 
   3.701894566874161*^9}, 3.701898020551093*^9, {3.701903282327601*^9, 
   3.701903283500523*^9}, {3.701911200698804*^9, 3.701911202601316*^9}, {
   3.701915682054678*^9, 3.701915720675168*^9}, {3.701915759772274*^9, 
   3.7019157927706213`*^9}, {3.701915923602686*^9, 3.701915923900078*^9}, 
   3.7019209193048553`*^9, 3.701920950145496*^9, {3.701921306764739*^9, 
   3.701921308673313*^9}, {3.701921408184596*^9, 3.7019214156809187`*^9}, 
   3.7019220747800493`*^9, {3.701922189786292*^9, 3.701922218088579*^9}, {
   3.701922248592429*^9, 3.701922251876824*^9}, 3.701922322852202*^9, {
   3.701922383801173*^9, 3.7019224315654707`*^9}, {3.701922463501308*^9, 
   3.7019224895050097`*^9}, 3.7019225472984467`*^9, {3.701922594846767*^9, 
   3.701922598092758*^9}, {3.701922662563005*^9, 3.701922735877761*^9}, {
   3.7019231046383343`*^9, 3.701923105684675*^9}, {3.7019639715923243`*^9, 
   3.7019639718841667`*^9}, {3.7019642654040737`*^9, 3.701964352167139*^9}, {
   3.701964387110903*^9, 3.7019644147887087`*^9}, {3.702757419429731*^9, 
   3.7027575039883213`*^9}, {3.7511302149210863`*^9, 3.751130222225973*^9}, 
   3.751131245052647*^9, 3.7518224212768917`*^9, 3.7518595722003613`*^9, 
   3.751859962421912*^9, 3.751860991893059*^9, 3.7519374018238077`*^9},
 CellID->1816140723,ExpressionUUID->"261de412-8f59-4fc9-a0d0-47c3f7b4ef94"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["vm", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"Fk", "[", "t", "]"}], "m"]}], "+", 
       FractionBox[
        RowBox[{"Fs", "[", "t", "]"}], "m"], "-", 
       FractionBox[
        RowBox[{"B", " ", 
         RowBox[{"vm", "[", "t", "]"}]}], "m"]}]}]},
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["Fk", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{"k", " ", 
       RowBox[{"vm", "[", "t", "]"}]}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751131246142264*^9, 3.751131562228766*^9, 3.751154207578877*^9, 
   3.751155061538066*^9, 3.7511551539969883`*^9, 3.7511556539137783`*^9, 
   3.751156830900199*^9, 3.751157044451893*^9, 3.751157305712584*^9, 
   3.751157692923893*^9, 3.751237248504381*^9, 3.7512373121455393`*^9, 
   3.751237557961287*^9, {3.7512412411479073`*^9, 3.751241257691305*^9}, 
   3.7512413334070673`*^9, 3.751241455823284*^9, 3.751241611586341*^9, 
   3.7512433878599854`*^9, 3.751243524307231*^9, 3.751243608962484*^9, 
   3.7512437545853853`*^9, 3.751243860047454*^9, 3.7512441819725847`*^9, 
   3.751244399097206*^9, 3.751244486437664*^9, 3.75124455927641*^9, 
   3.75124464012558*^9, 3.75124506931707*^9, 3.751245129883816*^9, 
   3.751245199900049*^9, 3.751245786492696*^9, 3.7512458405736723`*^9, 
   3.751245872204157*^9, {3.7512470996055098`*^9, 3.751247133340377*^9}, 
   3.751822506215632*^9, {3.751822707767754*^9, 3.751822723484655*^9}, 
   3.751822800835991*^9, 3.7518235244045973`*^9, 3.751823574246002*^9, 
   3.75182394710122*^9, 3.751824050485718*^9, {3.751824086094249*^9, 
   3.7518241542062597`*^9}, 3.751824200734988*^9, 3.751824907878703*^9, {
   3.751824946854702*^9, 3.75182495340958*^9}, 3.7518274485918093`*^9, 
   3.751861136932356*^9},
 CellLabel->"Out[206]//TableForm=",
 CellID->204117320,ExpressionUUID->"4b8efab3-f6e7-4a1a-9961-850b8fa0a150"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"outEqList", "=", 
   RowBox[{"outEquations", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outExps", ",", 
     RowBox[{"elementalEqs", "~", "Join", "~", "constraintEqs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outEqList", "//", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"y", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "outExps", "]"}]}], "}"}]}], "]"}], 
      "\[Equal]", "#"}], "]"}], "&"}]}], "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.75115407229806*^9, 3.7511540907068577`*^9}, {
   3.7511541283727303`*^9, 3.751154145140655*^9}, {3.751154185947949*^9, 
   3.751154186454541*^9}, {3.75115440553708*^9, 3.751154408241644*^9}, {
   3.751157061478198*^9, 3.75115706228808*^9}, {3.751157258647379*^9, 
   3.751157263470278*^9}, {3.751157318329653*^9, 3.751157382599204*^9}, 
   3.751243546881419*^9, 3.7512446518094807`*^9, {3.7518241789029417`*^9, 
   3.751824190813037*^9}},
 CellLabel->"In[207]:=",
 CellID->1417662976,ExpressionUUID->"31ab87e4-e77e-4515-89a0-776431a9ca7c"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{"y", "[", "1", "]"}], "\[Equal]", 
       RowBox[{"vm", "[", "t", "]"}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "2", "]"}], "\[Equal]", 
       RowBox[{"Fk", "[", "t", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751154146341402*^9, {3.7511541874520807`*^9, 3.75115421035389*^9}, 
   3.751154409289606*^9, 3.751155063159431*^9, 3.7511551578703537`*^9, {
   3.751155631171876*^9, 3.7511556669733973`*^9}, 3.751156831153225*^9, {
   3.7511570444961233`*^9, 3.751157063011318*^9}, 3.7511573845757217`*^9, 
   3.7511576929574337`*^9, 3.751237248545403*^9, 3.75123731846103*^9, 
   3.751237558009218*^9, 3.75124126512782*^9, 3.751241341691312*^9, 
   3.7512414602930183`*^9, {3.7512415890389347`*^9, 3.751241614550478*^9}, 
   3.751243391757332*^9, {3.751243525864511*^9, 3.7512435473077707`*^9}, 
   3.7512436090180597`*^9, 3.751243754645124*^9, 3.751243860169832*^9, 
   3.751244182055914*^9, 3.751244399162704*^9, 3.751244486514542*^9, 
   3.751244523619996*^9, 3.7512445593242817`*^9, {3.751244640162719*^9, 
   3.7512446526642714`*^9}, 3.7512450693463917`*^9, 3.751245129916429*^9, 
   3.751245199944006*^9, 3.751245811673089*^9, 3.75124584198965*^9, 
   3.75124587430195*^9, {3.751247099662253*^9, 3.751247148020466*^9}, {
   3.751824169273649*^9, 3.751824200839072*^9}, 3.751824953547636*^9, 
   3.75182744877538*^9, 3.751861137067021*^9},
 CellLabel->"Out[208]//TableForm=",
 CellID->1068412981,ExpressionUUID->"96406a49-cf3e-4c65-8ead-e6e4a0d86ed4"]
}, Open  ]],

Cell["\<\
Linearize the state and output equations about operating point.\
\>", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.7512479601059103`*^9}},
 CellID->183089538,ExpressionUUID->"fd1b8b92-4837-4dd3-95eb-bb1d7e6d6dd1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"abe", "=", 
   RowBox[{"linearizeState", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "stateEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdf", "=", 
   RowBox[{"linearizeOutput", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"e", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"d", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"f", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<A = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<B = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<E = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<C = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<D = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<F = \>\"", ",", "#"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.751247952610923*^9}},
 CellLabel->"In[209]:=",
 CellID->1989282662,ExpressionUUID->"80aba029-e8ce-4e54-8687-2e9ba1631da0"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox["B", "m"]}], 
        RowBox[{"-", 
         FractionBox["1", "m"]}]},
       {"k", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["A = ", 
   MatrixForm[{{-$CellContext`B/$CellContext`m, (-1)/$CellContext`m}, \
{$CellContext`k, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.751824953718067*^9, 
  3.751827448980358*^9, 3.751861137179367*^9},
 CellLabel->"During evaluation of In[209]:=",
 CellID->1706199100,ExpressionUUID->"3040bda4-44c3-4490-81b2-0d0ea9c794ba"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"B = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["1", "m"]},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["B = ", 
   MatrixForm[{{$CellContext`m^(-1)}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.751824953718067*^9, 
  3.751827448980358*^9, 3.751861137189979*^9},
 CellLabel->"During evaluation of In[209]:=",
 CellID->739135309,ExpressionUUID->"df48d758-4915-4c6c-ab90-d1d4eb142c79"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"E = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["E = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.751824953718067*^9, 
  3.751827448980358*^9, 3.751861137210534*^9},
 CellLabel->"During evaluation of In[209]:=",
 CellID->1601724115,ExpressionUUID->"201351f5-b9db-42bc-a888-9daf65a4b3cc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0"},
       {"0", "1"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{1, 0}, {0, 1}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.751824953718067*^9, 
  3.751827448980358*^9, 3.7518611372160063`*^9},
 CellLabel->"During evaluation of In[209]:=",
 CellID->1469685660,ExpressionUUID->"58518d2a-ae8e-412f-b318-452e660ead34"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.751824953718067*^9, 
  3.751827448980358*^9, 3.75186113722152*^9},
 CellLabel->"During evaluation of In[209]:=",
 CellID->649979826,ExpressionUUID->"ef07dfe1-9d36-458e-be57-fd73d3c4a9c8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.751824953718067*^9, 
  3.751827448980358*^9, 3.7518611372270117`*^9},
 CellLabel->"During evaluation of In[209]:=",
 CellID->2109106940,ExpressionUUID->"b0382dfe-3615-477b-bde2-4835b9d9de42"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.75124808019132*^9, 3.7512480809379053`*^9}},
 CellID->1848283738,ExpressionUUID->"b0a0d56a-bf89-434f-875e-e93c5c8a063f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.747505552707037*^9, {3.7475057578295593`*^9, 3.747505759222794*^9}, {
   3.747505842150148*^9, 3.7475058458319883`*^9}, {3.747505896191999*^9, 
   3.74750589728131*^9}, {3.748124150238531*^9, 3.748124150517943*^9}, 
   3.748169029221862*^9, 3.748173244647019*^9},
 CellLabel->"In[219]:=",
 CellID->1754857514,ExpressionUUID->"9a396330-aaf9-444b-af98-23361d0f2a85"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "B"}], "/", "m"}], ",", 
      RowBox[{
       RowBox[{"-", "1"}], "/", "m"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"k", ",", "0"}], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.747505555643032*^9, 3.7475055867312613`*^9}, {
   3.747505761476728*^9, 3.747505764318122*^9}, {3.747505847665118*^9, 
   3.7475058502692757`*^9}, {3.747505898843794*^9, 3.74750590124069*^9}, {
   3.7475063255823507`*^9, 3.747506334276267*^9}, {3.7481241530496283`*^9, 
   3.748124156712919*^9}, 3.7481690353265944`*^9, {3.748169641556839*^9, 
   3.748169730141844*^9}, {3.7481706308795347`*^9, 3.748170648343268*^9}, {
   3.7481713324991817`*^9, 3.748171412017522*^9}, {3.7481722117935038`*^9, 
   3.748172266534639*^9}, {3.748172557215331*^9, 3.748172586783577*^9}, 
   3.748172811167288*^9, {3.748173455617723*^9, 3.748173456202003*^9}, {
   3.748173684193961*^9, 3.7481736910145693`*^9}, {3.748174023178488*^9, 
   3.748174074694357*^9}, {3.7482024431310062`*^9, 3.7482024882994432`*^9}, {
   3.748203045867991*^9, 3.748203049432695*^9}, {3.7482031539741383`*^9, 
   3.748203165353072*^9}},
 CellID->168180068,ExpressionUUID->"ae922c8f-6b2f-4e9b-8458-1f4fe75b57cc"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"B\\\", \
\\\"m\\\"]}], \\\",\\\", RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \
\\\"m\\\"]}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"k\\\", \
\\\",\\\", \\\"0\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"B\", \"m\"]}], \",\", RowBox[{\"-\", \
FractionBox[\"1\", \"m\"]}]}], \"}\"}], \",\", RowBox[{\"{\", RowBox[{\"k\", \
\",\", \"0\"}], \"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\
\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"B\\\", \
\\\"m\\\"]}], \\\",\\\", RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \
\\\"m\\\"]}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"k\\\", \
\\\",\\\", \\\"0\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"B\", \"m\"]}], \",\", RowBox[{\"-\", \
FractionBox[\"1\", \"m\"]}]}], \"}\"}], \",\", RowBox[{\"{\", RowBox[{\"k\", \
\",\", \"0\"}], \"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\
\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00047599999999903275`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00047599999999903275`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1395263198,ExpressionUUID->"7f00db5e-8d87-4f86-9140-cedb8940df73"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1814627193,ExpressionUUID->"4c0cdfc8-273e-4276-9e8f-452e5d8752cc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.748169118881194*^9, {3.748173109584269*^9, 3.748173111317824*^9}},
 CellLabel->"In[220]:=",
 CellID->1705075774,ExpressionUUID->"36415f51-b70d-4b49-9f3e-5d26f8c89901"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", "/", "m"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169152633688*^9, 3.748169166417688*^9}, 
   3.74816961437001*^9, {3.748169735895432*^9, 3.74816976416591*^9}, {
   3.7481714534342337`*^9, 3.748171524401494*^9}, {3.748172277994993*^9, 
   3.748172388840468*^9}, {3.748173070786932*^9, 3.7481730730294323`*^9}, {
   3.748173117430595*^9, 3.7481731307454023`*^9}, {3.748173458595439*^9, 
   3.74817345887745*^9}, {3.748173695194269*^9, 3.748173699950642*^9}, {
   3.748202504888515*^9, 3.7482025270319357`*^9}, {3.748203173557973*^9, 
   3.748203178913308*^9}},
 CellID->836054372,ExpressionUUID->"13fa82ef-a53e-49e8-8a93-4a4b81a79e42"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", FractionBox[\\\"1\\\", \\\"m\\\"], \\\"}\\\"}], \\\
\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", FractionBox[\"1\
\", \"m\"], \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", FractionBox[\\\"1\\\", \\\"m\\\"], \\\"}\\\"}], \\\
\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", FractionBox[\"1\
\", \"m\"], \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015899999999824388`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015899999999824388`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->2023961704,ExpressionUUID->"e572dc1c-8394-4229-ac06-8953df820e9f"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->583390648,ExpressionUUID->"876eefae-83cd-41f6-866b-32d9df676ff5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169171923123*^9, 3.748173146603053*^9},
 CellLabel->"In[221]:=",
 CellID->1688325336,ExpressionUUID->"008a6ca4-4e4e-4413-9765-ba86fc9fbd69"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481691806324472`*^9, 3.748169184126515*^9}, {
   3.7481697745097303`*^9, 3.7481698177840567`*^9}, 3.748170212558292*^9, {
   3.74817153653963*^9, 3.748171557948637*^9}, {3.748172403638979*^9, 
   3.748172459180491*^9}, 3.748173461553569*^9, {3.748202537450017*^9, 
   3.748202581324718*^9}, {3.748203197531724*^9, 3.74820320090259*^9}},
 CellID->438342181,ExpressionUUID->"49423afe-4ed7-4c80-80a0-05c40ed86d82"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\
\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"1\", \
\",\", \"0\"}], \"}\"}], \",\", RowBox[{\"{\", RowBox[{\"0\", \",\", \"1\"}], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\
\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"1\", \
\",\", \"0\"}], \"}\"}], \",\", RowBox[{\"{\", RowBox[{\"0\", \",\", \"1\"}], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015399999999843317`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015399999999843317`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1783772381,ExpressionUUID->"09f456da-60fb-4708-b9ef-f64c1d02e9c8"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->990695347,ExpressionUUID->"f732b6c2-8471-44cf-bcef-cf596f0e037d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169187965559*^9, 3.748173150905864*^9},
 CellLabel->"In[222]:=",
 CellID->1866551030,ExpressionUUID->"387ce3c7-7236-4028-9716-93052bca029c"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169193927287*^9, 3.748169194789258*^9}, {
   3.748169826851533*^9, 3.7481698714627047`*^9}, {3.748171572452416*^9, 
   3.748171580237145*^9}, {3.748172509134172*^9, 3.7481725445555677`*^9}, {
   3.748172960660345*^9, 3.7481729614507627`*^9}, 3.7481734650745153`*^9, {
   3.7482025915862713`*^9, 3.748202630873435*^9}, {3.748203221716777*^9, 
   3.748203224246625*^9}},
 CellID->1620274030,ExpressionUUID->"f114040b-03b7-457c-9a5c-61ecf8d7be6a"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00016399999999983095`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00016399999999983095`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1175981838,ExpressionUUID->"fcb11072-7ea6-4bd2-abd7-aa4e6b84dfb8"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1434747925,ExpressionUUID->"7eb7d7fa-5573-412d-9d6d-79f31bb981fb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"e", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.74816921143508*^9, 3.74817315251501*^9},
 CellLabel->"In[223]:=",
 CellID->1807272232,ExpressionUUID->"80a28f5e-d696-404d-9a10-fea8888f93e8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "b", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692120543423`*^9, 3.748169217153222*^9}, 
   3.748169620186891*^9, {3.7481699674394503`*^9, 3.7481699868030443`*^9}, 
   3.748173467456937*^9},
 CellID->542719504,ExpressionUUID->"dca8acbf-2330-499d-aca6-db2befb2aa56"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015699999999974068`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015699999999974068`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1861986959,ExpressionUUID->"94929195-6535-46ea-8884-a2b78d5ce992"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1283115829,ExpressionUUID->"4c8743d3-6342-4078-bc78-0350b6f873b6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169221684237*^9, 3.7481731563003674`*^9},
 CellLabel->"In[224]:=",
 CellID->438324506,ExpressionUUID->"e96bd6a7-ae4b-4f7b-81e9-bb8f3c106e35"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "d", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692270490217`*^9, 3.748169230838327*^9}, {
   3.748169991971572*^9, 3.748170004254684*^9}, 3.748173469973262*^9},
 CellID->1777068154,ExpressionUUID->"fbfad1ac-cff0-4a87-ac63-6027ab0681f3"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001610000000002998`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001610000000002998`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->296954829,ExpressionUUID->"a9907071-676b-4e57-a653-840d64fc9d11"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->167815375,ExpressionUUID->"71842014-ca77-41c8-8ba4-ac3b83ae0239"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test System 8", "Section",
 CellChangeTimes->{{3.7481692698005457`*^9, 3.748169273381559*^9}, 
   3.7481693114624357`*^9, {3.748169361271824*^9, 3.748169361361087*^9}, {
   3.748170308281064*^9, 3.7481703083633633`*^9}, {3.748171876095627*^9, 
   3.748171876178361*^9}, {3.748173822514773*^9, 3.748173822575068*^9}, {
   3.748201957095229*^9, 3.748201957209919*^9}, {3.748202693602541*^9, 
   3.748202694592355*^9}, {3.748203258099217*^9, 3.748203258755952*^9}},
 CellID->1513383795,ExpressionUUID->"7eff7695-b3f2-4905-b929-2687a075b628"],

Cell[CellGroupData[{

Cell["System model", "Subsection",
 CellChangeTimes->{{3.7512866318884087`*^9, 3.751286633462303*^9}},
 CellID->360278988,ExpressionUUID->"c69b6b75-fb03-4833-8306-d3f29ad5424b"],

Cell["Rowell and Wormley Example 5.4", "Text",
 CellChangeTimes->{{3.748169314267838*^9, 3.748169333731399*^9}, {
  3.748169368971754*^9, 3.748169377466568*^9}, {3.74817032089456*^9, 
  3.748170327324637*^9}, {3.748171903869137*^9, 3.748171911436009*^9}, {
  3.748173840454677*^9, 3.748173847774159*^9}, {3.748201999818125*^9, 
  3.748202000841951*^9}, {3.748202706062766*^9, 3.74820270612952*^9}, {
  3.748203275897526*^9, 3.7482032759962273`*^9}},
 CellID->1555907635,ExpressionUUID->"223ca98d-5c87-4361-b119-aefe6ccb5dba"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"ws", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primaryVars", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"wj", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"TB1", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"TB2", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outExps", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"wj", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"elementalEqs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"wj", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Tj", "[", "t", "]"}], " ", "/", " ", "J"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TB1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"B1", " ", 
       RowBox[{"wB1", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TB2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"B2", " ", 
       RowBox[{"wB2", "[", "t", "]"}]}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"constraintEqs", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Tj", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"TB2", "[", "t", "]"}], "-", 
       RowBox[{"TB1", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"wB2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"ws", "[", "t", "]"}], "-", 
       RowBox[{"wj", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"wB1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"wj", "[", "t", "]"}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.747499218184157*^9, 3.74749931067735*^9}, {
   3.7474997703057547`*^9, 3.747499862953096*^9}, {3.7475000427164516`*^9, 
   3.7475001179609213`*^9}, 3.747500172506531*^9, {3.7475052421578627`*^9, 
   3.7475052437525806`*^9}, {3.7475052792870703`*^9, 3.747505305743517*^9}, {
   3.7475054395550127`*^9, 3.74750549238805*^9}, {3.748169383980278*^9, 
   3.748169603265369*^9}, {3.748170115690106*^9, 3.748170132266461*^9}, {
   3.748170333165715*^9, 3.7481705921461983`*^9}, {3.748171917577342*^9, 
   3.74817195326005*^9}, {3.748171995123074*^9, 3.7481720024895773`*^9}, {
   3.748172035662871*^9, 3.7481721909688787`*^9}, {3.748173852472159*^9, 
   3.7481740097196913`*^9}, {3.7482022679021463`*^9, 3.748202298767332*^9}, {
   3.748202329707706*^9, 3.748202426597817*^9}, {3.7482027090106783`*^9, 
   3.748202788912438*^9}, {3.74820743586224*^9, 3.748207471308917*^9}, {
   3.748207507244035*^9, 3.748207585893305*^9}, {3.7512866499323072`*^9, 
   3.751286696945836*^9}, {3.7512867468072777`*^9, 3.7512868045975237`*^9}, 
   3.751286880069577*^9, {3.751825012471862*^9, 3.751825044409275*^9}},
 CellLabel->"In[225]:=",
 CellID->1337573792,ExpressionUUID->"6ad8cc8a-3465-4d12-978d-cf24281eaed3"],

Cell["Find state equation.", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.75124789335491*^9}},
 CellID->248883740,ExpressionUUID->"e92ef1bf-7a57-46b0-a0e9-f4d3e30a6471"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stateSolution", "=", 
   RowBox[{
    RowBox[{"stateEquations", "[", 
     RowBox[{
     "inVars", ",", "primaryVars", ",", "elementalEqs", ",", 
      "constraintEqs"}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateVars", " ", "=", " ", 
   RowBox[{"\"\<state variables\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateEqList", " ", "=", " ", 
   RowBox[{"\"\<RHS\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\"\<state equations\>\"", "/.", "stateSolution"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.7018797195836763`*^9, 3.7018797204767036`*^9}, {
   3.701879810803969*^9, 3.701879844544981*^9}, {3.7018942050184517`*^9, 
   3.701894566874161*^9}, 3.701898020551093*^9, {3.701903282327601*^9, 
   3.701903283500523*^9}, {3.701911200698804*^9, 3.701911202601316*^9}, {
   3.701915682054678*^9, 3.701915720675168*^9}, {3.701915759772274*^9, 
   3.7019157927706213`*^9}, {3.701915923602686*^9, 3.701915923900078*^9}, 
   3.7019209193048553`*^9, 3.701920950145496*^9, {3.701921306764739*^9, 
   3.701921308673313*^9}, {3.701921408184596*^9, 3.7019214156809187`*^9}, 
   3.7019220747800493`*^9, {3.701922189786292*^9, 3.701922218088579*^9}, {
   3.701922248592429*^9, 3.701922251876824*^9}, 3.701922322852202*^9, {
   3.701922383801173*^9, 3.7019224315654707`*^9}, {3.701922463501308*^9, 
   3.7019224895050097`*^9}, 3.7019225472984467`*^9, {3.701922594846767*^9, 
   3.701922598092758*^9}, {3.701922662563005*^9, 3.701922735877761*^9}, {
   3.7019231046383343`*^9, 3.701923105684675*^9}, {3.7019639715923243`*^9, 
   3.7019639718841667`*^9}, {3.7019642654040737`*^9, 3.701964352167139*^9}, {
   3.701964387110903*^9, 3.7019644147887087`*^9}, {3.702757419429731*^9, 
   3.7027575039883213`*^9}, {3.7511302149210863`*^9, 3.751130222225973*^9}, 
   3.751131245052647*^9, 3.7518224212768917`*^9, 3.751859572262361*^9, 
   3.751859962427989*^9, 3.751860991897524*^9, 3.751937401889017*^9},
 CellID->43206385,ExpressionUUID->"b1a18068-cb53-465d-8510-4d59f6950431"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["wj", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "B1"}], "-", "B2"}], ")"}], " ", 
         RowBox[{"wj", "[", "t", "]"}]}], "J"], "+", 
       FractionBox[
        RowBox[{"B2", " ", 
         RowBox[{"ws", "[", "t", "]"}]}], "J"]}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751131246142264*^9, 3.751131562228766*^9, 3.751154207578877*^9, 
   3.751155061538066*^9, 3.7511551539969883`*^9, 3.7511556539137783`*^9, 
   3.751156830900199*^9, 3.751157044451893*^9, 3.751157305712584*^9, 
   3.751157692923893*^9, 3.751237248504381*^9, 3.7512373121455393`*^9, 
   3.751237557961287*^9, {3.7512412411479073`*^9, 3.751241257691305*^9}, 
   3.7512413334070673`*^9, 3.751241455823284*^9, 3.751241611586341*^9, 
   3.7512433878599854`*^9, 3.751243524307231*^9, 3.751243608962484*^9, 
   3.7512437545853853`*^9, 3.751243860047454*^9, 3.7512441819725847`*^9, 
   3.751244399097206*^9, 3.751244486437664*^9, 3.75124455927641*^9, 
   3.75124464012558*^9, 3.75124506931707*^9, 3.751245129883816*^9, 
   3.751245199900049*^9, 3.751245786492696*^9, 3.7512458405736723`*^9, 
   3.751245872204157*^9, {3.7512470996055098`*^9, 3.751247133340377*^9}, 
   3.751822506215632*^9, {3.751822707767754*^9, 3.751822723484655*^9}, 
   3.751822800835991*^9, 3.7518235244045973`*^9, 3.751823574246002*^9, 
   3.75182394710122*^9, 3.751824050485718*^9, {3.751824086094249*^9, 
   3.7518241542062597`*^9}, 3.751824200734988*^9, {3.751825060349099*^9, 
   3.7518250691164637`*^9}, 3.751827503954809*^9, 3.7518611541362133`*^9},
 CellLabel->"Out[233]//TableForm=",
 CellID->826979114,ExpressionUUID->"b7f0398c-109e-477f-a89c-741ee3942f85"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"outEqList", "=", 
   RowBox[{"outEquations", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outExps", ",", 
     RowBox[{"elementalEqs", "~", "Join", "~", "constraintEqs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outEqList", "//", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"y", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "outExps", "]"}]}], "}"}]}], "]"}], 
      "\[Equal]", "#"}], "]"}], "&"}]}], "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.75115407229806*^9, 3.7511540907068577`*^9}, {
   3.7511541283727303`*^9, 3.751154145140655*^9}, {3.751154185947949*^9, 
   3.751154186454541*^9}, {3.75115440553708*^9, 3.751154408241644*^9}, {
   3.751157061478198*^9, 3.75115706228808*^9}, {3.751157258647379*^9, 
   3.751157263470278*^9}, {3.751157318329653*^9, 3.751157382599204*^9}, 
   3.751243546881419*^9, 3.7512446518094807`*^9, {3.7518241789029417`*^9, 
   3.751824190813037*^9}},
 CellLabel->"In[234]:=",
 CellID->679811881,ExpressionUUID->"07d047f9-d8b4-488b-9431-8bb17ad23536"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{"y", "[", "1", "]"}], "\[Equal]", 
       RowBox[{"wj", "[", "t", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751154146341402*^9, {3.7511541874520807`*^9, 3.75115421035389*^9}, 
   3.751154409289606*^9, 3.751155063159431*^9, 3.7511551578703537`*^9, {
   3.751155631171876*^9, 3.7511556669733973`*^9}, 3.751156831153225*^9, {
   3.7511570444961233`*^9, 3.751157063011318*^9}, 3.7511573845757217`*^9, 
   3.7511576929574337`*^9, 3.751237248545403*^9, 3.75123731846103*^9, 
   3.751237558009218*^9, 3.75124126512782*^9, 3.751241341691312*^9, 
   3.7512414602930183`*^9, {3.7512415890389347`*^9, 3.751241614550478*^9}, 
   3.751243391757332*^9, {3.751243525864511*^9, 3.7512435473077707`*^9}, 
   3.7512436090180597`*^9, 3.751243754645124*^9, 3.751243860169832*^9, 
   3.751244182055914*^9, 3.751244399162704*^9, 3.751244486514542*^9, 
   3.751244523619996*^9, 3.7512445593242817`*^9, {3.751244640162719*^9, 
   3.7512446526642714`*^9}, 3.7512450693463917`*^9, 3.751245129916429*^9, 
   3.751245199944006*^9, 3.751245811673089*^9, 3.75124584198965*^9, 
   3.75124587430195*^9, {3.751247099662253*^9, 3.751247148020466*^9}, {
   3.751824169273649*^9, 3.751824200839072*^9}, {3.751825063249402*^9, 
   3.7518250692690973`*^9}, 3.751827504152313*^9, 3.751861154282572*^9},
 CellLabel->"Out[235]//TableForm=",
 CellID->523805614,ExpressionUUID->"92cc9e7e-f288-4b9f-af1c-b4048aa02cb6"]
}, Open  ]],

Cell["\<\
Linearize the state and output equations about operating point.\
\>", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.7512479601059103`*^9}},
 CellID->1281207206,ExpressionUUID->"4c26c8b3-83dd-4b32-996d-a2f07cbd1e51"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"abe", "=", 
   RowBox[{"linearizeState", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "stateEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdf", "=", 
   RowBox[{"linearizeOutput", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"e", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"d", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"f", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<A = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<B = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<E = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<C = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<D = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<F = \>\"", ",", "#"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.751247952610923*^9}},
 CellLabel->"In[236]:=",
 CellID->430982773,ExpressionUUID->"22d3c957-66c8-4425-a003-e1c36f53cf81"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox[
         RowBox[{
          RowBox[{"-", "B1"}], "-", "B2"}], "J"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["A = ", 
   MatrixForm[{{(-$CellContext`B1 - $CellContext`B2)/$CellContext`J}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751825069524253*^9, 3.751827504356629*^9, 3.751861154430434*^9},
 CellLabel->"During evaluation of In[236]:=",
 CellID->1065485445,ExpressionUUID->"4651a075-14b9-4264-93fe-baef5ecbb15a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"B = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["B2", "J"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["B = ", 
   MatrixForm[{{$CellContext`B2/$CellContext`J}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751825069524253*^9, 3.751827504356629*^9, 3.751861154442168*^9},
 CellLabel->"During evaluation of In[236]:=",
 CellID->1895225429,ExpressionUUID->"ec496b35-64c7-4ebe-908b-6553fa4f746a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"E = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["E = ", 
   MatrixForm[{{0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751825069524253*^9, 3.751827504356629*^9, 3.7518611544656467`*^9},
 CellLabel->"During evaluation of In[236]:=",
 CellID->1576332899,ExpressionUUID->"7f40a33e-1fd4-4e9c-bbab-4d1075dd16e5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{1}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751825069524253*^9, 3.751827504356629*^9, 3.751861154471396*^9},
 CellLabel->"During evaluation of In[236]:=",
 CellID->2068764101,ExpressionUUID->"cc8efca1-9d34-4a1f-a703-99c0ff7274c2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751825069524253*^9, 3.751827504356629*^9, 3.751861154477024*^9},
 CellLabel->"During evaluation of In[236]:=",
 CellID->1958000577,ExpressionUUID->"642ea121-b7dd-4d8a-ad6f-e419bb3f90ce"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751825069524253*^9, 3.751827504356629*^9, 3.751861154482559*^9},
 CellLabel->"During evaluation of In[236]:=",
 CellID->76291011,ExpressionUUID->"6cc54014-ed9e-4c72-8dcc-51671d1176e7"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.75124808019132*^9, 3.7512480809379053`*^9}},
 CellID->323926419,ExpressionUUID->"d2de7dfc-7b80-41f3-8250-f1e4d326080b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.747505552707037*^9, {3.7475057578295593`*^9, 3.747505759222794*^9}, {
   3.747505842150148*^9, 3.7475058458319883`*^9}, {3.747505896191999*^9, 
   3.74750589728131*^9}, {3.748124150238531*^9, 3.748124150517943*^9}, 
   3.748169029221862*^9, 3.748173244647019*^9},
 CellLabel->"In[246]:=",
 CellID->1387947054,ExpressionUUID->"a2b044f2-8810-419b-af90-eb23ae7aa302"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"B1", "+", "B2"}], "J"]}], "}"}], "}"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.747505555643032*^9, 3.7475055867312613`*^9}, {
   3.747505761476728*^9, 3.747505764318122*^9}, {3.747505847665118*^9, 
   3.7475058502692757`*^9}, {3.747505898843794*^9, 3.74750590124069*^9}, {
   3.7475063255823507`*^9, 3.747506334276267*^9}, {3.7481241530496283`*^9, 
   3.748124156712919*^9}, 3.7481690353265944`*^9, {3.748169641556839*^9, 
   3.748169730141844*^9}, {3.7481706308795347`*^9, 3.748170648343268*^9}, {
   3.7481713324991817`*^9, 3.748171412017522*^9}, {3.7481722117935038`*^9, 
   3.748172266534639*^9}, {3.748172557215331*^9, 3.748172586783577*^9}, 
   3.748172811167288*^9, {3.748173455617723*^9, 3.748173456202003*^9}, {
   3.748173684193961*^9, 3.7481736910145693`*^9}, {3.748174023178488*^9, 
   3.748174074694357*^9}, {3.7482024431310062`*^9, 3.7482024882994432`*^9}, {
   3.748203045867991*^9, 3.748203049432695*^9}, {3.7482031539741383`*^9, 
   3.748203165353072*^9}, {3.748207600236726*^9, 3.7482076437651033`*^9}},
 CellID->276496415,ExpressionUUID->"1448a586-e59d-462f-a491-1d6ea4341321"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"-\\\", FractionBox[RowBox[{\\\"B1\\\", \\\"+\\\
\", \\\"B2\\\"}], \\\"J\\\"]}], \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"-\", \
FractionBox[RowBox[{\"B1\", \"+\", \"B2\"}], \"J\"]}], \"}\"}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"-\\\", FractionBox[RowBox[{\\\"B1\\\", \\\"+\\\
\", \\\"B2\\\"}], \\\"J\\\"]}], \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"-\", \
FractionBox[RowBox[{\"B1\", \"+\", \"B2\"}], \"J\"]}], \"}\"}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
001346999999999099`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.001346999999999099`\", \"\\\"s\\\
\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->175284618,ExpressionUUID->"94974d0d-bb41-4b82-a508-39d1355cc64c"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1808494689,ExpressionUUID->"9d4b8659-0a78-401b-8274-7f6df76c3ae0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.748169118881194*^9, {3.748173109584269*^9, 3.748173111317824*^9}},
 CellLabel->"In[247]:=",
 CellID->654434760,ExpressionUUID->"f9cd6f74-fd30-4553-a629-3f3395ccd212"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"B2", "/", "J"}], "}"}], "}"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169152633688*^9, 3.748169166417688*^9}, 
   3.74816961437001*^9, {3.748169735895432*^9, 3.74816976416591*^9}, {
   3.7481714534342337`*^9, 3.748171524401494*^9}, {3.748172277994993*^9, 
   3.748172388840468*^9}, {3.748173070786932*^9, 3.7481730730294323`*^9}, {
   3.748173117430595*^9, 3.7481731307454023`*^9}, {3.748173458595439*^9, 
   3.74817345887745*^9}, {3.748173695194269*^9, 3.748173699950642*^9}, {
   3.748202504888515*^9, 3.7482025270319357`*^9}, {3.748203173557973*^9, 
   3.748203178913308*^9}, {3.748207655028558*^9, 3.748207662940427*^9}},
 CellID->1354756641,ExpressionUUID->"1b9ce355-5e55-4d37-ab58-c1cbb4c75ddc"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", FractionBox[\\\"B2\\\", \\\"J\\\"], \\\"}\\\"}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", FractionBox[\"B2\", \"J\
\"], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", FractionBox[\\\"B2\\\", \\\"J\\\"], \\\"}\\\"}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", FractionBox[\"B2\", \"J\
\"], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00035400000000151977`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00035400000000151977`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->2034182032,ExpressionUUID->"f19476b1-12dc-49ee-971d-eb9b48b14199"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->557751584,ExpressionUUID->"61a1e866-9f60-443d-9e2e-4c35f485b524"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169171923123*^9, 3.748173146603053*^9},
 CellLabel->"In[248]:=",
 CellID->1304305929,ExpressionUUID->"4033ade2-f3b1-4c59-bd1a-067b46c12514"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", "1", "}"}], "}"}], "//", "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481691806324472`*^9, 3.748169184126515*^9}, {
   3.7481697745097303`*^9, 3.7481698177840567`*^9}, 3.748170212558292*^9, {
   3.74817153653963*^9, 3.748171557948637*^9}, {3.748172403638979*^9, 
   3.748172459180491*^9}, 3.748173461553569*^9, {3.748202537450017*^9, 
   3.748202581324718*^9}, {3.748203197531724*^9, 3.74820320090259*^9}, {
   3.74820768305413*^9, 3.748207686169286*^9}},
 CellID->1549648249,ExpressionUUID->"a4988572-c0aa-4705-992d-c37547ed23c3"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"1\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"1\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"1\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"1\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001610000000002998`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001610000000002998`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->364753133,ExpressionUUID->"63ac7ceb-6607-436a-9186-c9bedcd423a7"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1487577793,ExpressionUUID->"c2e7bcbc-b072-40b9-922e-62f639e97f78"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169187965559*^9, 3.748173150905864*^9},
 CellLabel->"In[249]:=",
 CellID->1483141090,ExpressionUUID->"3647b0f6-e980-400d-b35c-97a6855520d4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", "0", "}"}], "}"}], "//", "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169193927287*^9, 3.748169194789258*^9}, {
   3.748169826851533*^9, 3.7481698714627047`*^9}, {3.748171572452416*^9, 
   3.748171580237145*^9}, {3.748172509134172*^9, 3.7481725445555677`*^9}, {
   3.748172960660345*^9, 3.7481729614507627`*^9}, 3.7481734650745153`*^9, {
   3.7482025915862713`*^9, 3.748202630873435*^9}, {3.748203221716777*^9, 
   3.748203224246625*^9}, {3.7482076998962*^9, 3.7482077040054913`*^9}},
 CellID->1403689137,ExpressionUUID->"fff6286b-4406-448b-9df7-0ff6bd335ff0"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015700000000151704`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015700000000151704`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->715348577,ExpressionUUID->"e92202eb-a151-47a9-9e86-9c9fe5f30a98"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1250077733,ExpressionUUID->"5ca3020c-151b-4687-bad2-b5bc3500359c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"e", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.74816921143508*^9, 3.74817315251501*^9},
 CellLabel->"In[250]:=",
 CellID->417437835,ExpressionUUID->"39caa422-61f4-4f30-92a7-45ab1e0a4a3a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "b", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692120543423`*^9, 3.748169217153222*^9}, 
   3.748169620186891*^9, {3.7481699674394503`*^9, 3.7481699868030443`*^9}, 
   3.748173467456937*^9},
 CellID->620081943,ExpressionUUID->"df853328-103f-4a7f-ac53-a56775c84d2e"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00016099999999852344`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00016099999999852344`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1223939930,ExpressionUUID->"0a74498f-d347-40f0-9bfc-c93a34695d88"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->12548897,ExpressionUUID->"41f34048-b21a-4476-a4dd-543e0c53627d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169221684237*^9, 3.7481731563003674`*^9},
 CellLabel->"In[251]:=",
 CellID->670386769,ExpressionUUID->"42cb018b-f455-4d0b-9408-5d1db288ce73"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "d", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692270490217`*^9, 3.748169230838327*^9}, {
   3.748169991971572*^9, 3.748170004254684*^9}, 3.748173469973262*^9},
 CellID->1441824756,ExpressionUUID->"d2199e24-381e-49b6-b71b-1aa594386e7e"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001299999999986312`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001299999999986312`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->455914473,ExpressionUUID->"3a1adc58-18d1-4794-8adc-3248201de5af"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->332895215,ExpressionUUID->"2ffc553a-21b0-49c5-abc1-7de13a8de06d"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test System 9", "Section",
 CellChangeTimes->{{3.7481692698005457`*^9, 3.748169273381559*^9}, 
   3.7481693114624357`*^9, {3.748169361271824*^9, 3.748169361361087*^9}, {
   3.748170308281064*^9, 3.7481703083633633`*^9}, {3.748171876095627*^9, 
   3.748171876178361*^9}, {3.748173822514773*^9, 3.748173822575068*^9}, {
   3.748201957095229*^9, 3.748201957209919*^9}, {3.748202693602541*^9, 
   3.748202694592355*^9}, {3.748203258099217*^9, 3.748203258755952*^9}, {
   3.748207736252469*^9, 3.7482077387114143`*^9}},
 CellID->1123870704,ExpressionUUID->"af5f6f11-47bc-432c-8e81-a6e011ceeffb"],

Cell[CellGroupData[{

Cell["System model", "Subsection",
 CellChangeTimes->{{3.7512869916895933`*^9, 3.751286993273737*^9}},
 CellID->1897281308,ExpressionUUID->"29632997-11d3-4914-a23e-c635cd69cf47"],

Cell["Rowell and Wormley Example 5.5", "Text",
 CellChangeTimes->{{3.748169314267838*^9, 3.748169333731399*^9}, {
  3.748169368971754*^9, 3.748169377466568*^9}, {3.74817032089456*^9, 
  3.748170327324637*^9}, {3.748171903869137*^9, 3.748171911436009*^9}, {
  3.748173840454677*^9, 3.748173847774159*^9}, {3.748201999818125*^9, 
  3.748202000841951*^9}, {3.748202706062766*^9, 3.74820270612952*^9}, {
  3.748203275897526*^9, 3.7482032759962273`*^9}, {3.748207745579783*^9, 
  3.7482077456859827`*^9}},
 CellID->996763060,ExpressionUUID->"96c70424-85ff-4efc-a2a7-019a0f6b9a0c"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"Vs", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primaryVars", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vC", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"iL", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"vR", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outExps", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vL", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"iC", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"vC", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"elementalEqs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"vC", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"iC", "[", "t", "]"}], "/", "CC"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"iL", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vL", "[", "t", "]"}], "/", "L"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vR", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"R", " ", 
       RowBox[{"iR", "[", "t", "]"}]}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"constraintEqs", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"iC", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"iL", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"iR", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"iL", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vL", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Vs", "[", "t", "]"}], "-", 
       RowBox[{"vR", "[", "t", "]"}], "-", 
       RowBox[{"vC", "[", "t", "]"}]}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.747499218184157*^9, 3.74749931067735*^9}, {
   3.7474997703057547`*^9, 3.747499862953096*^9}, {3.7475000427164516`*^9, 
   3.7475001179609213`*^9}, 3.747500172506531*^9, {3.7475052421578627`*^9, 
   3.7475052437525806`*^9}, {3.7475052792870703`*^9, 3.747505305743517*^9}, {
   3.7475054395550127`*^9, 3.74750549238805*^9}, {3.748169383980278*^9, 
   3.748169603265369*^9}, {3.748170115690106*^9, 3.748170132266461*^9}, {
   3.748170333165715*^9, 3.7481705921461983`*^9}, {3.748171917577342*^9, 
   3.74817195326005*^9}, {3.748171995123074*^9, 3.7481720024895773`*^9}, {
   3.748172035662871*^9, 3.7481721909688787`*^9}, {3.748173852472159*^9, 
   3.7481740097196913`*^9}, {3.7482022679021463`*^9, 3.748202298767332*^9}, {
   3.748202329707706*^9, 3.748202426597817*^9}, {3.7482027090106783`*^9, 
   3.748202788912438*^9}, {3.74820743586224*^9, 3.748207471308917*^9}, {
   3.748207507244035*^9, 3.748207585893305*^9}, {3.7482077486519814`*^9, 
   3.748207772848833*^9}, {3.748207850305572*^9, 3.7482079126557817`*^9}, {
   3.7512869993730164`*^9, 3.7512870970364027`*^9}, {3.751825122582345*^9, 
   3.751825148806971*^9}},
 CellLabel->"In[252]:=",
 CellID->1726614346,ExpressionUUID->"03371df5-6d55-4a77-bcc0-b421efd6baa8"],

Cell["Find state equation.", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.75124789335491*^9}},
 CellID->95329236,ExpressionUUID->"2bd20373-8b5b-49c2-94ed-c1b8cbd69a75"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stateSolution", "=", 
   RowBox[{
    RowBox[{"stateEquations", "[", 
     RowBox[{
     "inVars", ",", "primaryVars", ",", "elementalEqs", ",", 
      "constraintEqs"}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateVars", " ", "=", " ", 
   RowBox[{"\"\<state variables\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateEqList", " ", "=", " ", 
   RowBox[{"\"\<RHS\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\"\<state equations\>\"", "/.", "stateSolution"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.7018797195836763`*^9, 3.7018797204767036`*^9}, {
   3.701879810803969*^9, 3.701879844544981*^9}, {3.7018942050184517`*^9, 
   3.701894566874161*^9}, 3.701898020551093*^9, {3.701903282327601*^9, 
   3.701903283500523*^9}, {3.701911200698804*^9, 3.701911202601316*^9}, {
   3.701915682054678*^9, 3.701915720675168*^9}, {3.701915759772274*^9, 
   3.7019157927706213`*^9}, {3.701915923602686*^9, 3.701915923900078*^9}, 
   3.7019209193048553`*^9, 3.701920950145496*^9, {3.701921306764739*^9, 
   3.701921308673313*^9}, {3.701921408184596*^9, 3.7019214156809187`*^9}, 
   3.7019220747800493`*^9, {3.701922189786292*^9, 3.701922218088579*^9}, {
   3.701922248592429*^9, 3.701922251876824*^9}, 3.701922322852202*^9, {
   3.701922383801173*^9, 3.7019224315654707`*^9}, {3.701922463501308*^9, 
   3.7019224895050097`*^9}, 3.7019225472984467`*^9, {3.701922594846767*^9, 
   3.701922598092758*^9}, {3.701922662563005*^9, 3.701922735877761*^9}, {
   3.7019231046383343`*^9, 3.701923105684675*^9}, {3.7019639715923243`*^9, 
   3.7019639718841667`*^9}, {3.7019642654040737`*^9, 3.701964352167139*^9}, {
   3.701964387110903*^9, 3.7019644147887087`*^9}, {3.702757419429731*^9, 
   3.7027575039883213`*^9}, {3.7511302149210863`*^9, 3.751130222225973*^9}, 
   3.751131245052647*^9, 3.7518224212768917`*^9, 3.751859572324561*^9, 
   3.751859962433818*^9, 3.75186099190203*^9, 3.7519374019550056`*^9},
 CellID->348677981,ExpressionUUID->"719c281a-edcc-4c6a-b02f-c07e365dada0"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["vC", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      FractionBox[
       RowBox[{"iL", "[", "t", "]"}], "CC"]}]},
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["iL", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"R", " ", 
          RowBox[{"iL", "[", "t", "]"}]}], "L"]}], "-", 
       FractionBox[
        RowBox[{"vC", "[", "t", "]"}], "L"], "+", 
       FractionBox[
        RowBox[{"Vs", "[", "t", "]"}], "L"]}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751131246142264*^9, 3.751131562228766*^9, 3.751154207578877*^9, 
   3.751155061538066*^9, 3.7511551539969883`*^9, 3.7511556539137783`*^9, 
   3.751156830900199*^9, 3.751157044451893*^9, 3.751157305712584*^9, 
   3.751157692923893*^9, 3.751237248504381*^9, 3.7512373121455393`*^9, 
   3.751237557961287*^9, {3.7512412411479073`*^9, 3.751241257691305*^9}, 
   3.7512413334070673`*^9, 3.751241455823284*^9, 3.751241611586341*^9, 
   3.7512433878599854`*^9, 3.751243524307231*^9, 3.751243608962484*^9, 
   3.7512437545853853`*^9, 3.751243860047454*^9, 3.7512441819725847`*^9, 
   3.751244399097206*^9, 3.751244486437664*^9, 3.75124455927641*^9, 
   3.75124464012558*^9, 3.75124506931707*^9, 3.751245129883816*^9, 
   3.751245199900049*^9, 3.751245786492696*^9, 3.7512458405736723`*^9, 
   3.751245872204157*^9, {3.7512470996055098`*^9, 3.751247133340377*^9}, 
   3.751822506215632*^9, {3.751822707767754*^9, 3.751822723484655*^9}, 
   3.751822800835991*^9, 3.7518235244045973`*^9, 3.751823574246002*^9, 
   3.75182394710122*^9, 3.751824050485718*^9, {3.751824086094249*^9, 
   3.7518241542062597`*^9}, 3.751824200734988*^9, {3.7518251621784353`*^9, 
   3.7518251752654953`*^9}, 3.751827565621702*^9, 3.751861174060754*^9},
 CellLabel->"Out[260]//TableForm=",
 CellID->774978070,ExpressionUUID->"f6bbc70d-f0e5-4bd4-af20-2f400b3d10be"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"outEqList", "=", 
   RowBox[{"outEquations", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outExps", ",", 
     RowBox[{"elementalEqs", "~", "Join", "~", "constraintEqs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outEqList", "//", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"y", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "outExps", "]"}]}], "}"}]}], "]"}], 
      "\[Equal]", "#"}], "]"}], "&"}]}], "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.75115407229806*^9, 3.7511540907068577`*^9}, {
   3.7511541283727303`*^9, 3.751154145140655*^9}, {3.751154185947949*^9, 
   3.751154186454541*^9}, {3.75115440553708*^9, 3.751154408241644*^9}, {
   3.751157061478198*^9, 3.75115706228808*^9}, {3.751157258647379*^9, 
   3.751157263470278*^9}, {3.751157318329653*^9, 3.751157382599204*^9}, 
   3.751243546881419*^9, 3.7512446518094807`*^9, {3.7518241789029417`*^9, 
   3.751824190813037*^9}},
 CellLabel->"In[261]:=",
 CellID->848180759,ExpressionUUID->"71361f98-6aee-44d9-a6c3-416211331aee"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{"y", "[", "1", "]"}], "\[Equal]", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "R"}], " ", 
         RowBox[{"iL", "[", "t", "]"}]}], "-", 
        RowBox[{"vC", "[", "t", "]"}], "+", 
        RowBox[{"Vs", "[", "t", "]"}]}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "2", "]"}], "\[Equal]", 
       RowBox[{"iL", "[", "t", "]"}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "3", "]"}], "\[Equal]", 
       RowBox[{"vC", "[", "t", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751154146341402*^9, {3.7511541874520807`*^9, 3.75115421035389*^9}, 
   3.751154409289606*^9, 3.751155063159431*^9, 3.7511551578703537`*^9, {
   3.751155631171876*^9, 3.7511556669733973`*^9}, 3.751156831153225*^9, {
   3.7511570444961233`*^9, 3.751157063011318*^9}, 3.7511573845757217`*^9, 
   3.7511576929574337`*^9, 3.751237248545403*^9, 3.75123731846103*^9, 
   3.751237558009218*^9, 3.75124126512782*^9, 3.751241341691312*^9, 
   3.7512414602930183`*^9, {3.7512415890389347`*^9, 3.751241614550478*^9}, 
   3.751243391757332*^9, {3.751243525864511*^9, 3.7512435473077707`*^9}, 
   3.7512436090180597`*^9, 3.751243754645124*^9, 3.751243860169832*^9, 
   3.751244182055914*^9, 3.751244399162704*^9, 3.751244486514542*^9, 
   3.751244523619996*^9, 3.7512445593242817`*^9, {3.751244640162719*^9, 
   3.7512446526642714`*^9}, 3.7512450693463917`*^9, 3.751245129916429*^9, 
   3.751245199944006*^9, 3.751245811673089*^9, 3.75124584198965*^9, 
   3.75124587430195*^9, {3.751247099662253*^9, 3.751247148020466*^9}, {
   3.751824169273649*^9, 3.751824200839072*^9}, {3.751825165847077*^9, 
   3.751825175403233*^9}, 3.7518275658615627`*^9, 3.751861174226636*^9},
 CellLabel->"Out[262]//TableForm=",
 CellID->568103435,ExpressionUUID->"aa9ffc34-b50b-43cb-a483-f31fb3c6fb24"]
}, Open  ]],

Cell["\<\
Linearize the state and output equations about operating point.\
\>", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.7512479601059103`*^9}},
 CellID->1521132909,ExpressionUUID->"ea7f4f34-8522-4ebd-a458-0381756be2a9"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"abe", "=", 
   RowBox[{"linearizeState", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "stateEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdf", "=", 
   RowBox[{"linearizeOutput", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"e", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"d", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"f", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<A = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<B = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<E = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<C = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<D = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<F = \>\"", ",", "#"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.751247952610923*^9}},
 CellLabel->"In[263]:=",
 CellID->2035467675,ExpressionUUID->"74d05c00-93c4-4480-a212-b0330bad09d5"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", 
        FractionBox["1", "CC"]},
       {
        RowBox[{"-", 
         FractionBox["1", "L"]}], 
        RowBox[{"-", 
         FractionBox["R", "L"]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["A = ", 
   MatrixForm[{{
     0, $CellContext`CC^(-1)}, {(-1)/$CellContext`L, -$CellContext`L^(-1) \
$CellContext`R}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.7518251755337543`*^9, 3.751827566098858*^9, 
  3.751861174386557*^9},
 CellLabel->"During evaluation of In[263]:=",
 CellID->402137483,ExpressionUUID->"44d4de27-f902-4d81-9f06-407d672e5fc3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"B = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {
        FractionBox["1", "L"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["B = ", 
   MatrixForm[{{0}, {$CellContext`L^(-1)}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.7518251755337543`*^9, 3.751827566098858*^9, 
  3.751861174396453*^9},
 CellLabel->"During evaluation of In[263]:=",
 CellID->593639672,ExpressionUUID->"be5a3e73-621a-4d75-9cbd-e10fc43ff4e1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"E = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["E = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.7518251755337543`*^9, 3.751827566098858*^9, 
  3.7518611744207153`*^9},
 CellLabel->"During evaluation of In[263]:=",
 CellID->92943342,ExpressionUUID->"e08cddd7-ac65-4a5e-bab1-a3efae1491e6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", "1"}], 
        RowBox[{"-", "R"}]},
       {"0", "1"},
       {"1", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{-1, -$CellContext`R}, {0, 1}, {1, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.7518251755337543`*^9, 3.751827566098858*^9, 
  3.751861174426585*^9},
 CellLabel->"During evaluation of In[263]:=",
 CellID->878137625,ExpressionUUID->"ab5ebc54-aea7-46d2-af34-3e69c1b41b79"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1"},
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{1}, {0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.7518251755337543`*^9, 3.751827566098858*^9, 
  3.7518611744323263`*^9},
 CellLabel->"During evaluation of In[263]:=",
 CellID->1351441191,ExpressionUUID->"8a9f5616-ec2f-4057-a7b8-5261c946d95a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0}, {0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.7518251755337543`*^9, 3.751827566098858*^9, 
  3.751861174438002*^9},
 CellLabel->"During evaluation of In[263]:=",
 CellID->1885046465,ExpressionUUID->"f5b61e84-0e0a-40c8-ac31-539651623c60"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.75124808019132*^9, 3.7512480809379053`*^9}},
 CellID->1261361835,ExpressionUUID->"8ad63a52-c29d-433a-a876-97b9b7a096e4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.747505552707037*^9, {3.7475057578295593`*^9, 3.747505759222794*^9}, {
   3.747505842150148*^9, 3.7475058458319883`*^9}, {3.747505896191999*^9, 
   3.74750589728131*^9}, {3.748124150238531*^9, 3.748124150517943*^9}, 
   3.748169029221862*^9, 3.748173244647019*^9},
 CellLabel->"In[273]:=",
 CellID->398927661,ExpressionUUID->"c49ec61d-b163-4350-bfdd-7b8768fc7a9d"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{"1", "/", "CC"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "/", "L"}], ",", 
      RowBox[{
       RowBox[{"-", "R"}], "/", "L"}]}], "}"}]}], "}"}], 
  "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.747505555643032*^9, 3.7475055867312613`*^9}, {
   3.747505761476728*^9, 3.747505764318122*^9}, {3.747505847665118*^9, 
   3.7475058502692757`*^9}, {3.747505898843794*^9, 3.74750590124069*^9}, {
   3.7475063255823507`*^9, 3.747506334276267*^9}, {3.7481241530496283`*^9, 
   3.748124156712919*^9}, 3.7481690353265944`*^9, {3.748169641556839*^9, 
   3.748169730141844*^9}, {3.7481706308795347`*^9, 3.748170648343268*^9}, {
   3.7481713324991817`*^9, 3.748171412017522*^9}, {3.7481722117935038`*^9, 
   3.748172266534639*^9}, {3.748172557215331*^9, 3.748172586783577*^9}, 
   3.748172811167288*^9, {3.748173455617723*^9, 3.748173456202003*^9}, {
   3.748173684193961*^9, 3.7481736910145693`*^9}, {3.748174023178488*^9, 
   3.748174074694357*^9}, {3.7482024431310062`*^9, 3.7482024882994432`*^9}, {
   3.748203045867991*^9, 3.748203049432695*^9}, {3.7482031539741383`*^9, 
   3.748203165353072*^9}, {3.748207600236726*^9, 3.7482076437651033`*^9}, {
   3.748207926849205*^9, 3.748207952971178*^9}},
 CellID->1092749213,ExpressionUUID->"c598a579-ac25-444e-916c-190c53a16d90"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
FractionBox[\\\"1\\\", \\\"CC\\\"]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \\\"L\\\"]}], \
\\\",\\\", RowBox[{\\\"-\\\", FractionBox[\\\"R\\\", \\\"L\\\"]}]}], \
\\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"0\", \
\",\", FractionBox[\"1\", \"CC\"]}], \"}\"}], \",\", RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"1\", \"L\"]}], \",\", RowBox[{\"-\", \
FractionBox[\"R\", \"L\"]}]}], \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
FractionBox[\\\"1\\\", \\\"CC\\\"]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \\\"L\\\"]}], \
\\\",\\\", RowBox[{\\\"-\\\", FractionBox[\\\"R\\\", \\\"L\\\"]}]}], \
\\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"0\", \
\",\", FractionBox[\"1\", \"CC\"]}], \"}\"}], \",\", RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"1\", \"L\"]}], \",\", RowBox[{\"-\", \
FractionBox[\"R\", \"L\"]}]}], \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
000658999999998855`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.000658999999998855`\", \"\\\"s\\\
\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->149693064,ExpressionUUID->"d09ab5e9-878b-4cde-aa57-449994ae6b60"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1187976011,ExpressionUUID->"8485608a-2960-429e-a14a-a0aa8a2573af"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.748169118881194*^9, {3.748173109584269*^9, 3.748173111317824*^9}},
 CellLabel->"In[274]:=",
 CellID->348954702,ExpressionUUID->"e0d9ea8b-2dc1-45f5-9f1e-5ea67b06f87b"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"1", "/", "L"}], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169152633688*^9, 3.748169166417688*^9}, 
   3.74816961437001*^9, {3.748169735895432*^9, 3.74816976416591*^9}, {
   3.7481714534342337`*^9, 3.748171524401494*^9}, {3.748172277994993*^9, 
   3.748172388840468*^9}, {3.748173070786932*^9, 3.7481730730294323`*^9}, {
   3.748173117430595*^9, 3.7481731307454023`*^9}, {3.748173458595439*^9, 
   3.74817345887745*^9}, {3.748173695194269*^9, 3.748173699950642*^9}, {
   3.748202504888515*^9, 3.7482025270319357`*^9}, {3.748203173557973*^9, 
   3.748203178913308*^9}, {3.748207655028558*^9, 3.748207662940427*^9}, {
   3.7482079592072783`*^9, 3.7482079715754347`*^9}},
 CellID->646201416,ExpressionUUID->"a36cacc2-7233-4522-bbb3-a19194899d44"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", FractionBox[\\\"1\\\", \\\"L\\\"], \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", FractionBox[\"1\", \"L\"], \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", FractionBox[\\\"1\\\", \\\"L\\\"], \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", FractionBox[\"1\", \"L\"], \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015900000000357295`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015900000000357295`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1157350718,ExpressionUUID->"ac29444b-8d71-4794-90e8-3bd0c96ee73e"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1834126547,ExpressionUUID->"1157340b-110b-4b12-8d2d-0e4615f54941"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169171923123*^9, 3.748173146603053*^9},
 CellLabel->"In[275]:=",
 CellID->1266283360,ExpressionUUID->"1d23eec1-f636-4809-8d6d-d91546fe4872"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "R"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481691806324472`*^9, 3.748169184126515*^9}, {
   3.7481697745097303`*^9, 3.7481698177840567`*^9}, 3.748170212558292*^9, {
   3.74817153653963*^9, 3.748171557948637*^9}, {3.748172403638979*^9, 
   3.748172459180491*^9}, 3.748173461553569*^9, {3.748202537450017*^9, 
   3.748202581324718*^9}, {3.748203197531724*^9, 3.74820320090259*^9}, {
   3.74820768305413*^9, 3.748207686169286*^9}, {3.748207980487094*^9, 
   3.748208000065283*^9}},
 CellID->786295109,ExpressionUUID->"b374ae3d-daa2-4be3-8ca1-b53a2db70717"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"-\\\", \\\"R\\\"}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
RowBox[{\\\"0\\\", \\\",\\\", \\\"1\\\"}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\
\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}]}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", \"1\"}], \",\", RowBox[{\"-\", \"R\"}]}], \"}\"}], \",\
\", RowBox[{\"{\", RowBox[{\"0\", \",\", \"1\"}], \"}\"}], \",\", RowBox[{\"{\
\", RowBox[{\"1\", \",\", \"0\"}], \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", \\\"1\\\"}], \\\",\\\", \
RowBox[{\\\"-\\\", \\\"R\\\"}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \
RowBox[{\\\"0\\\", \\\",\\\", \\\"1\\\"}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\
\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}]}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", \"1\"}], \",\", RowBox[{\"-\", \"R\"}]}], \"}\"}], \",\
\", RowBox[{\"{\", RowBox[{\"0\", \",\", \"1\"}], \"}\"}], \",\", RowBox[{\"{\
\", RowBox[{\"1\", \",\", \"0\"}], \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00016300000000057935`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00016300000000057935`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1184606391,ExpressionUUID->"78058d5c-4dee-43aa-997d-01760bf20aca"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->358722200,ExpressionUUID->"6f94608e-e32f-4562-a3d8-a1b24ac5e252"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169187965559*^9, 3.748173150905864*^9},
 CellLabel->"In[276]:=",
 CellID->80636217,ExpressionUUID->"8aa7c457-bb49-4f35-9193-3de98e864e4c"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "1", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169193927287*^9, 3.748169194789258*^9}, {
   3.748169826851533*^9, 3.7481698714627047`*^9}, {3.748171572452416*^9, 
   3.748171580237145*^9}, {3.748172509134172*^9, 3.7481725445555677`*^9}, {
   3.748172960660345*^9, 3.7481729614507627`*^9}, 3.7481734650745153`*^9, {
   3.7482025915862713`*^9, 3.748202630873435*^9}, {3.748203221716777*^9, 
   3.748203224246625*^9}, {3.7482076998962*^9, 3.7482077040054913`*^9}, {
   3.748208008511187*^9, 3.748208021025865*^9}},
 CellID->1002636004,ExpressionUUID->"38278a10-59be-4d45-9441-0e88dddc4d00"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"1\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \
\\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"1\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}]}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"1\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \
\\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"1\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}]}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015100000000245473`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015100000000245473`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1057418271,ExpressionUUID->"56fdcc12-8702-4f41-b2a8-9996278861f0"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1601701772,ExpressionUUID->"6973ace5-8322-4460-892e-5f4a45fb0e65"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"e", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.74816921143508*^9, 3.74817315251501*^9},
 CellLabel->"In[277]:=",
 CellID->1198337696,ExpressionUUID->"d524e200-692e-4105-84b5-140a471e5dde"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "b", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692120543423`*^9, 3.748169217153222*^9}, 
   3.748169620186891*^9, {3.7481699674394503`*^9, 3.7481699868030443`*^9}, 
   3.748173467456937*^9},
 CellID->813827590,ExpressionUUID->"9f3c6c7d-2397-4320-8b10-76a2e77737a9"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015199999999992997`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015199999999992997`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1094166859,ExpressionUUID->"5bb75440-3677-4373-a4fa-90f41d5089cf"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->759929952,ExpressionUUID->"0345f9ac-9726-4adc-aefa-76e5513b368b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169221684237*^9, 3.7481731563003674`*^9},
 CellLabel->"In[278]:=",
 CellID->1325491493,ExpressionUUID->"e61e78fc-1a6a-481a-ace0-35db87cea199"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "d", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692270490217`*^9, 3.748169230838327*^9}, {
   3.748169991971572*^9, 3.748170004254684*^9}, 3.748173469973262*^9},
 CellID->406808914,ExpressionUUID->"fde42fba-4a60-4737-b8d2-c403743ab2ac"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \
\\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}]}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \
\\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}]}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001659999999965578`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001659999999965578`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1057454555,ExpressionUUID->"7f6db97b-34b2-485f-9036-319da019d027"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->64043313,ExpressionUUID->"f44d29ee-4447-4789-87af-30f955815941"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test System 10", "Section",
 CellChangeTimes->{{3.7481692698005457`*^9, 3.748169273381559*^9}, 
   3.7481693114624357`*^9, {3.748169361271824*^9, 3.748169361361087*^9}, {
   3.748170308281064*^9, 3.7481703083633633`*^9}, {3.748171876095627*^9, 
   3.748171876178361*^9}, {3.748173822514773*^9, 3.748173822575068*^9}, {
   3.748201957095229*^9, 3.748201957209919*^9}, {3.748202693602541*^9, 
   3.748202694592355*^9}, {3.748203258099217*^9, 3.748203258755952*^9}, {
   3.748207736252469*^9, 3.7482077387114143`*^9}, {3.7482080854975643`*^9, 
   3.748208086239914*^9}},
 CellID->981828233,ExpressionUUID->"96b4ea27-a54a-48ed-9566-7ee0bdeb6952"],

Cell[CellGroupData[{

Cell["System model", "Subsection",
 CellChangeTimes->{{3.751287198430723*^9, 3.751287200060608*^9}},
 CellID->450237986,ExpressionUUID->"88dd66ef-510d-46a5-be89-c5246f01b83f"],

Cell["Rowell and Wormley Example 5.6", "Text",
 CellChangeTimes->{{3.748169314267838*^9, 3.748169333731399*^9}, {
  3.748169368971754*^9, 3.748169377466568*^9}, {3.74817032089456*^9, 
  3.748170327324637*^9}, {3.748171903869137*^9, 3.748171911436009*^9}, {
  3.748173840454677*^9, 3.748173847774159*^9}, {3.748201999818125*^9, 
  3.748202000841951*^9}, {3.748202706062766*^9, 3.74820270612952*^9}, {
  3.748203275897526*^9, 3.7482032759962273`*^9}, {3.748207745579783*^9, 
  3.7482077456859827`*^9}, {3.748208092550345*^9, 3.748208092618396*^9}},
 CellID->2076059377,ExpressionUUID->"1dc1d35f-9b23-4c8c-8653-0e56b32e1c02"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"Ps", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primaryVars", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"PC", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"QIp", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"PRp", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"QR1", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outExps", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"PC", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"QIp", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"elementalEqs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"PC", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"QC", "[", "t", "]"}], "/", "CC"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"QIp", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"PIp", "[", "t", "]"}], "/", "Ip"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"PRp", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"Rp", " ", 
       RowBox[{"QRp", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"QR1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"PR1", "[", "t", "]"}], "/", "R1"}]}]}], "\[IndentingNewLine]",
     "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"constraintEqs", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"QC", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"QIp", "[", "t", "]"}], "-", 
       RowBox[{"QR1", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"QRp", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"QIp", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"PIp", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Ps", "[", "t", "]"}], "-", 
       RowBox[{"PRp", "[", "t", "]"}], "-", 
       RowBox[{"PC", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"PR1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"PC", "[", "t", "]"}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.747499218184157*^9, 3.74749931067735*^9}, {
   3.7474997703057547`*^9, 3.747499862953096*^9}, {3.7475000427164516`*^9, 
   3.7475001179609213`*^9}, 3.747500172506531*^9, {3.7475052421578627`*^9, 
   3.7475052437525806`*^9}, {3.7475052792870703`*^9, 3.747505305743517*^9}, {
   3.7475054395550127`*^9, 3.74750549238805*^9}, {3.748169383980278*^9, 
   3.748169603265369*^9}, {3.748170115690106*^9, 3.748170132266461*^9}, {
   3.748170333165715*^9, 3.7481705921461983`*^9}, {3.748171917577342*^9, 
   3.74817195326005*^9}, {3.748171995123074*^9, 3.7481720024895773`*^9}, {
   3.748172035662871*^9, 3.7481721909688787`*^9}, {3.748173852472159*^9, 
   3.7481740097196913`*^9}, {3.7482022679021463`*^9, 3.748202298767332*^9}, {
   3.748202329707706*^9, 3.748202426597817*^9}, {3.7482027090106783`*^9, 
   3.748202788912438*^9}, {3.74820743586224*^9, 3.748207471308917*^9}, {
   3.748207507244035*^9, 3.748207585893305*^9}, {3.7482077486519814`*^9, 
   3.748207772848833*^9}, {3.748207850305572*^9, 3.7482079126557817`*^9}, {
   3.748208102199922*^9, 3.748208255621907*^9}, {3.751287219284433*^9, 
   3.751287330488763*^9}, {3.751825224616199*^9, 3.7518252901636343`*^9}},
 CellLabel->"In[279]:=",
 CellID->1048506747,ExpressionUUID->"90dbfafd-f978-45fd-b937-61d27b68c28c"],

Cell["Find state equation.", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.75124789335491*^9}},
 CellID->892609393,ExpressionUUID->"876e6286-3005-4fe0-8a9d-2c995f97b9d1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stateSolution", "=", 
   RowBox[{
    RowBox[{"stateEquations", "[", 
     RowBox[{
     "inVars", ",", "primaryVars", ",", "elementalEqs", ",", 
      "constraintEqs"}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateVars", " ", "=", " ", 
   RowBox[{"\"\<state variables\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateEqList", " ", "=", " ", 
   RowBox[{"\"\<RHS\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\"\<state equations\>\"", "/.", "stateSolution"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.7018797195836763`*^9, 3.7018797204767036`*^9}, {
   3.701879810803969*^9, 3.701879844544981*^9}, {3.7018942050184517`*^9, 
   3.701894566874161*^9}, 3.701898020551093*^9, {3.701903282327601*^9, 
   3.701903283500523*^9}, {3.701911200698804*^9, 3.701911202601316*^9}, {
   3.701915682054678*^9, 3.701915720675168*^9}, {3.701915759772274*^9, 
   3.7019157927706213`*^9}, {3.701915923602686*^9, 3.701915923900078*^9}, 
   3.7019209193048553`*^9, 3.701920950145496*^9, {3.701921306764739*^9, 
   3.701921308673313*^9}, {3.701921408184596*^9, 3.7019214156809187`*^9}, 
   3.7019220747800493`*^9, {3.701922189786292*^9, 3.701922218088579*^9}, {
   3.701922248592429*^9, 3.701922251876824*^9}, 3.701922322852202*^9, {
   3.701922383801173*^9, 3.7019224315654707`*^9}, {3.701922463501308*^9, 
   3.7019224895050097`*^9}, 3.7019225472984467`*^9, {3.701922594846767*^9, 
   3.701922598092758*^9}, {3.701922662563005*^9, 3.701922735877761*^9}, {
   3.7019231046383343`*^9, 3.701923105684675*^9}, {3.7019639715923243`*^9, 
   3.7019639718841667`*^9}, {3.7019642654040737`*^9, 3.701964352167139*^9}, {
   3.701964387110903*^9, 3.7019644147887087`*^9}, {3.702757419429731*^9, 
   3.7027575039883213`*^9}, {3.7511302149210863`*^9, 3.751130222225973*^9}, 
   3.751131245052647*^9, 3.7518224212768917`*^9, 3.751859572387329*^9, 
   3.7518599624394493`*^9, 3.751860991906557*^9, 3.7519374020209827`*^9},
 CellID->825200426,ExpressionUUID->"c36450cd-d8bf-43f1-a0fd-83f64cf36f71"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["PC", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"PC", "[", "t", "]"}], 
         RowBox[{"CC", " ", "R1"}]]}], "+", 
       FractionBox[
        RowBox[{"QIp", "[", "t", "]"}], "CC"]}]}]},
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["QIp", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"PC", "[", "t", "]"}], "Ip"]}], "+", 
       FractionBox[
        RowBox[{"Ps", "[", "t", "]"}], "Ip"], "-", 
       FractionBox[
        RowBox[{"Rp", " ", 
         RowBox[{"QIp", "[", "t", "]"}]}], "Ip"]}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751131246142264*^9, 3.751131562228766*^9, 3.751154207578877*^9, 
   3.751155061538066*^9, 3.7511551539969883`*^9, 3.7511556539137783`*^9, 
   3.751156830900199*^9, 3.751157044451893*^9, 3.751157305712584*^9, 
   3.751157692923893*^9, 3.751237248504381*^9, 3.7512373121455393`*^9, 
   3.751237557961287*^9, {3.7512412411479073`*^9, 3.751241257691305*^9}, 
   3.7512413334070673`*^9, 3.751241455823284*^9, 3.751241611586341*^9, 
   3.7512433878599854`*^9, 3.751243524307231*^9, 3.751243608962484*^9, 
   3.7512437545853853`*^9, 3.751243860047454*^9, 3.7512441819725847`*^9, 
   3.751244399097206*^9, 3.751244486437664*^9, 3.75124455927641*^9, 
   3.75124464012558*^9, 3.75124506931707*^9, 3.751245129883816*^9, 
   3.751245199900049*^9, 3.751245786492696*^9, 3.7512458405736723`*^9, 
   3.751245872204157*^9, {3.7512470996055098`*^9, 3.751247133340377*^9}, 
   3.751822506215632*^9, {3.751822707767754*^9, 3.751822723484655*^9}, 
   3.751822800835991*^9, 3.7518235244045973`*^9, 3.751823574246002*^9, 
   3.75182394710122*^9, 3.751824050485718*^9, {3.751824086094249*^9, 
   3.7518241542062597`*^9}, 3.751824200734988*^9, {3.7518253066644087`*^9, 
   3.751825314330853*^9}, 3.751827631310697*^9, 3.7518611972399187`*^9},
 CellLabel->"Out[287]//TableForm=",
 CellID->486654444,ExpressionUUID->"391ff68c-5874-4a05-881b-860dac161af0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"outEqList", "=", 
   RowBox[{"outEquations", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outExps", ",", 
     RowBox[{"elementalEqs", "~", "Join", "~", "constraintEqs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outEqList", "//", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"y", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "outExps", "]"}]}], "}"}]}], "]"}], 
      "\[Equal]", "#"}], "]"}], "&"}]}], "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.75115407229806*^9, 3.7511540907068577`*^9}, {
   3.7511541283727303`*^9, 3.751154145140655*^9}, {3.751154185947949*^9, 
   3.751154186454541*^9}, {3.75115440553708*^9, 3.751154408241644*^9}, {
   3.751157061478198*^9, 3.75115706228808*^9}, {3.751157258647379*^9, 
   3.751157263470278*^9}, {3.751157318329653*^9, 3.751157382599204*^9}, 
   3.751243546881419*^9, 3.7512446518094807`*^9, {3.7518241789029417`*^9, 
   3.751824190813037*^9}},
 CellLabel->"In[288]:=",
 CellID->1741262488,ExpressionUUID->"3525ce52-219f-4f9e-9cf1-b03884198751"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{"y", "[", "1", "]"}], "\[Equal]", 
       RowBox[{"PC", "[", "t", "]"}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "2", "]"}], "\[Equal]", 
       RowBox[{"QIp", "[", "t", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751154146341402*^9, {3.7511541874520807`*^9, 3.75115421035389*^9}, 
   3.751154409289606*^9, 3.751155063159431*^9, 3.7511551578703537`*^9, {
   3.751155631171876*^9, 3.7511556669733973`*^9}, 3.751156831153225*^9, {
   3.7511570444961233`*^9, 3.751157063011318*^9}, 3.7511573845757217`*^9, 
   3.7511576929574337`*^9, 3.751237248545403*^9, 3.75123731846103*^9, 
   3.751237558009218*^9, 3.75124126512782*^9, 3.751241341691312*^9, 
   3.7512414602930183`*^9, {3.7512415890389347`*^9, 3.751241614550478*^9}, 
   3.751243391757332*^9, {3.751243525864511*^9, 3.7512435473077707`*^9}, 
   3.7512436090180597`*^9, 3.751243754645124*^9, 3.751243860169832*^9, 
   3.751244182055914*^9, 3.751244399162704*^9, 3.751244486514542*^9, 
   3.751244523619996*^9, 3.7512445593242817`*^9, {3.751244640162719*^9, 
   3.7512446526642714`*^9}, 3.7512450693463917`*^9, 3.751245129916429*^9, 
   3.751245199944006*^9, 3.751245811673089*^9, 3.75124584198965*^9, 
   3.75124587430195*^9, {3.751247099662253*^9, 3.751247148020466*^9}, {
   3.751824169273649*^9, 3.751824200839072*^9}, {3.751825309467411*^9, 
   3.7518253144497128`*^9}, 3.751827631537046*^9, 3.751861197412943*^9},
 CellLabel->"Out[289]//TableForm=",
 CellID->1583512532,ExpressionUUID->"3d9a2614-6cd5-42ea-a850-267e45abfffb"]
}, Open  ]],

Cell["\<\
Linearize the state and output equations about operating point.\
\>", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.7512479601059103`*^9}},
 CellID->852042610,ExpressionUUID->"56d012a1-6ec6-4def-afb7-5eb840e730fb"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"abe", "=", 
   RowBox[{"linearizeState", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "stateEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdf", "=", 
   RowBox[{"linearizeOutput", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"e", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"d", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"f", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<A = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<B = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<E = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<C = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<D = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<F = \>\"", ",", "#"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.751247952610923*^9}},
 CellLabel->"In[290]:=",
 CellID->859188074,ExpressionUUID->"024d4e9a-760e-4839-a406-295d8257cd9c"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox["1", 
          RowBox[{"CC", " ", "R1"}]]}], 
        FractionBox["1", "CC"]},
       {
        RowBox[{"-", 
         FractionBox["1", "Ip"]}], 
        RowBox[{"-", 
         FractionBox["Rp", "Ip"]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["A = ", 
   MatrixForm[{{-$CellContext`CC^(-1)/$CellContext`R1, $CellContext`CC^(-1)}, \
{(-1)/$CellContext`Ip, -$CellContext`Ip^(-1) $CellContext`Rp}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751825314585294*^9, 
  3.751827631812792*^9, 3.751861197578994*^9},
 CellLabel->"During evaluation of In[290]:=",
 CellID->330288053,ExpressionUUID->"51de3172-af40-410b-bea9-677dc71ce46d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"B = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {
        FractionBox["1", "Ip"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["B = ", 
   MatrixForm[{{0}, {$CellContext`Ip^(-1)}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751825314585294*^9, 
  3.751827631812792*^9, 3.751861197589151*^9},
 CellLabel->"During evaluation of In[290]:=",
 CellID->2053562923,ExpressionUUID->"736cce33-7c5e-4a63-bb8a-7a3a45808703"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"E = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["E = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751825314585294*^9, 
  3.751827631812792*^9, 3.7518611976172047`*^9},
 CellLabel->"During evaluation of In[290]:=",
 CellID->2022355924,ExpressionUUID->"d9fecfc5-e506-480f-abda-e78a79f51585"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0"},
       {"0", "1"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{1, 0}, {0, 1}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751825314585294*^9, 
  3.751827631812792*^9, 3.751861197623233*^9},
 CellLabel->"During evaluation of In[290]:=",
 CellID->1512333599,ExpressionUUID->"f5ec5b79-3d04-496d-9be9-9dba8267f071"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751825314585294*^9, 
  3.751827631812792*^9, 3.751861197629114*^9},
 CellLabel->"During evaluation of In[290]:=",
 CellID->174352501,ExpressionUUID->"1c6cf3dd-fa32-4c96-a6b0-00cc3a19058e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751825314585294*^9, 
  3.751827631812792*^9, 3.751861197635051*^9},
 CellLabel->"During evaluation of In[290]:=",
 CellID->1174789799,ExpressionUUID->"ca903028-9f1f-4a9a-a5fb-00cc659124c8"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.75124808019132*^9, 3.7512480809379053`*^9}},
 CellID->423899325,ExpressionUUID->"7caf4ba3-0aeb-4c58-b010-f206ab7a627f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.747505552707037*^9, {3.7475057578295593`*^9, 3.747505759222794*^9}, {
   3.747505842150148*^9, 3.7475058458319883`*^9}, {3.747505896191999*^9, 
   3.74750589728131*^9}, {3.748124150238531*^9, 3.748124150517943*^9}, 
   3.748169029221862*^9, 3.748173244647019*^9},
 CellLabel->"In[300]:=",
 CellID->714870838,ExpressionUUID->"865cfadd-d89e-4182-b8fa-0b237d1a013a"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", 
        RowBox[{"R1", " ", "CC"}]]}], ",", 
      FractionBox["1", "CC"]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", "Ip"]}], ",", 
      RowBox[{"-", 
       FractionBox["Rp", "Ip"]}]}], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.747505555643032*^9, 3.7475055867312613`*^9}, {
   3.747505761476728*^9, 3.747505764318122*^9}, {3.747505847665118*^9, 
   3.7475058502692757`*^9}, {3.747505898843794*^9, 3.74750590124069*^9}, {
   3.7475063255823507`*^9, 3.747506334276267*^9}, {3.7481241530496283`*^9, 
   3.748124156712919*^9}, 3.7481690353265944`*^9, {3.748169641556839*^9, 
   3.748169730141844*^9}, {3.7481706308795347`*^9, 3.748170648343268*^9}, {
   3.7481713324991817`*^9, 3.748171412017522*^9}, {3.7481722117935038`*^9, 
   3.748172266534639*^9}, {3.748172557215331*^9, 3.748172586783577*^9}, 
   3.748172811167288*^9, {3.748173455617723*^9, 3.748173456202003*^9}, {
   3.748173684193961*^9, 3.7481736910145693`*^9}, {3.748174023178488*^9, 
   3.748174074694357*^9}, {3.7482024431310062`*^9, 3.7482024882994432`*^9}, {
   3.748203045867991*^9, 3.748203049432695*^9}, {3.7482031539741383`*^9, 
   3.748203165353072*^9}, {3.748207600236726*^9, 3.7482076437651033`*^9}, {
   3.748207926849205*^9, 3.748207952971178*^9}, {3.748208268582942*^9, 
   3.748208337143387*^9}},
 CellID->322452496,ExpressionUUID->"4bba16c3-58be-4ce9-92f4-50dfb7d2fa20"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \
RowBox[{\\\"CC\\\", \\\" \\\", \\\"R1\\\"}]]}], \\\",\\\", \
FractionBox[\\\"1\\\", \\\"CC\\\"]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \\\"Ip\\\"]}], \
\\\",\\\", RowBox[{\\\"-\\\", FractionBox[RowBox[{\\\"\[LeftSkeleton]\\\", \\\
\"2\\\", \\\"\[RightSkeleton]\\\"}], RowBox[{\\\"\[LeftSkeleton]\\\", \\\"2\\\
\", \\\"\[RightSkeleton]\\\"}]]}]}], \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"1\", RowBox[{\"CC\", \" \", \"R1\"}]]}], \
\",\", FractionBox[\"1\", \"CC\"]}], \"}\"}], \",\", RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"1\", \"Ip\"]}], \",\", RowBox[{\"-\", \
FractionBox[RowBox[{\"\[LeftSkeleton]\", \"2\", \"\[RightSkeleton]\"}], \
RowBox[{\"\[LeftSkeleton]\", \"2\", \"\[RightSkeleton]\"}]]}]}], \"}\"}]}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \
RowBox[{\\\"CC\\\", \\\" \\\", \\\"R1\\\"}]]}], \\\",\\\", \
FractionBox[\\\"1\\\", \\\"CC\\\"]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \\\"Ip\\\"]}], \
\\\",\\\", RowBox[{\\\"-\\\", FractionBox[RowBox[{\\\"\[LeftSkeleton]\\\", \\\
\"2\\\", \\\"\[RightSkeleton]\\\"}], RowBox[{\\\"\[LeftSkeleton]\\\", \\\"2\\\
\", \\\"\[RightSkeleton]\\\"}]]}]}], \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"1\", RowBox[{\"CC\", \" \", \"R1\"}]]}], \
\",\", FractionBox[\"1\", \"CC\"]}], \"}\"}], \",\", RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"1\", \"Ip\"]}], \",\", RowBox[{\"-\", \
FractionBox[RowBox[{\"\[LeftSkeleton]\", \"2\", \"\[RightSkeleton]\"}], \
RowBox[{\"\[LeftSkeleton]\", \"2\", \"\[RightSkeleton]\"}]]}]}], \"}\"}]}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0008569999999998856`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0008569999999998856`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->727501275,ExpressionUUID->"1fadbdd5-c464-473e-9c55-c407a933b622"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1489526554,ExpressionUUID->"b5166b90-d677-466f-ba92-147a361b5751"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.748169118881194*^9, {3.748173109584269*^9, 3.748173111317824*^9}},
 CellLabel->"In[301]:=",
 CellID->1325088500,ExpressionUUID->"afcadf3f-176c-48f3-90ba-d49334288c5a"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"1", "/", "Ip"}], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169152633688*^9, 3.748169166417688*^9}, 
   3.74816961437001*^9, {3.748169735895432*^9, 3.74816976416591*^9}, {
   3.7481714534342337`*^9, 3.748171524401494*^9}, {3.748172277994993*^9, 
   3.748172388840468*^9}, {3.748173070786932*^9, 3.7481730730294323`*^9}, {
   3.748173117430595*^9, 3.7481731307454023`*^9}, {3.748173458595439*^9, 
   3.74817345887745*^9}, {3.748173695194269*^9, 3.748173699950642*^9}, {
   3.748202504888515*^9, 3.7482025270319357`*^9}, {3.748203173557973*^9, 
   3.748203178913308*^9}, {3.748207655028558*^9, 3.748207662940427*^9}, {
   3.7482079592072783`*^9, 3.7482079715754347`*^9}, {3.748208353270157*^9, 
   3.748208354059061*^9}},
 CellID->1529551905,ExpressionUUID->"19d64d2f-5bfb-4c80-b917-c8449ad8bdf3"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", FractionBox[\\\"1\\\", \\\"Ip\\\"], \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", FractionBox[\"1\", \"Ip\"], \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", FractionBox[\\\"1\\\", \\\"Ip\\\"], \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", FractionBox[\"1\", \"Ip\"], \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00043399999999849115`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00043399999999849115`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1255919999,ExpressionUUID->"d614d1f1-7cf0-42a2-a577-a0551688f3b3"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->630656830,ExpressionUUID->"2a8c5279-6ea4-47a4-b4ca-d7b49ba4bfd2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169171923123*^9, 3.748173146603053*^9},
 CellLabel->"In[302]:=",
 CellID->195895847,ExpressionUUID->"63b783c1-ae68-4a45-bacb-dc201d89ddb7"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481691806324472`*^9, 3.748169184126515*^9}, {
   3.7481697745097303`*^9, 3.7481698177840567`*^9}, 3.748170212558292*^9, {
   3.74817153653963*^9, 3.748171557948637*^9}, {3.748172403638979*^9, 
   3.748172459180491*^9}, 3.748173461553569*^9, {3.748202537450017*^9, 
   3.748202581324718*^9}, {3.748203197531724*^9, 3.74820320090259*^9}, {
   3.74820768305413*^9, 3.748207686169286*^9}, {3.748207980487094*^9, 
   3.748208000065283*^9}, {3.748208360903953*^9, 3.748208368060452*^9}},
 CellID->930877862,ExpressionUUID->"5ffb9c45-d40c-4444-8f8e-6cf0478cd4c2"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\
\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"1\", \
\",\", \"0\"}], \"}\"}], \",\", RowBox[{\"{\", RowBox[{\"0\", \",\", \"1\"}], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\
\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"1\", \
\",\", \"0\"}], \"}\"}], \",\", RowBox[{\"{\", RowBox[{\"0\", \",\", \"1\"}], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001449999999998397`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001449999999998397`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1617543865,ExpressionUUID->"3a8aa8f7-733c-4ad0-aab3-70617125e04e"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1064251682,ExpressionUUID->"73484575-084c-4136-99ce-774efbe338c2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169187965559*^9, 3.748173150905864*^9},
 CellLabel->"In[303]:=",
 CellID->1337686776,ExpressionUUID->"c63527ed-7117-40c3-9e25-405ca9d95df1"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169193927287*^9, 3.748169194789258*^9}, {
   3.748169826851533*^9, 3.7481698714627047`*^9}, {3.748171572452416*^9, 
   3.748171580237145*^9}, {3.748172509134172*^9, 3.7481725445555677`*^9}, {
   3.748172960660345*^9, 3.7481729614507627`*^9}, 3.7481734650745153`*^9, {
   3.7482025915862713`*^9, 3.748202630873435*^9}, {3.748203221716777*^9, 
   3.748203224246625*^9}, {3.7482076998962*^9, 3.7482077040054913`*^9}, {
   3.748208008511187*^9, 3.748208021025865*^9}, {3.7482083872773123`*^9, 
   3.748208388235784*^9}},
 CellID->825458383,ExpressionUUID->"6977cb23-7cd2-45c4-bbae-2ddfa965ae8c"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001600000000010482`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001600000000010482`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->486723511,ExpressionUUID->"3b3e53de-b4b9-4865-beca-deb67fdaf6e1"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->596837954,ExpressionUUID->"c6ec1128-8bcd-4455-ac03-e1d3a8191801"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"e", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.74816921143508*^9, 3.74817315251501*^9},
 CellLabel->"In[304]:=",
 CellID->1247766488,ExpressionUUID->"1c177f35-4e31-46fc-86b3-bd9f00436f69"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "b", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692120543423`*^9, 3.748169217153222*^9}, 
   3.748169620186891*^9, {3.7481699674394503`*^9, 3.7481699868030443`*^9}, 
   3.748173467456937*^9},
 CellID->748835101,ExpressionUUID->"0860d0ef-cf3f-4279-bc9b-1c982ed1966f"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00012899999999760325`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00012899999999760325`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->159377741,ExpressionUUID->"fc57299e-673a-49aa-b571-91cf0eb99472"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->749585178,ExpressionUUID->"336d570b-241c-48d5-84ec-ca37a7c5f6e5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169221684237*^9, 3.7481731563003674`*^9},
 CellLabel->"In[305]:=",
 CellID->1736729043,ExpressionUUID->"dbd703bb-ceb8-4925-b2b5-20a6660328cf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "d", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692270490217`*^9, 3.748169230838327*^9}, {
   3.748169991971572*^9, 3.748170004254684*^9}, 3.748173469973262*^9},
 CellID->98922809,ExpressionUUID->"60f2e5a2-e1f2-4a84-8f29-ac971a1e30e3"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015999999999749548`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015999999999749548`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1139013344,ExpressionUUID->"cf1e5a91-7ece-4804-a8eb-61e69102b556"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->728043250,ExpressionUUID->"aa3b7f25-5c83-48d9-9e60-c8cdc001e38f"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test System 11", "Section",
 CellChangeTimes->{{3.7481692698005457`*^9, 3.748169273381559*^9}, 
   3.7481693114624357`*^9, {3.748169361271824*^9, 3.748169361361087*^9}, {
   3.748170308281064*^9, 3.7481703083633633`*^9}, {3.748171876095627*^9, 
   3.748171876178361*^9}, {3.748173822514773*^9, 3.748173822575068*^9}, {
   3.748201957095229*^9, 3.748201957209919*^9}, {3.748202693602541*^9, 
   3.748202694592355*^9}, {3.748203258099217*^9, 3.748203258755952*^9}, {
   3.748207736252469*^9, 3.7482077387114143`*^9}, {3.7482080854975643`*^9, 
   3.748208086239914*^9}, {3.748208442026148*^9, 3.748208442059677*^9}},
 CellID->788888489,ExpressionUUID->"870bbda1-0670-46e9-b9d8-f8a2dbf9bb0c"],

Cell[CellGroupData[{

Cell["System model", "Subsection",
 CellChangeTimes->{{3.751287449298102*^9, 3.7512874506932793`*^9}},
 CellID->264060228,ExpressionUUID->"41ee1ddc-60d8-47f9-8b78-566f2e328384"],

Cell["Rowell and Wormley Example 5.7", "Text",
 CellChangeTimes->{{3.748169314267838*^9, 3.748169333731399*^9}, {
  3.748169368971754*^9, 3.748169377466568*^9}, {3.74817032089456*^9, 
  3.748170327324637*^9}, {3.748171903869137*^9, 3.748171911436009*^9}, {
  3.748173840454677*^9, 3.748173847774159*^9}, {3.748201999818125*^9, 
  3.748202000841951*^9}, {3.748202706062766*^9, 3.74820270612952*^9}, {
  3.748203275897526*^9, 3.7482032759962273`*^9}, {3.748207745579783*^9, 
  3.7482077456859827`*^9}, {3.748208092550345*^9, 3.748208092618396*^9}, {
  3.7482084571902933`*^9, 3.7482084587479973`*^9}},
 CellID->681143337,ExpressionUUID->"b43fd4e8-752a-47f7-a68b-a0f98e5f1261"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"Qs", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primaryVars", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Tc", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"TR2", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"qR1", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outExps", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"Tc", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"elementalEqs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Tc", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"qC", "[", "t", "]"}], "/", "CC"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TR2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"R2", " ", 
       RowBox[{"qR2", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"qR1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"TR1", "[", "t", "]"}], "/", "R1"}]}]}], "\[IndentingNewLine]",
     "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"constraintEqs", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"qC", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"qR1", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"qR2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Qs", "[", "t", "]"}], "-", 
       RowBox[{"qR1", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TR1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"TR2", "[", "t", "]"}], "-", 
       RowBox[{"Tc", "[", "t", "]"}]}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.747499218184157*^9, 3.74749931067735*^9}, {
   3.7474997703057547`*^9, 3.747499862953096*^9}, {3.7475000427164516`*^9, 
   3.7475001179609213`*^9}, 3.747500172506531*^9, {3.7475052421578627`*^9, 
   3.7475052437525806`*^9}, {3.7475052792870703`*^9, 3.747505305743517*^9}, {
   3.7475054395550127`*^9, 3.74750549238805*^9}, {3.748169383980278*^9, 
   3.748169603265369*^9}, {3.748170115690106*^9, 3.748170132266461*^9}, {
   3.748170333165715*^9, 3.7481705921461983`*^9}, {3.748171917577342*^9, 
   3.74817195326005*^9}, {3.748171995123074*^9, 3.7481720024895773`*^9}, {
   3.748172035662871*^9, 3.7481721909688787`*^9}, {3.748173852472159*^9, 
   3.7481740097196913`*^9}, {3.7482022679021463`*^9, 3.748202298767332*^9}, {
   3.748202329707706*^9, 3.748202426597817*^9}, {3.7482027090106783`*^9, 
   3.748202788912438*^9}, {3.74820743586224*^9, 3.748207471308917*^9}, {
   3.748207507244035*^9, 3.748207585893305*^9}, {3.7482077486519814`*^9, 
   3.748207772848833*^9}, {3.748207850305572*^9, 3.7482079126557817`*^9}, {
   3.748208102199922*^9, 3.748208255621907*^9}, {3.748208462423398*^9, 
   3.748208588053383*^9}, {3.751287455036386*^9, 3.7512875411103487`*^9}, {
   3.7518264190209513`*^9, 3.7518264540948963`*^9}},
 CellLabel->"In[306]:=",
 CellID->729025756,ExpressionUUID->"f7a7303b-bd29-4fa9-8a23-a86dc0c512a2"],

Cell["Find state equation.", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.75124789335491*^9}},
 CellID->1422520852,ExpressionUUID->"7d4deb98-016b-44c7-b664-4980fd936b72"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stateSolution", "=", 
   RowBox[{
    RowBox[{"stateEquations", "[", 
     RowBox[{
     "inVars", ",", "primaryVars", ",", "elementalEqs", ",", 
      "constraintEqs"}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateVars", " ", "=", " ", 
   RowBox[{"\"\<state variables\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateEqList", " ", "=", " ", 
   RowBox[{"\"\<RHS\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\"\<state equations\>\"", "/.", "stateSolution"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.7018797195836763`*^9, 3.7018797204767036`*^9}, {
   3.701879810803969*^9, 3.701879844544981*^9}, {3.7018942050184517`*^9, 
   3.701894566874161*^9}, 3.701898020551093*^9, {3.701903282327601*^9, 
   3.701903283500523*^9}, {3.701911200698804*^9, 3.701911202601316*^9}, {
   3.701915682054678*^9, 3.701915720675168*^9}, {3.701915759772274*^9, 
   3.7019157927706213`*^9}, {3.701915923602686*^9, 3.701915923900078*^9}, 
   3.7019209193048553`*^9, 3.701920950145496*^9, {3.701921306764739*^9, 
   3.701921308673313*^9}, {3.701921408184596*^9, 3.7019214156809187`*^9}, 
   3.7019220747800493`*^9, {3.701922189786292*^9, 3.701922218088579*^9}, {
   3.701922248592429*^9, 3.701922251876824*^9}, 3.701922322852202*^9, {
   3.701922383801173*^9, 3.7019224315654707`*^9}, {3.701922463501308*^9, 
   3.7019224895050097`*^9}, 3.7019225472984467`*^9, {3.701922594846767*^9, 
   3.701922598092758*^9}, {3.701922662563005*^9, 3.701922735877761*^9}, {
   3.7019231046383343`*^9, 3.701923105684675*^9}, {3.7019639715923243`*^9, 
   3.7019639718841667`*^9}, {3.7019642654040737`*^9, 3.701964352167139*^9}, {
   3.701964387110903*^9, 3.7019644147887087`*^9}, {3.702757419429731*^9, 
   3.7027575039883213`*^9}, {3.7511302149210863`*^9, 3.751130222225973*^9}, 
   3.751131245052647*^9, 3.7518224212768917`*^9, 3.751859572450069*^9, 
   3.751859962444891*^9, 3.751860991911108*^9, 3.7519374020871572`*^9},
 CellID->163345547,ExpressionUUID->"7b0acb8e-5675-468c-9c8f-f5989d18c2e3"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["Tc", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       FractionBox[
        RowBox[{"R2", " ", 
         RowBox[{"Qs", "[", "t", "]"}]}], 
        RowBox[{"CC", " ", 
         RowBox[{"(", 
          RowBox[{"R1", "+", "R2"}], ")"}]}]], "-", 
       FractionBox[
        RowBox[{"Tc", "[", "t", "]"}], 
        RowBox[{"CC", " ", 
         RowBox[{"(", 
          RowBox[{"R1", "+", "R2"}], ")"}]}]]}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751131246142264*^9, 3.751131562228766*^9, 3.751154207578877*^9, 
   3.751155061538066*^9, 3.7511551539969883`*^9, 3.7511556539137783`*^9, 
   3.751156830900199*^9, 3.751157044451893*^9, 3.751157305712584*^9, 
   3.751157692923893*^9, 3.751237248504381*^9, 3.7512373121455393`*^9, 
   3.751237557961287*^9, {3.7512412411479073`*^9, 3.751241257691305*^9}, 
   3.7512413334070673`*^9, 3.751241455823284*^9, 3.751241611586341*^9, 
   3.7512433878599854`*^9, 3.751243524307231*^9, 3.751243608962484*^9, 
   3.7512437545853853`*^9, 3.751243860047454*^9, 3.7512441819725847`*^9, 
   3.751244399097206*^9, 3.751244486437664*^9, 3.75124455927641*^9, 
   3.75124464012558*^9, 3.75124506931707*^9, 3.751245129883816*^9, 
   3.751245199900049*^9, 3.751245786492696*^9, 3.7512458405736723`*^9, 
   3.751245872204157*^9, {3.7512470996055098`*^9, 3.751247133340377*^9}, 
   3.751822506215632*^9, {3.751822707767754*^9, 3.751822723484655*^9}, 
   3.751822800835991*^9, 3.7518235244045973`*^9, 3.751823574246002*^9, 
   3.75182394710122*^9, 3.751824050485718*^9, {3.751824086094249*^9, 
   3.7518241542062597`*^9}, 3.751824200734988*^9, {3.751826469736061*^9, 
   3.75182648576022*^9}, 3.751827705331481*^9, 3.751861278143038*^9},
 CellLabel->"Out[314]//TableForm=",
 CellID->2008565791,ExpressionUUID->"92411e81-a0a9-488f-9102-f92e438425cf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"outEqList", "=", 
   RowBox[{"outEquations", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outExps", ",", 
     RowBox[{"elementalEqs", "~", "Join", "~", "constraintEqs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outEqList", "//", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"y", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "outExps", "]"}]}], "}"}]}], "]"}], 
      "\[Equal]", "#"}], "]"}], "&"}]}], "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.75115407229806*^9, 3.7511540907068577`*^9}, {
   3.7511541283727303`*^9, 3.751154145140655*^9}, {3.751154185947949*^9, 
   3.751154186454541*^9}, {3.75115440553708*^9, 3.751154408241644*^9}, {
   3.751157061478198*^9, 3.75115706228808*^9}, {3.751157258647379*^9, 
   3.751157263470278*^9}, {3.751157318329653*^9, 3.751157382599204*^9}, 
   3.751243546881419*^9, 3.7512446518094807`*^9, {3.7518241789029417`*^9, 
   3.751824190813037*^9}},
 CellLabel->"In[315]:=",
 CellID->2051739386,ExpressionUUID->"f8c0975e-b19f-4c86-ae39-27e916b3b71b"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{"y", "[", "1", "]"}], "\[Equal]", 
       RowBox[{"Tc", "[", "t", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751154146341402*^9, {3.7511541874520807`*^9, 3.75115421035389*^9}, 
   3.751154409289606*^9, 3.751155063159431*^9, 3.7511551578703537`*^9, {
   3.751155631171876*^9, 3.7511556669733973`*^9}, 3.751156831153225*^9, {
   3.7511570444961233`*^9, 3.751157063011318*^9}, 3.7511573845757217`*^9, 
   3.7511576929574337`*^9, 3.751237248545403*^9, 3.75123731846103*^9, 
   3.751237558009218*^9, 3.75124126512782*^9, 3.751241341691312*^9, 
   3.7512414602930183`*^9, {3.7512415890389347`*^9, 3.751241614550478*^9}, 
   3.751243391757332*^9, {3.751243525864511*^9, 3.7512435473077707`*^9}, 
   3.7512436090180597`*^9, 3.751243754645124*^9, 3.751243860169832*^9, 
   3.751244182055914*^9, 3.751244399162704*^9, 3.751244486514542*^9, 
   3.751244523619996*^9, 3.7512445593242817`*^9, {3.751244640162719*^9, 
   3.7512446526642714`*^9}, 3.7512450693463917`*^9, 3.751245129916429*^9, 
   3.751245199944006*^9, 3.751245811673089*^9, 3.75124584198965*^9, 
   3.75124587430195*^9, {3.751247099662253*^9, 3.751247148020466*^9}, {
   3.751824169273649*^9, 3.751824200839072*^9}, {3.7518264744872313`*^9, 
   3.751826485877845*^9}, 3.751827705594898*^9, 3.751861278374626*^9},
 CellLabel->"Out[316]//TableForm=",
 CellID->1669802144,ExpressionUUID->"86571172-a05a-4e78-af48-92d62a721892"]
}, Open  ]],

Cell["\<\
Linearize the state and output equations about operating point.\
\>", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.7512479601059103`*^9}},
 CellID->1033466272,ExpressionUUID->"d1cd2816-9fbd-438c-b392-f09ae54185fb"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"abe", "=", 
   RowBox[{"linearizeState", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "stateEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdf", "=", 
   RowBox[{"linearizeOutput", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"e", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"d", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"f", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<A = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<B = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<E = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<C = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<D = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<F = \>\"", ",", "#"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.751247952610923*^9}},
 CellLabel->"In[317]:=",
 CellID->619896568,ExpressionUUID->"24449604-7087-4149-8fae-bf48ff056d97"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox["1", 
          RowBox[{"CC", " ", 
           RowBox[{"(", 
            RowBox[{"R1", "+", "R2"}], ")"}]}]]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["A = ", 
   MatrixForm[{{-$CellContext`CC^(-1)/($CellContext`R1 + $CellContext`R2)}}]],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751287550393589*^9, 
  3.751826485984952*^9, 3.751827705911478*^9, 3.75186127860672*^9},
 CellLabel->"During evaluation of In[317]:=",
 CellID->1048335212,ExpressionUUID->"8767fd7d-db33-48a2-af86-e38a24a28216"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"B = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["R2", 
         RowBox[{"CC", " ", 
          RowBox[{"(", 
           RowBox[{"R1", "+", "R2"}], ")"}]}]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["B = ", 
   MatrixForm[{{$CellContext`CC^(-1) $CellContext`R2/($CellContext`R1 + \
$CellContext`R2)}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751287550393589*^9, 
  3.751826485984952*^9, 3.751827705911478*^9, 3.751861278618318*^9},
 CellLabel->"During evaluation of In[317]:=",
 CellID->1414068096,ExpressionUUID->"0e4b4384-b5ee-4516-8211-58bd752a28c4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"E = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["E = ", 
   MatrixForm[{{0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751287550393589*^9, 
  3.751826485984952*^9, 3.751827705911478*^9, 3.7518612786437597`*^9},
 CellLabel->"During evaluation of In[317]:=",
 CellID->40968123,ExpressionUUID->"d390407c-bef1-4926-a017-f105e603da83"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{1}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751287550393589*^9, 
  3.751826485984952*^9, 3.751827705911478*^9, 3.751861278649802*^9},
 CellLabel->"During evaluation of In[317]:=",
 CellID->1356476221,ExpressionUUID->"5f1a7703-2024-4e4b-872b-cbbf8b6c4624"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751287550393589*^9, 
  3.751826485984952*^9, 3.751827705911478*^9, 3.751861278655819*^9},
 CellLabel->"During evaluation of In[317]:=",
 CellID->609449795,ExpressionUUID->"e8840224-5555-4acd-b098-7f7d61823d50"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751287550393589*^9, 
  3.751826485984952*^9, 3.751827705911478*^9, 3.751861278661721*^9},
 CellLabel->"During evaluation of In[317]:=",
 CellID->1673192022,ExpressionUUID->"bd881fa5-3d54-46e2-b11a-fa84f7bf559b"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.75124808019132*^9, 3.7512480809379053`*^9}},
 CellID->288271980,ExpressionUUID->"3434f91a-e613-4fca-8753-ff545c5d9d04"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.747505552707037*^9, {3.7475057578295593`*^9, 3.747505759222794*^9}, {
   3.747505842150148*^9, 3.7475058458319883`*^9}, {3.747505896191999*^9, 
   3.74750589728131*^9}, {3.748124150238531*^9, 3.748124150517943*^9}, 
   3.748169029221862*^9, 3.748173244647019*^9},
 CellLabel->"In[327]:=",
 CellID->1612021199,ExpressionUUID->"1c47681f-c61d-4af0-adcb-4d4d1f25fb14"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", 
    FractionBox[
     RowBox[{"-", "1"}], 
     RowBox[{"CC", 
      RowBox[{"(", 
       RowBox[{"R1", "+", "R2"}], ")"}]}]], "}"}], "}"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.747505555643032*^9, 3.7475055867312613`*^9}, {
   3.747505761476728*^9, 3.747505764318122*^9}, {3.747505847665118*^9, 
   3.7475058502692757`*^9}, {3.747505898843794*^9, 3.74750590124069*^9}, {
   3.7475063255823507`*^9, 3.747506334276267*^9}, {3.7481241530496283`*^9, 
   3.748124156712919*^9}, 3.7481690353265944`*^9, {3.748169641556839*^9, 
   3.748169730141844*^9}, {3.7481706308795347`*^9, 3.748170648343268*^9}, {
   3.7481713324991817`*^9, 3.748171412017522*^9}, {3.7481722117935038`*^9, 
   3.748172266534639*^9}, {3.748172557215331*^9, 3.748172586783577*^9}, 
   3.748172811167288*^9, {3.748173455617723*^9, 3.748173456202003*^9}, {
   3.748173684193961*^9, 3.7481736910145693`*^9}, {3.748174023178488*^9, 
   3.748174074694357*^9}, {3.7482024431310062`*^9, 3.7482024882994432`*^9}, {
   3.748203045867991*^9, 3.748203049432695*^9}, {3.7482031539741383`*^9, 
   3.748203165353072*^9}, {3.748207600236726*^9, 3.7482076437651033`*^9}, {
   3.748207926849205*^9, 3.748207952971178*^9}, {3.748208268582942*^9, 
   3.748208337143387*^9}, {3.748208598589538*^9, 3.7482086272775517`*^9}},
 CellID->1907431679,ExpressionUUID->"9926083b-4d70-4249-8e3a-661b59a5dda8"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", RowBox[{\\\"CC\\\
\", \\\" \\\", RowBox[{\\\"(\\\", RowBox[{\\\"R1\\\", \\\"+\\\", RowBox[{\\\"\
\[LeftSkeleton]\\\", \\\"2\\\", \\\"\[RightSkeleton]\\\"}]}], \
\\\")\\\"}]}]]}], \\\"}\\\"}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"-\", \
FractionBox[\"1\", RowBox[{\"CC\", \" \", RowBox[{\"(\", RowBox[{\"R1\", \
\"+\", RowBox[{\"\[LeftSkeleton]\", \"2\", \"\[RightSkeleton]\"}]}], \
\")\"}]}]]}], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", RowBox[{\\\"CC\\\
\", \\\" \\\", RowBox[{\\\"(\\\", RowBox[{\\\"R1\\\", \\\"+\\\", RowBox[{\\\"\
\[LeftSkeleton]\\\", \\\"2\\\", \\\"\[RightSkeleton]\\\"}]}], \
\\\")\\\"}]}]]}], \\\"}\\\"}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"-\", \
FractionBox[\"1\", RowBox[{\"CC\", \" \", RowBox[{\"(\", RowBox[{\"R1\", \
\"+\", RowBox[{\"\[LeftSkeleton]\", \"2\", \"\[RightSkeleton]\"}]}], \
\")\"}]}]]}], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0016379999999998063`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0016379999999998063`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->39956289,ExpressionUUID->"22e01d29-c7b8-4a48-883d-9760faeb3b0b"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1530451359,ExpressionUUID->"54189801-e19e-48a4-aeac-53aa4855cd13"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.748169118881194*^9, {3.748173109584269*^9, 3.748173111317824*^9}},
 CellLabel->"In[328]:=",
 CellID->585406414,ExpressionUUID->"189074dc-73f5-4df9-ae95-071cd4ad4373"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", 
    FractionBox["R2", 
     RowBox[{"CC", 
      RowBox[{"(", 
       RowBox[{"R1", "+", "R2"}], ")"}]}]], "}"}], "}"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169152633688*^9, 3.748169166417688*^9}, 
   3.74816961437001*^9, {3.748169735895432*^9, 3.74816976416591*^9}, {
   3.7481714534342337`*^9, 3.748171524401494*^9}, {3.748172277994993*^9, 
   3.748172388840468*^9}, {3.748173070786932*^9, 3.7481730730294323`*^9}, {
   3.748173117430595*^9, 3.7481731307454023`*^9}, {3.748173458595439*^9, 
   3.74817345887745*^9}, {3.748173695194269*^9, 3.748173699950642*^9}, {
   3.748202504888515*^9, 3.7482025270319357`*^9}, {3.748203173557973*^9, 
   3.748203178913308*^9}, {3.748207655028558*^9, 3.748207662940427*^9}, {
   3.7482079592072783`*^9, 3.7482079715754347`*^9}, {3.748208353270157*^9, 
   3.748208354059061*^9}, {3.748208640004923*^9, 3.748208652866403*^9}},
 CellID->1846243533,ExpressionUUID->"3d1e572e-c3e2-4564-aeb8-e7a9952653ae"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", FractionBox[\\\"R2\\\", RowBox[{\\\"CC\\\", \\\" \\\", \
RowBox[{\\\"(\\\", RowBox[{\\\"R1\\\", \\\"+\\\", RowBox[{\\\"\[LeftSkeleton]\
\\\", \\\"2\\\", \\\"\[RightSkeleton]\\\"}]}], \\\")\\\"}]}]], \\\"}\\\"}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", FractionBox[\"R2\", \
RowBox[{\"CC\", \" \", RowBox[{\"(\", RowBox[{\"R1\", \"+\", RowBox[{\"\
\[LeftSkeleton]\", \"2\", \"\[RightSkeleton]\"}]}], \")\"}]}]], \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", FractionBox[\\\"R2\\\", RowBox[{\\\"CC\\\", \\\" \\\", \
RowBox[{\\\"(\\\", RowBox[{\\\"R1\\\", \\\"+\\\", RowBox[{\\\"\[LeftSkeleton]\
\\\", \\\"2\\\", \\\"\[RightSkeleton]\\\"}]}], \\\")\\\"}]}]], \\\"}\\\"}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", FractionBox[\"R2\", \
RowBox[{\"CC\", \" \", RowBox[{\"(\", RowBox[{\"R1\", \"+\", RowBox[{\"\
\[LeftSkeleton]\", \"2\", \"\[RightSkeleton]\"}]}], \")\"}]}]], \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0013199999999997658`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0013199999999997658`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1884350594,ExpressionUUID->"f5ff93b8-9e9c-45dd-b258-bfb2f8224056"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1339091049,ExpressionUUID->"50768f96-6ca3-42c8-9527-527a6b576ad8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169171923123*^9, 3.748173146603053*^9},
 CellLabel->"In[329]:=",
 CellID->447594986,ExpressionUUID->"023852d3-4518-49ec-aece-190374e712f5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", "1", "}"}], "}"}], "//", "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481691806324472`*^9, 3.748169184126515*^9}, {
   3.7481697745097303`*^9, 3.7481698177840567`*^9}, 3.748170212558292*^9, {
   3.74817153653963*^9, 3.748171557948637*^9}, {3.748172403638979*^9, 
   3.748172459180491*^9}, 3.748173461553569*^9, {3.748202537450017*^9, 
   3.748202581324718*^9}, {3.748203197531724*^9, 3.74820320090259*^9}, {
   3.74820768305413*^9, 3.748207686169286*^9}, {3.748207980487094*^9, 
   3.748208000065283*^9}, {3.748208360903953*^9, 3.748208368060452*^9}, {
   3.7482086706482286`*^9, 3.74820867548411*^9}},
 CellID->834270223,ExpressionUUID->"39c38ca1-26d8-455b-bcb1-7dc5025ca13e"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"1\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"1\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"1\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"1\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001600000000010482`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001600000000010482`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->474639983,ExpressionUUID->"bdc1395d-6c07-490f-a916-b927dc66a36e"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1519929323,ExpressionUUID->"521146e0-43f1-4fc8-9077-44a49dfc65f2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169187965559*^9, 3.748173150905864*^9},
 CellLabel->"In[330]:=",
 CellID->933193033,ExpressionUUID->"74becbd5-8883-4a43-ae99-98289a13e9f7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", "0", "}"}], "}"}], "//", "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169193927287*^9, 3.748169194789258*^9}, {
   3.748169826851533*^9, 3.7481698714627047`*^9}, {3.748171572452416*^9, 
   3.748171580237145*^9}, {3.748172509134172*^9, 3.7481725445555677`*^9}, {
   3.748172960660345*^9, 3.7481729614507627`*^9}, 3.7481734650745153`*^9, {
   3.7482025915862713`*^9, 3.748202630873435*^9}, {3.748203221716777*^9, 
   3.748203224246625*^9}, {3.7482076998962*^9, 3.7482077040054913`*^9}, {
   3.748208008511187*^9, 3.748208021025865*^9}, {3.7482083872773123`*^9, 
   3.748208388235784*^9}, {3.748208685323637*^9, 3.748208689698819*^9}},
 CellID->394912443,ExpressionUUID->"bb562782-72a8-4e52-af65-b4e66e815f51"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00016800000000216642`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00016800000000216642`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1134150596,ExpressionUUID->"e41a559f-7509-4ce7-87e7-abfbfaec9b4c"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->604216200,ExpressionUUID->"b64dad2c-3c13-4936-8e5b-9b088b267887"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"e", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.74816921143508*^9, 3.74817315251501*^9},
 CellLabel->"In[331]:=",
 CellID->2137365557,ExpressionUUID->"d6a09c86-653b-4d10-a515-4a8d39d2483a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "b", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692120543423`*^9, 3.748169217153222*^9}, 
   3.748169620186891*^9, {3.7481699674394503`*^9, 3.7481699868030443`*^9}, 
   3.748173467456937*^9},
 CellID->1511248044,ExpressionUUID->"01cf3a58-ae38-413e-8402-d3bdd1f888d1"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00016499999999908255`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00016499999999908255`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1758990384,ExpressionUUID->"72c6c92a-aaea-4655-b703-c6bcaf9ed4b5"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1091499286,ExpressionUUID->"2aaafcf1-655f-43c4-814f-2099144d6142"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169221684237*^9, 3.7481731563003674`*^9},
 CellLabel->"In[332]:=",
 CellID->216790256,ExpressionUUID->"eebd459d-90d4-4aa2-be50-4e428f38a256"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "d", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692270490217`*^9, 3.748169230838327*^9}, {
   3.748169991971572*^9, 3.748170004254684*^9}, 3.748173469973262*^9},
 CellID->6159029,ExpressionUUID->"3836fc7b-ef83-42cd-b49c-a8a440887be2"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00016300000000413206`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00016300000000413206`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1023187128,ExpressionUUID->"6fe12ad7-c2a1-4fbf-bd1c-e6ba78e634ec"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1804498767,ExpressionUUID->"8b1e53c7-ba28-47fd-8e90-75e89f767020"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test System 12", "Section",
 CellChangeTimes->{{3.7481692698005457`*^9, 3.748169273381559*^9}, 
   3.7481693114624357`*^9, {3.748169361271824*^9, 3.748169361361087*^9}, {
   3.748170308281064*^9, 3.7481703083633633`*^9}, {3.748171876095627*^9, 
   3.748171876178361*^9}, {3.748173822514773*^9, 3.748173822575068*^9}, {
   3.748201957095229*^9, 3.748201957209919*^9}, {3.748202693602541*^9, 
   3.748202694592355*^9}, {3.748203258099217*^9, 3.748203258755952*^9}, {
   3.748207736252469*^9, 3.7482077387114143`*^9}, {3.7482080854975643`*^9, 
   3.748208086239914*^9}, {3.748208442026148*^9, 3.748208442059677*^9}, {
   3.7482087322418833`*^9, 3.748208732285034*^9}},
 CellID->1096616352,ExpressionUUID->"8986f361-795b-4672-8cc8-1691b8edc5b7"],

Cell["Rowell and Wormley Example 5.9", "Text",
 CellChangeTimes->{{3.748169314267838*^9, 3.748169333731399*^9}, {
  3.748169368971754*^9, 3.748169377466568*^9}, {3.74817032089456*^9, 
  3.748170327324637*^9}, {3.748171903869137*^9, 3.748171911436009*^9}, {
  3.748173840454677*^9, 3.748173847774159*^9}, {3.748201999818125*^9, 
  3.748202000841951*^9}, {3.748202706062766*^9, 3.74820270612952*^9}, {
  3.748203275897526*^9, 3.7482032759962273`*^9}, {3.748207745579783*^9, 
  3.7482077456859827`*^9}, {3.748208092550345*^9, 3.748208092618396*^9}, {
  3.7482084571902933`*^9, 3.7482084587479973`*^9}, {3.748208743462226*^9, 
  3.7482087438803596`*^9}},
 CellID->1902021877,ExpressionUUID->"5fcc21d2-da68-49fc-8b86-522d6f130c0a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"Fs", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primaryVars", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vm", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"FK1", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"FB2", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"vB1", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"vK2", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outExps", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"vB1", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"elementalEqs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"vm", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Fm", "[", "t", "]"}], "/", "m"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"FK1", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{"K1", " ", 
       RowBox[{"vK1", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FB2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"B2", " ", 
       RowBox[{"vB2", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vB1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"FB1", "[", "t", "]"}], "/", "B1"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vK2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{
        RowBox[{"FK2", "'"}], "[", "t", "]"}], "/", "K2"}]}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"constraintEqs", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"vK1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"vK2", "[", "t", "]"}], "-", 
       RowBox[{"vB1", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vB2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"vm", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FK2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Fs", "[", "t", "]"}], "-", 
       RowBox[{"FK1", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FB1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"FK1", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Fm", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Fs", "[", "t", "]"}], "-", 
       RowBox[{"FB2", "[", "t", "]"}]}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.747499218184157*^9, 3.74749931067735*^9}, {
   3.7474997703057547`*^9, 3.747499862953096*^9}, {3.7475000427164516`*^9, 
   3.7475001179609213`*^9}, 3.747500172506531*^9, {3.7475052421578627`*^9, 
   3.7475052437525806`*^9}, {3.7475052792870703`*^9, 3.747505305743517*^9}, {
   3.7475054395550127`*^9, 3.74750549238805*^9}, {3.748169383980278*^9, 
   3.748169603265369*^9}, {3.748170115690106*^9, 3.748170132266461*^9}, {
   3.748170333165715*^9, 3.7481705921461983`*^9}, {3.748171917577342*^9, 
   3.74817195326005*^9}, {3.748171995123074*^9, 3.7481720024895773`*^9}, {
   3.748172035662871*^9, 3.7481721909688787`*^9}, {3.748173852472159*^9, 
   3.7481740097196913`*^9}, {3.7482022679021463`*^9, 3.748202298767332*^9}, {
   3.748202329707706*^9, 3.748202426597817*^9}, {3.7482027090106783`*^9, 
   3.748202788912438*^9}, {3.74820743586224*^9, 3.748207471308917*^9}, {
   3.748207507244035*^9, 3.748207585893305*^9}, {3.7482077486519814`*^9, 
   3.748207772848833*^9}, {3.748207850305572*^9, 3.7482079126557817`*^9}, {
   3.748208102199922*^9, 3.748208255621907*^9}, {3.748208462423398*^9, 
   3.748208588053383*^9}, {3.748208759735673*^9, 3.748208934310471*^9}, {
   3.751287633106094*^9, 3.751287723846527*^9}, {3.751826511361567*^9, 
   3.7518265620257473`*^9}},
 CellLabel->"In[333]:=",
 CellID->357937628,ExpressionUUID->"c637c1c6-e88a-4103-ab53-35b2ad6318d7"],

Cell["Find state equation.", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.75124789335491*^9}},
 CellID->121022972,ExpressionUUID->"0a8df0e2-ba09-4195-b74e-ecad786ad991"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stateSolution", "=", 
   RowBox[{
    RowBox[{"stateEquations", "[", 
     RowBox[{
     "inVars", ",", "primaryVars", ",", "elementalEqs", ",", 
      "constraintEqs"}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateVars", " ", "=", " ", 
   RowBox[{"\"\<state variables\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateEqList", " ", "=", " ", 
   RowBox[{"\"\<RHS\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\"\<state equations\>\"", "/.", "stateSolution"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.7018797195836763`*^9, 3.7018797204767036`*^9}, {
   3.701879810803969*^9, 3.701879844544981*^9}, {3.7018942050184517`*^9, 
   3.701894566874161*^9}, 3.701898020551093*^9, {3.701903282327601*^9, 
   3.701903283500523*^9}, {3.701911200698804*^9, 3.701911202601316*^9}, {
   3.701915682054678*^9, 3.701915720675168*^9}, {3.701915759772274*^9, 
   3.7019157927706213`*^9}, {3.701915923602686*^9, 3.701915923900078*^9}, 
   3.7019209193048553`*^9, 3.701920950145496*^9, {3.701921306764739*^9, 
   3.701921308673313*^9}, {3.701921408184596*^9, 3.7019214156809187`*^9}, 
   3.7019220747800493`*^9, {3.701922189786292*^9, 3.701922218088579*^9}, {
   3.701922248592429*^9, 3.701922251876824*^9}, 3.701922322852202*^9, {
   3.701922383801173*^9, 3.7019224315654707`*^9}, {3.701922463501308*^9, 
   3.7019224895050097`*^9}, 3.7019225472984467`*^9, {3.701922594846767*^9, 
   3.701922598092758*^9}, {3.701922662563005*^9, 3.701922735877761*^9}, {
   3.7019231046383343`*^9, 3.701923105684675*^9}, {3.7019639715923243`*^9, 
   3.7019639718841667`*^9}, {3.7019642654040737`*^9, 3.701964352167139*^9}, {
   3.701964387110903*^9, 3.7019644147887087`*^9}, {3.702757419429731*^9, 
   3.7027575039883213`*^9}, {3.7511302149210863`*^9, 3.751130222225973*^9}, 
   3.751131245052647*^9, 3.7518224212768917`*^9, 3.751859572510261*^9, 
   3.751859962450288*^9, 3.751860991915605*^9, 3.751937402151412*^9},
 CellID->105684621,ExpressionUUID->"68066fb4-1ad4-493f-91b1-8734c26cc9f6"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["vm", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       FractionBox[
        RowBox[{"Fs", "[", "t", "]"}], "m"], "-", 
       FractionBox[
        RowBox[{"B2", " ", 
         RowBox[{"vm", "[", "t", "]"}]}], "m"]}]}]},
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["FK1", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"K1", " ", "K2", " ", 
          RowBox[{"FK1", "[", "t", "]"}]}], 
         RowBox[{"B1", " ", 
          RowBox[{"(", 
           RowBox[{"K1", "+", "K2"}], ")"}]}]]}], "+", 
       FractionBox[
        RowBox[{"K1", " ", 
         RowBox[{
          SuperscriptBox["Fs", "\[Prime]",
           MultilineFunction->None], "[", "t", "]"}]}], 
        RowBox[{"K1", "+", "K2"}]]}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751131246142264*^9, 3.751131562228766*^9, 3.751154207578877*^9, 
   3.751155061538066*^9, 3.7511551539969883`*^9, 3.7511556539137783`*^9, 
   3.751156830900199*^9, 3.751157044451893*^9, 3.751157305712584*^9, 
   3.751157692923893*^9, 3.751237248504381*^9, 3.7512373121455393`*^9, 
   3.751237557961287*^9, {3.7512412411479073`*^9, 3.751241257691305*^9}, 
   3.7512413334070673`*^9, 3.751241455823284*^9, 3.751241611586341*^9, 
   3.7512433878599854`*^9, 3.751243524307231*^9, 3.751243608962484*^9, 
   3.7512437545853853`*^9, 3.751243860047454*^9, 3.7512441819725847`*^9, 
   3.751244399097206*^9, 3.751244486437664*^9, 3.75124455927641*^9, 
   3.75124464012558*^9, 3.75124506931707*^9, 3.751245129883816*^9, 
   3.751245199900049*^9, 3.751245786492696*^9, 3.7512458405736723`*^9, 
   3.751245872204157*^9, {3.7512470996055098`*^9, 3.751247133340377*^9}, 
   3.751822506215632*^9, {3.751822707767754*^9, 3.751822723484655*^9}, 
   3.751822800835991*^9, 3.7518235244045973`*^9, 3.751823574246002*^9, 
   3.75182394710122*^9, 3.751824050485718*^9, {3.751824086094249*^9, 
   3.7518241542062597`*^9}, 3.751824200734988*^9, {3.7518265869818153`*^9, 
   3.751826597135724*^9}, 3.751827786695668*^9, 3.7518613057782803`*^9},
 CellLabel->"Out[341]//TableForm=",
 CellID->1446714035,ExpressionUUID->"c35e0eac-5256-4c07-8dac-c55192ebf9dd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"outEqList", "=", 
   RowBox[{"outEquations", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outExps", ",", 
     RowBox[{"elementalEqs", "~", "Join", "~", "constraintEqs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outEqList", "//", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"y", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "outExps", "]"}]}], "}"}]}], "]"}], 
      "\[Equal]", "#"}], "]"}], "&"}]}], "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.75115407229806*^9, 3.7511540907068577`*^9}, {
   3.7511541283727303`*^9, 3.751154145140655*^9}, {3.751154185947949*^9, 
   3.751154186454541*^9}, {3.75115440553708*^9, 3.751154408241644*^9}, {
   3.751157061478198*^9, 3.75115706228808*^9}, {3.751157258647379*^9, 
   3.751157263470278*^9}, {3.751157318329653*^9, 3.751157382599204*^9}, 
   3.751243546881419*^9, 3.7512446518094807`*^9, {3.7518241789029417`*^9, 
   3.751824190813037*^9}},
 CellLabel->"In[342]:=",
 CellID->616518542,ExpressionUUID->"d82981d4-ac7f-4c3d-8c47-ed095dd5c1e7"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{"y", "[", "1", "]"}], "\[Equal]", 
       FractionBox[
        RowBox[{"FK1", "[", "t", "]"}], "B1"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751154146341402*^9, {3.7511541874520807`*^9, 3.75115421035389*^9}, 
   3.751154409289606*^9, 3.751155063159431*^9, 3.7511551578703537`*^9, {
   3.751155631171876*^9, 3.7511556669733973`*^9}, 3.751156831153225*^9, {
   3.7511570444961233`*^9, 3.751157063011318*^9}, 3.7511573845757217`*^9, 
   3.7511576929574337`*^9, 3.751237248545403*^9, 3.75123731846103*^9, 
   3.751237558009218*^9, 3.75124126512782*^9, 3.751241341691312*^9, 
   3.7512414602930183`*^9, {3.7512415890389347`*^9, 3.751241614550478*^9}, 
   3.751243391757332*^9, {3.751243525864511*^9, 3.7512435473077707`*^9}, 
   3.7512436090180597`*^9, 3.751243754645124*^9, 3.751243860169832*^9, 
   3.751244182055914*^9, 3.751244399162704*^9, 3.751244486514542*^9, 
   3.751244523619996*^9, 3.7512445593242817`*^9, {3.751244640162719*^9, 
   3.7512446526642714`*^9}, 3.7512450693463917`*^9, 3.751245129916429*^9, 
   3.751245199944006*^9, 3.751245811673089*^9, 3.75124584198965*^9, 
   3.75124587430195*^9, {3.751247099662253*^9, 3.751247148020466*^9}, {
   3.751824169273649*^9, 3.751824200839072*^9}, {3.751826592020762*^9, 
   3.7518265972720327`*^9}, 3.751827787030573*^9, 3.751861306057407*^9},
 CellLabel->"Out[343]//TableForm=",
 CellID->1112934911,ExpressionUUID->"b1faf17d-7e50-42d0-85b5-96e4cb636cb7"]
}, Open  ]],

Cell["\<\
Linearize the state and output equations about operating point.\
\>", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.7512479601059103`*^9}},
 CellID->978931082,ExpressionUUID->"8282dafb-d47b-48d5-b278-a5272977d2eb"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"abe", "=", 
   RowBox[{"linearizeState", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "stateEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdf", "=", 
   RowBox[{"linearizeOutput", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"e", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"d", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"f", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<A = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<B = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<E = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<C = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<D = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<F = \>\"", ",", "#"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.751247952610923*^9}},
 CellLabel->"In[344]:=",
 CellID->1022475507,ExpressionUUID->"c0d80b8e-c54c-46bc-84bb-18986e6214aa"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox["B2", "m"]}], "0"},
       {"0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"K1", " ", "K2"}], 
          RowBox[{"B1", " ", 
           RowBox[{"(", 
            RowBox[{"K1", "+", "K2"}], ")"}]}]]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["A = ", 
   MatrixForm[{{-$CellContext`B2/$CellContext`m, 0}, {
     0, -$CellContext`B1^(-1) $CellContext`K1 \
$CellContext`K2/($CellContext`K1 + $CellContext`K2)}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751287550393589*^9, 
  3.751287735454645*^9, 3.751826597404572*^9, 3.751827787344748*^9, 
  3.751861306322775*^9},
 CellLabel->"During evaluation of In[344]:=",
 CellID->514483807,ExpressionUUID->"b24b8d24-c14d-4546-8118-39cc532ba222"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"B = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["1", "m"]},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["B = ", 
   MatrixForm[{{$CellContext`m^(-1)}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751287550393589*^9, 
  3.751287735454645*^9, 3.751826597404572*^9, 3.751827787344748*^9, 
  3.751861306332868*^9},
 CellLabel->"During evaluation of In[344]:=",
 CellID->1160181427,ExpressionUUID->"af939f8a-dd6e-4cfe-9c56-660e7e5b6d2f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"E = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {
        FractionBox["K1", 
         RowBox[{"K1", "+", "K2"}]]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["E = ", 
   MatrixForm[{{0}, {$CellContext`K1/($CellContext`K1 + $CellContext`K2)}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751287550393589*^9, 
  3.751287735454645*^9, 3.751826597404572*^9, 3.751827787344748*^9, 
  3.7518613063598137`*^9},
 CellLabel->"During evaluation of In[344]:=",
 CellID->17728829,ExpressionUUID->"c1766e43-51b0-45e8-a560-a06bdae297e2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", 
        FractionBox["1", "B1"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{0, $CellContext`B1^(-1)}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751287550393589*^9, 
  3.751287735454645*^9, 3.751826597404572*^9, 3.751827787344748*^9, 
  3.751861306366948*^9},
 CellLabel->"During evaluation of In[344]:=",
 CellID->1615685717,ExpressionUUID->"0bc73975-c378-4815-8c44-fccd36225158"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751287550393589*^9, 
  3.751287735454645*^9, 3.751826597404572*^9, 3.751827787344748*^9, 
  3.75186130637462*^9},
 CellLabel->"During evaluation of In[344]:=",
 CellID->2046612951,ExpressionUUID->"2130fdf5-c96b-4f1d-87b3-6027c43ccdb5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.751248213527203*^9, 3.7512868941886044`*^9, 
  3.751287112179933*^9, 3.751287346211134*^9, 3.751287550393589*^9, 
  3.751287735454645*^9, 3.751826597404572*^9, 3.751827787344748*^9, 
  3.7518613063821373`*^9},
 CellLabel->"During evaluation of In[344]:=",
 CellID->1178293458,ExpressionUUID->"652722c9-0870-4f92-a538-c567a2b5313c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.75124808019132*^9, 3.7512480809379053`*^9}},
 CellID->1751331159,ExpressionUUID->"2d2eda25-aeea-4da8-aa69-aa042949e495"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.747505552707037*^9, {3.7475057578295593`*^9, 3.747505759222794*^9}, {
   3.747505842150148*^9, 3.7475058458319883`*^9}, {3.747505896191999*^9, 
   3.74750589728131*^9}, {3.748124150238531*^9, 3.748124150517943*^9}, 
   3.748169029221862*^9, 3.748173244647019*^9},
 CellLabel->"In[354]:=",
 CellID->588808452,ExpressionUUID->"c5728201-f5f7-493b-818c-20366c0c2a16"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      FractionBox[
       RowBox[{"-", "B2"}], "m"], ",", "0"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"K1", " ", "K2"}], 
        RowBox[{"B1", 
         RowBox[{"(", 
          RowBox[{"K1", "+", "K2"}], ")"}]}]]}]}], "}"}]}], "}"}], 
  "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.747505555643032*^9, 3.7475055867312613`*^9}, {
   3.747505761476728*^9, 3.747505764318122*^9}, {3.747505847665118*^9, 
   3.7475058502692757`*^9}, {3.747505898843794*^9, 3.74750590124069*^9}, {
   3.7475063255823507`*^9, 3.747506334276267*^9}, {3.7481241530496283`*^9, 
   3.748124156712919*^9}, 3.7481690353265944`*^9, {3.748169641556839*^9, 
   3.748169730141844*^9}, {3.7481706308795347`*^9, 3.748170648343268*^9}, {
   3.7481713324991817`*^9, 3.748171412017522*^9}, {3.7481722117935038`*^9, 
   3.748172266534639*^9}, {3.748172557215331*^9, 3.748172586783577*^9}, 
   3.748172811167288*^9, {3.748173455617723*^9, 3.748173456202003*^9}, {
   3.748173684193961*^9, 3.7481736910145693`*^9}, {3.748174023178488*^9, 
   3.748174074694357*^9}, {3.7482024431310062`*^9, 3.7482024882994432`*^9}, {
   3.748203045867991*^9, 3.748203049432695*^9}, {3.7482031539741383`*^9, 
   3.748203165353072*^9}, {3.748207600236726*^9, 3.7482076437651033`*^9}, {
   3.748207926849205*^9, 3.748207952971178*^9}, {3.748208268582942*^9, 
   3.748208337143387*^9}, {3.748208598589538*^9, 3.7482086272775517`*^9}, {
   3.748208949609263*^9, 3.748209010473353*^9}},
 CellID->562980888,ExpressionUUID->"1b92329b-1960-4032-b437-ed9ceca3a0fe"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"B2\\\", \
\\\"m\\\"]}], \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", RowBox[{\\\"0\\\", \\\",\\\", RowBox[{\\\"-\\\", \
FractionBox[RowBox[{\\\"K1\\\", \\\" \\\", RowBox[{\\\"\[LeftSkeleton]\\\", \
\\\"2\\\", \\\"\[RightSkeleton]\\\"}]}], RowBox[{\\\"B1\\\", \\\" \\\", \
RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \
\\\"\[RightSkeleton]\\\"}]}]]}]}], \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"B2\", \"m\"]}], \",\", \"0\"}], \"}\"}], \
\",\", RowBox[{\"{\", RowBox[{\"0\", \",\", RowBox[{\"-\", \
FractionBox[RowBox[{\"K1\", \" \", RowBox[{\"\[LeftSkeleton]\", \"2\", \"\
\[RightSkeleton]\"}]}], RowBox[{\"B1\", \" \", RowBox[{\"\[LeftSkeleton]\", \
\"1\", \"\[RightSkeleton]\"}]}]]}]}], \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"B2\\\", \
\\\"m\\\"]}], \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", RowBox[{\\\"0\\\", \\\",\\\", RowBox[{\\\"-\\\", \
FractionBox[RowBox[{\\\"K1\\\", \\\" \\\", RowBox[{\\\"\[LeftSkeleton]\\\", \
\\\"2\\\", \\\"\[RightSkeleton]\\\"}]}], RowBox[{\\\"B1\\\", \\\" \\\", \
RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \
\\\"\[RightSkeleton]\\\"}]}]]}]}], \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"B2\", \"m\"]}], \",\", \"0\"}], \"}\"}], \
\",\", RowBox[{\"{\", RowBox[{\"0\", \",\", RowBox[{\"-\", \
FractionBox[RowBox[{\"K1\", \" \", RowBox[{\"\[LeftSkeleton]\", \"2\", \"\
\[RightSkeleton]\"}]}], RowBox[{\"B1\", \" \", RowBox[{\"\[LeftSkeleton]\", \
\"1\", \"\[RightSkeleton]\"}]}]]}]}], \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0018220000000042091`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0018220000000042091`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1631439619,ExpressionUUID->"313a115e-8bd9-450e-aecf-3d785589c4d6"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->534471637,ExpressionUUID->"b6bdcea1-7014-4e80-84ae-1863f1612009"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.748169118881194*^9, {3.748173109584269*^9, 3.748173111317824*^9}},
 CellLabel->"In[355]:=",
 CellID->957893331,ExpressionUUID->"91321dbc-07cc-4fbe-89f4-6123e25ec130"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", "/", "m"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169152633688*^9, 3.748169166417688*^9}, 
   3.74816961437001*^9, {3.748169735895432*^9, 3.74816976416591*^9}, {
   3.7481714534342337`*^9, 3.748171524401494*^9}, {3.748172277994993*^9, 
   3.748172388840468*^9}, {3.748173070786932*^9, 3.7481730730294323`*^9}, {
   3.748173117430595*^9, 3.7481731307454023`*^9}, {3.748173458595439*^9, 
   3.74817345887745*^9}, {3.748173695194269*^9, 3.748173699950642*^9}, {
   3.748202504888515*^9, 3.7482025270319357`*^9}, {3.748203173557973*^9, 
   3.748203178913308*^9}, {3.748207655028558*^9, 3.748207662940427*^9}, {
   3.7482079592072783`*^9, 3.7482079715754347`*^9}, {3.748208353270157*^9, 
   3.748208354059061*^9}, {3.748208640004923*^9, 3.748208652866403*^9}, {
   3.748209037852523*^9, 3.7482090490292263`*^9}},
 CellID->1140297004,ExpressionUUID->"6f3aaac6-3cec-4bb2-b17e-2fe95e736aa1"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", FractionBox[\\\"1\\\", \\\"m\\\"], \\\"}\\\"}], \\\
\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", FractionBox[\"1\
\", \"m\"], \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", FractionBox[\\\"1\\\", \\\"m\\\"], \\\"}\\\"}], \\\
\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", FractionBox[\"1\
\", \"m\"], \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015999999999749548`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015999999999749548`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->2088191305,ExpressionUUID->"af88012a-1b43-4dc9-a05d-23b93d94533a"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->2053503861,ExpressionUUID->"54c041b8-4760-405a-a352-50d1219fb963"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169171923123*^9, 3.748173146603053*^9},
 CellLabel->"In[356]:=",
 CellID->504061400,ExpressionUUID->"ad2652b6-7217-4304-b7fd-7dab75f1ba63"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"1", "/", "B1"}]}], "}"}], "}"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481691806324472`*^9, 3.748169184126515*^9}, {
   3.7481697745097303`*^9, 3.7481698177840567`*^9}, 3.748170212558292*^9, {
   3.74817153653963*^9, 3.748171557948637*^9}, {3.748172403638979*^9, 
   3.748172459180491*^9}, 3.748173461553569*^9, {3.748202537450017*^9, 
   3.748202581324718*^9}, {3.748203197531724*^9, 3.74820320090259*^9}, {
   3.74820768305413*^9, 3.748207686169286*^9}, {3.748207980487094*^9, 
   3.748208000065283*^9}, {3.748208360903953*^9, 3.748208368060452*^9}, {
   3.7482086706482286`*^9, 3.74820867548411*^9}, {3.748209112415152*^9, 
   3.748209152553891*^9}},
 CellID->1378897368,ExpressionUUID->"c30e64a9-e64f-4e9a-98c8-a97734c6862a"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", FractionBox[\\\"1\\\", \
\\\"B1\\\"]}], \\\"}\\\"}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"0\", \",\", \
FractionBox[\"1\", \"B1\"]}], \"}\"}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", FractionBox[\\\"1\\\", \
\\\"B1\\\"]}], \\\"}\\\"}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"0\", \",\", \
FractionBox[\"1\", \"B1\"]}], \"}\"}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00016199999999599868`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00016199999999599868`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1029700890,ExpressionUUID->"05ede1fe-41ab-4266-a2ce-7e119b65665a"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1759630704,ExpressionUUID->"ce91ca55-a0b7-4e01-9f09-d602c99c6f97"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169187965559*^9, 3.748173150905864*^9},
 CellLabel->"In[357]:=",
 CellID->1385056397,ExpressionUUID->"74fde9b6-e0bc-4663-ae50-ff7d62e24915"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", "0", "}"}], "}"}], "//", "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169193927287*^9, 3.748169194789258*^9}, {
   3.748169826851533*^9, 3.7481698714627047`*^9}, {3.748171572452416*^9, 
   3.748171580237145*^9}, {3.748172509134172*^9, 3.7481725445555677`*^9}, {
   3.748172960660345*^9, 3.7481729614507627`*^9}, 3.7481734650745153`*^9, {
   3.7482025915862713`*^9, 3.748202630873435*^9}, {3.748203221716777*^9, 
   3.748203224246625*^9}, {3.7482076998962*^9, 3.7482077040054913`*^9}, {
   3.748208008511187*^9, 3.748208021025865*^9}, {3.7482083872773123`*^9, 
   3.748208388235784*^9}, {3.748208685323637*^9, 3.748208689698819*^9}},
 CellID->213045481,ExpressionUUID->"f18b20d3-9fb7-4fe8-b2ee-535ddc4b770b"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00016499999999908255`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00016499999999908255`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1115939291,ExpressionUUID->"4466569d-736e-4fb8-8e76-c38c1450506b"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1616974586,ExpressionUUID->"c2ec19c7-5f5f-4fe6-9d7b-c986821db4ce"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"e", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.74816921143508*^9, 3.74817315251501*^9},
 CellLabel->"In[358]:=",
 CellID->998811706,ExpressionUUID->"2bb6bcfb-a837-4a8f-9d45-c144e3c3177e"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     FractionBox["K1", 
      RowBox[{"K1", "+", "K2"}]], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692120543423`*^9, 3.748169217153222*^9}, 
   3.748169620186891*^9, {3.7481699674394503`*^9, 3.7481699868030443`*^9}, 
   3.748173467456937*^9, {3.748209175572798*^9, 3.748209200269844*^9}},
 CellID->1710988442,ExpressionUUID->"31632860-7d4e-4b3e-b1a5-57be4cb99e46"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", FractionBox[\\\"K1\\\", RowBox[{\\\"K1\\\", \\\"+\\\", \\\"K2\\\"}]], \
\\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", FractionBox[\"K1\", RowBox[{\"K1\", \"+\", \"K2\"}]], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", FractionBox[\\\"K1\\\", RowBox[{\\\"K1\\\", \\\"+\\\", \\\"K2\\\"}]], \
\\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", FractionBox[\"K1\", RowBox[{\"K1\", \"+\", \"K2\"}]], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0005919999999974834`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0005919999999974834`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->86314117,ExpressionUUID->"374823bc-59b6-421d-8d96-ff19e0590914"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1129902694,ExpressionUUID->"cf056a31-c492-4d6c-bc0f-fe9ed5689209"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169221684237*^9, 3.7481731563003674`*^9},
 CellLabel->"In[359]:=",
 CellID->2037882370,ExpressionUUID->"95188a96-ce16-4077-8356-13b9c525ad69"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "d", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692270490217`*^9, 3.748169230838327*^9}, {
   3.748169991971572*^9, 3.748170004254684*^9}, 3.748173469973262*^9},
 CellID->1744104550,ExpressionUUID->"6dda51af-3fc7-4470-a4b0-fe25b52e2b9d"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015300000000451064`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015300000000451064`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->76687637,ExpressionUUID->"dbec0e3d-b67c-42bf-a7ab-4fffbdcbdb93"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->398926859,ExpressionUUID->"131088cb-cf5c-4e70-b339-3cba1d1b2368"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test System 13", "Section",
 CellChangeTimes->{{3.7481692698005457`*^9, 3.748169273381559*^9}, 
   3.7481693114624357`*^9, {3.748169361271824*^9, 3.748169361361087*^9}, {
   3.748170308281064*^9, 3.7481703083633633`*^9}, {3.748171876095627*^9, 
   3.748171876178361*^9}, {3.748173822514773*^9, 3.748173822575068*^9}, {
   3.748201957095229*^9, 3.748201957209919*^9}, {3.748202693602541*^9, 
   3.748202694592355*^9}, {3.748203258099217*^9, 3.748203258755952*^9}, {
   3.748207736252469*^9, 3.7482077387114143`*^9}, {3.7482080854975643`*^9, 
   3.748208086239914*^9}, {3.748208442026148*^9, 3.748208442059677*^9}, {
   3.748209226121472*^9, 3.7482092261957827`*^9}},
 CellID->1139115897,ExpressionUUID->"505fc513-ecd1-489f-a4fe-e2460401b3b3"],

Cell[CellGroupData[{

Cell["Sytem model", "Subsection",
 CellChangeTimes->{{3.751287776171789*^9, 3.751287778673774*^9}},
 CellID->1279425610,ExpressionUUID->"6513dd28-ea30-498a-9972-4de7a5e35114"],

Cell["Rowell and Wormley Example 5.11", "Text",
 CellChangeTimes->{{3.748169314267838*^9, 3.748169333731399*^9}, {
  3.748169368971754*^9, 3.748169377466568*^9}, {3.74817032089456*^9, 
  3.748170327324637*^9}, {3.748171903869137*^9, 3.748171911436009*^9}, {
  3.748173840454677*^9, 3.748173847774159*^9}, {3.748201999818125*^9, 
  3.748202000841951*^9}, {3.748202706062766*^9, 3.74820270612952*^9}, {
  3.748203275897526*^9, 3.7482032759962273`*^9}, {3.748207745579783*^9, 
  3.7482077456859827`*^9}, {3.748208092550345*^9, 3.748208092618396*^9}, {
  3.7482084571902933`*^9, 3.7482084587479973`*^9}, {3.7482092349334173`*^9, 
  3.748209235307046*^9}},
 CellID->1912467664,ExpressionUUID->"f944b4a8-b8b8-49b7-b744-7453515b2eca"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Fp", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"F0", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primaryVars", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vm", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Fd", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outExps", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"vm", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"elementalEqs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"vm", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Fm", "[", "t", "]"}], "/", "m"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Fd", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"cd", " ", 
       SuperscriptBox[
        RowBox[{"vd", "[", "t", "]"}], "2"]}]}]}], "\[IndentingNewLine]", 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"constraintEqs", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Fm", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Fp", "[", "t", "]"}], "-", 
       RowBox[{"F0", "[", "t", "]"}], "-", 
       RowBox[{"Fd", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vd", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"vm", "[", "t", "]"}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.747499218184157*^9, 3.74749931067735*^9}, {
   3.7474997703057547`*^9, 3.747499862953096*^9}, {3.7475000427164516`*^9, 
   3.7475001179609213`*^9}, 3.747500172506531*^9, {3.7475052421578627`*^9, 
   3.7475052437525806`*^9}, {3.7475052792870703`*^9, 3.747505305743517*^9}, {
   3.7475054395550127`*^9, 3.74750549238805*^9}, {3.748169383980278*^9, 
   3.748169603265369*^9}, {3.748170115690106*^9, 3.748170132266461*^9}, {
   3.748170333165715*^9, 3.7481705921461983`*^9}, {3.748171917577342*^9, 
   3.74817195326005*^9}, {3.748171995123074*^9, 3.7481720024895773`*^9}, {
   3.748172035662871*^9, 3.7481721909688787`*^9}, {3.748173852472159*^9, 
   3.7481740097196913`*^9}, {3.7482022679021463`*^9, 3.748202298767332*^9}, {
   3.748202329707706*^9, 3.748202426597817*^9}, {3.7482027090106783`*^9, 
   3.748202788912438*^9}, {3.74820743586224*^9, 3.748207471308917*^9}, {
   3.748207507244035*^9, 3.748207585893305*^9}, {3.7482077486519814`*^9, 
   3.748207772848833*^9}, {3.748207850305572*^9, 3.7482079126557817`*^9}, {
   3.748208102199922*^9, 3.748208255621907*^9}, {3.748208462423398*^9, 
   3.748208588053383*^9}, {3.748209240181383*^9, 3.7482092694545383`*^9}, {
   3.748209306213228*^9, 3.74820932247434*^9}, {3.7512877985500183`*^9, 
   3.751287885858892*^9}, {3.751826645662801*^9, 3.7518266697793617`*^9}},
 CellLabel->"In[360]:=",
 CellID->2002840320,ExpressionUUID->"37d107b7-936e-4815-829f-4d0f00f2b12a"],

Cell["Find state equation.", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.75124789335491*^9}},
 CellID->1289745999,ExpressionUUID->"fea9afb7-bdd0-47d0-8a40-cd594735f426"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stateSolution", "=", 
   RowBox[{
    RowBox[{"stateEquations", "[", 
     RowBox[{
     "inVars", ",", "primaryVars", ",", "elementalEqs", ",", 
      "constraintEqs"}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateVars", " ", "=", " ", 
   RowBox[{"\"\<state variables\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateEqList", " ", "=", " ", 
   RowBox[{"\"\<RHS\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\"\<state equations\>\"", "/.", "stateSolution"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.7018797195836763`*^9, 3.7018797204767036`*^9}, {
   3.701879810803969*^9, 3.701879844544981*^9}, {3.7018942050184517`*^9, 
   3.701894566874161*^9}, 3.701898020551093*^9, {3.701903282327601*^9, 
   3.701903283500523*^9}, {3.701911200698804*^9, 3.701911202601316*^9}, {
   3.701915682054678*^9, 3.701915720675168*^9}, {3.701915759772274*^9, 
   3.7019157927706213`*^9}, {3.701915923602686*^9, 3.701915923900078*^9}, 
   3.7019209193048553`*^9, 3.701920950145496*^9, {3.701921306764739*^9, 
   3.701921308673313*^9}, {3.701921408184596*^9, 3.7019214156809187`*^9}, 
   3.7019220747800493`*^9, {3.701922189786292*^9, 3.701922218088579*^9}, {
   3.701922248592429*^9, 3.701922251876824*^9}, 3.701922322852202*^9, {
   3.701922383801173*^9, 3.7019224315654707`*^9}, {3.701922463501308*^9, 
   3.7019224895050097`*^9}, 3.7019225472984467`*^9, {3.701922594846767*^9, 
   3.701922598092758*^9}, {3.701922662563005*^9, 3.701922735877761*^9}, {
   3.7019231046383343`*^9, 3.701923105684675*^9}, {3.7019639715923243`*^9, 
   3.7019639718841667`*^9}, {3.7019642654040737`*^9, 3.701964352167139*^9}, {
   3.701964387110903*^9, 3.7019644147887087`*^9}, {3.702757419429731*^9, 
   3.7027575039883213`*^9}, {3.7511302149210863`*^9, 3.751130222225973*^9}, 
   3.751131245052647*^9, 3.7518224212768917`*^9, 3.751859572572956*^9, 
   3.751859962455748*^9, 3.75186099192008*^9, 3.751937402218643*^9},
 CellID->1123096216,ExpressionUUID->"e023fd88-99a1-4350-9529-89887306e1fd"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["vm", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"-", 
          RowBox[{"F0", "[", "t", "]"}]}], "+", 
         RowBox[{"Fp", "[", "t", "]"}]}], "m"], "-", 
       FractionBox[
        RowBox[{"cd", " ", 
         SuperscriptBox[
          RowBox[{"vm", "[", "t", "]"}], "2"]}], "m"]}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751131246142264*^9, 3.751131562228766*^9, 3.751154207578877*^9, 
   3.751155061538066*^9, 3.7511551539969883`*^9, 3.7511556539137783`*^9, 
   3.751156830900199*^9, 3.751157044451893*^9, 3.751157305712584*^9, 
   3.751157692923893*^9, 3.751237248504381*^9, 3.7512373121455393`*^9, 
   3.751237557961287*^9, {3.7512412411479073`*^9, 3.751241257691305*^9}, 
   3.7512413334070673`*^9, 3.751241455823284*^9, 3.751241611586341*^9, 
   3.7512433878599854`*^9, 3.751243524307231*^9, 3.751243608962484*^9, 
   3.7512437545853853`*^9, 3.751243860047454*^9, 3.7512441819725847`*^9, 
   3.751244399097206*^9, 3.751244486437664*^9, 3.75124455927641*^9, 
   3.75124464012558*^9, 3.75124506931707*^9, 3.751245129883816*^9, 
   3.751245199900049*^9, 3.751245786492696*^9, 3.7512458405736723`*^9, 
   3.751245872204157*^9, {3.7512470996055098`*^9, 3.751247133340377*^9}, 
   3.751822506215632*^9, {3.751822707767754*^9, 3.751822723484655*^9}, 
   3.751822800835991*^9, 3.7518235244045973`*^9, 3.751823574246002*^9, 
   3.75182394710122*^9, 3.751824050485718*^9, {3.751824086094249*^9, 
   3.7518241542062597`*^9}, 3.751824200734988*^9, {3.7518266880693703`*^9, 
   3.751826697303438*^9}, 3.751827875741453*^9, 3.751861336354251*^9},
 CellLabel->"Out[368]//TableForm=",
 CellID->319773279,ExpressionUUID->"554657fb-3d16-4947-a450-f49981fe8fc1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"outEqList", "=", 
   RowBox[{"outEquations", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outExps", ",", 
     RowBox[{"elementalEqs", "~", "Join", "~", "constraintEqs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outEqList", "//", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"y", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "outExps", "]"}]}], "}"}]}], "]"}], 
      "\[Equal]", "#"}], "]"}], "&"}]}], "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.75115407229806*^9, 3.7511540907068577`*^9}, {
   3.7511541283727303`*^9, 3.751154145140655*^9}, {3.751154185947949*^9, 
   3.751154186454541*^9}, {3.75115440553708*^9, 3.751154408241644*^9}, {
   3.751157061478198*^9, 3.75115706228808*^9}, {3.751157258647379*^9, 
   3.751157263470278*^9}, {3.751157318329653*^9, 3.751157382599204*^9}, 
   3.751243546881419*^9, 3.7512446518094807`*^9, {3.7518241789029417`*^9, 
   3.751824190813037*^9}},
 CellLabel->"In[369]:=",
 CellID->267575760,ExpressionUUID->"6c3371a8-305c-40df-9c0a-82d4cf9bf5df"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{"y", "[", "1", "]"}], "\[Equal]", 
       RowBox[{"vm", "[", "t", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751154146341402*^9, {3.7511541874520807`*^9, 3.75115421035389*^9}, 
   3.751154409289606*^9, 3.751155063159431*^9, 3.7511551578703537`*^9, {
   3.751155631171876*^9, 3.7511556669733973`*^9}, 3.751156831153225*^9, {
   3.7511570444961233`*^9, 3.751157063011318*^9}, 3.7511573845757217`*^9, 
   3.7511576929574337`*^9, 3.751237248545403*^9, 3.75123731846103*^9, 
   3.751237558009218*^9, 3.75124126512782*^9, 3.751241341691312*^9, 
   3.7512414602930183`*^9, {3.7512415890389347`*^9, 3.751241614550478*^9}, 
   3.751243391757332*^9, {3.751243525864511*^9, 3.7512435473077707`*^9}, 
   3.7512436090180597`*^9, 3.751243754645124*^9, 3.751243860169832*^9, 
   3.751244182055914*^9, 3.751244399162704*^9, 3.751244486514542*^9, 
   3.751244523619996*^9, 3.7512445593242817`*^9, {3.751244640162719*^9, 
   3.7512446526642714`*^9}, 3.7512450693463917`*^9, 3.751245129916429*^9, 
   3.751245199944006*^9, 3.751245811673089*^9, 3.75124584198965*^9, 
   3.75124587430195*^9, {3.751247099662253*^9, 3.751247148020466*^9}, {
   3.751824169273649*^9, 3.751824200839072*^9}, {3.751826692086622*^9, 
   3.751826697436322*^9}, 3.751827876079237*^9, 3.7518613366319017`*^9},
 CellLabel->"Out[370]//TableForm=",
 CellID->1425415359,ExpressionUUID->"061d4705-97ab-4993-a2bf-76c54f489e74"]
}, Open  ]],

Cell["\<\
Linearize the state and output equations about operating point.\
\>", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.7512479601059103`*^9}},
 CellID->1826710506,ExpressionUUID->"da0337f3-8edf-4403-aa15-588c4731212b"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"abe", "=", 
   RowBox[{"linearizeState", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "stateEqList", ",", 
     RowBox[{"ConstantArray", "[", 
      RowBox[{"0", ",", 
       RowBox[{"Dimensions", "[", "inVars", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"vm", "[", "0", "]"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdf", "=", 
   RowBox[{"linearizeOutput", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"e", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"d", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"f", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<A = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<B = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<E = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<C = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<D = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<F = \>\"", ",", "#"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.751247952610923*^9}, {
   3.75128846048738*^9, 3.751288516214229*^9}},
 CellLabel->"In[371]:=",
 CellID->1097256830,ExpressionUUID->"422aa9a5-c3ea-405c-8be8-3af48ca7a6a0"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", " ", "cd", " ", 
           RowBox[{"vm", "[", "0", "]"}]}], "m"]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["A = ", 
   MatrixForm[{{(-2) $CellContext`cd $CellContext`m^(-1) $CellContext`vm[
       0]}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, 3.751826697571349*^9, 3.751827876392082*^9, 
   3.751861336917791*^9},
 CellLabel->"During evaluation of In[371]:=",
 CellID->1775856428,ExpressionUUID->"d23d0825-32c8-4bf4-b91d-eff165640e1b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"B = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["1", "m"], 
        RowBox[{"-", 
         FractionBox["1", "m"]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["B = ", 
   MatrixForm[{{$CellContext`m^(-1), (-1)/$CellContext`m}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, 3.751826697571349*^9, 3.751827876392082*^9, 
   3.7518613369302473`*^9},
 CellLabel->"During evaluation of In[371]:=",
 CellID->1091259390,ExpressionUUID->"cce6ca03-de3b-4e63-85f2-936561e42b6f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"E = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["E = ", 
   MatrixForm[{{0, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, 3.751826697571349*^9, 3.751827876392082*^9, 
   3.75186133695837*^9},
 CellLabel->"During evaluation of In[371]:=",
 CellID->1286222350,ExpressionUUID->"5e320302-e36e-467b-bae2-9ac96dfc6b3f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{1}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, 3.751826697571349*^9, 3.751827876392082*^9, 
   3.751861336964953*^9},
 CellLabel->"During evaluation of In[371]:=",
 CellID->968645748,ExpressionUUID->"49da9ba6-e88a-460b-acb1-54bd1c7649f5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{0, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, 3.751826697571349*^9, 3.751827876392082*^9, 
   3.7518613369713297`*^9},
 CellLabel->"During evaluation of In[371]:=",
 CellID->2103042376,ExpressionUUID->"ffd8e5da-cb95-425e-8b7b-12d5f8a76a18"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0, 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, 3.751826697571349*^9, 3.751827876392082*^9, 
   3.751861336977768*^9},
 CellLabel->"During evaluation of In[371]:=",
 CellID->399867459,ExpressionUUID->"b61df08f-96d6-4c3c-aaa0-776494e2553b"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.75124808019132*^9, 3.7512480809379053`*^9}},
 CellID->979410698,ExpressionUUID->"f3769dd1-49fe-4994-9114-b8b74feb4d96"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.747505552707037*^9, {3.7475057578295593`*^9, 3.747505759222794*^9}, {
   3.747505842150148*^9, 3.7475058458319883`*^9}, {3.747505896191999*^9, 
   3.74750589728131*^9}, {3.748124150238531*^9, 3.748124150517943*^9}, 
   3.748169029221862*^9, 3.748173244647019*^9},
 CellLabel->"In[381]:=",
 CellID->415536027,ExpressionUUID->"567fa777-2cc5-4286-afb2-1b7964e5e9b8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2"}], " ", "cd", " ", 
     RowBox[{
      RowBox[{"vm", "[", "0", "]"}], "/", "m"}]}], "}"}], "}"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.747505555643032*^9, 3.7475055867312613`*^9}, {
   3.747505761476728*^9, 3.747505764318122*^9}, {3.747505847665118*^9, 
   3.7475058502692757`*^9}, {3.747505898843794*^9, 3.74750590124069*^9}, {
   3.7475063255823507`*^9, 3.747506334276267*^9}, {3.7481241530496283`*^9, 
   3.748124156712919*^9}, 3.7481690353265944`*^9, {3.748169641556839*^9, 
   3.748169730141844*^9}, {3.7481706308795347`*^9, 3.748170648343268*^9}, {
   3.7481713324991817`*^9, 3.748171412017522*^9}, {3.7481722117935038`*^9, 
   3.748172266534639*^9}, {3.748172557215331*^9, 3.748172586783577*^9}, 
   3.748172811167288*^9, {3.748173455617723*^9, 3.748173456202003*^9}, {
   3.748173684193961*^9, 3.7481736910145693`*^9}, {3.748174023178488*^9, 
   3.748174074694357*^9}, {3.7482024431310062`*^9, 3.7482024882994432`*^9}, {
   3.748203045867991*^9, 3.748203049432695*^9}, {3.7482031539741383`*^9, 
   3.748203165353072*^9}, {3.748207600236726*^9, 3.7482076437651033`*^9}, {
   3.748207926849205*^9, 3.748207952971178*^9}, {3.748208268582942*^9, 
   3.748208337143387*^9}, {3.748208598589538*^9, 3.7482086272775517`*^9}, {
   3.7482093419924383`*^9, 3.748209356014646*^9}, {3.748214938731691*^9, 
   3.748214941318255*^9}, {3.751288568113187*^9, 3.751288570168941*^9}},
 CellID->854168379,ExpressionUUID->"c0270aab-d017-4ac9-96d0-241f0c5bd49f"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"-\\\", FractionBox[RowBox[{\\\"2\\\", \\\" \
\\\", \\\"cd\\\", \\\" \\\", RowBox[{\\\"vm\\\", \\\"[\\\", \\\"0\\\", \
\\\"]\\\"}]}], \\\"m\\\"]}], \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"-\", \
FractionBox[RowBox[{\"2\", \" \", \"cd\", \" \", RowBox[{\"vm\", \"[\", \
\"0\", \"]\"}]}], \"m\"]}], \"}\"}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"-\\\", FractionBox[RowBox[{\\\"2\\\", \\\" \
\\\", \\\"cd\\\", \\\" \\\", RowBox[{\\\"vm\\\", \\\"[\\\", \\\"0\\\", \
\\\"]\\\"}]}], \\\"m\\\"]}], \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"-\", \
FractionBox[RowBox[{\"2\", \" \", \"cd\", \" \", RowBox[{\"vm\", \"[\", \
\"0\", \"]\"}]}], \"m\"]}], \"}\"}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00045100000000175555`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00045100000000175555`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1096051950,ExpressionUUID->"945fd796-5bc3-46b9-b05c-5f47492fe0c7"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->230399684,ExpressionUUID->"1e85fd1a-8228-44b1-8d1d-c586b86b033e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.748169118881194*^9, {3.748173109584269*^9, 3.748173111317824*^9}},
 CellLabel->"In[382]:=",
 CellID->1172406000,ExpressionUUID->"69d3df47-e6dd-4bb6-afd6-6d06298766fb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1", "/", "m"}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "/", "m"}]}], "}"}], "}"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169152633688*^9, 3.748169166417688*^9}, 
   3.74816961437001*^9, {3.748169735895432*^9, 3.74816976416591*^9}, {
   3.7481714534342337`*^9, 3.748171524401494*^9}, {3.748172277994993*^9, 
   3.748172388840468*^9}, {3.748173070786932*^9, 3.7481730730294323`*^9}, {
   3.748173117430595*^9, 3.7481731307454023`*^9}, {3.748173458595439*^9, 
   3.74817345887745*^9}, {3.748173695194269*^9, 3.748173699950642*^9}, {
   3.748202504888515*^9, 3.7482025270319357`*^9}, {3.748203173557973*^9, 
   3.748203178913308*^9}, {3.748207655028558*^9, 3.748207662940427*^9}, {
   3.7482079592072783`*^9, 3.7482079715754347`*^9}, {3.748208353270157*^9, 
   3.748208354059061*^9}, {3.748208640004923*^9, 3.748208652866403*^9}, {
   3.748209391710054*^9, 3.748209395322097*^9}},
 CellID->558656035,ExpressionUUID->"ac85f684-9b6a-4955-8e45-de64002633e3"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{FractionBox[\\\"1\\\", \\\"m\\\"], \\\",\\\", \
RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \\\"m\\\"]}]}], \\\"}\\\"}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{FractionBox[\"1\
\", \"m\"], \",\", RowBox[{\"-\", FractionBox[\"1\", \"m\"]}]}], \"}\"}], \"}\
\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{FractionBox[\\\"1\\\", \\\"m\\\"], \\\",\\\", \
RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \\\"m\\\"]}]}], \\\"}\\\"}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{FractionBox[\"1\
\", \"m\"], \",\", RowBox[{\"-\", FractionBox[\"1\", \"m\"]}]}], \"}\"}], \"}\
\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00017099999999814486`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00017099999999814486`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->414473447,ExpressionUUID->"7fb64312-bac8-4b89-865a-5a8765a13a27"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1765756508,ExpressionUUID->"ce82bdd5-d9ea-491a-aa25-3c5c0e86eb4b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169171923123*^9, 3.748173146603053*^9},
 CellLabel->"In[383]:=",
 CellID->535896717,ExpressionUUID->"82713b47-a0c8-4827-b2e0-90b6f5f3c50c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", "1", "}"}], "}"}], "//", "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481691806324472`*^9, 3.748169184126515*^9}, {
   3.7481697745097303`*^9, 3.7481698177840567`*^9}, 3.748170212558292*^9, {
   3.74817153653963*^9, 3.748171557948637*^9}, {3.748172403638979*^9, 
   3.748172459180491*^9}, 3.748173461553569*^9, {3.748202537450017*^9, 
   3.748202581324718*^9}, {3.748203197531724*^9, 3.74820320090259*^9}, {
   3.74820768305413*^9, 3.748207686169286*^9}, {3.748207980487094*^9, 
   3.748208000065283*^9}, {3.748208360903953*^9, 3.748208368060452*^9}, {
   3.7482086706482286`*^9, 3.74820867548411*^9}},
 CellID->1711570411,ExpressionUUID->"90658f04-35bc-4614-9832-86dfa63c93b7"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"1\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"1\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"1\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"1\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00015799999999899228`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00015799999999899228`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->993112063,ExpressionUUID->"03806c21-acd3-4038-9798-2ff7bf4bb5a5"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->991538357,ExpressionUUID->"4061618b-e968-4aa0-bf44-12bd785dffbf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169187965559*^9, 3.748173150905864*^9},
 CellLabel->"In[384]:=",
 CellID->1655180484,ExpressionUUID->"1ff12343-5068-45bf-9ed9-a566a6b9612b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], "}"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169193927287*^9, 3.748169194789258*^9}, {
   3.748169826851533*^9, 3.7481698714627047`*^9}, {3.748171572452416*^9, 
   3.748171580237145*^9}, {3.748172509134172*^9, 3.7481725445555677`*^9}, {
   3.748172960660345*^9, 3.7481729614507627`*^9}, 3.7481734650745153`*^9, {
   3.7482025915862713`*^9, 3.748202630873435*^9}, {3.748203221716777*^9, 
   3.748203224246625*^9}, {3.7482076998962*^9, 3.7482077040054913`*^9}, {
   3.748208008511187*^9, 3.748208021025865*^9}, {3.7482083872773123`*^9, 
   3.748208388235784*^9}, {3.748208685323637*^9, 3.748208689698819*^9}, {
   3.7482094216066628`*^9, 3.748209422232356*^9}},
 CellID->1700890378,ExpressionUUID->"80a3712f-28e0-4806-9176-2cb663c91c9d"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\
\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"0\", \",\", \
\"0\"}], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\
\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"0\", \",\", \
\"0\"}], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001640000000016073`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001640000000016073`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->312065379,ExpressionUUID->"5dbfa084-e3e8-44a0-97b7-235b81b69d17"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->727758879,ExpressionUUID->"f2defc92-76a8-40cb-95f8-f3a500084543"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"e", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.74816921143508*^9, 3.74817315251501*^9},
 CellLabel->"In[385]:=",
 CellID->732625942,ExpressionUUID->"2e99e9a8-561f-4020-9e03-4f5c061f90e4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "b", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692120543423`*^9, 3.748169217153222*^9}, 
   3.748169620186891*^9, {3.7481699674394503`*^9, 3.7481699868030443`*^9}, 
   3.748173467456937*^9},
 CellID->1615736382,ExpressionUUID->"a91ac2e3-0fca-4770-8b2f-22cec7b3c3c9"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\
\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"0\", \",\", \
\"0\"}], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\
\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"0\", \",\", \
\"0\"}], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001659999999965578`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001659999999965578`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1524109688,ExpressionUUID->"258df9f6-eea6-4bdb-af51-9fdf52951225"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->526584800,ExpressionUUID->"d58fac2a-9900-4f39-a794-3393f1f86da6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169221684237*^9, 3.7481731563003674`*^9},
 CellLabel->"In[386]:=",
 CellID->1996553637,ExpressionUUID->"ffdb40ab-cab3-4895-a613-4e441cd701b0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "d", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692270490217`*^9, 3.748169230838327*^9}, {
   3.748169991971572*^9, 3.748170004254684*^9}, 3.748173469973262*^9},
 CellID->1831110570,ExpressionUUID->"6d9932f3-24a0-4b5e-a053-1701b71d6e4b"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\
\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"0\", \",\", \
\"0\"}], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\"}], \\\
\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"0\", \",\", \
\"0\"}], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00013600000000479895`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00013600000000479895`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->530624313,ExpressionUUID->"267d64be-576a-439b-9350-876192a09979"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1850726247,ExpressionUUID->"fe11ebc9-5efd-4fd7-ada5-6704611b9f1f"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test System 14", "Section",
 CellChangeTimes->{{3.7481692698005457`*^9, 3.748169273381559*^9}, 
   3.7481693114624357`*^9, {3.748169361271824*^9, 3.748169361361087*^9}, {
   3.748170308281064*^9, 3.7481703083633633`*^9}, {3.748171876095627*^9, 
   3.748171876178361*^9}, {3.748173822514773*^9, 3.748173822575068*^9}, {
   3.748201957095229*^9, 3.748201957209919*^9}, {3.748202693602541*^9, 
   3.748202694592355*^9}, {3.748203258099217*^9, 3.748203258755952*^9}, {
   3.748207736252469*^9, 3.7482077387114143`*^9}, {3.7482080854975643`*^9, 
   3.748208086239914*^9}, {3.748208442026148*^9, 3.748208442059677*^9}, {
   3.748209226121472*^9, 3.7482092261957827`*^9}, {3.748209472916519*^9, 
   3.748209472960353*^9}},
 CellID->832889734,ExpressionUUID->"7966df63-b9bb-443a-856d-c07e0fad677c"],

Cell[CellGroupData[{

Cell["System model", "Subsection",
 CellChangeTimes->{{3.751288702034144*^9, 3.751288707812042*^9}},
 CellID->1953520599,ExpressionUUID->"0e394ac4-0dc5-4bf8-8cc8-55b9a43ac107"],

Cell["Rowell and Wormley Example 5.12", "Text",
 CellChangeTimes->{{3.748169314267838*^9, 3.748169333731399*^9}, {
  3.748169368971754*^9, 3.748169377466568*^9}, {3.74817032089456*^9, 
  3.748170327324637*^9}, {3.748171903869137*^9, 3.748171911436009*^9}, {
  3.748173840454677*^9, 3.748173847774159*^9}, {3.748201999818125*^9, 
  3.748202000841951*^9}, {3.748202706062766*^9, 3.74820270612952*^9}, {
  3.748203275897526*^9, 3.7482032759962273`*^9}, {3.748207745579783*^9, 
  3.7482077456859827`*^9}, {3.748208092550345*^9, 3.748208092618396*^9}, {
  3.7482084571902933`*^9, 3.7482084587479973`*^9}, {3.7482092349334173`*^9, 
  3.748209235307046*^9}, {3.748209479371266*^9, 3.7482094794372387`*^9}},
 CellID->829028169,ExpressionUUID->"f05e4cd9-816f-4bae-b1cf-5349a77050f3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"Ts", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primaryVars", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"wj", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"TK", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"TB", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outExps", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"TK", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"elementalEqs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"wj", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Tj", "[", "t", "]"}], "/", "J"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"TK", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{"m", " ", "g", " ", "l", " ", 
       RowBox[{"Cos", "[", "theta", "]"}], 
       RowBox[{"wK", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TB", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"B", " ", 
       RowBox[{"wB", "[", "t", "]"}]}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"constraintEqs", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Tj", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Ts", "[", "t", "]"}], "-", 
       RowBox[{"TK", "[", "t", "]"}], "-", 
       RowBox[{"TB", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"wB", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"wj", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"wK", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"wj", "[", "t", "]"}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.747499218184157*^9, 3.74749931067735*^9}, {
   3.7474997703057547`*^9, 3.747499862953096*^9}, {3.7475000427164516`*^9, 
   3.7475001179609213`*^9}, 3.747500172506531*^9, {3.7475052421578627`*^9, 
   3.7475052437525806`*^9}, {3.7475052792870703`*^9, 3.747505305743517*^9}, {
   3.7475054395550127`*^9, 3.74750549238805*^9}, {3.748169383980278*^9, 
   3.748169603265369*^9}, {3.748170115690106*^9, 3.748170132266461*^9}, {
   3.748170333165715*^9, 3.7481705921461983`*^9}, {3.748171917577342*^9, 
   3.74817195326005*^9}, {3.748171995123074*^9, 3.7481720024895773`*^9}, {
   3.748172035662871*^9, 3.7481721909688787`*^9}, {3.748173852472159*^9, 
   3.7481740097196913`*^9}, {3.7482022679021463`*^9, 3.748202298767332*^9}, {
   3.748202329707706*^9, 3.748202426597817*^9}, {3.7482027090106783`*^9, 
   3.748202788912438*^9}, {3.74820743586224*^9, 3.748207471308917*^9}, {
   3.748207507244035*^9, 3.748207585893305*^9}, {3.7482077486519814`*^9, 
   3.748207772848833*^9}, {3.748207850305572*^9, 3.7482079126557817`*^9}, {
   3.748208102199922*^9, 3.748208255621907*^9}, {3.748208462423398*^9, 
   3.748208588053383*^9}, {3.748209240181383*^9, 3.7482092694545383`*^9}, {
   3.748209306213228*^9, 3.74820932247434*^9}, {3.7482094984175673`*^9, 
   3.7482096496197243`*^9}, {3.7495158179812183`*^9, 3.74951581876071*^9}, {
   3.751288712991231*^9, 3.75128879282076*^9}, {3.751288832910524*^9, 
   3.7512888704922132`*^9}, 3.7513182614228992`*^9, {3.75131830104685*^9, 
   3.7513183043846273`*^9}, {3.751318356693005*^9, 3.7513183590884733`*^9}, {
   3.7518267459607363`*^9, 3.7518267691067133`*^9}},
 CellLabel->"In[387]:=",
 CellID->1961085994,ExpressionUUID->"cd812325-885e-481f-97ce-758d98bae930"],

Cell["Find state equation.", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.75124789335491*^9}},
 CellID->1427259116,ExpressionUUID->"d33f0036-1046-4519-8a19-b8da3bbc0f50"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stateSolution", "=", 
   RowBox[{
    RowBox[{"stateEquations", "[", 
     RowBox[{
     "inVars", ",", "primaryVars", ",", "elementalEqs", ",", 
      "constraintEqs"}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateVars", " ", "=", " ", 
   RowBox[{"\"\<state variables\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateEqList", " ", "=", " ", 
   RowBox[{"\"\<RHS\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\"\<state equations\>\"", "/.", "stateSolution"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.7018797195836763`*^9, 3.7018797204767036`*^9}, {
   3.701879810803969*^9, 3.701879844544981*^9}, {3.7018942050184517`*^9, 
   3.701894566874161*^9}, 3.701898020551093*^9, {3.701903282327601*^9, 
   3.701903283500523*^9}, {3.701911200698804*^9, 3.701911202601316*^9}, {
   3.701915682054678*^9, 3.701915720675168*^9}, {3.701915759772274*^9, 
   3.7019157927706213`*^9}, {3.701915923602686*^9, 3.701915923900078*^9}, 
   3.7019209193048553`*^9, 3.701920950145496*^9, {3.701921306764739*^9, 
   3.701921308673313*^9}, {3.701921408184596*^9, 3.7019214156809187`*^9}, 
   3.7019220747800493`*^9, {3.701922189786292*^9, 3.701922218088579*^9}, {
   3.701922248592429*^9, 3.701922251876824*^9}, 3.701922322852202*^9, {
   3.701922383801173*^9, 3.7019224315654707`*^9}, {3.701922463501308*^9, 
   3.7019224895050097`*^9}, 3.7019225472984467`*^9, {3.701922594846767*^9, 
   3.701922598092758*^9}, {3.701922662563005*^9, 3.701922735877761*^9}, {
   3.7019231046383343`*^9, 3.701923105684675*^9}, {3.7019639715923243`*^9, 
   3.7019639718841667`*^9}, {3.7019642654040737`*^9, 3.701964352167139*^9}, {
   3.701964387110903*^9, 3.7019644147887087`*^9}, {3.702757419429731*^9, 
   3.7027575039883213`*^9}, {3.7511302149210863`*^9, 3.751130222225973*^9}, 
   3.751131245052647*^9, 3.7518224212768917`*^9, 3.7518595726352997`*^9, 
   3.751859962461113*^9, 3.7518609919245863`*^9, 3.751937402285021*^9},
 CellID->1403872895,ExpressionUUID->"b1114a8a-2f1e-46a9-8418-8a5a450e4b30"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["wj", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"TK", "[", "t", "]"}], "J"]}], "+", 
       FractionBox[
        RowBox[{"Ts", "[", "t", "]"}], "J"], "-", 
       FractionBox[
        RowBox[{"B", " ", 
         RowBox[{"wj", "[", "t", "]"}]}], "J"]}]}]},
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["TK", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{"g", " ", "l", " ", "m", " ", 
       RowBox[{"Cos", "[", "theta", "]"}], " ", 
       RowBox[{"wj", "[", "t", "]"}]}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751131246142264*^9, 3.751131562228766*^9, 3.751154207578877*^9, 
   3.751155061538066*^9, 3.7511551539969883`*^9, 3.7511556539137783`*^9, 
   3.751156830900199*^9, 3.751157044451893*^9, 3.751157305712584*^9, 
   3.751157692923893*^9, 3.751237248504381*^9, 3.7512373121455393`*^9, 
   3.751237557961287*^9, {3.7512412411479073`*^9, 3.751241257691305*^9}, 
   3.7512413334070673`*^9, 3.751241455823284*^9, 3.751241611586341*^9, 
   3.7512433878599854`*^9, 3.751243524307231*^9, 3.751243608962484*^9, 
   3.7512437545853853`*^9, 3.751243860047454*^9, 3.7512441819725847`*^9, 
   3.751244399097206*^9, 3.751244486437664*^9, 3.75124455927641*^9, 
   3.75124464012558*^9, 3.75124506931707*^9, 3.751245129883816*^9, 
   3.751245199900049*^9, 3.751245786492696*^9, 3.7512458405736723`*^9, 
   3.751245872204157*^9, {3.7512470996055098`*^9, 3.751247133340377*^9}, 
   3.751822506215632*^9, {3.751822707767754*^9, 3.751822723484655*^9}, 
   3.751822800835991*^9, 3.7518235244045973`*^9, 3.751823574246002*^9, 
   3.75182394710122*^9, 3.751824050485718*^9, {3.751824086094249*^9, 
   3.7518241542062597`*^9}, 3.751824200734988*^9, {3.751826780550068*^9, 
   3.751826795070689*^9}, 3.7518279744992247`*^9, 3.751861369403275*^9},
 CellLabel->"Out[395]//TableForm=",
 CellID->1002890181,ExpressionUUID->"9d52ed99-5d7f-4b56-a332-96b6c85e51a7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"outEqList", "=", 
   RowBox[{"outEquations", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outExps", ",", 
     RowBox[{"elementalEqs", "~", "Join", "~", "constraintEqs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outEqList", "//", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"y", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "outExps", "]"}]}], "}"}]}], "]"}], 
      "\[Equal]", "#"}], "]"}], "&"}]}], "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.75115407229806*^9, 3.7511540907068577`*^9}, {
   3.7511541283727303`*^9, 3.751154145140655*^9}, {3.751154185947949*^9, 
   3.751154186454541*^9}, {3.75115440553708*^9, 3.751154408241644*^9}, {
   3.751157061478198*^9, 3.75115706228808*^9}, {3.751157258647379*^9, 
   3.751157263470278*^9}, {3.751157318329653*^9, 3.751157382599204*^9}, 
   3.751243546881419*^9, 3.7512446518094807`*^9, {3.7518241789029417`*^9, 
   3.751824190813037*^9}},
 CellLabel->"In[396]:=",
 CellID->950140110,ExpressionUUID->"e284c537-b15a-4330-919f-479d79119670"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{"y", "[", "1", "]"}], "\[Equal]", 
       RowBox[{"TK", "[", "t", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751154146341402*^9, {3.7511541874520807`*^9, 3.75115421035389*^9}, 
   3.751154409289606*^9, 3.751155063159431*^9, 3.7511551578703537`*^9, {
   3.751155631171876*^9, 3.7511556669733973`*^9}, 3.751156831153225*^9, {
   3.7511570444961233`*^9, 3.751157063011318*^9}, 3.7511573845757217`*^9, 
   3.7511576929574337`*^9, 3.751237248545403*^9, 3.75123731846103*^9, 
   3.751237558009218*^9, 3.75124126512782*^9, 3.751241341691312*^9, 
   3.7512414602930183`*^9, {3.7512415890389347`*^9, 3.751241614550478*^9}, 
   3.751243391757332*^9, {3.751243525864511*^9, 3.7512435473077707`*^9}, 
   3.7512436090180597`*^9, 3.751243754645124*^9, 3.751243860169832*^9, 
   3.751244182055914*^9, 3.751244399162704*^9, 3.751244486514542*^9, 
   3.751244523619996*^9, 3.7512445593242817`*^9, {3.751244640162719*^9, 
   3.7512446526642714`*^9}, 3.7512450693463917`*^9, 3.751245129916429*^9, 
   3.751245199944006*^9, 3.751245811673089*^9, 3.75124584198965*^9, 
   3.75124587430195*^9, {3.751247099662253*^9, 3.751247148020466*^9}, {
   3.751824169273649*^9, 3.751824200839072*^9}, {3.75182678545227*^9, 
   3.751826795186431*^9}, 3.751827974927226*^9, 3.751861369748941*^9},
 CellLabel->"Out[397]//TableForm=",
 CellID->2123610411,ExpressionUUID->"1d5f0e46-a83f-42f5-9465-bfa10ab6202f"]
}, Open  ]],

Cell["\<\
Linearize the state and output equations about operating point.\
\>", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.7512479601059103`*^9}},
 CellID->649946168,ExpressionUUID->"6e18c79d-a17d-472b-9601-64536113e951"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"abe", "=", 
   RowBox[{"linearizeState", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "stateEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdf", "=", 
   RowBox[{"linearizeOutput", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"e", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"d", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"f", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<A = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<B = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<E = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<C = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<D = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<F = \>\"", ",", "#"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.751247952610923*^9}, {
   3.75128846048738*^9, 3.751288516214229*^9}, {3.751288925220256*^9, 
   3.751288932694913*^9}},
 CellLabel->"In[398]:=",
 CellID->1543416934,ExpressionUUID->"9ccd4963-fcd2-4b12-a82b-abb913e2a636"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"-", 
         FractionBox["B", "J"]}], 
        RowBox[{"-", 
         FractionBox["1", "J"]}]},
       {
        RowBox[{"g", " ", "l", " ", "m", " ", 
         RowBox[{"Cos", "[", "theta", "]"}]}], "0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["A = ", 
   MatrixForm[{{-$CellContext`B/$CellContext`J, (-1)/$CellContext`J}, \
{$CellContext`g $CellContext`l $CellContext`m Cos[$CellContext`theta], 0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, {3.751288913488022*^9, 3.751288933782707*^9}, 
   3.751317949288458*^9, 3.751318241151705*^9, 3.751318313146922*^9, 
   3.7518267953274317`*^9, 3.751827975311142*^9, 3.751861370078986*^9},
 CellLabel->"During evaluation of In[398]:=",
 CellID->341964537,ExpressionUUID->"e0bdb08d-4458-41c7-bb1f-92558a31ebbb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"B = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        FractionBox["1", "J"]},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["B = ", 
   MatrixForm[{{$CellContext`J^(-1)}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, {3.751288913488022*^9, 3.751288933782707*^9}, 
   3.751317949288458*^9, 3.751318241151705*^9, 3.751318313146922*^9, 
   3.7518267953274317`*^9, 3.751827975311142*^9, 3.751861370089078*^9},
 CellLabel->"During evaluation of In[398]:=",
 CellID->731733987,ExpressionUUID->"5aea90a1-a3a1-450b-84c2-2c69c14c9c75"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"E = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["E = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, {3.751288913488022*^9, 3.751288933782707*^9}, 
   3.751317949288458*^9, 3.751318241151705*^9, 3.751318313146922*^9, 
   3.7518267953274317`*^9, 3.751827975311142*^9, 3.7518613701161337`*^9},
 CellLabel->"During evaluation of In[398]:=",
 CellID->1761756787,ExpressionUUID->"b916ffa1-b4dd-495f-83f8-f88489ffb4f2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "1"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{0, 1}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, {3.751288913488022*^9, 3.751288933782707*^9}, 
   3.751317949288458*^9, 3.751318241151705*^9, 3.751318313146922*^9, 
   3.7518267953274317`*^9, 3.751827975311142*^9, 3.7518613701226683`*^9},
 CellLabel->"During evaluation of In[398]:=",
 CellID->341794273,ExpressionUUID->"766a849c-ab16-4128-bfa0-ef7f1be509b3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, {3.751288913488022*^9, 3.751288933782707*^9}, 
   3.751317949288458*^9, 3.751318241151705*^9, 3.751318313146922*^9, 
   3.7518267953274317`*^9, 3.751827975311142*^9, 3.751861370128961*^9},
 CellLabel->"During evaluation of In[398]:=",
 CellID->17590586,ExpressionUUID->"2a56e506-b948-4403-b738-922890525471"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, {3.751288913488022*^9, 3.751288933782707*^9}, 
   3.751317949288458*^9, 3.751318241151705*^9, 3.751318313146922*^9, 
   3.7518267953274317`*^9, 3.751827975311142*^9, 3.751861370135481*^9},
 CellLabel->"During evaluation of In[398]:=",
 CellID->1439719263,ExpressionUUID->"fb7cf764-10b6-4c15-9a96-e803a2898a2f"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.75124808019132*^9, 3.7512480809379053`*^9}},
 CellID->684980417,ExpressionUUID->"45cc41e3-c81a-45ec-bb4f-4603d11f2862"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.747505552707037*^9, {3.7475057578295593`*^9, 3.747505759222794*^9}, {
   3.747505842150148*^9, 3.7475058458319883`*^9}, {3.747505896191999*^9, 
   3.74750589728131*^9}, {3.748124150238531*^9, 3.748124150517943*^9}, 
   3.748169029221862*^9, 3.748173244647019*^9},
 CellLabel->"In[408]:=",
 CellID->1939507788,ExpressionUUID->"0ed21042-7bef-49a1-839a-0653b1b507be"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "B"}], "/", "J"}], ",", 
      RowBox[{
       RowBox[{"-", "1"}], "/", "J"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"m", " ", "g", " ", "l", " ", 
       RowBox[{"Cos", "[", "theta", "]"}]}], ",", " ", "0"}], "}"}]}], "}"}], 
  "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.747505555643032*^9, 3.7475055867312613`*^9}, {
   3.747505761476728*^9, 3.747505764318122*^9}, {3.747505847665118*^9, 
   3.7475058502692757`*^9}, {3.747505898843794*^9, 3.74750590124069*^9}, {
   3.7475063255823507`*^9, 3.747506334276267*^9}, {3.7481241530496283`*^9, 
   3.748124156712919*^9}, 3.7481690353265944`*^9, {3.748169641556839*^9, 
   3.748169730141844*^9}, {3.7481706308795347`*^9, 3.748170648343268*^9}, {
   3.7481713324991817`*^9, 3.748171412017522*^9}, {3.7481722117935038`*^9, 
   3.748172266534639*^9}, {3.748172557215331*^9, 3.748172586783577*^9}, 
   3.748172811167288*^9, {3.748173455617723*^9, 3.748173456202003*^9}, {
   3.748173684193961*^9, 3.7481736910145693`*^9}, {3.748174023178488*^9, 
   3.748174074694357*^9}, {3.7482024431310062`*^9, 3.7482024882994432`*^9}, {
   3.748203045867991*^9, 3.748203049432695*^9}, {3.7482031539741383`*^9, 
   3.748203165353072*^9}, {3.748207600236726*^9, 3.7482076437651033`*^9}, {
   3.748207926849205*^9, 3.748207952971178*^9}, {3.748208268582942*^9, 
   3.748208337143387*^9}, {3.748208598589538*^9, 3.7482086272775517`*^9}, {
   3.7482093419924383`*^9, 3.748209356014646*^9}, {3.748209683964367*^9, 
   3.748209717678073*^9}},
 CellID->998988119,ExpressionUUID->"309ea178-0a20-4420-a127-efb29cecd485"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"B\\\", \
\\\"J\\\"]}], \\\",\\\", RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \
\\\"J\\\"]}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \
\\\"1\\\", \\\"\[RightSkeleton]\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"B\", \"J\"]}], \",\", RowBox[{\"-\", \
FractionBox[\"1\", \"J\"]}]}], \"}\"}], \",\", RowBox[{\"\[LeftSkeleton]\", \
\"1\", \"\[RightSkeleton]\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"-\\\", FractionBox[\\\"B\\\", \
\\\"J\\\"]}], \\\",\\\", RowBox[{\\\"-\\\", FractionBox[\\\"1\\\", \
\\\"J\\\"]}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \
\\\"1\\\", \\\"\[RightSkeleton]\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \
RowBox[{RowBox[{\"-\", FractionBox[\"B\", \"J\"]}], \",\", RowBox[{\"-\", \
FractionBox[\"1\", \"J\"]}]}], \"}\"}], \",\", RowBox[{\"\[LeftSkeleton]\", \
\"1\", \"\[RightSkeleton]\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
006276000000003279`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.006276000000003279`\", \"\\\"s\\\
\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1663402492,ExpressionUUID->"3142ce90-1248-431c-a5f3-2a0271f74a2b"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->863566398,ExpressionUUID->"c5da7af2-98f9-4d64-800d-de3f6c2f6bd5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"b", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.748169118881194*^9, {3.748173109584269*^9, 3.748173111317824*^9}},
 CellLabel->"In[409]:=",
 CellID->900191581,ExpressionUUID->"b20d7061-2831-45d0-8074-9d54ffcc0030"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", "/", "J"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169152633688*^9, 3.748169166417688*^9}, 
   3.74816961437001*^9, {3.748169735895432*^9, 3.74816976416591*^9}, {
   3.7481714534342337`*^9, 3.748171524401494*^9}, {3.748172277994993*^9, 
   3.748172388840468*^9}, {3.748173070786932*^9, 3.7481730730294323`*^9}, {
   3.748173117430595*^9, 3.7481731307454023`*^9}, {3.748173458595439*^9, 
   3.74817345887745*^9}, {3.748173695194269*^9, 3.748173699950642*^9}, {
   3.748202504888515*^9, 3.7482025270319357`*^9}, {3.748203173557973*^9, 
   3.748203178913308*^9}, {3.748207655028558*^9, 3.748207662940427*^9}, {
   3.7482079592072783`*^9, 3.7482079715754347`*^9}, {3.748208353270157*^9, 
   3.748208354059061*^9}, {3.748208640004923*^9, 3.748208652866403*^9}, {
   3.748209391710054*^9, 3.748209395322097*^9}, {3.7482097396705713`*^9, 
   3.748209755429841*^9}},
 CellID->78056813,ExpressionUUID->"be7e9477-ec71-4fb6-9925-fba372493bff"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", FractionBox[\\\"1\\\", \\\"J\\\"], \\\"}\\\"}], \\\
\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", FractionBox[\"1\
\", \"J\"], \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", FractionBox[\\\"1\\\", \\\"J\\\"], \\\"}\\\"}], \\\
\",\\\", RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", FractionBox[\"1\
\", \"J\"], \"}\"}], \",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00016500000000263526`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00016500000000263526`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1265964760,ExpressionUUID->"5c1b05db-94a5-42d9-b9c2-a9b063090111"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1949230491,ExpressionUUID->"b10458f5-b508-4b10-94f5-709df15f6fbb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169171923123*^9, 3.748173146603053*^9},
 CellLabel->"In[410]:=",
 CellID->1364419805,ExpressionUUID->"62774966-6c3d-4759-94a7-81977a728541"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], "}"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481691806324472`*^9, 3.748169184126515*^9}, {
   3.7481697745097303`*^9, 3.7481698177840567`*^9}, 3.748170212558292*^9, {
   3.74817153653963*^9, 3.748171557948637*^9}, {3.748172403638979*^9, 
   3.748172459180491*^9}, 3.748173461553569*^9, {3.748202537450017*^9, 
   3.748202581324718*^9}, {3.748203197531724*^9, 3.74820320090259*^9}, {
   3.74820768305413*^9, 3.748207686169286*^9}, {3.748207980487094*^9, 
   3.748208000065283*^9}, {3.748208360903953*^9, 3.748208368060452*^9}, {
   3.7482086706482286`*^9, 3.74820867548411*^9}, {3.74820977366685*^9, 
   3.748209773860571*^9}},
 CellID->361639652,ExpressionUUID->"e8043c59-3f22-42fb-b981-a36540778724"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \\\"1\\\"}], \\\"}\\\"}], \\\
\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"0\", \",\", \
\"1\"}], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \\\"1\\\"}], \\\"}\\\"}], \\\
\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", RowBox[{\"0\", \",\", \
\"1\"}], \"}\"}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00012900000000115597`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00012900000000115597`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->853827252,ExpressionUUID->"6a9b9953-740b-49a7-8faf-a121193cb4f8"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->788895110,ExpressionUUID->"bae4bdad-c89e-4304-aae6-fff727568a16"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169187965559*^9, 3.748173150905864*^9},
 CellLabel->"In[411]:=",
 CellID->1539302137,ExpressionUUID->"161288f5-025a-40e5-88e9-7ada59fd8836"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"{", "0", "}"}], "}"}], "//", "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169193927287*^9, 3.748169194789258*^9}, {
   3.748169826851533*^9, 3.7481698714627047`*^9}, {3.748171572452416*^9, 
   3.748171580237145*^9}, {3.748172509134172*^9, 3.7481725445555677`*^9}, {
   3.748172960660345*^9, 3.7481729614507627`*^9}, 3.7481734650745153`*^9, {
   3.7482025915862713`*^9, 3.748202630873435*^9}, {3.748203221716777*^9, 
   3.748203224246625*^9}, {3.7482076998962*^9, 3.7482077040054913`*^9}, {
   3.748208008511187*^9, 3.748208021025865*^9}, {3.7482083872773123`*^9, 
   3.748208388235784*^9}, {3.748208685323637*^9, 3.748208689698819*^9}, {
   3.7482094216066628`*^9, 3.748209422232356*^9}, {3.7482097828935757`*^9, 
   3.748209783470134*^9}},
 CellID->455133749,ExpressionUUID->"e8c5a2da-cc99-41d6-807a-b040e65c1255"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001620000000031041`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001620000000031041`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->396077192,ExpressionUUID->"0b502ca3-469b-4037-b227-2185833e621d"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1817543891,ExpressionUUID->"078bafca-9d99-4aa2-89c9-bb739581602f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"e", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.74816921143508*^9, 3.74817315251501*^9},
 CellLabel->"In[412]:=",
 CellID->1696140808,ExpressionUUID->"6cf47e5a-0381-497c-9717-5f6841ba5933"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "b", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692120543423`*^9, 3.748169217153222*^9}, 
   3.748169620186891*^9, {3.7481699674394503`*^9, 3.7481699868030443`*^9}, 
   3.748173467456937*^9},
 CellID->1341373379,ExpressionUUID->"ba2d8ec1-6b8b-4dad-945e-1666def89c93"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
000158000000002545`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.000158000000002545`\", \"\\\"s\\\
\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1652781109,ExpressionUUID->"be964880-0aa6-4d37-ae43-d8be572d108a"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->591125018,ExpressionUUID->"12094d8a-e003-47b0-8f42-4b5a4c3e4d47"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169221684237*^9, 3.7481731563003674`*^9},
 CellLabel->"In[413]:=",
 CellID->336697932,ExpressionUUID->"9067967d-8797-4a89-b36c-a8ebf0d3baff"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "d", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692270490217`*^9, 3.748169230838327*^9}, {
   3.748169991971572*^9, 3.748170004254684*^9}, 3.748173469973262*^9},
 CellID->269137595,ExpressionUUID->"bc14ea51-4d1c-4afa-8db5-5382f122db12"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\"}\\\"}], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{\"{\", \"0\", \"}\"}], \
\"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00014399999999881175`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00014399999999881175`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->778826504,ExpressionUUID->"612edee9-4c71-496c-a6fc-be7a37d19818"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->824224263,ExpressionUUID->"e8d4da6f-59df-4181-af4a-7815e7adf78d"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test System 15", "Section",
 CellChangeTimes->{{3.7481692698005457`*^9, 3.748169273381559*^9}, 
   3.7481693114624357`*^9, {3.748169361271824*^9, 3.748169361361087*^9}, {
   3.748170308281064*^9, 3.7481703083633633`*^9}, {3.748171876095627*^9, 
   3.748171876178361*^9}, {3.748173822514773*^9, 3.748173822575068*^9}, {
   3.748201957095229*^9, 3.748201957209919*^9}, {3.748202693602541*^9, 
   3.748202694592355*^9}, {3.748203258099217*^9, 3.748203258755952*^9}, {
   3.748207736252469*^9, 3.7482077387114143`*^9}, {3.7482080854975643`*^9, 
   3.748208086239914*^9}, {3.748208442026148*^9, 3.748208442059677*^9}, {
   3.748209226121472*^9, 3.7482092261957827`*^9}, {3.748209472916519*^9, 
   3.748209472960353*^9}, {3.748209968276277*^9, 3.748209968369547*^9}},
 CellID->1617962669,ExpressionUUID->"95af2603-e0b6-4a16-b052-c7e7d371e1cb"],

Cell[CellGroupData[{

Cell["System model", "Subsection",
 CellChangeTimes->{{3.751288977145709*^9, 3.751288979085246*^9}},
 CellID->693269198,ExpressionUUID->"9d3127c8-f981-48fc-8df9-946b24929c92"],

Cell["Rowell and Wormley Example 5.13", "Text",
 CellChangeTimes->{{3.748169314267838*^9, 3.748169333731399*^9}, {
  3.748169368971754*^9, 3.748169377466568*^9}, {3.74817032089456*^9, 
  3.748170327324637*^9}, {3.748171903869137*^9, 3.748171911436009*^9}, {
  3.748173840454677*^9, 3.748173847774159*^9}, {3.748201999818125*^9, 
  3.748202000841951*^9}, {3.748202706062766*^9, 3.74820270612952*^9}, {
  3.748203275897526*^9, 3.7482032759962273`*^9}, {3.748207745579783*^9, 
  3.7482077456859827`*^9}, {3.748208092550345*^9, 3.748208092618396*^9}, {
  3.7482084571902933`*^9, 3.7482084587479973`*^9}, {3.7482092349334173`*^9, 
  3.748209235307046*^9}, {3.748209479371266*^9, 3.7482094794372387`*^9}, {
  3.7482099793239183`*^9, 3.748209979453545*^9}},
 CellID->1619415724,ExpressionUUID->"835eef9d-5225-458a-9151-f5f21e8cd031"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inVars", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"Qs", "[", "t", "]"}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primaryVars", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"QI", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"PC", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"QR1", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"PR2", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outExps", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"QI", "[", "t", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"PC", "[", "t", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"elementalEqs", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"QI", "'"}], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"PI", "[", "t", "]"}], "/", "ii"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"PC", "'"}], "[", "t", "]"}], "\[Equal]", 
      FractionBox[
       RowBox[{"QC", "[", "t", "]"}], 
       RowBox[{"KT0", "+", 
        RowBox[{"(", 
         RowBox[{"KT1", " ", 
          RowBox[{"PC", "[", "t", "]"}]}], ")"}], "+", 
        RowBox[{"(", 
         RowBox[{"KT2", " ", 
          SuperscriptBox[
           RowBox[{"PC", "[", "t", "]"}], "2"]}], ")"}]}]]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"QR1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"K1", " ", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"Abs", "[", 
         RowBox[{"PR1", "[", "t", "]"}], "]"}], "]"}], " ", 
       RowBox[{"Sign", "[", 
        RowBox[{"PR1", "[", "t", "]"}], "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"PR2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"QR2", "[", "t", "]"}], " ", 
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{"QR2", "[", "t", "]"}], "]"}], "/", 
        SuperscriptBox["K2", "2"]}]}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"constraintEqs", " ", "=", " ", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"QC", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"Qs", "[", "t", "]"}], "-", 
       RowBox[{"QR1", "[", "t", "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"QR2", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"QI", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"PR1", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"PC", "[", "t", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"PI", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"PC", "[", "t", "]"}], "-", 
       RowBox[{"PR2", "[", "t", "]"}]}]}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.747499218184157*^9, 3.74749931067735*^9}, {
   3.7474997703057547`*^9, 3.747499862953096*^9}, {3.7475000427164516`*^9, 
   3.7475001179609213`*^9}, 3.747500172506531*^9, {3.7475052421578627`*^9, 
   3.7475052437525806`*^9}, {3.7475052792870703`*^9, 3.747505305743517*^9}, {
   3.7475054395550127`*^9, 3.74750549238805*^9}, {3.748169383980278*^9, 
   3.748169603265369*^9}, {3.748170115690106*^9, 3.748170132266461*^9}, {
   3.748170333165715*^9, 3.7481705921461983`*^9}, {3.748171917577342*^9, 
   3.74817195326005*^9}, {3.748171995123074*^9, 3.7481720024895773`*^9}, {
   3.748172035662871*^9, 3.7481721909688787`*^9}, {3.748173852472159*^9, 
   3.7481740097196913`*^9}, {3.7482022679021463`*^9, 3.748202298767332*^9}, {
   3.748202329707706*^9, 3.748202426597817*^9}, {3.7482027090106783`*^9, 
   3.748202788912438*^9}, {3.74820743586224*^9, 3.748207471308917*^9}, {
   3.748207507244035*^9, 3.748207585893305*^9}, {3.7482077486519814`*^9, 
   3.748207772848833*^9}, {3.748207850305572*^9, 3.7482079126557817`*^9}, {
   3.748208102199922*^9, 3.748208255621907*^9}, {3.748208462423398*^9, 
   3.748208588053383*^9}, {3.748209240181383*^9, 3.7482092694545383`*^9}, {
   3.748209306213228*^9, 3.74820932247434*^9}, {3.7482094984175673`*^9, 
   3.7482096496197243`*^9}, {3.748209992720366*^9, 3.748209993647952*^9}, {
   3.748210132528723*^9, 3.748210143667449*^9}, {3.748210488294092*^9, 
   3.7482107134268513`*^9}, {3.751288992120525*^9, 3.7512891197290382`*^9}, {
   3.751826894743176*^9, 3.751826924327701*^9}, {3.751826987558015*^9, 
   3.7518269961777353`*^9}},
 CellLabel->"In[414]:=",
 CellID->1563337662,ExpressionUUID->"a58c814e-bfe8-4a2f-84d0-1183249acc04"],

Cell["Find state equation.", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.75124789335491*^9}},
 CellID->1827694738,ExpressionUUID->"1f6133ff-5c2a-468e-9795-f8fe1c7abe18"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"stateSolution", "=", 
   RowBox[{
    RowBox[{"stateEquations", "[", 
     RowBox[{
     "inVars", ",", "primaryVars", ",", "elementalEqs", ",", 
      "constraintEqs"}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateVars", " ", "=", " ", 
   RowBox[{"\"\<state variables\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stateEqList", " ", "=", " ", 
   RowBox[{"\"\<RHS\>\"", "/.", "stateSolution"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\"\<state equations\>\"", "/.", "stateSolution"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.7018797195836763`*^9, 3.7018797204767036`*^9}, {
   3.701879810803969*^9, 3.701879844544981*^9}, {3.7018942050184517`*^9, 
   3.701894566874161*^9}, 3.701898020551093*^9, {3.701903282327601*^9, 
   3.701903283500523*^9}, {3.701911200698804*^9, 3.701911202601316*^9}, {
   3.701915682054678*^9, 3.701915720675168*^9}, {3.701915759772274*^9, 
   3.7019157927706213`*^9}, {3.701915923602686*^9, 3.701915923900078*^9}, 
   3.7019209193048553`*^9, 3.701920950145496*^9, {3.701921306764739*^9, 
   3.701921308673313*^9}, {3.701921408184596*^9, 3.7019214156809187`*^9}, 
   3.7019220747800493`*^9, {3.701922189786292*^9, 3.701922218088579*^9}, {
   3.701922248592429*^9, 3.701922251876824*^9}, 3.701922322852202*^9, {
   3.701922383801173*^9, 3.7019224315654707`*^9}, {3.701922463501308*^9, 
   3.7019224895050097`*^9}, 3.7019225472984467`*^9, {3.701922594846767*^9, 
   3.701922598092758*^9}, {3.701922662563005*^9, 3.701922735877761*^9}, {
   3.7019231046383343`*^9, 3.701923105684675*^9}, {3.7019639715923243`*^9, 
   3.7019639718841667`*^9}, {3.7019642654040737`*^9, 3.701964352167139*^9}, {
   3.701964387110903*^9, 3.7019644147887087`*^9}, {3.702757419429731*^9, 
   3.7027575039883213`*^9}, {3.7511302149210863`*^9, 3.751130222225973*^9}, 
   3.751131245052647*^9, 3.7518224212768917`*^9, 3.751859572693215*^9, 
   3.751859962466999*^9, 3.751860991929316*^9, 3.751937402352337*^9},
 CellID->206947660,ExpressionUUID->"3fd1bdc4-2bd7-4045-bbf1-ff2b0d18e290"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["QI", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       FractionBox[
        RowBox[{"PC", "[", "t", "]"}], "ii"], "-", 
       FractionBox[
        RowBox[{
         RowBox[{"Abs", "[", 
          RowBox[{"QI", "[", "t", "]"}], "]"}], " ", 
         RowBox[{"QI", "[", "t", "]"}]}], 
        RowBox[{"ii", " ", 
         SuperscriptBox["K2", "2"]}]]}]}]},
    {
     RowBox[{
      RowBox[{
       SuperscriptBox["PC", "\[Prime]",
        MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
      FractionBox[
       RowBox[{
        RowBox[{"Qs", "[", "t", "]"}], "-", 
        RowBox[{"K1", " ", 
         SqrtBox[
          RowBox[{"Abs", "[", 
           RowBox[{"PC", "[", "t", "]"}], "]"}]], " ", 
         RowBox[{"Sign", "[", 
          RowBox[{"PC", "[", "t", "]"}], "]"}]}]}], 
       RowBox[{"KT0", "+", 
        RowBox[{"KT1", " ", 
         RowBox[{"PC", "[", "t", "]"}]}], "+", 
        RowBox[{"KT2", " ", 
         SuperscriptBox[
          RowBox[{"PC", "[", "t", "]"}], "2"]}]}]]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751131246142264*^9, 3.751131562228766*^9, 3.751154207578877*^9, 
   3.751155061538066*^9, 3.7511551539969883`*^9, 3.7511556539137783`*^9, 
   3.751156830900199*^9, 3.751157044451893*^9, 3.751157305712584*^9, 
   3.751157692923893*^9, 3.751237248504381*^9, 3.7512373121455393`*^9, 
   3.751237557961287*^9, {3.7512412411479073`*^9, 3.751241257691305*^9}, 
   3.7512413334070673`*^9, 3.751241455823284*^9, 3.751241611586341*^9, 
   3.7512433878599854`*^9, 3.751243524307231*^9, 3.751243608962484*^9, 
   3.7512437545853853`*^9, 3.751243860047454*^9, 3.7512441819725847`*^9, 
   3.751244399097206*^9, 3.751244486437664*^9, 3.75124455927641*^9, 
   3.75124464012558*^9, 3.75124506931707*^9, 3.751245129883816*^9, 
   3.751245199900049*^9, 3.751245786492696*^9, 3.7512458405736723`*^9, 
   3.751245872204157*^9, {3.7512470996055098`*^9, 3.751247133340377*^9}, 
   3.751822506215632*^9, {3.751822707767754*^9, 3.751822723484655*^9}, 
   3.751822800835991*^9, 3.7518235244045973`*^9, 3.751823574246002*^9, 
   3.75182394710122*^9, 3.751824050485718*^9, {3.751824086094249*^9, 
   3.7518241542062597`*^9}, 3.751824200734988*^9, {3.751826941450078*^9, 
   3.75182696430166*^9}, {3.751827001747229*^9, 3.751827017344389*^9}, 
   3.7518280761255417`*^9, 3.751861404988887*^9},
 CellLabel->"Out[422]//TableForm=",
 CellID->1467665091,ExpressionUUID->"94baadbc-dce0-4101-bf21-40c24a2a6671"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"outEqList", "=", 
   RowBox[{"outEquations", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outExps", ",", 
     RowBox[{"elementalEqs", "~", "Join", "~", "constraintEqs"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outEqList", "//", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"y", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "outExps", "]"}]}], "}"}]}], "]"}], 
      "\[Equal]", "#"}], "]"}], "&"}]}], "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.75115407229806*^9, 3.7511540907068577`*^9}, {
   3.7511541283727303`*^9, 3.751154145140655*^9}, {3.751154185947949*^9, 
   3.751154186454541*^9}, {3.75115440553708*^9, 3.751154408241644*^9}, {
   3.751157061478198*^9, 3.75115706228808*^9}, {3.751157258647379*^9, 
   3.751157263470278*^9}, {3.751157318329653*^9, 3.751157382599204*^9}, 
   3.751243546881419*^9, 3.7512446518094807`*^9, {3.7518241789029417`*^9, 
   3.751824190813037*^9}},
 CellLabel->"In[423]:=",
 CellID->983126601,ExpressionUUID->"eb48b425-124b-469c-9074-48d5e9043274"],

Cell[BoxData[
 TemplateBox[{
  "InverseFunction","ifun",
   "\"Inverse functions are being used. Values may be lost for multivalued \
inverses.\"",2,423,1,24104262236063638955,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.751826946639595*^9, 3.7518269663524103`*^9}, {
   3.7518270068487473`*^9, 3.751827017452927*^9}, 3.751828076546097*^9, 
   3.751861405608395*^9},
 CellLabel->"During evaluation of In[423]:=",
 CellID->1050014995,ExpressionUUID->"b92f5396-13f8-4d0f-89ef-e3ba97b16c0c"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      RowBox[{
       RowBox[{"y", "[", "1", "]"}], "\[Equal]", 
       RowBox[{"QI", "[", "t", "]"}]}]},
     {
      RowBox[{
       RowBox[{"y", "[", "2", "]"}], "\[Equal]", 
       RowBox[{"PC", "[", "t", "]"}]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.751154146341402*^9, {3.7511541874520807`*^9, 3.75115421035389*^9}, 
   3.751154409289606*^9, 3.751155063159431*^9, 3.7511551578703537`*^9, {
   3.751155631171876*^9, 3.7511556669733973`*^9}, 3.751156831153225*^9, {
   3.7511570444961233`*^9, 3.751157063011318*^9}, 3.7511573845757217`*^9, 
   3.7511576929574337`*^9, 3.751237248545403*^9, 3.75123731846103*^9, 
   3.751237558009218*^9, 3.75124126512782*^9, 3.751241341691312*^9, 
   3.7512414602930183`*^9, {3.7512415890389347`*^9, 3.751241614550478*^9}, 
   3.751243391757332*^9, {3.751243525864511*^9, 3.7512435473077707`*^9}, 
   3.7512436090180597`*^9, 3.751243754645124*^9, 3.751243860169832*^9, 
   3.751244182055914*^9, 3.751244399162704*^9, 3.751244486514542*^9, 
   3.751244523619996*^9, 3.7512445593242817`*^9, {3.751244640162719*^9, 
   3.7512446526642714`*^9}, 3.7512450693463917`*^9, 3.751245129916429*^9, 
   3.751245199944006*^9, 3.751245811673089*^9, 3.75124584198965*^9, 
   3.75124587430195*^9, {3.751247099662253*^9, 3.751247148020466*^9}, {
   3.751824169273649*^9, 3.751824200839072*^9}, {3.7518269466501827`*^9, 
   3.751826966383209*^9}, {3.751827006878113*^9, 3.7518270174817142`*^9}, 
   3.751828076578298*^9, 3.7518614056366243`*^9},
 CellLabel->"Out[424]//TableForm=",
 CellID->1728893566,ExpressionUUID->"58ef52e1-1879-48fe-853a-70c51c3fd442"]
}, Open  ]],

Cell["\<\
Linearize the state and output equations about operating point.\
\>", "Text",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.7512479601059103`*^9}},
 CellID->852590568,ExpressionUUID->"f963f4aa-f87c-44c6-b197-95514e3edc4b"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"abe", "=", 
   RowBox[{"linearizeState", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "stateEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdf", "=", 
   RowBox[{"linearizeOutput", "[", 
    RowBox[{"inVars", ",", "stateVars", ",", "outEqList"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"e", "=", 
   RowBox[{"abe", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"d", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"f", "=", 
   RowBox[{"cdf", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<A = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<B = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<E = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<C = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<D = \>\"", ",", "#"}], "]"}], "&"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "//", "MatrixForm"}], "//", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\<F = \>\"", ",", "#"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.747505219904416*^9, 3.747505268393756*^9}, 
   3.7475055408334427`*^9, 3.751247764999488*^9, {3.751247875354883*^9, 
   3.751247880163527*^9}, {3.7512479164452343`*^9, 3.751247952610923*^9}, {
   3.75128846048738*^9, 3.751288516214229*^9}, {3.751288925220256*^9, 
   3.751288932694913*^9}},
 CellLabel->"In[425]:=",
 CellID->1478783592,ExpressionUUID->"dcd13ef4-01c1-4709-83e0-c9aabfc7ef6a"],

Cell[BoxData[
 TemplateBox[{
  "Power","infy",
   "\"Infinite expression \\!\\(\\*FractionBox[\\\"1\\\", SqrtBox[\\\"0\\\"]]\
\\) encountered.\"",2,425,2,24104262236063638955,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.751827017618236*^9, 3.751828077016183*^9, 
  3.751861406393766*^9},
 CellLabel->"During evaluation of In[425]:=",
 CellID->2060419852,ExpressionUUID->"3d45b353-1ff3-4471-b932-99a961bf2ce8"],

Cell[BoxData[
 TemplateBox[{
  "Infinity","indet",
   "\"Indeterminate expression \\!\\(\\*RowBox[{\\\"0\\\", \\\" \\\", \
\\\"K1\\\", \\\" \\\", \\\"ComplexInfinity\\\", \\\" \\\", \
RowBox[{SuperscriptBox[\\\"Abs\\\", \\\"\[Prime]\\\", Rule[MultilineFunction, \
None]], \\\"[\\\", \\\"0\\\", \\\"]\\\"}]}]\\) encountered.\"",2,425,3,
   24104262236063638955,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.751827017618236*^9, 3.751828077016183*^9, 
  3.751861406420327*^9},
 CellLabel->"During evaluation of In[425]:=",
 CellID->1302644689,ExpressionUUID->"b6214a96-cbac-47d5-b6e2-738793844f04"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", 
        FractionBox["1", "ii"]},
       {"0", "Indeterminate"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["A = ", 
   MatrixForm[{{0, $CellContext`ii^(-1)}, {0, Indeterminate}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, {3.751288913488022*^9, 3.751288933782707*^9}, 
   3.751318380117668*^9, 3.75182701767343*^9, 3.7518280770745687`*^9, 
   3.751861406440997*^9},
 CellLabel->"During evaluation of In[425]:=",
 CellID->2100990505,ExpressionUUID->"03a722cc-4b5f-493b-b9e6-b9bfc57ec8e4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"B = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {
        FractionBox["1", "KT0"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["B = ", 
   MatrixForm[{{0}, {$CellContext`KT0^(-1)}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, {3.751288913488022*^9, 3.751288933782707*^9}, 
   3.751318380117668*^9, 3.75182701767343*^9, 3.7518280770745687`*^9, 
   3.7518614064483013`*^9},
 CellLabel->"During evaluation of In[425]:=",
 CellID->273809914,ExpressionUUID->"bc12edd8-5c60-48ea-8134-e14dc182d42a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"E = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["E = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, {3.751288913488022*^9, 3.751288933782707*^9}, 
   3.751318380117668*^9, 3.75182701767343*^9, 3.7518280770745687`*^9, 
   3.75186140646075*^9},
 CellLabel->"During evaluation of In[425]:=",
 CellID->2013252724,ExpressionUUID->"328754f8-c4cd-454b-962e-73e97359e5f8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"C = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0"},
       {"0", "1"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["C = ", 
   MatrixForm[{{1, 0}, {0, 1}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, {3.751288913488022*^9, 3.751288933782707*^9}, 
   3.751318380117668*^9, 3.75182701767343*^9, 3.7518280770745687`*^9, 
   3.751861406467711*^9},
 CellLabel->"During evaluation of In[425]:=",
 CellID->986190136,ExpressionUUID->"4f3f8842-f708-4c0d-b6f2-562f922f9e06"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"D = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["D = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, {3.751288913488022*^9, 3.751288933782707*^9}, 
   3.751318380117668*^9, 3.75182701767343*^9, 3.7518280770745687`*^9, 
   3.7518614064743633`*^9},
 CellLabel->"During evaluation of In[425]:=",
 CellID->618828206,ExpressionUUID->"be260fd0-1d14-4b6a-af5a-50e6adc1e33f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"F = \"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["F = ", 
   MatrixForm[{{0}, {0}}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.751288494547102*^9, 3.751288518979985*^9}, 
   3.751288593350533*^9, {3.751288913488022*^9, 3.751288933782707*^9}, 
   3.751318380117668*^9, 3.75182701767343*^9, 3.7518280770745687`*^9, 
   3.751861406481145*^9},
 CellLabel->"During evaluation of In[425]:=",
 CellID->382355821,ExpressionUUID->"1b975545-e61b-4370-8689-e045b2f1c048"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.75124808019132*^9, 3.7512480809379053`*^9}},
 CellID->1180942566,ExpressionUUID->"a70c0d82-c6f2-4b6c-b6a6-6d01170dda43"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"stateEqList", "//", "FullSimplify"}]], "VerificationTest",
 CellChangeTimes->{
  3.747505552707037*^9, {3.7475057578295593`*^9, 3.747505759222794*^9}, {
   3.747505842150148*^9, 3.7475058458319883`*^9}, {3.747505896191999*^9, 
   3.74750589728131*^9}, {3.748124150238531*^9, 3.748124150517943*^9}, 
   3.748169029221862*^9, 3.748173244647019*^9, {3.748210758528468*^9, 
   3.748210760837919*^9}, {3.748258593097474*^9, 3.748258593551626*^9}, 
   3.7518270505994253`*^9, {3.7518271138128366`*^9, 3.751827120226841*^9}},
 CellLabel->"In[435]:=",
 CellID->1154292932,ExpressionUUID->"cb6e3548-141e-4561-b1b2-deec08b719ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     FractionBox["1", "ii"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"PC", "[", "t", "]"}], "-", 
       RowBox[{
        FractionBox["1", 
         SuperscriptBox["K2", "2"]], 
        RowBox[{"QI", "[", "t", "]"}], 
        RowBox[{"Abs", "[", 
         RowBox[{"QI", "[", "t", "]"}], "]"}]}]}], ")"}]}], ",", 
    FractionBox[
     RowBox[{
      RowBox[{"Qs", "[", "t", "]"}], "-", 
      RowBox[{"K1", " ", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"Abs", "[", 
         RowBox[{"PC", "[", "t", "]"}], "]"}], "]"}], 
       RowBox[{"Sign", "[", 
        RowBox[{"PC", "[", "t", "]"}], "]"}]}]}], 
     RowBox[{"KT0", "+", 
      RowBox[{"KT1", " ", 
       RowBox[{"PC", "[", "t", "]"}]}], "+", 
      RowBox[{"KT2", " ", 
       SuperscriptBox[
        RowBox[{"PC", "[", "t", "]"}], "2"]}]}]]}], "}"}], "//", 
  "FullSimplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.747505555643032*^9, 3.7475055867312613`*^9}, {
   3.747505761476728*^9, 3.747505764318122*^9}, {3.747505847665118*^9, 
   3.7475058502692757`*^9}, {3.747505898843794*^9, 3.74750590124069*^9}, {
   3.7475063255823507`*^9, 3.747506334276267*^9}, {3.7481241530496283`*^9, 
   3.748124156712919*^9}, 3.7481690353265944`*^9, {3.748169641556839*^9, 
   3.748169730141844*^9}, {3.7481706308795347`*^9, 3.748170648343268*^9}, {
   3.7481713324991817`*^9, 3.748171412017522*^9}, {3.7481722117935038`*^9, 
   3.748172266534639*^9}, {3.748172557215331*^9, 3.748172586783577*^9}, 
   3.748172811167288*^9, {3.748173455617723*^9, 3.748173456202003*^9}, {
   3.748173684193961*^9, 3.7481736910145693`*^9}, {3.748174023178488*^9, 
   3.748174074694357*^9}, {3.7482024431310062`*^9, 3.7482024882994432`*^9}, {
   3.748203045867991*^9, 3.748203049432695*^9}, {3.7482031539741383`*^9, 
   3.748203165353072*^9}, {3.748207600236726*^9, 3.7482076437651033`*^9}, {
   3.748207926849205*^9, 3.748207952971178*^9}, {3.748208268582942*^9, 
   3.748208337143387*^9}, {3.748208598589538*^9, 3.7482086272775517`*^9}, {
   3.7482093419924383`*^9, 3.748209356014646*^9}, {3.748209683964367*^9, 
   3.748209717678073*^9}, {3.748210804474401*^9, 3.748210974383256*^9}, {
   3.7482578086717567`*^9, 3.748257822359613*^9}, {3.7482578640411243`*^9, 
   3.748257878381981*^9}, {3.748258106821583*^9, 3.7482581117860413`*^9}, {
   3.748258152543186*^9, 3.748258184960374*^9}, {3.748258595997621*^9, 
   3.748258596677702*^9}, {3.749515465507197*^9, 3.7495154693022327`*^9}},
 CellID->860464999,ExpressionUUID->"a563cbb8-a1a7-4ee4-b97b-116e06ac41a0"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{FractionBox[RowBox[{RowBox[{\\\"PC\\\", \\\"[\\\", \\\"t\\\", \\\"]\\\
\"}], \\\"-\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\
\[RightSkeleton]\\\"}]}], \\\"ii\\\"], \\\",\\\", \
FractionBox[RowBox[{RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\
\[RightSkeleton]\\\"}], \\\"-\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \
\\\"1\\\", \\\"\[RightSkeleton]\\\"}]}], RowBox[{\\\"KT0\\\", \\\"+\\\", \
RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\[RightSkeleton]\\\"}]}]]}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", \
RowBox[{FractionBox[RowBox[{RowBox[{\"PC\", \"[\", \"t\", \"]\"}], \"-\", \
RowBox[{\"\[LeftSkeleton]\", \"1\", \"\[RightSkeleton]\"}]}], \"ii\"], \",\", \
FractionBox[RowBox[{RowBox[{\"\[LeftSkeleton]\", \"1\", \
\"\[RightSkeleton]\"}], \"-\", RowBox[{\"\[LeftSkeleton]\", \"1\", \"\
\[RightSkeleton]\"}]}], RowBox[{\"KT0\", \"+\", RowBox[{\"\[LeftSkeleton]\", \
\"1\", \"\[RightSkeleton]\"}]}]]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{FractionBox[RowBox[{RowBox[{\\\"PC\\\", \\\"[\\\", \\\"t\\\", \\\"]\\\
\"}], \\\"-\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\
\[RightSkeleton]\\\"}]}], \\\"ii\\\"], \\\",\\\", \
FractionBox[RowBox[{RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\
\[RightSkeleton]\\\"}], \\\"-\\\", RowBox[{\\\"\[LeftSkeleton]\\\", \
\\\"1\\\", \\\"\[RightSkeleton]\\\"}]}], RowBox[{\\\"KT0\\\", \\\"+\\\", \
RowBox[{\\\"\[LeftSkeleton]\\\", \\\"1\\\", \\\"\[RightSkeleton]\\\"}]}]]}], \
\\\"}\\\"}], Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", \
RowBox[{FractionBox[RowBox[{RowBox[{\"PC\", \"[\", \"t\", \"]\"}], \"-\", \
RowBox[{\"\[LeftSkeleton]\", \"1\", \"\[RightSkeleton]\"}]}], \"ii\"], \",\", \
FractionBox[RowBox[{RowBox[{\"\[LeftSkeleton]\", \"1\", \
\"\[RightSkeleton]\"}], \"-\", RowBox[{\"\[LeftSkeleton]\", \"1\", \"\
\[RightSkeleton]\"}]}], RowBox[{\"KT0\", \"+\", RowBox[{\"\[LeftSkeleton]\", \
\"1\", \"\[RightSkeleton]\"}]}]]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
10794600000000187`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.10794600000000187`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->983211723,ExpressionUUID->"e1ad2932-2a8d-47dd-94b7-b14d28bbf024"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->2100248443,ExpressionUUID->"2be9d602-b4e9-41f5-82b6-c7661a29b792"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169171923123*^9, 3.748173146603053*^9},
 CellLabel->"In[436]:=",
 CellID->1942943384,ExpressionUUID->"6d49f2ef-c7d2-41cf-9e41-d486b5e2a5fd"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481691806324472`*^9, 3.748169184126515*^9}, {
   3.7481697745097303`*^9, 3.7481698177840567`*^9}, 3.748170212558292*^9, {
   3.74817153653963*^9, 3.748171557948637*^9}, {3.748172403638979*^9, 
   3.748172459180491*^9}, 3.748173461553569*^9, {3.748202537450017*^9, 
   3.748202581324718*^9}, {3.748203197531724*^9, 3.74820320090259*^9}, {
   3.74820768305413*^9, 3.748207686169286*^9}, {3.748207980487094*^9, 
   3.748208000065283*^9}, {3.748208360903953*^9, 3.748208368060452*^9}, {
   3.7482086706482286`*^9, 3.74820867548411*^9}, {3.74820977366685*^9, 
   3.748209773860571*^9}, {3.7482110603397827`*^9, 3.748211070225501*^9}},
 CellID->456156699,ExpressionUUID->"4ad98e61-0b3a-42cc-8f7f-2192fc74b03b"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\
\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"1\", \
\",\", \"0\"}], \"}\"}], \",\", RowBox[{\"{\", RowBox[{\"0\", \",\", \"1\"}], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \\\"0\\\"}], \\\"}\\\
\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"0\\\", \\\",\\\", \
\\\"1\\\"}], \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], Rational[2, \
3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", RowBox[{\"1\", \
\",\", \"0\"}], \"}\"}], \",\", RowBox[{\"{\", RowBox[{\"0\", \",\", \"1\"}], \
\"}\"}]}], \"}\"}], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
000150999999998902`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.000150999999998902`\", \"\\\"s\\\
\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->686875762,ExpressionUUID->"1945fe92-ab2d-4af6-a1c3-7b6f7e4c4534"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->1596329309,ExpressionUUID->"0d3ed146-1683-451c-aa30-f4eb66ce2370"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169187965559*^9, 3.748173150905864*^9},
 CellLabel->"In[437]:=",
 CellID->193004571,ExpressionUUID->"c0d29612-b95e-45d1-b20c-68e59a4ec656"],

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "0", "}"}]}], "}"}], "]"}]], "ExpectedOutput",
 CellChangeTimes->{{3.748169193927287*^9, 3.748169194789258*^9}, {
   3.748169826851533*^9, 3.7481698714627047`*^9}, {3.748171572452416*^9, 
   3.748171580237145*^9}, {3.748172509134172*^9, 3.7481725445555677`*^9}, {
   3.748172960660345*^9, 3.7481729614507627`*^9}, 3.7481734650745153`*^9, {
   3.7482025915862713`*^9, 3.748202630873435*^9}, {3.748203221716777*^9, 
   3.748203224246625*^9}, {3.7482076998962*^9, 3.7482077040054913`*^9}, {
   3.748208008511187*^9, 3.748208021025865*^9}, {3.7482083872773123`*^9, 
   3.748208388235784*^9}, {3.748208685323637*^9, 3.748208689698819*^9}, {
   3.7482094216066628`*^9, 3.748209422232356*^9}, {3.7482097828935757`*^9, 
   3.748209783470134*^9}, {3.748211023796912*^9, 3.7482110437528467`*^9}},
 CellID->2081689028,ExpressionUUID->"3d7cac27-569a-46a5-bbe3-07b116304c2b"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
0001639999999980546`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.0001639999999980546`\", \
\"\\\"s\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, \
Mod]], Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->993494392,ExpressionUUID->"b86e33de-71be-4ba1-a339-a905a2963213"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->974890919,ExpressionUUID->"0e170a59-5ad7-4235-917b-b4ef8ce81135"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "//", "Simplify"}]], "VerificationTest",
 CellChangeTimes->{3.748169221684237*^9, 3.7481731563003674`*^9},
 CellLabel->"In[438]:=",
 CellID->1160542593,ExpressionUUID->"78623ef6-2ce0-4aaf-ac6b-69fc0391d872"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConstantArray", "[", 
   RowBox[{"0", ",", 
    RowBox[{"Dimensions", "[", "d", "]"}]}], "]"}], "//", 
  "Simplify"}]], "ExpectedOutput",
 CellChangeTimes->{{3.7481692270490217`*^9, 3.748169230838327*^9}, {
   3.748169991971572*^9, 3.748170004254684*^9}, 3.748173469973262*^9},
 CellID->2117812846,ExpressionUUID->"7e3b0d4e-1f43-452e-b9e6-eeb36640d8b9"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      TagBox[GridBox[{
         {
          StyleBox[
           
           DynamicBox[FEPrivate`FrontEndResource[
            "MUnitStrings", "Success-TestSuccess"],
            ImageSizeCache->{57., {1., 11.}}],
           StripOnInput->False,
           LineColor->GrayLevel[1],
           FrontFaceColor->GrayLevel[1],
           BackFaceColor->GrayLevel[1],
           GraphicsColor->GrayLevel[1],
           FontFamily->"Arial",
           FontSize->14,
           FontWeight->Bold,
           FontColor->GrayLevel[1]], 
          
          DynamicBox[FEPrivate`FrontEndResource[
           "MUnitExpressions", "SuccessCheck"],
           ImageSizeCache->{16., {4., 8.}}]}
        },
        AutoDelete->False,
        GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"], 
      ItemBox["\<\"\"\>",
       ItemSize->Fit,
       StripOnInput->False], 
      ActionMenuBox[
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "Details-Label"],
             ImageSizeCache->{33., {1., 8.}}],
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontFamily->"Helvetica",
            FontSize->10,
            FontColor->GrayLevel[1]], 
           StyleBox["\<\"\[RightGuillemet]\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[1],
            FrontFaceColor->GrayLevel[1],
            BackFaceColor->GrayLevel[1],
            GraphicsColor->GrayLevel[1],
            FontSize->12,
            FontColor->GrayLevel[1]]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"ColumnsIndexed" -> {2 -> 0.3}}],
        "Grid"], {
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "TestID-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[\\\"None\\\", \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource["MUnitStrings", "TestID-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[\"None\", Function[Short[Slot[1], Rational[2, \
3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ActualOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", \\\"0\\\", \\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\
\", \\\"0\\\", \\\"}\\\"}]}], \\\"}\\\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "ExpectedOutput-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[RowBox[{\"{\", RowBox[{RowBox[{\"{\", \"0\", \"}\"}], \
\",\", RowBox[{\"{\", \"0\", \"}\"}]}], \"}\"}], Function[Short[Slot[1], \
Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}], 
       TagBox[GridBox[{
          {
           StyleBox[
            
            DynamicBox[FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]],
            StripOnInput->False,
            LineColor->RGBColor[0.458824, 0.458824, 0.458824],
            FrontFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            BackFaceColor->RGBColor[0.458824, 0.458824, 0.458824],
            GraphicsColor->RGBColor[0.458824, 0.458824, 0.458824],
            FontColor->RGBColor[0.458824, 0.458824, 0.458824]], 
           
           StyleBox["\<\"\\!\\(\\*TagBox[TemplateBox[List[\\\"0.\
00016299999999702663`\\\", \\\"\\\\\\\"s\\\\\\\"\\\", \\\"s\\\", \
\\\"\\\\\\\"Seconds\\\\\\\"\\\"], \\\"Quantity\\\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\\)\"\>",
            StripOnInput->False,
            LineColor->RGBColor[0.14902, 0.14902, 0.14902],
            FrontFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            BackFaceColor->RGBColor[0.14902, 0.14902, 0.14902],
            GraphicsColor->RGBColor[0.14902, 0.14902, 0.14902],
            FontColor->RGBColor[0.14902, 0.14902, 0.14902]]}
         },
         AutoDelete->False,
         BaseStyle->{FontFamily -> "Helvetica", FontWeight -> "Bold"},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5}, "Rows" -> {{Automatic}}}],
        "Grid"]:>Grid[{{
          Style[
           Dynamic[
            RawBoxes[
             FEPrivate`FrontEndResource[
             "MUnitStrings", "CPUTimeUsed-Detail"]]], 
           RGBColor[0.458824, 0.458824, 0.458824]], 
          Style[
          "\!\(\*TagBox[TemplateBox[List[\"0.00016299999999702663`\", \"\\\"s\
\\\"\", \"s\", \"\\\"Seconds\\\"\"], \"Quantity\", Rule[SyntaxForm, Mod]], \
Function[Short[Slot[1], Rational[2, 3]]]]\)", 
           RGBColor[0.14902, 0.14902, 0.14902]]}}, 
        BaseStyle -> {FontFamily -> "Helvetica", FontWeight -> "Bold"}, 
        Spacings -> {{2 -> 0.5}, Automatic}]},
       Appearance->None]}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Right}}},
    GridBoxItemSize->{"Columns" -> {{All}}, "Rows" -> {{All}}}],
   "Grid"],
  ImageSize->Full]], "TestSuccess",
 CellID->1838932670,ExpressionUUID->"57e50527-9531-4858-bcea-edb33960f7d5"],

Cell[BoxData[
 PaneBox[
  TagBox[GridBox[{
     {
      PaneBox[
       TagBox[GridBox[{
          {
           ButtonBox[
            TagBox[
             TooltipBox[
              PaneSelectorBox[{False->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"],
                    ImageSizeCache->{80., {3., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"], True->
               TagBox[GridBox[{
                  {
                   
                   DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                   StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddMessages-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                 },
                 AutoDelete->False,
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                "Grid"]}, Dynamic[
                CurrentValue["MouseOver"]],
               FrameMargins->0,
               ImageSize->Automatic],
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "AddMessages-Tooltip"]],
              TooltipDelay->0.5],
             Annotation[#, 
              Dynamic[
               RawBoxes[
                FEPrivate`FrontEndResource[
                "MUnitStrings", "AddMessages-Tooltip"]]], "Tooltip"]& ],
            
            Appearance->FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"],
            
            ButtonFunction:>
             Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addMessages[]],
            Evaluator->Automatic,
            FrameMargins->{{10, 10}, {0, 0}},
            ImageSize->Automatic,
            Method->"Queued"], 
           TagBox[GridBox[{
              {
               ButtonBox[
                TagBox[
                 TooltipBox[
                  PaneSelectorBox[{False->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"],
                    ImageSizeCache->{16., {3., 9.}}], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"],
                    ImageSizeCache->{67., {2., 9.}}], "ButtonText",
                    StripOnInput->False,
                    AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"], True->
                   TagBox[GridBox[{
                    {
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitExpressions", "Add"]], 
                    StyleBox[
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Label"]], "ButtonText",
                    StripOnInput->False,
                    LineColor->RGBColor[0.9059, 0.3451, 0.102],
                    FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
                    GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
                    FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
                    },
                    AutoDelete->False,
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    "Grid"]}, Dynamic[
                    CurrentValue["MouseOver"]],
                   FrameMargins->0,
                   ImageSize->Automatic],
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "AddOptions-Tooltip"]],
                  TooltipDelay->0.5],
                 Annotation[#, 
                  Dynamic[
                   RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "AddOptions-Tooltip"]]], "Tooltip"]& ],
                
                Appearance->FEPrivate`FrontEndResource[
                 "MUnitExpressions", "ButtonAppearances"],
                
                ButtonFunction:>
                 Block[{$ContextPath}, Needs["MUnit`"]; MUnit`addOptions[]],
                Evaluator->Automatic,
                FrameMargins->{{10, 10}, {0, 0}},
                ImageSize->Automatic,
                Method->"Queued"], 
               ActionMenuBox[
                ButtonBox["\<\"\"\>",
                 
                 Appearance->FEPrivate`FrontEndResource[
                  "MUnitExpressions", "ButtonAppearancesNoLeftBorder"],
                 ButtonFunction:>{},
                 ContentPadding->False,
                 Evaluator->None,
                 Method->"Preemptive"], {
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "MemoryConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["MemoryConstraint"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "SameTest-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["SameTest"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TestID-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TestID"]], 
                
                DynamicBox[FEPrivate`FrontEndResource[
                 "MUnitStrings", "TimeConstraint-Label"]]:>
                Block[{$ContextPath}, Needs["MUnit`"]; 
                 MUnit`InsertOptionRule["TimeConstraint"]]},
                Appearance->None,
                Method->"Queued"]}
             },
             AutoDelete->False,
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{Automatic}}}],
            "Grid"]}
         },
         AutoDelete->False,
         GridBoxAlignment->{"Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
         
         GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{2}}},
         GridBoxSpacings->{
          "ColumnsIndexed" -> {2 -> 0.5, 3 -> 2, 4 -> 0.5}, 
           "Rows" -> {{Automatic}}}],
        "Grid"],
       Alignment->{Left, Center},
       ImageSize->Full], 
      ItemBox["\<\"\"\>",
       ItemSize->Full,
       StripOnInput->False], 
      ButtonBox[
       TagBox[
        TooltipBox[
         PaneSelectorBox[{False->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"],
               ImageSizeCache->{12., {3., 9.}}], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"],
                ImageSizeCache->{33., {0., 8.}}], "ButtonText",
               StripOnInput->False,
               AdjustmentBoxOptions->{BoxBaselineShift->-50}]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"], True->
          TagBox[GridBox[{
             {
              
              DynamicBox[FEPrivate`FrontEndResource[
               "MUnitExpressions", "Rerun"]], 
              StyleBox[
               
               DynamicBox[FEPrivate`FrontEndResource[
                "MUnitStrings", "Rerun-Label"]], "ButtonText",
               StripOnInput->False,
               LineColor->RGBColor[0.9059, 0.3451, 0.102],
               FrontFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               BackFaceColor->RGBColor[0.9059, 0.3451, 0.102],
               GraphicsColor->RGBColor[0.9059, 0.3451, 0.102],
               FontColor->RGBColor[0.9059, 0.3451, 0.102]]}
            },
            AutoDelete->False,
            
            GridBoxAlignment->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Center}}},
            
            GridBoxItemSize->{
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
           "Grid"]}, Dynamic[
           CurrentValue["MouseOver"]],
          FrameMargins->0,
          ImageSize->Automatic],
         DynamicBox[
          FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]],
         TooltipDelay->0.5],
        Annotation[#, 
         Dynamic[
          RawBoxes[
           FEPrivate`FrontEndResource["MUnitStrings", "Rerun-Tooltip"]]], 
         "Tooltip"]& ],
       Appearance->FEPrivate`FrontEndResource[
        "MUnitExpressions", "ButtonAppearances"],
       ButtonFunction:>MUnit`testRerun[],
       Evaluator->Automatic,
       FrameMargins->{{10, 10}, {0, 0}},
       ImageSize->Automatic,
       Method->"Queued"]}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  ImageSize->Full]], "BottomCell",
 CellID->356737066,ExpressionUUID->"b6ecfdc9-469a-4a29-92b5-788c96ef2c6e"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{681, 711},
WindowMargins->{{49, Automatic}, {1, Automatic}},
WindowTitle->"TestSuite.nb",
DockedCells->{
  Cell[
   BoxData[
    PanelBox[
     PaneBox[
      TagBox[
       GridBox[{{
          StyleBox[
           DynamicBox[
            FEPrivate`FrontEndResource[
            "MUnitStrings", "TestingNotebook-Title"], 
            ImageSizeCache -> {100., {3., 9.}}], StripOnInput -> False, 
           FontSize -> 12, FontColor -> GrayLevel[0.4]], "\[SpanFromLeft]", 
          "\[SpanFromLeft]", "\[SpanFromLeft]", "\[SpanFromLeft]", 
          "\[SpanFromLeft]"}, {
          ButtonBox[
           TagBox[
            TooltipBox[
             PaneSelectorBox[{False -> PaneBox[
                 TagBox[
                  GridBox[{{
                    DynamicBox[
                    FEPrivate`FrontEndResource["MUnitExpressions", "New"], 
                    ImageSizeCache -> {11., {4., 8.}}], 
                    StyleBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource["MUnitStrings", "New-Label"], 
                    ImageSizeCache -> {26., {0., 9.}}], "ButtonText", 
                    StripOnInput -> False]}}, AutoDelete -> False, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}}, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{0.4}}, "Rows" -> {{Automatic}}}], "Grid"], 
                 ImageMargins -> {{Automatic, Automatic}, {4, Automatic}}], 
               True -> PaneBox[
                 TagBox[
                  GridBox[{{
                    DynamicBox[
                    FEPrivate`FrontEndResource["MUnitExpressions", "New"]], 
                    StyleBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource["MUnitStrings", "New-Label"]], 
                    "ButtonText", StripOnInput -> False, LineColor -> 
                    RGBColor[0.9059, 0.3451, 0.102], FrontFaceColor -> 
                    RGBColor[
                    0.9059, 0.3451, 0.102], $CellContext`BackFaceColor -> 
                    RGBColor[0.9059, 0.3451, 0.102], GraphicsColor -> 
                    RGBColor[0.9059, 0.3451, 0.102], FontColor -> 
                    RGBColor[0.9059, 0.3451, 0.102]]}}, AutoDelete -> False, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}}, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{0.4}}, "Rows" -> {{Automatic}}}], "Grid"], 
                 ImageMargins -> {{Automatic, Automatic}, {4, Automatic}}]}, 
              Dynamic[
               CurrentValue["MouseOver"]], FrameMargins -> 0, ImageSize -> 
              Automatic], 
             DynamicBox[
              FEPrivate`FrontEndResource["MUnitStrings", "New-Tooltip"]], 
             TooltipDelay -> 0.5], Annotation[#, 
             Dynamic[
              RawBoxes[
               FEPrivate`FrontEndResource["MUnitStrings", "New-Tooltip"]]], 
             "Tooltip"]& ], Appearance -> 
           FEPrivate`FrontEndResource[
            "MUnitExpressions", "ButtonAppearances"], ButtonFunction :> 
           Block[{$ContextPath}, Needs["MUnit`"]; MUnit`PaletteInsertTest[
               InputNotebook[]]], Evaluator -> Automatic, 
           FrameMargins -> {{10, 10}, {0, 0}}, ImageSize -> {Automatic, 28}, 
           Method -> "Queued"], 
          ButtonBox[
           TagBox[
            TooltipBox[
             PaneSelectorBox[{False -> PaneBox[
                 TagBox[
                  GridBox[{{
                    PaneBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitExpressions", "ConvertSelection"], 
                    ImageSizeCache -> {14., {4., 8.}}], 
                    ImageMargins -> {{
                    Automatic, Automatic}, {-1, Automatic}}], 
                    PaneBox[
                    StyleBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "ConvertSelectiontoTest-Label"], 
                    ImageSizeCache -> {99., {1., 9.}}], "ButtonText", 
                    StripOnInput -> False], 
                    ImageMargins -> {{
                    Automatic, Automatic}, {-1, Automatic}}]}}, AutoDelete -> 
                   False, GridBoxAlignment -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}}, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{0.4}}, "Rows" -> {{Automatic}}}], "Grid"], 
                 ImageMargins -> {{Automatic, Automatic}, {4, Automatic}}], 
               True -> PaneBox[
                 TagBox[
                  GridBox[{{
                    PaneBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitExpressions", "ConvertSelection"]], 
                    ImageMargins -> {{
                    Automatic, Automatic}, {-1, Automatic}}], 
                    PaneBox[
                    StyleBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "ConvertSelectiontoTest-Label"]], 
                    "ButtonText", StripOnInput -> False, LineColor -> 
                    RGBColor[0.9059, 0.3451, 0.102], FrontFaceColor -> 
                    RGBColor[
                    0.9059, 0.3451, 0.102], $CellContext`BackFaceColor -> 
                    RGBColor[0.9059, 0.3451, 0.102], GraphicsColor -> 
                    RGBColor[0.9059, 0.3451, 0.102], FontColor -> 
                    RGBColor[0.9059, 0.3451, 0.102]], 
                    ImageMargins -> {{
                    Automatic, Automatic}, {-1, Automatic}}]}}, AutoDelete -> 
                   False, GridBoxAlignment -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}}, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{0.4}}, "Rows" -> {{Automatic}}}], "Grid"], 
                 ImageMargins -> {{Automatic, Automatic}, {4, Automatic}}]}, 
              Dynamic[
               CurrentValue["MouseOver"]], FrameMargins -> 0, ImageSize -> 
              Automatic], 
             DynamicBox[
              FEPrivate`FrontEndResource[
              "MUnitStrings", "ConvertSelectiontoTest-Tooltip"]], 
             TooltipDelay -> 0.5], Annotation[#, 
             Dynamic[
              RawBoxes[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "ConvertSelectiontoTest-Tooltip"]]], 
             "Tooltip"]& ], Appearance -> 
           FEPrivate`FrontEndResource[
            "MUnitExpressions", "ButtonAppearances"], ButtonFunction :> 
           Block[{$ContextPath}, Needs["MUnit`"]; MUnit`buttonConvertCellGroup[
               InputNotebook[]]], Evaluator -> Automatic, 
           FrameMargins -> {{10, 10}, {0, 0}}, ImageSize -> {Automatic, 28}, 
           Method -> "Queued"], 
          ButtonBox[
           TagBox[
            TooltipBox[
             PaneSelectorBox[{False -> PaneBox[
                 TagBox[
                  GridBox[{{
                    DynamicBox[
                    FEPrivate`FrontEndResource["MUnitExpressions", "Run"], 
                    ImageSizeCache -> {9., {4., 8.}}], 
                    StyleBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource["MUnitStrings", "Run-Label"], 
                    ImageSizeCache -> {22., {0., 9.}}], "ButtonText", 
                    StripOnInput -> False]}}, AutoDelete -> False, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}}, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{0.3}}, "Rows" -> {{Automatic}}}], "Grid"], 
                 ImageMargins -> {{Automatic, Automatic}, {4, Automatic}}], 
               True -> PaneBox[
                 TagBox[
                  GridBox[{{
                    DynamicBox[
                    FEPrivate`FrontEndResource["MUnitExpressions", "Run"]], 
                    StyleBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource["MUnitStrings", "Run-Label"]], 
                    "ButtonText", StripOnInput -> False, LineColor -> 
                    RGBColor[0.9059, 0.3451, 0.102], FrontFaceColor -> 
                    RGBColor[
                    0.9059, 0.3451, 0.102], $CellContext`BackFaceColor -> 
                    RGBColor[0.9059, 0.3451, 0.102], GraphicsColor -> 
                    RGBColor[0.9059, 0.3451, 0.102], FontColor -> 
                    RGBColor[0.9059, 0.3451, 0.102]]}}, AutoDelete -> False, 
                   GridBoxAlignment -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}}, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "Columns" -> {{0.3}}, "Rows" -> {{Automatic}}}], "Grid"], 
                 ImageMargins -> {{Automatic, Automatic}, {4, Automatic}}]}, 
              Dynamic[
               CurrentValue["MouseOver"]], FrameMargins -> 0, ImageSize -> 
              Automatic], 
             DynamicBox[
              FEPrivate`FrontEndResource["MUnitStrings", "Run-Tooltip"]], 
             TooltipDelay -> 0.5], Annotation[#, 
             Dynamic[
              RawBoxes[
               FEPrivate`FrontEndResource["MUnitStrings", "Run-Tooltip"]]], 
             "Tooltip"]& ], Appearance -> 
           FEPrivate`FrontEndResource[
            "MUnitExpressions", "ButtonAppearances"], ButtonFunction :> 
           Block[{$ContextPath}, Needs["MUnit`"]; MUnit`PaletteRun[
               InputNotebook[]]], Evaluator -> Automatic, 
           FrameMargins -> {{10, 10}, {0, 0}}, ImageSize -> {Automatic, 28}, 
           Method -> "Queued"], 
          ActionMenuBox[
           ButtonBox[
            PaneSelectorBox[{False -> StyleBox[
                TagBox[
                 GridBox[{{
                    DynamicBox[
                    FEPrivate`FrontEndResource["MUnitStrings", "More-Label"], 
                    ImageSizeCache -> {30., {0., 9.}}], 
                    "\"\[FilledDownTriangle]\""}}, AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{0.5}}, "Rows" -> {{Automatic}}}], "Grid"], 
                "ButtonText", StripOnInput -> False], True -> StyleBox[
                TagBox[
                 GridBox[{{
                    DynamicBox[
                    FEPrivate`FrontEndResource["MUnitStrings", "More-Label"]],
                     "\"\[FilledDownTriangle]\""}}, AutoDelete -> False, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {
                   "Columns" -> {{0.5}}, "Rows" -> {{Automatic}}}], "Grid"], 
                "ButtonText", StripOnInput -> False, LineColor -> 
                RGBColor[0.9059, 0.3451, 0.102], FrontFaceColor -> 
                RGBColor[0.9059, 0.3451, 0.102], $CellContext`BackFaceColor -> 
                RGBColor[0.9059, 0.3451, 0.102], GraphicsColor -> 
                RGBColor[0.9059, 0.3451, 0.102], FontColor -> 
                RGBColor[0.9059, 0.3451, 0.102]]}, 
             Dynamic[
              CurrentValue["MouseOver"]], FrameMargins -> 0, ImageSize -> 
             Automatic], Appearance -> 
            FEPrivate`FrontEndResource[
             "MUnitExpressions", "ButtonAppearances"], ButtonFunction :> {}, 
            ContentPadding -> False, Evaluator -> None, 
            FrameMargins -> {{10, 10}, {0, 0}}, ImageSize -> {Automatic, 28}, 
            Method -> "Preemptive"], {TagBox[
              GridBox[{{
                 PaneBox[
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitExpressions", "AssignTestIDs"]], 
                  ImageMargins -> {{Automatic, Automatic}, {2, Automatic}}], 
                 DynamicBox[
                  FEPrivate`FrontEndResource[
                  "MUnitStrings", "AssignTestIDs-Label"]]}}, AutoDelete -> 
               False, GridBoxAlignment -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Center}}}, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
              "Grid"] :> Block[{$ContextPath}, Needs["MUnit`"]; 
              MUnit`PaletteAddTestIDs[
                InputNotebook[]]], TagBox[
              GridBox[{{
                 PaneBox[
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitExpressions", "SaveAsDotwlt"]], 
                  ImageMargins -> {{Automatic, Automatic}, {2, Automatic}}], 
                 DynamicBox[
                  FEPrivate`FrontEndResource[
                  "MUnitStrings", "SaveAsDotwlt-Label"]]}}, AutoDelete -> 
               False, GridBoxAlignment -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Center}}}, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
              "Grid"] :> Block[{$ContextPath}, Needs["MUnit`"]; 
              MUnit`PaletteSaveAs[
                InputNotebook[]]], TagBox[
              GridBox[{{
                 PaneBox[
                  DynamicBox[
                   FEPrivate`FrontEndResource["MUnitExpressions", "Help"]], 
                  ImageMargins -> {{Automatic, Automatic}, {3, Automatic}}], 
                 DynamicBox[
                  FEPrivate`FrontEndResource["MUnitStrings", "Help-Label"]]}},
                AutoDelete -> False, 
               GridBoxAlignment -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Center}}}, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
              "Grid"] :> SystemOpen[
             "paclet:tutorial/UsingTheTestingFramework"]}, Appearance -> None,
            Method -> "Queued"], 
          ItemBox["\"\"", ItemSize -> Fit, StripOnInput -> False], 
          PaneSelectorBox[{True -> ButtonBox[
              TagBox[
               TooltipBox[
                PaneSelectorBox[{False -> TagBox[
                    GridBox[{{
                    PaneBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitExpressions", "ClearTestResults-on"], 
                    ImageSizeCache -> {9., {4., 8.}}], 
                    ImageMargins -> {{Automatic, Automatic}, {2, Automatic}}], 
                    StyleBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "ClearTestResults-Label"], 
                    ImageSizeCache -> {96., {1., 9.}}], "ButtonText", 
                    StripOnInput -> False]}}, AutoDelete -> False, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.4}}, "Rows" -> {{Automatic}}}], "Grid"], 
                  True -> TagBox[
                    GridBox[{{
                    PaneBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitExpressions", "ClearTestResults-on"]], 
                    ImageMargins -> {{Automatic, Automatic}, {2, Automatic}}], 
                    StyleBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "ClearTestResults-Label"]], "ButtonText", 
                    StripOnInput -> False, LineColor -> 
                    RGBColor[0.9059, 0.3451, 0.102], FrontFaceColor -> 
                    RGBColor[
                    0.9059, 0.3451, 0.102], $CellContext`BackFaceColor -> 
                    RGBColor[0.9059, 0.3451, 0.102], GraphicsColor -> 
                    RGBColor[0.9059, 0.3451, 0.102], FontColor -> 
                    RGBColor[0.9059, 0.3451, 0.102]]}}, AutoDelete -> False, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Center}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.4}}, "Rows" -> {{Automatic}}}], "Grid"]}, 
                 Dynamic[
                  CurrentValue["MouseOver"]], FrameMargins -> 0, ImageSize -> 
                 Automatic], 
                DynamicBox[
                 FEPrivate`FrontEndResource[
                 "MUnitStrings", "ClearTestResults-Tooltip"]], TooltipDelay -> 
                0.5], Annotation[#, 
                Dynamic[
                 RawBoxes[
                  FEPrivate`FrontEndResource[
                  "MUnitStrings", "ClearTestResults-Tooltip"]]], 
                "Tooltip"]& ], Appearance -> 
              FEPrivate`FrontEndResource[
               "MUnitExpressions", "ButtonAppearances"], ButtonFunction :> 
              Block[{$ContextPath}, Needs["MUnit`"]; 
                MUnit`clearTestResults[]], Enabled -> FEPrivate`SameQ[
                FrontEnd`CurrentValue[
                 FrontEnd`ButtonNotebook[], {TaggingRules, "$testsRun"}, 
                 False], True], Evaluator -> Automatic, 
              FrameMargins -> {{10, 10}, {0, 0}}, 
              ImageSize -> {Automatic, 28}, Method -> "Queued"], False -> 
            ButtonBox[
              TagBox[
               GridBox[{{
                  PaneBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitExpressions", "ClearTestResults-off"], 
                    ImageSizeCache -> {9., {4., 8.}}], 
                   ImageMargins -> {{Automatic, Automatic}, {2, Automatic}}], 
                  
                  StyleBox[
                   DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "ClearTestResults-Label"], 
                    ImageSizeCache -> {96., {1., 9.}}], "ButtonText", 
                   StripOnInput -> False, LineColor -> GrayLevel[0.7], 
                   FrontFaceColor -> 
                   GrayLevel[0.7], $CellContext`BackFaceColor -> 
                   GrayLevel[0.7], GraphicsColor -> GrayLevel[0.7], FontColor -> 
                   GrayLevel[0.7]]}}, AutoDelete -> False, 
                GridBoxAlignment -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Center}}}, 
                GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                GridBoxSpacings -> {
                 "Columns" -> {{0.4}}, "Rows" -> {{Automatic}}}], "Grid"], 
              Appearance -> 
              FEPrivate`FrontEndResource[
               "MUnitExpressions", "ButtonAppearances"], ButtonFunction :> {},
               Enabled -> FEPrivate`SameQ[
                FrontEnd`CurrentValue[
                 FrontEnd`ButtonNotebook[], {TaggingRules, "$testsRun"}, 
                 False], True], Evaluator -> None, 
              FrameMargins -> {{10, 10}, {0, 0}}, 
              ImageSize -> {Automatic, 28}, Method -> "Preemptive"]}, 
           FrontEnd`CurrentValue[
            FrontEnd`ButtonNotebook[], {TaggingRules, "$testsRun"}, False], 
           ImageSize -> All]}}, AutoDelete -> False, 
        BaseStyle -> {
         "DialogStyle", Bold, FontColor -> 
          RGBColor[
           0.33333333333333337`, 0.33333333333333337`, 0.33333333333333337`]},
         GridBoxAlignment -> {"Columns" -> {{Left}}}, 
        GridBoxDividers -> {"Columns" -> {{False}}}, 
        GridBoxItemSize -> {
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
        GridBoxSpacings -> {"Columns" -> {{Automatic}}, "Rows" -> {{1}}}], 
       "Grid"], ImageMargins -> {{5, 5}, {Automatic, Automatic}}], Appearance -> 
     FEPrivate`FrontEndResource["MUnitExpressions", "StaticToolbarNinePatch"],
      FrameMargins -> {{26, 12}, {8, 12}}, ImageMargins -> -1]], "DockedCell",
    CellFrameMargins -> 0, ShowCellTags -> False, CellTags -> 
   "MUnitStaticToolbar"], 
  Cell[
   BoxData[
    PaneBox[
     TagBox[
      GridBox[{{
         TagBox[
          GridBox[{{
             StyleBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "MUnitStrings", "TotalTestsRun-Label"]], 11, 
              RGBColor[0.34902, 0.34902, 0.34902], StripOnInput -> False], 
             FrameBox[
              StyleBox["\"88\"", 11, Bold, 
               GrayLevel[1], StripOnInput -> False], Background -> 
              GrayLevel[0.55], FrameStyle -> GrayLevel[0.55], 
              FrameMargins -> {{8, 8}, {0, 0}}, StripOnInput -> False], 
             StyleBox[
              DynamicBox[
               FEPrivate`FrontEndResource["MUnitStrings", "Successes-Label"]],
               11, 
              RGBColor[0.34902, 0.34902, 0.34902], StripOnInput -> False], 
             FrameBox[
              StyleBox["\"88\"", 11, Bold, 
               GrayLevel[1], StripOnInput -> False], Background -> 
              RGBColor[0.380392, 0.603922, 0.384314], FrameStyle -> 
              RGBColor[0.380392, 0.603922, 0.384314], 
              FrameMargins -> {{8, 8}, {0, 0}}, StripOnInput -> False], 
             TagBox[
              GridBox[{{
                 StyleBox[
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "Failures-Label"]], 11, 
                  RGBColor[0.34902, 0.34902, 0.34902], StripOnInput -> False], 
                 PaneBox[
                  StyleBox[
                   TagBox[
                    GridBox[{{
                    StyleBox["\"(\"", 8, StripOnInput -> False], 
                    StyleBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "WrongResults-Label"]], 10, StripOnInput -> 
                    False], 
                    StyleBox["\")\"", 8, StripOnInput -> False]}}, AutoDelete -> 
                    False, GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"], 
                   RGBColor[0.521569, 0.521569, 0.521569], StripOnInput -> 
                   False], 
                  ImageMargins -> {{
                    Automatic, Automatic}, {-0.3, Automatic}}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Center}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "ColumnsIndexed" -> {2 -> 0.3}, "Rows" -> {{Automatic}}}], 
              "Grid"], 
             FrameBox[
              StyleBox["\"0\"", 11, Bold, 
               GrayLevel[1], StripOnInput -> False], Background -> 
              RGBColor[0.74902, 0.403922, 0.4], FrameStyle -> 
              RGBColor[0.74902, 0.403922, 0.4], 
              FrameMargins -> {{8, 8}, {0, 0}}, StripOnInput -> False]}, {
            "\"\"", "\"\"", 
             StyleBox[
              DynamicBox[
               FEPrivate`FrontEndResource["MUnitStrings", "Errors-Label"]], 
              11, 
              RGBColor[0.34902, 0.34902, 0.34902], StripOnInput -> False], 
             FrameBox[
              StyleBox["\"0\"", 11, Bold, 
               GrayLevel[1], StripOnInput -> False], Background -> 
              RGBColor[0.945, 0.81, 0.314], FrameStyle -> 
              RGBColor[0.945, 0.81, 0.314], FrameMargins -> {{8, 8}, {0, 0}}, 
              StripOnInput -> False], 
             TagBox[
              GridBox[{{
                 StyleBox[
                  DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitStrings", "Failures-Label"]], 11, 
                  RGBColor[0.34902, 0.34902, 0.34902], StripOnInput -> False], 
                 PaneBox[
                  StyleBox[
                   TagBox[
                    GridBox[{{
                    StyleBox["\"(\"", 8, StripOnInput -> False], 
                    StyleBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "Messages-Label"]], 10, StripOnInput -> 
                    False], 
                    StyleBox["\")\"", 8, StripOnInput -> False]}}, AutoDelete -> 
                    False, GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"], 
                   RGBColor[0.521569, 0.521569, 0.521569], StripOnInput -> 
                   False], 
                  ImageMargins -> {{
                    Automatic, Automatic}, {-0.3, Automatic}}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Center}}}, AutoDelete -> 
               False, GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {
                "ColumnsIndexed" -> {2 -> 0.3}, "Rows" -> {{Automatic}}}], 
              "Grid"], 
             FrameBox[
              StyleBox["\"0\"", 11, Bold, 
               GrayLevel[1], StripOnInput -> False], Background -> 
              RGBColor[0.921569, 0.678431, 0.337255], FrameStyle -> 
              RGBColor[0.921569, 0.678431, 0.337255], 
              FrameMargins -> {{8, 8}, {0, 0}}, StripOnInput -> False]}}, 
           GridBoxAlignment -> {"Columns" -> {{Left}}}, AutoDelete -> False, 
           GridBoxItemSize -> {
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
           GridBoxSpacings -> {
            "ColumnsIndexed" -> {
              2 -> 0.7, 3 -> 1.5, 4 -> 0.7, 5 -> 1.5, 6 -> 0.7}, 
             "Rows" -> {{0.5}}}, 
           BaseStyle -> {FontFamily -> "Helvetica", FontSize -> 12}], "Grid"], 
         ItemBox["", ItemSize -> Fit, StripOnInput -> False], 
         DynamicModuleBox[{
          MUnit`Palette`Private`$barDisplayType$$ = "InSequence", 
           MUnit`Palette`Private`resultColorBar$$}, 
          TagBox[
           GridBox[{{
              DynamicBox[
               ToBoxes[
                MUnit`Palette`Private`resultColorBar$$[CompressedData["
1:eJwBbQGS/iFib1JuAQAAAFgAAAC02Iwi7Te0WiyuYFSvPVs638rVIzo1Wzem
pClWJwabGuqIb0Pttn9djloXO0E9+gVRvnMvZ2cIE7SV8TRxhcd+A1ozOzDr
B1QPh1kvfPulOMFmV3BkaKwTfmgjG1/D507O0l92/ji+TREYi1ffaR8ns5ge
aLJkulbjfLsQeHDBUorAyEoMyM5/3szUNSrbZwzeBipTaDSjeN00UmoODxhG
j6r7bs0rsxGKoXIKkCc/ee2wvRVhWqMqWtfzSOmzLBuIIuwIPsX7RLeom0Yf
7AY/S6k3Qdt5Bz/byVwrf9HbSrnCaWC3zwIdTel/CeD240NBr2ECguhQcG9u
ShzEw5lDMBDYaLiY/DwDyz1hSUV3fBr9Xz3b4YNChQwlBRUpkgTubFRB51y0
GP+vMTtjvZkSeBHYWjmvoB/8gSVj2BZ1S7Re5DKIqJsXNXCDYgjzay7Lnpo6
cuTwKHiFNzu+4pttUwqiuw==
                 "], {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 
                 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 
                 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 
                 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 
                 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 
                 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 
                 86, 87, 88}, {}, {}, {}, 250, 12], StandardForm]], 
              ActionMenuBox[
               PaneSelectorBox[{False -> DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitExpressions", "Arrow-Off"]], True -> DynamicBox[
                   FEPrivate`FrontEndResource[
                   "MUnitExpressions", "Arrow-Hover"]]}, 
                Dynamic[
                 CurrentValue["MouseOver"]], ImageSize -> Automatic, 
                FrameMargins -> 0], {DynamicBox[
                  ToBoxes[
                   (If[MUnit`Palette`Private`$barDisplayType$$ === "ByStatus", 
                    Grid[{{"\[Checkmark]", #}}], 
                    Grid[{{
                    Spacer[10], #}}]]& )[
                    Dynamic[
                    RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "ByStatus-Label"]]]], StandardForm]] :> (
                 MUnit`Palette`Private`$barDisplayType$$ = "ByStatus"), 
                DynamicBox[
                  ToBoxes[
                   (If[
                   MUnit`Palette`Private`$barDisplayType$$ === "InSequence", 
                    Grid[{{"\[Checkmark]", #}}], 
                    Grid[{{
                    Spacer[10], #}}]]& )[
                    Dynamic[
                    RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "BySequence-Label"]]]], 
                   StandardForm]] :> (MUnit`Palette`Private`$barDisplayType$$ = 
                 "InSequence")}, Method -> "Queued", Appearance -> None, 
               ContentPadding -> False]}, {
              PaneSelectorBox[{True -> TagBox[
                  GridBox[{{
                    ButtonBox[
                    TagBox[
                    TooltipBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitExpressions", "PreviousFailure"]], 
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "PreviousFailure-Tooltip"]], TooltipDelay -> 
                    0.35], Annotation[#, 
                    Dynamic[
                    RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "PreviousFailure-Tooltip"]]], 
                    "Tooltip"]& ], ButtonFunction :> 
                    Block[{$ContextPath}, Needs["MUnit`"]; 
                    MUnit`findFailedTest[
                    ButtonNotebook[], "Previous"]], Appearance -> 
                    FEPrivate`FrontEndResource[
                    "MUnitExpressions", "ButtonAppearances"], 
                    ImageSize -> {Automatic, 28}, 
                    FrameMargins -> {{7, 7}, {0, 0}}, Enabled -> 
                    FEPrivate`SameQ[
                    FrontEnd`CurrentValue[
                    FrontEnd`ButtonNotebook[], {
                    TaggingRules, "$someTestsFailed"}, False], True], Method -> 
                    "Queued", Evaluator -> Automatic], 
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "Failure-Label"]], ButtonFunction :> {}, 
                    Evaluator -> None, ImageSize -> {Automatic, 28}, Enabled -> 
                    False, Appearance -> 
                    FEPrivate`FrontEndResource[
                    "MUnitExpressions", "DefaultButtonAppearance"], 
                    FrameMargins -> {{7, 7}, {0, 0}}, Method -> "Preemptive"], 
                    ButtonBox[
                    TagBox[
                    TooltipBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitExpressions", "NextFailure"]], 
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "NextFailure-Tooltip"]], TooltipDelay -> 
                    0.35], Annotation[#, 
                    Dynamic[
                    RawBoxes[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "NextFailure-Tooltip"]]], "Tooltip"]& ], 
                    ButtonFunction :> 
                    Block[{$ContextPath}, Needs["MUnit`"]; 
                    MUnit`findFailedTest[
                    ButtonNotebook[], "Next"]], Appearance -> 
                    FEPrivate`FrontEndResource[
                    "MUnitExpressions", "ButtonAppearances"], 
                    ImageSize -> {Automatic, 28}, 
                    FrameMargins -> {{7, 7}, {0, 0}}, Enabled -> 
                    FEPrivate`SameQ[
                    FrontEnd`CurrentValue[
                    FrontEnd`ButtonNotebook[], {
                    TaggingRules, "$someTestsFailed"}, False], True], Method -> 
                    "Queued", Evaluator -> Automatic]}}, AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "ColumnsIndexed" -> {1 -> 0, 2 -> -0.1, 3 -> -0.1}, 
                    "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    "DialogStyle", Bold, FontColor -> 
                    RGBColor[
                    0.33333333333333337`, 0.33333333333333337`, 
                    0.33333333333333337`]}], "Grid"], False -> TagBox[
                  GridBox[{{
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitExpressions", "PreviousFailureDeactivated"]], 
                    ButtonFunction :> {}, Evaluator -> None, Appearance -> 
                    FEPrivate`FrontEndResource[
                    "MUnitExpressions", "ButtonAppearances"], 
                    ImageSize -> {Automatic, 28}, 
                    FrameMargins -> {{7, 7}, {0, 0}}, Enabled -> 
                    FEPrivate`SameQ[
                    FrontEnd`CurrentValue[
                    FrontEnd`ButtonNotebook[], {
                    TaggingRules, "$someTestsFailed"}, False], True], Method -> 
                    "Preemptive"], 
                    ButtonBox[
                    StyleBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitStrings", "Failure-Label"]], 
                    GrayLevel[0.7], StripOnInput -> False], 
                    ButtonFunction :> {}, Evaluator -> None, 
                    ImageSize -> {Automatic, 28}, Enabled -> False, 
                    Appearance -> 
                    FEPrivate`FrontEndResource[
                    "MUnitExpressions", "DefaultButtonAppearance"], 
                    FrameMargins -> {{7, 7}, {0, 0}}, Method -> "Preemptive"], 
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "MUnitExpressions", "NextFailureDeactivated"]], 
                    ButtonFunction :> {}, Evaluator -> None, Appearance -> 
                    FEPrivate`FrontEndResource[
                    "MUnitExpressions", "ButtonAppearances"], 
                    ImageSize -> {Automatic, 28}, 
                    FrameMargins -> {{7, 7}, {0, 0}}, Enabled -> 
                    FEPrivate`SameQ[
                    FrontEnd`CurrentValue[
                    FrontEnd`ButtonNotebook[], {
                    TaggingRules, "$someTestsFailed"}, False], True], Method -> 
                    "Preemptive"]}}, AutoDelete -> False, 
                   GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                   GridBoxSpacings -> {
                    "ColumnsIndexed" -> {1 -> 0, 2 -> -0.1, 3 -> -0.1}, 
                    "Rows" -> {{Automatic}}}, 
                   BaseStyle -> {
                    "DialogStyle", Bold, FontColor -> 
                    RGBColor[
                    0.33333333333333337`, 0.33333333333333337`, 
                    0.33333333333333337`]}], "Grid"]}, 
               FrontEnd`CurrentValue[
                FrontEnd`ButtonNotebook[], {TaggingRules, "$someTestsFailed"},
                 False], ImageSize -> All], "\"\""}}, 
            GridBoxAlignment -> {
             "Columns" -> {Right, Left}, "Rows" -> {{Automatic}}}, AutoDelete -> 
            False, GridBoxItemSize -> {
             "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
            GridBoxSpacings -> {
             "ColumnsIndexed" -> {2 -> 0.5}, "RowsIndexed" -> {2 -> 0.75}}], 
           "Grid"], 
          Initialization :> (MUnit`Palette`Private`resultColorBar$$[
             Pattern[MUnit`Palette`Private`cellids1$, 
              Blank[]], 
             Pattern[MUnit`Palette`Private`successPositions1$, 
              Blank[]], 
             Pattern[MUnit`Palette`Private`errorPositions1$, 
              Blank[]], 
             Pattern[MUnit`Palette`Private`failurePositions1$, 
              Blank[]], 
             Pattern[MUnit`Palette`Private`messagePositions1$, 
              Blank[]], 
             Pattern[MUnit`Palette`Private`barlength1$, 
              Blank[]], 
             Pattern[MUnit`Palette`Private`barheight1$, 
              Blank[]]] := 
           Module[{MUnit`Palette`Private`successPositions2$ = Map[{#, 
                 Extract[MUnit`Palette`Private`cellids1$, {#}]}& , 
                MUnit`Palette`Private`successPositions1$], 
              MUnit`Palette`Private`errorPositions2$ = Map[{#, 
                 Extract[MUnit`Palette`Private`cellids1$, {#}]}& , 
                MUnit`Palette`Private`errorPositions1$], 
              MUnit`Palette`Private`failurePositions2$ = Map[{#, 
                 Extract[MUnit`Palette`Private`cellids1$, {#}]}& , 
                MUnit`Palette`Private`failurePositions1$], 
              MUnit`Palette`Private`messagePositions2$ = Map[{#, 
                 Extract[MUnit`Palette`Private`cellids1$, {#}]}& , 
                MUnit`Palette`Private`messagePositions1$], 
              MUnit`Palette`Private`sp$, MUnit`Palette`Private`testnumber$, 
              MUnit`Palette`Private`buttonlength$}, 
             MUnit`Palette`Private`sp$ = Cases[
                ReplaceAll[
                 (If[MUnit`Palette`Private`$barDisplayType$$ === "ByStatus", 
                  SplitBy[#, Last], 
                  SplitBy[
                   SortBy[#, Part[#, 1, 1]& ], Last]]& )[
                  Join[
                   Map[{#, "s"}& , MUnit`Palette`Private`successPositions2$], 
                   
                   Map[{#, "e"}& , MUnit`Palette`Private`errorPositions2$], 
                   Map[{#, "f"}& , MUnit`Palette`Private`failurePositions2$], 
                   
                   
                   Map[{#, "m"}& , 
                    MUnit`Palette`Private`messagePositions2$]]], {{
                    Pattern[MUnit`Palette`Private`a, 
                    Blank[]], 
                    Pattern[MUnit`Palette`Private`n, 
                    Blank[]]}, 
                   Pattern[MUnit`Palette`Private`s, 
                    Blank[String]]} :> {{
                   MUnit`Palette`Private`a, MUnit`Palette`Private`s}, 
                   MUnit`Palette`Private`n}], {{
                  Blank[], 
                  Blank[String]}, 
                 Blank[]}, {1, Infinity}]; 
             MUnit`Palette`Private`testnumber$ = 
              Length[MUnit`Palette`Private`successPositions1$] + 
               Length[MUnit`Palette`Private`errorPositions1$] + 
               Length[MUnit`Palette`Private`failurePositions1$] + 
               Length[MUnit`Palette`Private`messagePositions1$]; 
             If[MUnit`Palette`Private`testnumber$ > 0, 
               MUnit`Palette`Private`buttonlength$ = 
               MUnit`Palette`Private`barlength1$/N[
                MUnit`Palette`Private`testnumber$]]; 
             If[MUnit`Palette`Private`testnumber$ > 50, 
               Graphics[
                Raster[{
                  ReplaceAll[MUnit`Palette`Private`sp$, {{
                    Pattern[MUnit`Palette`Private`n, 
                    Blank[]], 
                    Pattern[MUnit`Palette`Private`a, 
                    Blank[String]]}, 
                    Pattern[MUnit`Palette`Private`b, 
                    Blank[]]} :> 
                   Switch[MUnit`Palette`Private`a, "s", {0.380392, 0.603922, 
                    0.384314}, "e", {0.945, 0.81, 0.314}, "m", {0.921569, 
                    0.678431, 0.337255}, "f", {0.74902, 0.403922, 0.4}]]}, {{
                  0, 0}, {
                  MUnit`Palette`Private`barlength1$ + 50, 
                   MUnit`Palette`Private`barheight1$}}], 
                ImageSize -> {
                 MUnit`Palette`Private`barlength1$ + 50, 
                  MUnit`Palette`Private`barheight1$}, 
                PlotRange -> {{0, MUnit`Palette`Private`barlength1$ + 50}, {
                  0, MUnit`Palette`Private`barheight1$}}], 
               Grid[
                If[MUnit`Palette`Private`testnumber$ === 0, {{}}, {
                  Riffle[
                   ReplaceAll[MUnit`Palette`Private`sp$, {{
                    Pattern[MUnit`Palette`Private`n$, 
                    Blank[]], 
                    Pattern[MUnit`Palette`Private`a$, 
                    Blank[String]]}, 
                    Pattern[MUnit`Palette`Private`b$, 
                    Blank[]]} :> Button[
                    Tooltip[
                    Graphics[{
                    Switch[MUnit`Palette`Private`a$, "s", 
                    RGBColor[0.380392, 0.603922, 0.384314], "e", 
                    RGBColor[0.945, 0.81, 0.314], "m", 
                    RGBColor[0.921569, 0.678431, 0.337255], "f", 
                    RGBColor[0.74902, 0.403922, 0.4]], 
                    
                    Rectangle[{0, 0}, {
                    MUnit`Palette`Private`buttonlength$, 
                    MUnit`Palette`Private`barheight1$}]}, ImagePadding -> 0, 
                    PlotRangePadding -> 0, 
                    ImageSize -> {
                    MUnit`Palette`Private`buttonlength$, 
                    MUnit`Palette`Private`barheight1$}], 
                    StringJoin["Test ", 
                    ToString[MUnit`Palette`Private`n$]], TooltipDelay -> 
                    0.35], NotebookFind[
                    ButtonNotebook[], MUnit`Palette`Private`b$, All, CellID]; 
                    SelectionMove[
                    ButtonNotebook[], All, CellGroup], Appearance -> None, 
                    Method -> "Queued"]], 
                   Graphics[{White, 
                    
                    Rectangle[{0, 0}, {
                    1, MUnit`Palette`Private`barheight1$}]}, ImagePadding -> 
                    0, PlotRangePadding -> 0, 
                    ImageSize -> {1, MUnit`Palette`Private`barheight1$}]]}], 
                Alignment -> {Automatic, Center}, Spacings -> {0, 0}]]]), 
          DynamicModuleValues :> {}]}}, 
       GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Right}}}, 
       GridBoxItemSize -> {
        "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Grid"], 
     FrameMargins -> {{26, 12}, {Automatic, Automatic}}, ImageSize -> Full, 
     BaseStyle -> {Background -> RGBColor[0.827, 0.827, 0.827]}]], Background -> 
   RGBColor[0.827, 0.827, 0.827], "DockedCell", CellTags -> 
   "MUnitResultsCell"]},
TaggingRules->{"$testsRun" -> True, "$someTestsFailed" -> False},
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->FrontEnd`FileName[{"MUnit"}, "MUnit.nb", CharacterEncoding -> 
  "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[606, 23, 171, 2, 68, "Section",ExpressionUUID->"2ece5787-1c98-49c3-af72-87ee1160e5aa",
 CellID->139676244],
Cell[780, 27, 499, 10, 55, "Input",ExpressionUUID->"f78a615a-c66e-44a7-95e5-c627ef3bf2e8",
 CellID->1608041939]
}, Open  ]],
Cell[CellGroupData[{
Cell[1316, 42, 250, 3, 68, "Section",ExpressionUUID->"3e7deeaf-d666-4f63-8d99-e2a377827b67",
 CellID->1552110904],
Cell[CellGroupData[{
Cell[1591, 49, 176, 2, 54, "Subsection",ExpressionUUID->"ab42a3d8-0eca-47ba-ba7b-e42ff20da355",
 CellID->1170065825],
Cell[1770, 53, 262, 3, 35, "Text",ExpressionUUID->"a1a98d7d-9680-48c7-8c80-a9704c85d82f",
 CellID->1280424743],
Cell[2035, 58, 6650, 138, 745, "Input",ExpressionUUID->"c3626026-dd9f-47af-b7c7-c0fcd9ba93ee",
 CellID->1771228406],
Cell[8688, 198, 279, 4, 35, "Text",ExpressionUUID->"88ae39df-ffe2-472e-839f-70e2f27858b8",
 CellID->617504928],
Cell[CellGroupData[{
Cell[8992, 206, 2565, 45, 136, "Input",ExpressionUUID->"cf668524-82aa-4f2b-b67c-ed90114e332d",
 CellID->1449591737],
Cell[11560, 253, 2632, 78, 116, "Output",ExpressionUUID->"9ad236ca-e22f-428e-b9b0-4e5655510741",
 CellID->593268746]
}, Open  ]],
Cell[CellGroupData[{
Cell[14229, 336, 1202, 27, 94, "Input",ExpressionUUID->"bf698411-8407-4880-ab17-4536821e0f9f",
 CellID->168493274],
Cell[15434, 365, 2916, 71, 134, "Output",ExpressionUUID->"41ae329b-e6b3-448e-9341-e3234ada850d",
 CellID->301241001]
}, Open  ]],
Cell[18365, 439, 377, 6, 35, "Text",ExpressionUUID->"308ac7ac-eafd-400f-8076-c53ae2252dfd",
 CellID->1243308122],
Cell[CellGroupData[{
Cell[18767, 449, 3063, 76, 220, "Input",ExpressionUUID->"07833039-69c6-4257-b744-75db67945d48",
 CellID->1263721144],
Cell[CellGroupData[{
Cell[21855, 529, 2244, 54, 90, "Print",ExpressionUUID->"e07ccda9-d76e-4eed-82fe-2a934d421bae",
 CellID->1338547828],
Cell[24102, 585, 1606, 38, 82, "Print",ExpressionUUID->"500da608-f9b6-4b3a-8db0-196acf5d9b59",
 CellID->2082142871],
Cell[25711, 625, 1528, 36, 74, "Print",ExpressionUUID->"1f68596b-8e0d-4867-a65b-9c89ae1cd9ef",
 CellID->1329205032],
Cell[27242, 663, 1815, 42, 108, "Print",ExpressionUUID->"a6b5114d-e883-429f-b2e5-947997ec7633",
 CellID->1824076730],
Cell[29060, 707, 1579, 38, 108, "Print",ExpressionUUID->"bc36a636-cc1b-4614-9d83-5191922bbd6e",
 CellID->1928540185],
Cell[30642, 747, 1564, 38, 108, "Print",ExpressionUUID->"ac0b80a7-5f9d-449a-8b00-f205aca39995",
 CellID->1004205124]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[32255, 791, 226, 4, 30, "Input",ExpressionUUID->"f4563a53-ce0d-41ff-b56e-d09e365eaffa",
 CellID->885220549],
Cell[32484, 797, 1437, 40, 112, "Output",ExpressionUUID->"2aac9252-9ced-4588-a9e2-e6eddfaa79f4",
 CellID->601537295]
}, Open  ]],
Cell[CellGroupData[{
Cell[33958, 842, 201, 3, 30, "Input",ExpressionUUID->"6c4cc0a0-3948-4400-9d6a-fc8c4a83993c",
 CellID->1340322197],
Cell[34162, 847, 651, 14, 34, "Output",ExpressionUUID->"6af53751-7b5b-482d-9928-a76f2bb6a06f",
 CellID->1831790636]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[34862, 867, 220, 3, 54, "Subsection",ExpressionUUID->"54f286a2-a4b5-4e3c-8c06-1a069bdc43d2",
 CellID->1980104077],
Cell[CellGroupData[{
Cell[35107, 874, 505, 9, 49, "VerificationTest",ExpressionUUID->"0791b85e-5b13-4e41-a244-5d387dbe4800",
 CellID->2042467455],
Cell[35615, 885, 1460, 35, 126, "ExpectedOutput",ExpressionUUID->"4affd5b9-6103-4508-9a70-400b86f18119",
 CellID->29485513],
Cell[37078, 922, 11788, 262, 26, "TestSuccess",ExpressionUUID->"5747743e-6260-40c3-9561-ca770ddd6e0c",
 CellID->579655860],
Cell[48869, 1186, 11087, 278, 43, "BottomCell",ExpressionUUID->"6c59a323-9046-4b5b-a47d-76c6f2843200",
 CellID->1290216228]
}, Open  ]],
Cell[CellGroupData[{
Cell[59993, 1469, 232, 4, 49, "VerificationTest",ExpressionUUID->"5a7bc859-6632-4268-8f95-3251c181c44d",
 CellID->83003778],
Cell[60228, 1475, 673, 13, 126, "ExpectedOutput",ExpressionUUID->"d112b320-c557-4649-966e-d0ac77b917bd",
 CellID->170346871],
Cell[60904, 1490, 10907, 250, 26, "TestSuccess",ExpressionUUID->"f2f55624-aa92-43e9-b4d0-4e026009fa16",
 CellID->1521760237],
Cell[71814, 1742, 11087, 278, 43, "BottomCell",ExpressionUUID->"acb236a0-ae70-4f56-a46e-d436e3518efc",
 CellID->1841551136]
}, Open  ]],
Cell[CellGroupData[{
Cell[82938, 2025, 232, 4, 49, "VerificationTest",ExpressionUUID->"da2312ec-723d-46a2-a7d2-9f611bb142dc",
 CellID->1287863259],
Cell[83173, 2031, 1119, 28, 168, "ExpectedOutput",ExpressionUUID->"49b41064-6923-4893-a696-854c7a92b5ff",
 CellID->436570979],
Cell[84295, 2061, 11350, 255, 26, "TestSuccess",ExpressionUUID->"f7cb2c9a-b4f9-48ed-8dc4-d454646599b1",
 CellID->1415622188],
Cell[95648, 2318, 11086, 278, 43, "BottomCell",ExpressionUUID->"7b0db278-dac5-4e04-9aea-c25498c85cd6",
 CellID->390788603]
}, Open  ]],
Cell[CellGroupData[{
Cell[106771, 2601, 231, 4, 49, "VerificationTest",ExpressionUUID->"6c8fb4e8-0139-44cb-95d6-c33512124575",
 CellID->115560600],
Cell[107005, 2607, 734, 13, 168, "ExpectedOutput",ExpressionUUID->"791f0c5b-7af7-451e-b6aa-258fdb0eef32",
 CellID->1067147800],
Cell[107742, 2622, 11186, 254, 26, "TestSuccess",ExpressionUUID->"7c01f9d3-4753-4f96-b4f5-21b6689070f0",
 CellID->979058095],
Cell[118931, 2878, 11087, 278, 43, "BottomCell",ExpressionUUID->"05a4fb3a-7df8-4012-93d0-b14a2ab89c7f",
 CellID->1009699351]
}, Open  ]],
Cell[CellGroupData[{
Cell[130055, 3161, 230, 4, 49, "VerificationTest",ExpressionUUID->"926cafef-4200-4d16-acf5-e84d9b3bb7be",
 CellID->795695155],
Cell[130288, 3167, 466, 9, 41, "ExpectedOutput",ExpressionUUID->"da37f63d-06e0-461b-9043-6e8f0c587559",
 CellID->1391789614],
Cell[130757, 3178, 10798, 248, 26, "TestSuccess",ExpressionUUID->"1b44b5a6-aa24-460e-8dce-c7a16261d13f",
 CellID->601213663],
Cell[141558, 3428, 11086, 278, 43, "BottomCell",ExpressionUUID->"888f7696-4746-4b2a-aa84-1237f5063b3a",
 CellID->687474906]
}, Open  ]],
Cell[CellGroupData[{
Cell[152681, 3711, 231, 4, 49, "VerificationTest",ExpressionUUID->"c045e6cd-2d28-45fd-ad58-3788f40d39c4",
 CellID->249536683],
Cell[152915, 3717, 439, 9, 41, "ExpectedOutput",ExpressionUUID->"308d9f81-07ac-4027-b8a2-26921e8d165a",
 CellID->244679970],
Cell[153357, 3728, 11182, 254, 26, "TestSuccess",ExpressionUUID->"df512f0f-25fe-4c3b-ab2d-39d01ba83e64",
 CellID->928724282],
Cell[164542, 3984, 11087, 278, 43, "BottomCell",ExpressionUUID->"bbe2194b-8607-4acc-86e8-071a97e94958",
 CellID->1157861178]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[175690, 4269, 302, 4, 54, "Section",ExpressionUUID->"79e7c282-6bf5-45c6-a4b7-08ede19907c6",
 CellID->1535036385],
Cell[CellGroupData[{
Cell[176017, 4277, 176, 2, 54, "Subsection",ExpressionUUID->"88a29ac9-4e27-4501-b94d-208a8e7533a3",
 CellID->1779275761],
Cell[176196, 4281, 282, 3, 35, "Text",ExpressionUUID->"456df054-98f9-4dfc-b5ef-45bdf6b8f95a",
 CellID->577930652],
Cell[176481, 4286, 4616, 116, 829, "Input",ExpressionUUID->"fdfed571-47d7-4092-aa34-959adedb7698",
 CellID->59658601],
Cell[181100, 4404, 280, 4, 35, "Text",ExpressionUUID->"f4fb8173-33a6-491e-835d-a11ddd298929",
 CellID->1426397155],
Cell[CellGroupData[{
Cell[181405, 4412, 2265, 41, 136, "Input",ExpressionUUID->"ce787ae6-e68c-471b-b2ef-de36916e00d4",
 CellID->1097032624],
Cell[183673, 4455, 3005, 67, 66, "Output",ExpressionUUID->"e58d6762-e26d-44d2-9eff-efbb417c0a8c",
 CellID->1823493179]
}, Open  ]],
Cell[CellGroupData[{
Cell[186715, 4527, 1300, 28, 94, "Input",ExpressionUUID->"03036d77-0d5f-4f59-b8d9-0ab702ca9392",
 CellID->1893766508],
Cell[188018, 4557, 2942, 66, 114, "Output",ExpressionUUID->"2937ef0f-5286-4a78-ad30-a26026097d70",
 CellID->710733116]
}, Open  ]],
Cell[190975, 4626, 377, 6, 35, "Text",ExpressionUUID->"b87087ba-cf91-4560-81c7-bd19c6044a5a",
 CellID->1550328013],
Cell[CellGroupData[{
Cell[191377, 4636, 3062, 76, 220, "Input",ExpressionUUID->"5192c78b-e2c5-4a94-b1c4-b8f80264ffdd",
 CellID->943825440],
Cell[CellGroupData[{
Cell[194464, 4716, 2292, 51, 46, "Print",ExpressionUUID->"89095902-84ca-40ba-b8d2-3ff505d2c050",
 CellID->987435998],
Cell[196759, 4769, 2114, 46, 42, "Print",ExpressionUUID->"39bf46f1-4f67-48e9-8546-eb628b8233d8",
 CellID->83194370],
Cell[198876, 4817, 1725, 36, 25, "Print",ExpressionUUID->"eeb12eb6-44dd-475d-a434-805f991baf7e",
 CellID->235922393],
Cell[200604, 4855, 1905, 43, 90, "Print",ExpressionUUID->"f1ab79af-5220-4a8a-8d3e-cc26dacd9dcc",
 CellID->892846789],
Cell[202512, 4900, 1826, 40, 82, "Print",ExpressionUUID->"6bc20185-fde5-4f14-8a19-a43de290c902",
 CellID->1607741134],
Cell[204341, 4942, 1781, 39, 74, "Print",ExpressionUUID->"5fc46900-4d77-442a-8959-788af07b0401",
 CellID->1665992584]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[206183, 4988, 220, 3, 54, "Subsection",ExpressionUUID->"44571f5a-60e3-48be-927e-9a4b0e41b365",
 CellID->1685561734],
Cell[CellGroupData[{
Cell[206428, 4995, 455, 8, 49, "VerificationTest",ExpressionUUID->"f5bab334-906f-48b0-a49c-ee7bcd62d2a8",
 CellID->579825297],
Cell[206886, 5005, 1137, 26, 70, "ExpectedOutput",ExpressionUUID->"132e31c7-506e-4be7-9ea8-9a3270e04e3d",
 CellID->539182276],
Cell[208026, 5033, 11511, 258, 26, "TestSuccess",ExpressionUUID->"e838d47a-82ff-4942-a4bf-ed4f67971055",
 CellID->1445569702],
Cell[219540, 5293, 11087, 278, 43, "BottomCell",ExpressionUUID->"619f7b9d-37f9-459d-b42f-f3add73b8480",
 CellID->1207483003]
}, Open  ]],
Cell[CellGroupData[{
Cell[230664, 5576, 231, 4, 49, "VerificationTest",ExpressionUUID->"e46f3256-0d82-49b7-9717-fa40e235ea27",
 CellID->1652478564],
Cell[230898, 5582, 767, 19, 68, "ExpectedOutput",ExpressionUUID->"1ff6c5cf-14dd-48d8-837d-5a6f1b2e65dd",
 CellID->632170420],
Cell[231668, 5603, 11050, 252, 26, "TestSuccess",ExpressionUUID->"0aa2856a-7121-47e5-81da-605e179fe6aa",
 CellID->446367271],
Cell[242721, 5857, 11086, 278, 43, "BottomCell",ExpressionUUID->"46c6cfe1-6669-488d-8b7e-534b7405837f",
 CellID->934344726]
}, Open  ]],
Cell[CellGroupData[{
Cell[253844, 6140, 232, 4, 49, "VerificationTest",ExpressionUUID->"7ae92245-a60b-464b-b81d-2e38caf9a1ed",
 CellID->1632785011],
Cell[254079, 6146, 746, 14, 126, "ExpectedOutput",ExpressionUUID->"0fea616d-ab90-457f-af71-1c8043f7cf38",
 CellID->295221976],
Cell[254828, 6162, 10989, 250, 26, "TestSuccess",ExpressionUUID->"e7e95278-ab93-404e-9d18-36638ced1954",
 CellID->1131383018],
Cell[265820, 6414, 11087, 278, 43, "BottomCell",ExpressionUUID->"55a903b5-920a-4074-85e0-9f5f40c40393",
 CellID->1334172988]
}, Open  ]],
Cell[CellGroupData[{
Cell[276944, 6697, 231, 4, 49, "VerificationTest",ExpressionUUID->"d1348039-fa9f-4000-9506-99ee54269f25",
 CellID->993902552],
Cell[277178, 6703, 694, 13, 126, "ExpectedOutput",ExpressionUUID->"24bde1a5-8813-4f47-8c3e-b4b3b2777e42",
 CellID->2097280005],
Cell[277875, 6718, 10891, 248, 26, "TestSuccess",ExpressionUUID->"9768f71d-37fe-4d01-9784-5b01cc044287",
 CellID->1568650989],
Cell[288769, 6968, 11087, 278, 43, "BottomCell",ExpressionUUID->"e6672f2a-f804-4108-b40d-b3210ab4007c",
 CellID->1807921551]
}, Open  ]],
Cell[CellGroupData[{
Cell[299893, 7251, 230, 4, 49, "VerificationTest",ExpressionUUID->"b461d11c-735a-49d8-9508-f896e3cbdc1f",
 CellID->482876599],
Cell[300126, 7257, 441, 9, 41, "ExpectedOutput",ExpressionUUID->"0e366c46-69c9-4fc2-a4c7-83e0cfc01f20",
 CellID->256108941],
Cell[300570, 7268, 10181, 239, 26, "TestSuccess",ExpressionUUID->"5d996416-f070-4213-8a05-ccf53fd3296e",
 CellID->991386254],
Cell[310754, 7509, 11087, 278, 43, "BottomCell",ExpressionUUID->"c9877885-b1b7-4d0f-9ae2-06b0f917cc08",
 CellID->2050637552]
}, Open  ]],
Cell[CellGroupData[{
Cell[321878, 7792, 232, 4, 49, "VerificationTest",ExpressionUUID->"64620c11-d6f1-4fb8-bf33-e615025ca6b7",
 CellID->2128865875],
Cell[322113, 7798, 387, 8, 41, "ExpectedOutput",ExpressionUUID->"2a60b7e5-fbe4-41fd-a943-71794fab3361",
 CellID->618603978],
Cell[322503, 7808, 10800, 248, 26, "TestSuccess",ExpressionUUID->"1322b026-dec1-47c0-ad69-526d1527b171",
 CellID->100285761],
Cell[333306, 8058, 11087, 278, 43, "BottomCell",ExpressionUUID->"b9d9a0cd-059e-4c3d-b3b2-e59b8ead13fc",
 CellID->1875605879]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[344454, 8343, 351, 5, 54, "Section",ExpressionUUID->"8a7e7995-31ec-40d8-bc1d-34ed4eea1436",
 CellID->337961518],
Cell[CellGroupData[{
Cell[344830, 8352, 176, 2, 54, "Subsection",ExpressionUUID->"065958ba-cd09-4a35-9f13-7d90f573d30f",
 CellID->1963009032],
Cell[345009, 8356, 355, 4, 35, "Text",ExpressionUUID->"3501198d-02f5-4ee5-bd64-7a1d2111aee7",
 CellID->556431460],
Cell[345367, 8362, 4521, 109, 661, "Input",ExpressionUUID->"c4d9d8e0-9dc5-474e-8d80-cb475776cbea",
 CellID->1156856462],
Cell[349891, 8473, 280, 4, 35, "Text",ExpressionUUID->"cf5555bf-1763-416c-9f05-fdd0cc2ef937",
 CellID->1724112944],
Cell[CellGroupData[{
Cell[350196, 8481, 2142, 39, 136, "Input",ExpressionUUID->"2e105646-9196-4a03-a81f-f7b32874db42",
 CellID->1169400837],
Cell[352341, 8522, 3039, 73, 78, "Output",ExpressionUUID->"a2b4c311-f9b3-4f12-926d-afd4473d5e94",
 CellID->395554040]
}, Open  ]],
Cell[CellGroupData[{
Cell[355417, 8600, 1206, 27, 94, "Input",ExpressionUUID->"80b3a806-6969-4734-bde0-60a6a0987da5",
 CellID->1184868260],
Cell[356626, 8629, 2579, 59, 60, "Output",ExpressionUUID->"f8a4b8f5-b915-432e-a3c5-6d04e887ab7a",
 CellID->1614862815]
}, Open  ]],
Cell[359220, 8691, 376, 6, 35, "Text",ExpressionUUID->"982154be-f21a-4e24-acc2-8113efb57b46",
 CellID->346694090],
Cell[CellGroupData[{
Cell[359621, 8701, 3063, 76, 220, "Input",ExpressionUUID->"faa4bdfd-089b-4706-a967-ecc50792eaf0",
 CellID->764436319],
Cell[CellGroupData[{
Cell[362709, 8781, 1738, 41, 52, "Print",ExpressionUUID->"d10fe061-b97c-4d60-bfcb-a9c22dc506d3",
 CellID->1101000919],
Cell[364450, 8824, 1801, 43, 52, "Print",ExpressionUUID->"588f4a84-6ee3-4154-adee-ea27d70fc0fd",
 CellID->1803343081],
Cell[366254, 8869, 1384, 32, 40, "Print",ExpressionUUID->"94ebd210-e04b-4e49-9d54-efe020247b9a",
 CellID->1350452256],
Cell[367641, 8903, 1604, 38, 34, "Print",ExpressionUUID->"ca1ddb40-a5bb-46c8-af76-9e7d9a98b4e6",
 CellID->296401449],
Cell[369248, 8943, 1635, 38, 34, "Print",ExpressionUUID->"21f94789-2397-4ba7-a5cf-ffdc991def39",
 CellID->1604575950],
Cell[370886, 8983, 1354, 31, 25, "Print",ExpressionUUID->"b288bcf5-c21a-4709-b2b2-7ea0e71fc7f3",
 CellID->8352624]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[372301, 9021, 170, 2, 54, "Subsection",ExpressionUUID->"0b3f267e-d304-4426-89b0-5e92d8bffbf9",
 CellID->807677320],
Cell[CellGroupData[{
Cell[372496, 9027, 456, 8, 49, "VerificationTest",ExpressionUUID->"986cba12-62c5-4cee-950d-50dcb55b6745",
 CellID->243180492],
Cell[372955, 9037, 1272, 26, 120, "ExpectedOutput",ExpressionUUID->"ea8c1a94-61dd-4808-a6a0-c45d57f56dbb",
 CellID->1032740090],
Cell[374230, 9065, 11788, 262, 26, "TestSuccess",ExpressionUUID->"3a1de372-1af3-4887-bb7e-53220dfd2d16",
 CellID->796114513],
Cell[386021, 9329, 11087, 278, 43, "BottomCell",ExpressionUUID->"e7320cf5-5f0f-48a7-a645-ec042480d550",
 CellID->1473499181]
}, Open  ]],
Cell[CellGroupData[{
Cell[397145, 9612, 259, 5, 49, "VerificationTest",ExpressionUUID->"f0ce0e58-52af-4a91-a311-f164f6743198",
 CellID->793943167],
Cell[397407, 9619, 1018, 23, 120, "ExpectedOutput",ExpressionUUID->"46c8a590-9e7a-4095-abfd-fe8081bd21d0",
 CellID->942693365],
Cell[398428, 9644, 11808, 262, 26, "TestSuccess",ExpressionUUID->"da2fd692-84f0-41c6-a405-f0777ebdd8a3",
 CellID->319317863],
Cell[410239, 9908, 11086, 278, 43, "BottomCell",ExpressionUUID->"74bac65f-2154-427a-917e-f63c545f8052",
 CellID->213689588]
}, Open  ]],
Cell[CellGroupData[{
Cell[421362, 10191, 233, 4, 49, "VerificationTest",ExpressionUUID->"10200a55-b1c2-49cd-a929-934a912d075b",
 CellID->1656134055],
Cell[421598, 10197, 634, 16, 61, "ExpectedOutput",ExpressionUUID->"17869727-2f0a-4cf1-ac75-4fb1b1c61d36",
 CellID->525944430],
Cell[422235, 10215, 10892, 250, 26, "TestSuccess",ExpressionUUID->"6feaf8e1-a973-4c4a-b2ab-964259e1e129",
 CellID->888247732],
Cell[433130, 10467, 11087, 278, 43, "BottomCell",ExpressionUUID->"73fd4021-e9a1-43e3-beb8-2b2887a39951",
 CellID->1620801427]
}, Open  ]],
Cell[CellGroupData[{
Cell[444254, 10750, 232, 4, 49, "VerificationTest",ExpressionUUID->"268483ea-b266-496d-8f85-370d4b254cae",
 CellID->986467167],
Cell[444489, 10756, 664, 16, 61, "ExpectedOutput",ExpressionUUID->"7d1f0534-6577-45f0-8909-b7df02087b3d",
 CellID->832557140],
Cell[445156, 10774, 10793, 248, 26, "TestSuccess",ExpressionUUID->"01df7196-0407-4d9e-b821-0174413f8951",
 CellID->2127005041],
Cell[455952, 11024, 11087, 278, 43, "BottomCell",ExpressionUUID->"e01c06da-862d-4e14-a0ec-77019a97fd09",
 CellID->1560936125]
}, Open  ]],
Cell[CellGroupData[{
Cell[467076, 11307, 229, 4, 49, "VerificationTest",ExpressionUUID->"2b59b02a-909e-4c49-9978-dc8b1b84186d",
 CellID->41001967],
Cell[467308, 11313, 417, 9, 41, "ExpectedOutput",ExpressionUUID->"78224247-9509-4a3d-978c-c03c0b980695",
 CellID->316979101],
Cell[467728, 11324, 10652, 246, 26, "TestSuccess",ExpressionUUID->"aedb21f3-904f-4908-9814-8e89af0a2527",
 CellID->993221123],
Cell[478383, 11572, 11086, 278, 43, "BottomCell",ExpressionUUID->"c9e728f1-8711-4dc3-a657-fb714c045c1d",
 CellID->677026130]
}, Open  ]],
Cell[CellGroupData[{
Cell[489506, 11855, 235, 4, 49, "VerificationTest",ExpressionUUID->"f09a933f-9e3b-4ebd-9390-b4b00828e5ad",
 CellID->1221270702],
Cell[489744, 11861, 388, 8, 41, "ExpectedOutput",ExpressionUUID->"3cbb3d8a-593f-4d44-8286-2300d7c34d06",
 CellID->1856114390],
Cell[490135, 11871, 10307, 240, 26, "TestSuccess",ExpressionUUID->"4f640f3f-9ba1-4480-8028-805a26933e9d",
 CellID->1409805104],
Cell[500445, 12113, 11087, 278, 43, "BottomCell",ExpressionUUID->"34f33b04-5bee-48f6-b3c8-8343131e4b91",
 CellID->1407305577]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[511593, 12398, 397, 5, 54, "Section",ExpressionUUID->"73583882-eaeb-44c5-80ca-351ef5f46205",
 CellID->463695855],
Cell[CellGroupData[{
Cell[512015, 12407, 176, 2, 54, "Subsection",ExpressionUUID->"91760916-3696-437d-82e3-fd3e9f13ca1e",
 CellID->1719208034],
Cell[512194, 12411, 400, 5, 35, "Text",ExpressionUUID->"60a2751e-8ce9-49cf-8ef0-4d9d71c61bb5",
 CellID->35029913],
Cell[512597, 12418, 3765, 90, 598, "Input",ExpressionUUID->"a77a8b0f-d451-4889-8878-97822df72689",
 CellID->132546791],
Cell[516365, 12510, 279, 4, 35, "Text",ExpressionUUID->"96eef973-ae4e-4c05-b81a-9dcdcbab25cb",
 CellID->931588782],
Cell[CellGroupData[{
Cell[516669, 12518, 2147, 39, 136, "Input",ExpressionUUID->"a8b3f72a-c41c-499b-85c4-a41282d890bb",
 CellID->1061798999],
Cell[518819, 12559, 2629, 60, 74, "Output",ExpressionUUID->"19847368-8d31-4693-af0e-573845131ae5",
 CellID->199944581]
}, Open  ]],
Cell[CellGroupData[{
Cell[521485, 12624, 1207, 27, 94, "Input",ExpressionUUID->"67498dd3-7708-457d-8a49-12b76158b7cc",
 CellID->1677373674],
Cell[522695, 12653, 2075, 44, 62, "Output",ExpressionUUID->"bddfdb66-f90f-4ad3-a554-0530adab07a1",
 CellID->1804148959]
}, Open  ]],
Cell[524785, 12700, 377, 6, 35, "Text",ExpressionUUID->"8f345be9-ee88-42d4-84d6-67a45c200444",
 CellID->1697172553],
Cell[CellGroupData[{
Cell[525187, 12710, 3064, 76, 220, "Input",ExpressionUUID->"230f82eb-1f21-444e-a14f-39daa0e99d3e",
 CellID->1501298817],
Cell[CellGroupData[{
Cell[528276, 12790, 1630, 38, 52, "Print",ExpressionUUID->"31b6736c-17ed-418a-ba64-ea0a18658057",
 CellID->2009941920],
Cell[529909, 12830, 1466, 33, 48, "Print",ExpressionUUID->"aa977b27-a8f3-484d-8b3e-7655fad3378e",
 CellID->1176082130],
Cell[531378, 12865, 1358, 31, 40, "Print",ExpressionUUID->"e1ce394e-9466-45c9-8f08-6716753505fd",
 CellID->972871922],
Cell[532739, 12898, 1374, 31, 40, "Print",ExpressionUUID->"a18b9dbf-7e4a-4d2d-9f0f-5c971ebe43f3",
 CellID->117904796],
Cell[534116, 12931, 1359, 31, 40, "Print",ExpressionUUID->"d2eb88a5-e64d-441a-8023-999cb9ec3633",
 CellID->1645983838],
Cell[535478, 12964, 1358, 31, 40, "Print",ExpressionUUID->"09750b18-e696-4667-a904-d394ad777892",
 CellID->166024612]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[536897, 13002, 168, 2, 54, "Subsection",ExpressionUUID->"b9988d23-a6a4-4119-9e6b-077f1da10edb",
 CellID->197977086],
Cell[CellGroupData[{
Cell[537090, 13008, 457, 8, 49, "VerificationTest",ExpressionUUID->"68152773-6370-46a9-9577-5d604805972e",
 CellID->1659838998],
Cell[537550, 13018, 1262, 25, 121, "ExpectedOutput",ExpressionUUID->"955d2db3-5d56-45cb-a1e5-f560fe0857e6",
 CellID->2035920903],
Cell[538815, 13045, 11212, 254, 26, "TestSuccess",ExpressionUUID->"7cc285e7-2137-4b8e-beb0-afccc3e237bd",
 CellID->794396431],
Cell[550030, 13301, 11086, 278, 43, "BottomCell",ExpressionUUID->"244dcb19-1fd3-40a4-b31f-8f26fac67cce",
 CellID->514982418]
}, Open  ]],
Cell[CellGroupData[{
Cell[561153, 13584, 259, 5, 49, "VerificationTest",ExpressionUUID->"9e8df048-ac93-41b8-b4f9-ea0a09c93d94",
 CellID->240770846],
Cell[561415, 13591, 824, 15, 117, "ExpectedOutput",ExpressionUUID->"a395add5-a1e3-4760-9bdd-b705b09ad153",
 CellID->1935570068],
Cell[562242, 13608, 10634, 246, 26, "TestSuccess",ExpressionUUID->"ffafdfe7-5320-42cf-9f59-d3bc389298ff",
 CellID->950401916],
Cell[572879, 13856, 11086, 278, 43, "BottomCell",ExpressionUUID->"a737cf81-f33d-4d0d-a317-a7d8d7ec4d3b",
 CellID->421635826]
}, Open  ]],
Cell[CellGroupData[{
Cell[584002, 14139, 232, 4, 49, "VerificationTest",ExpressionUUID->"d9c56077-40ec-44e7-9736-41832ad0057b",
 CellID->308626153],
Cell[584237, 14145, 657, 13, 84, "ExpectedOutput",ExpressionUUID->"8fe2d2e1-24ef-4642-9b36-5cc5c865e471",
 CellID->903885071],
Cell[584897, 14160, 10653, 246, 26, "TestSuccess",ExpressionUUID->"86d37889-bf1a-432a-aaa8-77e4c95d290e",
 CellID->1884776129],
Cell[595553, 14408, 11087, 278, 43, "BottomCell",ExpressionUUID->"fd83d6bf-3bed-4d79-b2b2-e189040d2666",
 CellID->2048606853]
}, Open  ]],
Cell[CellGroupData[{
Cell[606677, 14691, 231, 4, 49, "VerificationTest",ExpressionUUID->"ad176e77-5a07-472e-bc73-de67f297f9cd",
 CellID->29019256],
Cell[606911, 14697, 629, 11, 84, "ExpectedOutput",ExpressionUUID->"1e840152-f2e7-4333-aee6-82d572391ef3",
 CellID->1636965545],
Cell[607543, 14710, 10426, 244, 26, "TestSuccess",ExpressionUUID->"7848846b-1227-4ae6-925d-ca04146d938f",
 CellID->330066020],
Cell[617972, 14956, 11086, 278, 43, "BottomCell",ExpressionUUID->"cd2c70c5-76f1-4715-a4d0-78a5b96a313e",
 CellID->469337939]
}, Open  ]],
Cell[CellGroupData[{
Cell[629095, 15239, 231, 4, 49, "VerificationTest",ExpressionUUID->"370c08f6-470c-4b6c-87c1-79a4b4876924",
 CellID->1806999093],
Cell[629329, 15245, 417, 9, 41, "ExpectedOutput",ExpressionUUID->"6a50089c-f51a-4de6-821e-78c2179708f9",
 CellID->242148617],
Cell[629749, 15256, 10426, 244, 26, "TestSuccess",ExpressionUUID->"9e5eda04-ae38-4570-99b6-e3ece0e51fe5",
 CellID->455305342],
Cell[640178, 15502, 11086, 278, 43, "BottomCell",ExpressionUUID->"e33af765-2ca9-4c67-976f-a799f636b684",
 CellID->832648733]
}, Open  ]],
Cell[CellGroupData[{
Cell[651301, 15785, 235, 4, 49, "VerificationTest",ExpressionUUID->"4d78c4e3-c3b9-4b20-8cf8-4d8ab02a44b5",
 CellID->1647391173],
Cell[651539, 15791, 387, 8, 41, "ExpectedOutput",ExpressionUUID->"363016a0-56bc-46a2-ab11-ad0cc6519d81",
 CellID->703811211],
Cell[651929, 15801, 10425, 244, 26, "TestSuccess",ExpressionUUID->"b27cb3b0-5987-4fec-a3bb-549c165fe2e5",
 CellID->1323811679],
Cell[662357, 16047, 11087, 278, 43, "BottomCell",ExpressionUUID->"080e885a-536b-4203-8f2f-775daa3198c4",
 CellID->1372306033]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[673505, 16332, 448, 6, 54, "Section",ExpressionUUID->"56d21efe-bb41-4cb4-89e2-80b7b95c8a15",
 CellID->1785023302],
Cell[CellGroupData[{
Cell[673978, 16342, 174, 2, 55, "Subsection",ExpressionUUID->"37f935b0-66e6-4fcb-b43b-57a900b97acf",
 CellID->62897900],
Cell[674155, 16346, 429, 6, 35, "Text",ExpressionUUID->"c87dff30-af1f-4984-b503-3626dcf8e477",
 CellID->2086613689],
Cell[674587, 16354, 3297, 76, 561, "Input",ExpressionUUID->"9b1d2b64-bdc9-40db-9a4b-48915892516f",
 CellID->603372099],
Cell[677887, 16432, 280, 4, 35, "Text",ExpressionUUID->"b9e499f3-fc0d-469a-9031-ce751f7fdd06",
 CellID->1198604992],
Cell[CellGroupData[{
Cell[678192, 16440, 2239, 41, 136, "Input",ExpressionUUID->"4ad85d0c-1bc8-4d28-bfa5-234448eafefc",
 CellID->405558399],
Cell[680434, 16483, 2711, 60, 80, "Output",ExpressionUUID->"4e4b0344-5c21-4b68-8e82-33ffac712baa",
 CellID->323165683]
}, Open  ]],
Cell[CellGroupData[{
Cell[683182, 16548, 1206, 27, 94, "Input",ExpressionUUID->"e769d23c-9292-4893-bae4-89e10670a9c3",
 CellID->1647858013],
Cell[684391, 16577, 2750, 66, 116, "Output",ExpressionUUID->"1285a025-fce1-4686-8d01-723da77aee77",
 CellID->2087221808]
}, Open  ]],
Cell[687156, 16646, 376, 6, 35, "Text",ExpressionUUID->"c5cc61b6-ff86-42be-9ac2-2965757b6dfa",
 CellID->722145470],
Cell[CellGroupData[{
Cell[687557, 16656, 2789, 66, 220, "Input",ExpressionUUID->"c086abee-b68a-461e-9773-8d74d48baba3",
 CellID->1668825093],
Cell[CellGroupData[{
Cell[690371, 16726, 1359, 35, 56, "Print",ExpressionUUID->"41ad8d64-eabe-4fc6-b289-8e233cde71b9",
 CellID->737638985],
Cell[691733, 16763, 1198, 30, 48, "Print",ExpressionUUID->"ea17eac7-4d17-47f4-b5b9-856a107354b8",
 CellID->75326764],
Cell[692934, 16795, 1106, 28, 40, "Print",ExpressionUUID->"2947e0a1-5835-4eca-9d04-f7b76f8e9526",
 CellID->1149054465],
Cell[694043, 16825, 1372, 37, 90, "Print",ExpressionUUID->"cb9dfd7b-4502-4cb7-9578-3f74e30a40c4",
 CellID->1985439431],
Cell[695418, 16864, 1233, 32, 90, "Print",ExpressionUUID->"8500658c-f3b4-465c-8943-36f9c16da56d",
 CellID->1679609731],
Cell[696654, 16898, 1143, 30, 74, "Print",ExpressionUUID->"7493b52e-bce9-4003-beed-1f8ce0387911",
 CellID->528209102]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[697846, 16934, 955, 24, 157, "Input",ExpressionUUID->"5576cc55-5315-4ff3-860b-3d3a7bdfe69b",
 CellID->1295314612],
Cell[CellGroupData[{
Cell[698826, 16962, 1304, 36, 90, "Print",ExpressionUUID->"1e9cd687-e4c4-460b-9b36-b785bfaf2884",
 CellID->362799389],
Cell[700133, 17000, 1166, 31, 90, "Print",ExpressionUUID->"7142c05e-c66c-4318-bba7-8b399bedf6a8",
 CellID->863257090],
Cell[701302, 17033, 1076, 29, 74, "Print",ExpressionUUID->"0d1eb3ca-e8dc-4f7b-8483-6f2d38e2748d",
 CellID->362392498]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[702439, 17069, 169, 2, 54, "Subsection",ExpressionUUID->"84b0f8cb-e02a-409d-9be6-2f359427f1dc",
 CellID->1806908231],
Cell[CellGroupData[{
Cell[702633, 17075, 455, 8, 49, "VerificationTest",ExpressionUUID->"eb2e96f7-19eb-4bb1-a4bf-56fad086f4f3",
 CellID->71676832],
Cell[703091, 17085, 1310, 26, 127, "ExpectedOutput",ExpressionUUID->"175490de-8827-4558-a562-6da5db3c6260",
 CellID->862007093],
Cell[704404, 17113, 11227, 254, 26, "TestSuccess",ExpressionUUID->"db7394d6-31b6-45cc-9443-213f9e105ce1",
 CellID->1985991374],
Cell[715634, 17369, 11086, 278, 43, "BottomCell",ExpressionUUID->"aafa0907-3755-479a-aafe-8757e8a95d7b",
 CellID->218697497]
}, Open  ]],
Cell[CellGroupData[{
Cell[726757, 17652, 259, 5, 49, "VerificationTest",ExpressionUUID->"76649db4-73f1-4e41-b765-f30c8b76dc81",
 CellID->339233762],
Cell[727019, 17659, 825, 15, 117, "ExpectedOutput",ExpressionUUID->"ee7f4c10-c568-4517-807e-8c5b51e75c37",
 CellID->994211324],
Cell[727847, 17676, 10631, 244, 26, "TestSuccess",ExpressionUUID->"066f9c2d-f210-490c-81a6-a93930152e14",
 CellID->1304312062],
Cell[738481, 17922, 11085, 278, 43, "BottomCell",ExpressionUUID->"393fc72e-546f-41ad-b527-6b5f5f3bf244",
 CellID->59757458]
}, Open  ]],
Cell[CellGroupData[{
Cell[749603, 18205, 233, 4, 49, "VerificationTest",ExpressionUUID->"02b304fb-2e6c-4e44-93cd-68fe1c6ef695",
 CellID->2010502978],
Cell[749839, 18211, 973, 24, 126, "ExpectedOutput",ExpressionUUID->"1821d0c4-3c32-4da5-a205-d42bcda0fa5c",
 CellID->1355423925],
Cell[750815, 18237, 11759, 262, 26, "TestSuccess",ExpressionUUID->"e45e987a-770d-4c13-abcf-4d8d9d513d8c",
 CellID->1468733457],
Cell[762577, 18501, 11087, 278, 43, "BottomCell",ExpressionUUID->"c0350e9a-f907-48ab-b2ea-fcac3847f2b2",
 CellID->1826173181]
}, Open  ]],
Cell[CellGroupData[{
Cell[773701, 18784, 232, 4, 49, "VerificationTest",ExpressionUUID->"ebe52bf4-0da8-4569-83f8-7a9074fc7915",
 CellID->463206704],
Cell[773936, 18790, 801, 15, 126, "ExpectedOutput",ExpressionUUID->"4afb4ad7-abaf-4515-a36d-9acc4be50287",
 CellID->1950835585],
Cell[774740, 18807, 10982, 250, 26, "TestSuccess",ExpressionUUID->"48e5f637-7e86-476e-b398-458c3b9bb028",
 CellID->656370143],
Cell[785725, 19059, 11087, 278, 43, "BottomCell",ExpressionUUID->"7808cad7-0f5c-47e0-b0be-5675f96beaf1",
 CellID->2136982409]
}, Open  ]],
Cell[CellGroupData[{
Cell[796849, 19342, 231, 4, 49, "VerificationTest",ExpressionUUID->"76b3e4d7-27b2-4403-b7de-4ee5b7c824f9",
 CellID->1713910284],
Cell[797083, 19348, 418, 9, 41, "ExpectedOutput",ExpressionUUID->"3136a4f4-5cd8-40e1-96a6-7180ce7a5973",
 CellID->1536895706],
Cell[797504, 19359, 10427, 244, 26, "TestSuccess",ExpressionUUID->"f3066f1f-47de-400d-b9ab-bacc2ee41887",
 CellID->1746835635],
Cell[807934, 19605, 11086, 278, 43, "BottomCell",ExpressionUUID->"ea4b795f-33be-4be8-be16-02c7f0afec42",
 CellID->817579308]
}, Open  ]],
Cell[CellGroupData[{
Cell[819057, 19888, 234, 4, 49, "VerificationTest",ExpressionUUID->"7f9c719c-aa63-4072-b540-ecf808cfd113",
 CellID->887622295],
Cell[819294, 19894, 387, 8, 41, "ExpectedOutput",ExpressionUUID->"71c984e0-f272-40b5-947f-60df84f2b2aa",
 CellID->852270963],
Cell[819684, 19904, 10801, 248, 26, "TestSuccess",ExpressionUUID->"1a1fa901-f502-4c3d-bbb1-b602900156bb",
 CellID->1455056050],
Cell[830488, 20154, 11087, 278, 43, "BottomCell",ExpressionUUID->"8ef07169-52ba-4b4c-839b-f5fbb20ed45c",
 CellID->1730743961]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[841636, 20439, 203, 3, 67, "Section",ExpressionUUID->"46187148-15b3-404a-9e01-00baac692e0a",
 CellID->451857424],
Cell[CellGroupData[{
Cell[841864, 20446, 176, 2, 54, "Subsection",ExpressionUUID->"dd9d5705-9ddc-411c-a5df-92a3664856d2",
 CellID->1875869356],
Cell[842043, 20450, 187, 2, 35, "Text",ExpressionUUID->"309e01b4-7d75-4cba-a33c-2aa9cef4e7b8",
 CellID->142666285],
Cell[842233, 20454, 2150, 54, 388, "Input",ExpressionUUID->"0ce74805-71cc-4c40-b1c6-35633b5821ab",
 CellID->397079176],
Cell[844386, 20510, 277, 4, 35, "Text",ExpressionUUID->"68df1e0f-e7cb-40a8-93bb-e2163c5a4efc",
 CellID->2068155801],
Cell[CellGroupData[{
Cell[844688, 20518, 2145, 39, 136, "Input",ExpressionUUID->"12f68d30-d998-4c89-9299-e697e5639067",
 CellID->1472217929],
Cell[846836, 20559, 2405, 53, 70, "Output",ExpressionUUID->"96ee793d-026f-4532-b012-5ef7846b9ab5",
 CellID->947753912]
}, Open  ]],
Cell[CellGroupData[{
Cell[849278, 20617, 1205, 27, 94, "Input",ExpressionUUID->"5317f8bc-29c8-4334-8350-c5329b8f7e91",
 CellID->97437691],
Cell[850486, 20646, 1965, 40, 46, "Output",ExpressionUUID->"6efb44e4-174c-4423-a53f-faed0947a940",
 CellID->1013789185]
}, Open  ]],
Cell[852466, 20689, 379, 6, 35, "Text",ExpressionUUID->"803335eb-e2ce-48e1-9210-39bfcf0a5ca1",
 CellID->1203125043],
Cell[CellGroupData[{
Cell[852870, 20699, 2291, 65, 220, "Input",ExpressionUUID->"ecd3e4ad-5904-465e-9124-79fdd630b9eb",
 CellID->1625490944],
Cell[CellGroupData[{
Cell[855186, 20768, 1129, 29, 48, "Print",ExpressionUUID->"75ef5450-1e81-4842-806a-3f462f818e96",
 CellID->619576997],
Cell[856318, 20799, 1076, 28, 48, "Print",ExpressionUUID->"f1828fc1-d591-4f74-8ca9-96d8dceed494",
 CellID->82384276],
Cell[857397, 20829, 1031, 27, 40, "Print",ExpressionUUID->"734e1e3a-542f-4968-bc56-5184e2d7ae90",
 CellID->1653058064],
Cell[858431, 20858, 1019, 26, 25, "Print",ExpressionUUID->"83ced470-b4bc-4df3-ae6e-f7b1cb9f448a",
 CellID->950940409],
Cell[859453, 20886, 1011, 26, 25, "Print",ExpressionUUID->"6edb56dc-fad1-4e9e-949c-d396f150c43a",
 CellID->882153089],
Cell[860467, 20914, 1010, 26, 25, "Print",ExpressionUUID->"2e68e59f-573b-4755-8e27-0b8e72f3ba45",
 CellID->119867935]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[861538, 20947, 171, 2, 54, "Subsection",ExpressionUUID->"818ede21-086f-461f-b6ab-18e02693a2e7",
 CellID->1491226901],
Cell[CellGroupData[{
Cell[861734, 20953, 456, 8, 49, "VerificationTest",ExpressionUUID->"ee7dfa62-251b-4a08-8d2b-e65c25474c5a",
 CellID->568706413],
Cell[862193, 20963, 855, 17, 84, "ExpectedOutput",ExpressionUUID->"6da55ee6-22a8-4ab8-8095-58f1a903fb20",
 CellID->1555578576],
Cell[863051, 20982, 10820, 248, 70, "TestSuccess",ExpressionUUID->"229230bd-9c0a-4868-94f7-1df7939bb31d",
 CellID->280722659],
Cell[873874, 21232, 11085, 278, 70, "BottomCell",ExpressionUUID->"63539d3f-1cf6-42ca-8d8e-dbfeb7823b03",
 CellID->84157354]
}, Open  ]],
Cell[CellGroupData[{
Cell[884996, 21515, 232, 4, 49, "VerificationTest",ExpressionUUID->"f3aa0ded-b66e-4ba0-ba9d-8eb6098210ff",
 CellID->828567318],
Cell[885231, 21521, 503, 10, 84, "ExpectedOutput",ExpressionUUID->"d42cd582-3106-4118-b4e4-2c98a21854f9",
 CellID->128945674],
Cell[885737, 21533, 10515, 244, 26, "TestSuccess",ExpressionUUID->"211e0e32-201c-488e-822a-4d24c9baa15f",
 CellID->1388408952],
Cell[896255, 21779, 11086, 278, 43, "BottomCell",ExpressionUUID->"f52807c6-0a5a-4b2b-aa87-f7452a875aca",
 CellID->431947962]
}, Open  ]],
Cell[CellGroupData[{
Cell[907378, 22062, 232, 4, 49, "VerificationTest",ExpressionUUID->"2b29f8e6-ef61-416d-a369-e1904dc76977",
 CellID->762042712],
Cell[907613, 22068, 311, 8, 41, "ExpectedOutput",ExpressionUUID->"d2ffdc76-3788-480e-a407-b5371da9f199",
 CellID->1905357201],
Cell[907927, 22078, 10307, 240, 26, "TestSuccess",ExpressionUUID->"018aa1fc-dcfc-4fcd-b8ed-75f0c66780ca",
 CellID->1254670474],
Cell[918237, 22320, 11087, 278, 43, "BottomCell",ExpressionUUID->"14a80396-946c-48e7-ad53-282ed7f9ed0c",
 CellID->1104726625]
}, Open  ]],
Cell[CellGroupData[{
Cell[929361, 22603, 232, 4, 49, "VerificationTest",ExpressionUUID->"2ecb5664-43ee-49d6-b964-ef49e30ffb55",
 CellID->874052351],
Cell[929596, 22609, 279, 6, 41, "ExpectedOutput",ExpressionUUID->"a0af1a9f-31c9-4b84-8c0f-5c246714af42",
 CellID->53518265],
Cell[929878, 22617, 10178, 239, 26, "TestSuccess",ExpressionUUID->"fde04b53-fa48-4878-b91f-5d42ac1e6180",
 CellID->2144258060],
Cell[940059, 22858, 11087, 278, 43, "BottomCell",ExpressionUUID->"19b7400c-dafa-4a81-b26f-a089000b8176",
 CellID->1622134113]
}, Open  ]],
Cell[CellGroupData[{
Cell[951183, 23141, 234, 4, 49, "VerificationTest",ExpressionUUID->"08515548-57ad-4a21-a53d-7faa42e47d9f",
 CellID->1194284115],
Cell[951420, 23147, 413, 9, 41, "ExpectedOutput",ExpressionUUID->"6752d434-63cb-4a80-82be-f26182fee20c",
 CellID->888736535],
Cell[951836, 23158, 10426, 244, 26, "TestSuccess",ExpressionUUID->"3cf8a044-09a0-4b40-aa02-12dade3d6f1e",
 CellID->903138526],
Cell[962265, 23404, 11086, 278, 43, "BottomCell",ExpressionUUID->"9bccffeb-a3b9-468c-9460-e89d705961d4",
 CellID->634789486]
}, Open  ]],
Cell[CellGroupData[{
Cell[973388, 23687, 232, 4, 49, "VerificationTest",ExpressionUUID->"85409f48-961a-489a-8e11-b7460147dd4c",
 CellID->620734353],
Cell[973623, 23693, 387, 8, 41, "ExpectedOutput",ExpressionUUID->"dab89008-23a0-4b7a-a852-ac6d5b6104b8",
 CellID->837014992],
Cell[974013, 23703, 10179, 239, 26, "TestSuccess",ExpressionUUID->"062c1d69-352b-47d8-89d9-b721217ddeb8",
 CellID->208132906],
Cell[984195, 23944, 11087, 278, 43, "BottomCell",ExpressionUUID->"d24ce924-92b7-4c9c-a0f4-c1b13d728c26",
 CellID->1986373826]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[995343, 24229, 497, 7, 67, "Section",ExpressionUUID->"5fa63185-5d53-4f84-9386-b800c0aed41d",
 CellID->807955020],
Cell[995843, 24238, 474, 6, 35, "Text",ExpressionUUID->"d64f6588-bfe9-4694-963c-a971997bc278",
 CellID->1951505576],
Cell[996320, 24246, 3181, 73, 472, "Input",ExpressionUUID->"0e5b66ae-6b16-4a40-9857-672d626e7c86",
 CellID->1519740058],
Cell[999504, 24321, 276, 4, 35, "Text",ExpressionUUID->"ce2c32f3-5a4f-4724-b195-77ffa8db416c",
 CellID->205081466],
Cell[CellGroupData[{
Cell[999805, 24329, 2145, 39, 136, "Input",ExpressionUUID->"261de412-8f59-4fc9-a0d0-47c3f7b4ef94",
 CellID->1816140723],
Cell[1001953, 24370, 2507, 56, 70, "Output",ExpressionUUID->"4b8efab3-f6e7-4a1a-9961-850b8fa0a150",
 CellID->204117320]
}, Open  ]],
Cell[CellGroupData[{
Cell[1004497, 24431, 1207, 27, 94, "Input",ExpressionUUID->"31ab87e4-e77e-4515-89a0-776431a9ca7c",
 CellID->1417662976],
Cell[1005707, 24460, 2025, 43, 62, "Output",ExpressionUUID->"96406a49-cf3e-4c65-8ead-e6e4a0d86ed4",
 CellID->1068412981]
}, Open  ]],
Cell[1007747, 24506, 378, 6, 35, "Text",ExpressionUUID->"fd1b8b92-4837-4dd3-95eb-bb1d7e6d6dd1",
 CellID->183089538],
Cell[CellGroupData[{
Cell[1008150, 24516, 2291, 65, 220, "Input",ExpressionUUID->"80aba029-e8ce-4e54-8687-2e9ba1631da0",
 CellID->1989282662],
Cell[CellGroupData[{
Cell[1010466, 24585, 1165, 31, 48, "Print",ExpressionUUID->"3040bda4-44c3-4490-81b2-0d0ea9c794ba",
 CellID->1706199100],
Cell[1011634, 24618, 1027, 27, 48, "Print",ExpressionUUID->"df48d758-4915-4c6c-ab90-d1d4eb142c79",
 CellID->739135309],
Cell[1012664, 24647, 983, 26, 40, "Print",ExpressionUUID->"201351f5-b9db-42bc-a888-9daf65a4b3cc",
 CellID->1601724115],
Cell[1013650, 24675, 1001, 26, 40, "Print",ExpressionUUID->"58518d2a-ae8e-412f-b318-452e660ead34",
 CellID->1469685660],
Cell[1014654, 24703, 981, 26, 40, "Print",ExpressionUUID->"ef07dfe1-9d36-458e-be57-fd73d3c4a9c8",
 CellID->649979826],
Cell[1015638, 24731, 985, 26, 40, "Print",ExpressionUUID->"b0382dfe-3615-477b-bde2-4835b9d9de42",
 CellID->2109106940]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1016672, 24763, 170, 2, 54, "Subsection",ExpressionUUID->"b0a0d56a-bf89-434f-875e-e93c5c8a063f",
 CellID->1848283738],
Cell[CellGroupData[{
Cell[1016867, 24769, 457, 8, 49, "VerificationTest",ExpressionUUID->"9a396330-aaf9-444b-af98-23361d0f2a85",
 CellID->1754857514],
Cell[1017327, 24779, 1357, 25, 84, "ExpectedOutput",ExpressionUUID->"ae922c8f-6b2f-4e9b-8458-1f4fe75b57cc",
 CellID->168180068],
Cell[1018687, 24806, 10995, 252, 26, "TestSuccess",ExpressionUUID->"7f00db5e-8d87-4f86-9140-cedb8940df73",
 CellID->1395263198],
Cell[1029685, 25060, 11087, 278, 70, "BottomCell",ExpressionUUID->"4c0cdfc8-273e-4276-9e8f-452e5d8752cc",
 CellID->1814627193]
}, Open  ]],
Cell[CellGroupData[{
Cell[1040809, 25343, 260, 5, 70, "VerificationTest",ExpressionUUID->"36415f51-b70d-4b49-9f3e-5d26f8c89901",
 CellID->1705075774],
Cell[1041072, 25350, 849, 15, 84, "ExpectedOutput",ExpressionUUID->"13fa82ef-a53e-49e8-8a93-4a4b81a79e42",
 CellID->836054372],
Cell[1041924, 25367, 10515, 244, 26, "TestSuccess",ExpressionUUID->"e572dc1c-8394-4229-ac06-8953df820e9f",
 CellID->2023961704],
Cell[1052442, 25613, 11086, 278, 43, "BottomCell",ExpressionUUID->"876eefae-83cd-41f6-866b-32d9df676ff5",
 CellID->583390648]
}, Open  ]],
Cell[CellGroupData[{
Cell[1063565, 25896, 233, 4, 49, "VerificationTest",ExpressionUUID->"008a6ca4-4e4e-4413-9765-ba86fc9fbd69",
 CellID->1688325336],
Cell[1063801, 25902, 700, 13, 84, "ExpectedOutput",ExpressionUUID->"49423afe-4ed7-4c80-80a0-05c40ed86d82",
 CellID->438342181],
Cell[1064504, 25917, 10655, 246, 26, "TestSuccess",ExpressionUUID->"09f456da-60fb-4708-b9ef-f64c1d02e9c8",
 CellID->1783772381],
Cell[1075162, 26165, 11086, 278, 43, "BottomCell",ExpressionUUID->"f732b6c2-8471-44cf-bcef-cf596f0e037d",
 CellID->990695347]
}, Open  ]],
Cell[CellGroupData[{
Cell[1086285, 26448, 233, 4, 49, "VerificationTest",ExpressionUUID->"387ce3c7-7236-4028-9716-93052bca029c",
 CellID->1866551030],
Cell[1086521, 26454, 683, 12, 84, "ExpectedOutput",ExpressionUUID->"f114040b-03b7-457c-9a5c-61ecf8d7be6a",
 CellID->1620274030],
Cell[1087207, 26468, 10427, 244, 26, "TestSuccess",ExpressionUUID->"fcb11072-7ea6-4bd2-abd7-aa4e6b84dfb8",
 CellID->1175981838],
Cell[1097637, 26714, 11087, 278, 43, "BottomCell",ExpressionUUID->"7eb7d7fa-5573-412d-9d6d-79f31bb981fb",
 CellID->1434747925]
}, Open  ]],
Cell[CellGroupData[{
Cell[1108761, 26997, 231, 4, 49, "VerificationTest",ExpressionUUID->"80a28f5e-d696-404d-9a10-fea8888f93e8",
 CellID->1807272232],
Cell[1108995, 27003, 417, 9, 41, "ExpectedOutput",ExpressionUUID->"dca8acbf-2330-499d-aca6-db2befb2aa56",
 CellID->542719504],
Cell[1109415, 27014, 10427, 244, 26, "TestSuccess",ExpressionUUID->"94929195-6535-46ea-8884-a2b78d5ce992",
 CellID->1861986959],
Cell[1119845, 27260, 11087, 278, 43, "BottomCell",ExpressionUUID->"4c8743d3-6342-4078-bc78-0350b6f873b6",
 CellID->1283115829]
}, Open  ]],
Cell[CellGroupData[{
Cell[1130969, 27543, 234, 4, 49, "VerificationTest",ExpressionUUID->"e96bd6a7-ae4b-4f7b-81e9-bb8f3c106e35",
 CellID->438324506],
Cell[1131206, 27549, 388, 8, 41, "ExpectedOutput",ExpressionUUID->"fbfad1ac-cff0-4a87-ac63-6027ab0681f3",
 CellID->1777068154],
Cell[1131597, 27559, 10424, 244, 26, "TestSuccess",ExpressionUUID->"a9907071-676b-4e57-a653-840d64fc9d11",
 CellID->296954829],
Cell[1142024, 27805, 11086, 278, 43, "BottomCell",ExpressionUUID->"71842014-ca77-41c8-8ba4-ac3b83ae0239",
 CellID->167815375]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1153171, 28090, 544, 7, 67, "Section",ExpressionUUID->"7eff7695-b3f2-4905-b929-2687a075b628",
 CellID->1513383795],
Cell[CellGroupData[{
Cell[1153740, 28101, 177, 2, 54, "Subsection",ExpressionUUID->"c69b6b75-fb03-4833-8306-d3f29ad5424b",
 CellID->360278988],
Cell[1153920, 28105, 525, 7, 35, "Text",ExpressionUUID->"223ca98d-5c87-4361-b119-aefe6ccb5dba",
 CellID->1555907635],
Cell[1154448, 28114, 3249, 72, 451, "Input",ExpressionUUID->"6ad8cc8a-3465-4d12-978d-cf24281eaed3",
 CellID->1337573792],
Cell[1157700, 28188, 276, 4, 35, "Text",ExpressionUUID->"e92ef1bf-7a57-46b0-a0e9-f4d3e30a6471",
 CellID->248883740],
Cell[CellGroupData[{
Cell[1158001, 28196, 2139, 39, 136, "Input",ExpressionUUID->"b1a18068-cb53-465d-8510-4d59f6950431",
 CellID->43206385],
Cell[1160143, 28237, 2302, 49, 52, "Output",ExpressionUUID->"b7f0398c-109e-477f-a89c-741ee3942f85",
 CellID->826979114]
}, Open  ]],
Cell[CellGroupData[{
Cell[1162482, 28291, 1206, 27, 94, "Input",ExpressionUUID->"07d047f9-d8b4-488b-9431-8bb17ad23536",
 CellID->679811881],
Cell[1163691, 28320, 1938, 39, 46, "Output",ExpressionUUID->"92cc9e7e-f288-4b9f-af1c-b4048aa02cb6",
 CellID->523805614]
}, Open  ]],
Cell[1165644, 28362, 379, 6, 35, "Text",ExpressionUUID->"4c26c8b3-83dd-4b32-996d-a2f07cbd1e51",
 CellID->1281207206],
Cell[CellGroupData[{
Cell[1166048, 28372, 2290, 65, 220, "Input",ExpressionUUID->"22d3c957-66c8-4425-a003-e1c36f53cf81",
 CellID->430982773],
Cell[CellGroupData[{
Cell[1168363, 28441, 1123, 28, 31, "Print",ExpressionUUID->"4651a075-14b9-4264-93fe-baef5ecbb15a",
 CellID->1065485445],
Cell[1169489, 28471, 1045, 26, 31, "Print",ExpressionUUID->"ec496b35-64c7-4ebe-908b-6553fa4f746a",
 CellID->1895225429],
Cell[1170537, 28499, 990, 25, 25, "Print",ExpressionUUID->"7f40a33e-1fd4-4e9c-bbab-4d1075dd16e5",
 CellID->1576332899],
Cell[1171530, 28526, 988, 25, 25, "Print",ExpressionUUID->"cc8efca1-9d34-4a1f-a703-99c0ff7274c2",
 CellID->2068764101],
Cell[1172521, 28553, 988, 25, 25, "Print",ExpressionUUID->"642ea121-b7dd-4d8a-ad6f-e419bb3f90ce",
 CellID->1958000577],
Cell[1173512, 28580, 986, 25, 25, "Print",ExpressionUUID->"6cc54014-ed9e-4c72-8dcc-51671d1176e7",
 CellID->76291011]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1174559, 28612, 169, 2, 54, "Subsection",ExpressionUUID->"d2de7dfc-7b80-41f3-8250-f1e4d326080b",
 CellID->323926419],
Cell[CellGroupData[{
Cell[1174753, 28618, 457, 8, 49, "VerificationTest",ExpressionUUID->"a2b044f2-8810-419b-af90-eb23ae7aa302",
 CellID->1387947054],
Cell[1175213, 28628, 1229, 21, 59, "ExpectedOutput",ExpressionUUID->"1448a586-e59d-462f-a491-1d6ea4341321",
 CellID->276496415],
Cell[1176445, 28651, 10482, 244, 26, "TestSuccess",ExpressionUUID->"94974d0d-bb41-4b82-a508-39d1355cc64c",
 CellID->175284618],
Cell[1186930, 28897, 11087, 278, 43, "BottomCell",ExpressionUUID->"9d4b8659-0a78-401b-8274-7f6df76c3ae0",
 CellID->1808494689]
}, Open  ]],
Cell[CellGroupData[{
Cell[1198054, 29180, 259, 5, 49, "VerificationTest",ExpressionUUID->"f9cd6f74-fd30-4553-a629-3f3395ccd212",
 CellID->654434760],
Cell[1198316, 29187, 799, 14, 41, "ExpectedOutput",ExpressionUUID->"1b9ce355-5e55-4d37-ab58-c1cbb4c75ddc",
 CellID->1354756641],
Cell[1199118, 29203, 10287, 240, 26, "TestSuccess",ExpressionUUID->"f19476b1-12dc-49ee-971d-eb9b48b14199",
 CellID->2034182032],
Cell[1209408, 29445, 11086, 278, 43, "BottomCell",ExpressionUUID->"61a1e866-9f60-443d-9e2e-4c35f485b524",
 CellID->557751584]
}, Open  ]],
Cell[CellGroupData[{
Cell[1220531, 29728, 233, 4, 49, "VerificationTest",ExpressionUUID->"4033ade2-f3b1-4c59-bd1a-067b46c12514",
 CellID->1304305929],
Cell[1220767, 29734, 598, 10, 41, "ExpectedOutput",ExpressionUUID->"a4988572-c0aa-4705-992d-c37547ed23c3",
 CellID->1549648249],
Cell[1221368, 29746, 10179, 239, 26, "TestSuccess",ExpressionUUID->"63ac7ceb-6607-436a-9186-c9bedcd423a7",
 CellID->364753133],
Cell[1231550, 29987, 11087, 278, 43, "BottomCell",ExpressionUUID->"c2e7bcbc-b072-40b9-922e-62f639e97f78",
 CellID->1487577793]
}, Open  ]],
Cell[CellGroupData[{
Cell[1242674, 30270, 233, 4, 49, "VerificationTest",ExpressionUUID->"3647b0f6-e980-400d-b35c-97a6855520d4",
 CellID->1483141090],
Cell[1242910, 30276, 629, 10, 41, "ExpectedOutput",ExpressionUUID->"fff6286b-4406-448b-9df7-0ff6bd335ff0",
 CellID->1403689137],
Cell[1243542, 30288, 10181, 239, 26, "TestSuccess",ExpressionUUID->"e92202eb-a151-47a9-9e86-9c9fe5f30a98",
 CellID->715348577],
Cell[1253726, 30529, 11087, 278, 43, "BottomCell",ExpressionUUID->"5ca3020c-151b-4687-bad2-b5bc3500359c",
 CellID->1250077733]
}, Open  ]],
Cell[CellGroupData[{
Cell[1264850, 30812, 230, 4, 49, "VerificationTest",ExpressionUUID->"39caa422-61f4-4f30-92a7-45ab1e0a4a3a",
 CellID->417437835],
Cell[1265083, 30818, 417, 9, 41, "ExpectedOutput",ExpressionUUID->"df853328-103f-4a7f-ac53-a56775c84d2e",
 CellID->620081943],
Cell[1265503, 30829, 10182, 239, 26, "TestSuccess",ExpressionUUID->"0a74498f-d347-40f0-9bfc-c93a34695d88",
 CellID->1223939930],
Cell[1275688, 31070, 11085, 278, 43, "BottomCell",ExpressionUUID->"41f34048-b21a-4476-a4dd-543e0c53627d",
 CellID->12548897]
}, Open  ]],
Cell[CellGroupData[{
Cell[1286810, 31353, 234, 4, 49, "VerificationTest",ExpressionUUID->"42cb018b-f455-4d0b-9408-5d1db288ce73",
 CellID->670386769],
Cell[1287047, 31359, 388, 8, 41, "ExpectedOutput",ExpressionUUID->"d2199e24-381e-49b6-b71b-1aa594386e7e",
 CellID->1441824756],
Cell[1287438, 31369, 10179, 239, 26, "TestSuccess",ExpressionUUID->"3a1adc58-18d1-4794-8adc-3248201de5af",
 CellID->455914473],
Cell[1297620, 31610, 11086, 278, 43, "BottomCell",ExpressionUUID->"2ffc553a-21b0-49c5-abc1-7de13a8de06d",
 CellID->332895215]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1308767, 31895, 596, 8, 67, "Section",ExpressionUUID->"af5f6f11-47bc-432c-8e81-a6e011ceeffb",
 CellID->1123870704],
Cell[CellGroupData[{
Cell[1309388, 31907, 178, 2, 54, "Subsection",ExpressionUUID->"29632997-11d3-4914-a23e-c635cd69cf47",
 CellID->1897281308],
Cell[1309569, 31911, 575, 8, 35, "Text",ExpressionUUID->"96c70424-85ff-4efc-a2a7-019a0f6b9a0c",
 CellID->996763060],
Cell[1310147, 31921, 3405, 77, 493, "Input",ExpressionUUID->"03371df5-6d55-4a77-bcc0-b421efd6baa8",
 CellID->1726614346],
Cell[1313555, 32000, 275, 4, 35, "Text",ExpressionUUID->"2bd20373-8b5b-49c2-94ed-c1b8cbd69a75",
 CellID->95329236],
Cell[CellGroupData[{
Cell[1313855, 32008, 2141, 39, 136, "Input",ExpressionUUID->"719c281a-edcc-4c6a-b02f-c07e365dada0",
 CellID->348677981],
Cell[1315999, 32049, 2484, 55, 80, "Output",ExpressionUUID->"f6bbc70d-f0e5-4bd4-af20-2f400b3d10be",
 CellID->774978070]
}, Open  ]],
Cell[CellGroupData[{
Cell[1318520, 32109, 1206, 27, 94, "Input",ExpressionUUID->"71361f98-6aee-44d9-a6c3-416211331aee",
 CellID->848180759],
Cell[1319729, 32138, 2328, 52, 80, "Output",ExpressionUUID->"aa9ffc34-b50b-43cb-a483-f31fb3c6fb24",
 CellID->568103435]
}, Open  ]],
Cell[1322072, 32193, 379, 6, 35, "Text",ExpressionUUID->"ea7f4f34-8522-4ebd-a458-0381756be2a9",
 CellID->1521132909],
Cell[CellGroupData[{
Cell[1322476, 32203, 2291, 65, 220, "Input",ExpressionUUID->"74d05c00-93c4-4480-a212-b0330bad09d5",
 CellID->2035467675],
Cell[CellGroupData[{
Cell[1324792, 32272, 1260, 34, 56, "Print",ExpressionUUID->"44d4de27-f902-4d81-9f06-407d672e5fc3",
 CellID->402137483],
Cell[1326055, 32308, 1078, 28, 48, "Print",ExpressionUUID->"be5a3e73-621a-4d75-9cbd-e10fc43ff4e1",
 CellID->593639672],
Cell[1327136, 32338, 1034, 27, 40, "Print",ExpressionUUID->"e08cddd7-ac65-4a5e-bab1-a3efae1491e6",
 CellID->92943342],
Cell[1328173, 32367, 1139, 30, 56, "Print",ExpressionUUID->"ab5ebc54-aea7-46d2-af34-3e69c1b41b79",
 CellID->878137625],
Cell[1329315, 32399, 1055, 28, 56, "Print",ExpressionUUID->"8a9f5616-ec2f-4057-a7b8-5261c946d95a",
 CellID->1351441191],
Cell[1330373, 32429, 1053, 28, 56, "Print",ExpressionUUID->"f5b61e84-0e0a-40c8-ac31-539651623c60",
 CellID->1885046465]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1331487, 32464, 170, 2, 54, "Subsection",ExpressionUUID->"8ad63a52-c29d-433a-a876-97b9b7a096e4",
 CellID->1261361835],
Cell[CellGroupData[{
Cell[1331682, 32470, 456, 8, 49, "VerificationTest",ExpressionUUID->"c49ec61d-b163-4350-bfdd-7b8768fc7a9d",
 CellID->398927661],
Cell[1332141, 32480, 1487, 28, 84, "ExpectedOutput",ExpressionUUID->"c598a579-ac25-444e-916c-190c53a16d90",
 CellID->1092749213],
Cell[1333631, 32510, 11108, 254, 26, "TestSuccess",ExpressionUUID->"d09ab5e9-878b-4cde-aa57-449994ae6b60",
 CellID->149693064],
Cell[1344742, 32766, 11087, 278, 43, "BottomCell",ExpressionUUID->"8485608a-2960-429e-a14a-a0aa8a2573af",
 CellID->1187976011]
}, Open  ]],
Cell[CellGroupData[{
Cell[1355866, 33049, 259, 5, 49, "VerificationTest",ExpressionUUID->"e0d9ea8b-2dc1-45f5-9f1e-5ea67b06f87b",
 CellID->348954702],
Cell[1356128, 33056, 949, 16, 84, "ExpectedOutput",ExpressionUUID->"a36cacc2-7233-4522-bbb3-a19194899d44",
 CellID->646201416],
Cell[1357080, 33074, 10515, 244, 26, "TestSuccess",ExpressionUUID->"ac29444b-8d71-4794-90e8-3bd0c96ee73e",
 CellID->1157350718],
Cell[1367598, 33320, 11087, 278, 43, "BottomCell",ExpressionUUID->"1157340b-110b-4b12-8d2d-0e4615f54941",
 CellID->1834126547]
}, Open  ]],
Cell[CellGroupData[{
Cell[1378722, 33603, 233, 4, 49, "VerificationTest",ExpressionUUID->"1d23eec1-f636-4809-8d6d-d91546fe4872",
 CellID->1266283360],
Cell[1378958, 33609, 927, 19, 105, "ExpectedOutput",ExpressionUUID->"b374ae3d-daa2-4be3-8ca1-b53a2db70717",
 CellID->786295109],
Cell[1379888, 33630, 11115, 252, 26, "TestSuccess",ExpressionUUID->"78058d5c-4dee-43aa-997d-01760bf20aca",
 CellID->1184606391],
Cell[1391006, 33884, 11086, 278, 43, "BottomCell",ExpressionUUID->"6f94608e-e32f-4562-a3d8-a1b24ac5e252",
 CellID->358722200]
}, Open  ]],
Cell[CellGroupData[{
Cell[1402129, 34167, 231, 4, 49, "VerificationTest",ExpressionUUID->"8aa7c457-bb49-4f35-9193-3de98e864e4c",
 CellID->80636217],
Cell[1402363, 34173, 837, 14, 105, "ExpectedOutput",ExpressionUUID->"38278a10-59be-4d45-9441-0e88dddc4d00",
 CellID->1002636004],
Cell[1403203, 34189, 10637, 246, 26, "TestSuccess",ExpressionUUID->"56fdcc12-8702-4f41-b2a8-9996278861f0",
 CellID->1057418271],
Cell[1413843, 34437, 11087, 278, 43, "BottomCell",ExpressionUUID->"6973ace5-8322-4460-892e-5f4a45fb0e65",
 CellID->1601701772]
}, Open  ]],
Cell[CellGroupData[{
Cell[1424967, 34720, 231, 4, 49, "VerificationTest",ExpressionUUID->"d524e200-692e-4105-84b5-140a471e5dde",
 CellID->1198337696],
Cell[1425201, 34726, 417, 9, 41, "ExpectedOutput",ExpressionUUID->"9f3c6c7d-2397-4320-8b10-76a2e77737a9",
 CellID->813827590],
Cell[1425621, 34737, 10427, 244, 26, "TestSuccess",ExpressionUUID->"5bb75440-3677-4373-a4fa-90f41d5089cf",
 CellID->1094166859],
Cell[1436051, 34983, 11086, 278, 43, "BottomCell",ExpressionUUID->"0345f9ac-9726-4adc-aefa-76e5513b368b",
 CellID->759929952]
}, Open  ]],
Cell[CellGroupData[{
Cell[1447174, 35266, 235, 4, 49, "VerificationTest",ExpressionUUID->"e61e78fc-1a6a-481a-ace0-35db87cea199",
 CellID->1325491493],
Cell[1447412, 35272, 387, 8, 41, "ExpectedOutput",ExpressionUUID->"fde42fba-4a60-4737-b8d2-c403743ab2ac",
 CellID->406808914],
Cell[1447802, 35282, 10635, 246, 26, "TestSuccess",ExpressionUUID->"7f6db97b-34b2-485f-9036-319da019d027",
 CellID->1057454555],
Cell[1458440, 35530, 11085, 278, 43, "BottomCell",ExpressionUUID->"f44d29ee-4447-4789-87af-30f955815941",
 CellID->64043313]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1469586, 35815, 648, 9, 67, "Section",ExpressionUUID->"96b4ea27-a54a-48ed-9566-7ee0bdeb6952",
 CellID->981828233],
Cell[CellGroupData[{
Cell[1470259, 35828, 175, 2, 54, "Subsection",ExpressionUUID->"88dd66ef-510d-46a5-be89-c5246f01b83f",
 CellID->450237986],
Cell[1470437, 35832, 622, 8, 35, "Text",ExpressionUUID->"1dc1d35f-9b23-4c8c-8653-0e56b32e1c02",
 CellID->2076059377],
Cell[1471062, 35842, 3835, 86, 535, "Input",ExpressionUUID->"90dbfafd-f978-45fd-b937-61d27b68c28c",
 CellID->1048506747],
Cell[1474900, 35930, 276, 4, 35, "Text",ExpressionUUID->"876e6286-3005-4fe0-8a9d-2c995f97b9d1",
 CellID->892609393],
Cell[CellGroupData[{
Cell[1475201, 35938, 2144, 39, 136, "Input",ExpressionUUID->"c36450cd-d8bf-43f1-a0fd-83f64cf36f71",
 CellID->825200426],
Cell[1477348, 35979, 2637, 60, 82, "Output",ExpressionUUID->"391ff68c-5874-4a05-881b-860dac161af0",
 CellID->486654444]
}, Open  ]],
Cell[CellGroupData[{
Cell[1480022, 36044, 1207, 27, 94, "Input",ExpressionUUID->"3525ce52-219f-4f9e-9cf1-b03884198751",
 CellID->1741262488],
Cell[1481232, 36073, 2053, 43, 62, "Output",ExpressionUUID->"3d9a2614-6cd5-42ea-a850-267e45abfffb",
 CellID->1583512532]
}, Open  ]],
Cell[1483300, 36119, 378, 6, 35, "Text",ExpressionUUID->"56d012a1-6ec6-4def-afb7-5eb840e730fb",
 CellID->852042610],
Cell[CellGroupData[{
Cell[1483703, 36129, 2290, 65, 220, "Input",ExpressionUUID->"024d4e9a-760e-4839-a406-295d8257cd9c",
 CellID->859188074],
Cell[CellGroupData[{
Cell[1486018, 36198, 1401, 36, 58, "Print",ExpressionUUID->"51de3172-af40-410b-bea9-677dc71ce46d",
 CellID->330288053],
Cell[1487422, 36236, 1101, 28, 50, "Print",ExpressionUUID->"736cce33-7c5e-4a63-bb8a-7a3a45808703",
 CellID->2053562923],
Cell[1488526, 36266, 1056, 27, 40, "Print",ExpressionUUID->"d9fecfc5-e506-480f-abda-e78a79f51585",
 CellID->2022355924],
Cell[1489585, 36295, 1070, 27, 40, "Print",ExpressionUUID->"f5ec5b79-3d04-496d-9be9-9dba8267f071",
 CellID->1512333599],
Cell[1490658, 36324, 1053, 27, 40, "Print",ExpressionUUID->"1c6cf3dd-fa32-4c96-a6b0-00cc3a19058e",
 CellID->174352501],
Cell[1491714, 36353, 1054, 27, 40, "Print",ExpressionUUID->"ca903028-9f1f-4a9a-a5fb-00cc659124c8",
 CellID->1174789799]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1492829, 36387, 169, 2, 54, "Subsection",ExpressionUUID->"7caf4ba3-0aeb-4c58-b010-f206ab7a627f",
 CellID->423899325],
Cell[CellGroupData[{
Cell[1493023, 36393, 456, 8, 49, "VerificationTest",ExpressionUUID->"865cfadd-d89e-4182-b8fa-0b237d1a013a",
 CellID->714870838],
Cell[1493482, 36403, 1609, 31, 130, "ExpectedOutput",ExpressionUUID->"4bba16c3-58be-4ce9-92f4-50dfb7d2fa20",
 CellID->322452496],
Cell[1495094, 36436, 11848, 262, 70, "TestSuccess",ExpressionUUID->"1fadbdd5-c464-473e-9c55-c407a933b622",
 CellID->727501275],
Cell[1506945, 36700, 11087, 278, 70, "BottomCell",ExpressionUUID->"b5166b90-d677-466f-ba92-147a361b5751",
 CellID->1489526554]
}, Open  ]],
Cell[CellGroupData[{
Cell[1518069, 36983, 260, 5, 70, "VerificationTest",ExpressionUUID->"afcadf3f-176c-48f3-90ba-d49334288c5a",
 CellID->1325088500],
Cell[1518332, 36990, 1001, 17, 84, "ExpectedOutput",ExpressionUUID->"19d64d2f-5bfb-4c80-b917-c8449ad8bdf3",
 CellID->1529551905],
Cell[1519336, 37009, 10519, 244, 26, "TestSuccess",ExpressionUUID->"d614d1f1-7cf0-42a2-a577-a0551688f3b3",
 CellID->1255919999],
Cell[1529858, 37255, 11086, 278, 43, "BottomCell",ExpressionUUID->"2a8c5279-6ea4-47a4-b4ca-d7b49ba4bfd2",
 CellID->630656830]
}, Open  ]],
Cell[CellGroupData[{
Cell[1540981, 37538, 232, 4, 49, "VerificationTest",ExpressionUUID->"63b783c1-ae68-4a45-bacb-dc201d89ddb7",
 CellID->195895847],
Cell[1541216, 37544, 845, 15, 84, "ExpectedOutput",ExpressionUUID->"5ffb9c45-d40c-4444-8f8e-6cf0478cd4c2",
 CellID->930877862],
Cell[1542064, 37561, 10653, 246, 26, "TestSuccess",ExpressionUUID->"3a8aa8f7-733c-4ad0-aab3-70617125e04e",
 CellID->1617543865],
Cell[1552720, 37809, 11087, 278, 43, "BottomCell",ExpressionUUID->"73484575-084c-4136-99ce-774efbe338c2",
 CellID->1064251682]
}, Open  ]],
Cell[CellGroupData[{
Cell[1563844, 38092, 233, 4, 49, "VerificationTest",ExpressionUUID->"c63527ed-7117-40c3-9e25-405ca9d95df1",
 CellID->1337686776],
Cell[1564080, 38098, 830, 14, 84, "ExpectedOutput",ExpressionUUID->"6977cb23-7cd2-45c4-bbae-2ddfa965ae8c",
 CellID->825458383],
Cell[1564913, 38114, 10424, 244, 26, "TestSuccess",ExpressionUUID->"3b3e53de-b4b9-4865-beca-deb67fdaf6e1",
 CellID->486723511],
Cell[1575340, 38360, 11086, 278, 43, "BottomCell",ExpressionUUID->"c6ec1128-8bcd-4455-ac03-e1d3a8191801",
 CellID->596837954]
}, Open  ]],
Cell[CellGroupData[{
Cell[1586463, 38643, 231, 4, 49, "VerificationTest",ExpressionUUID->"1c177f35-4e31-46fc-86b3-bd9f00436f69",
 CellID->1247766488],
Cell[1586697, 38649, 417, 9, 41, "ExpectedOutput",ExpressionUUID->"0860d0ef-cf3f-4279-bc9b-1c982ed1966f",
 CellID->748835101],
Cell[1587117, 38660, 10426, 244, 26, "TestSuccess",ExpressionUUID->"fc57299e-673a-49aa-b571-91cf0eb99472",
 CellID->159377741],
Cell[1597546, 38906, 11086, 278, 43, "BottomCell",ExpressionUUID->"336d570b-241c-48d5-84ec-ca37a7c5f6e5",
 CellID->749585178]
}, Open  ]],
Cell[CellGroupData[{
Cell[1608669, 39189, 235, 4, 49, "VerificationTest",ExpressionUUID->"dbd703bb-ceb8-4925-b2b5-20a6660328cf",
 CellID->1736729043],
Cell[1608907, 39195, 386, 8, 41, "ExpectedOutput",ExpressionUUID->"60f2e5a2-e1f2-4a84-8f29-ac971a1e30e3",
 CellID->98922809],
Cell[1609296, 39205, 10427, 244, 26, "TestSuccess",ExpressionUUID->"cf1e5a91-7ece-4804-a8eb-61e69102b556",
 CellID->1139013344],
Cell[1619726, 39451, 11086, 278, 43, "BottomCell",ExpressionUUID->"aa3b7f25-5c83-48d9-9e60-c8cdc001e38f",
 CellID->728043250]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1630873, 39736, 694, 9, 67, "Section",ExpressionUUID->"870bbda1-0670-46e9-b9d8-f8a2dbf9bb0c",
 CellID->788888489],
Cell[CellGroupData[{
Cell[1631592, 39749, 177, 2, 54, "Subsection",ExpressionUUID->"41ee1ddc-60d8-47f9-8b78-566f2e328384",
 CellID->264060228],
Cell[1631772, 39753, 674, 9, 35, "Text",ExpressionUUID->"b43fd4e8-752a-47f7-a68b-a0f98e5f1261",
 CellID->681143337],
Cell[1632449, 39764, 3370, 74, 451, "Input",ExpressionUUID->"f7a7303b-bd29-4fa9-8a23-a86dc0c512a2",
 CellID->729025756],
Cell[1635822, 39840, 277, 4, 35, "Text",ExpressionUUID->"7d4deb98-016b-44c7-b664-4980fd936b72",
 CellID->1422520852],
Cell[CellGroupData[{
Cell[1636124, 39848, 2142, 39, 136, "Input",ExpressionUUID->"7b0acb8e-5675-468c-9c8f-f5989d18c2e3",
 CellID->163345547],
Cell[1638269, 39889, 2364, 51, 54, "Output",ExpressionUUID->"92411e81-a0a9-488f-9102-f92e438425cf",
 CellID->2008565791]
}, Open  ]],
Cell[CellGroupData[{
Cell[1640670, 39945, 1207, 27, 94, "Input",ExpressionUUID->"f8c0975e-b19f-4c86-ae39-27e916b3b71b",
 CellID->2051739386],
Cell[1641880, 39974, 1939, 39, 46, "Output",ExpressionUUID->"86571172-a05a-4e78-af48-92d62a721892",
 CellID->1669802144]
}, Open  ]],
Cell[1643834, 40016, 379, 6, 35, "Text",ExpressionUUID->"d1cd2816-9fbd-438c-b392-f09ae54185fb",
 CellID->1033466272],
Cell[CellGroupData[{
Cell[1644238, 40026, 2290, 65, 220, "Input",ExpressionUUID->"24449604-7087-4149-8fae-bf48ff056d97",
 CellID->619896568],
Cell[CellGroupData[{
Cell[1646553, 40095, 1266, 32, 32, "Print",ExpressionUUID->"8767fd7d-db33-48a2-af86-e38a24a28216",
 CellID->1048335212],
Cell[1647822, 40129, 1254, 31, 32, "Print",ExpressionUUID->"0e4b4384-b5ee-4516-8211-58bd752a28c4",
 CellID->1414068096],
Cell[1649079, 40162, 1057, 26, 25, "Print",ExpressionUUID->"d390407c-bef1-4926-a017-f105e603da83",
 CellID->40968123],
Cell[1650139, 40190, 1057, 26, 25, "Print",ExpressionUUID->"5f1a7703-2024-4e4b-872b-cbbf8b6c4624",
 CellID->1356476221],
Cell[1651199, 40218, 1056, 26, 25, "Print",ExpressionUUID->"e8840224-5555-4acd-b098-7f7d61823d50",
 CellID->609449795],
Cell[1652258, 40246, 1057, 26, 25, "Print",ExpressionUUID->"bd881fa5-3d54-46e2-b11a-fa84f7bf559b",
 CellID->1673192022]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1653376, 40279, 169, 2, 54, "Subsection",ExpressionUUID->"3434f91a-e613-4fca-8753-ff545c5d9d04",
 CellID->288271980],
Cell[CellGroupData[{
Cell[1653570, 40285, 457, 8, 49, "VerificationTest",ExpressionUUID->"1c47681f-c61d-4af0-adcb-4d4d1f25fb14",
 CellID->1612021199],
Cell[1654030, 40295, 1428, 25, 60, "ExpectedOutput",ExpressionUUID->"9926083b-4d70-4249-8e3a-661b59a5dda8",
 CellID->1907431679],
Cell[1655461, 40322, 10971, 252, 26, "TestSuccess",ExpressionUUID->"22e01d29-c7b8-4a48-883d-9760faeb3b0b",
 CellID->39956289],
Cell[1666435, 40576, 11087, 278, 43, "BottomCell",ExpressionUUID->"54189801-e19e-48a4-aeac-53aa4855cd13",
 CellID->1530451359]
}, Open  ]],
Cell[CellGroupData[{
Cell[1677559, 40859, 259, 5, 49, "VerificationTest",ExpressionUUID->"189074dc-73f5-4df9-ae95-071cd4ad4373",
 CellID->585406414],
Cell[1677821, 40866, 1026, 19, 60, "ExpectedOutput",ExpressionUUID->"3d1e572e-c3e2-4564-aeb8-e7a9952653ae",
 CellID->1846243533],
Cell[1678850, 40887, 10873, 248, 26, "TestSuccess",ExpressionUUID->"f5ff93b8-9e9c-45dd-b258-bfb2f8224056",
 CellID->1884350594],
Cell[1689726, 41137, 11087, 278, 43, "BottomCell",ExpressionUUID->"50768f96-6ca3-42c8-9527-527a6b576ad8",
 CellID->1339091049]
}, Open  ]],
Cell[CellGroupData[{
Cell[1700850, 41420, 232, 4, 49, "VerificationTest",ExpressionUUID->"023852d3-4518-49ec-aece-190374e712f5",
 CellID->447594986],
Cell[1701085, 41426, 744, 12, 41, "ExpectedOutput",ExpressionUUID->"39c38ca1-26d8-455b-bcb1-7dc5025ca13e",
 CellID->834270223],
Cell[1701832, 41440, 10179, 239, 26, "TestSuccess",ExpressionUUID->"bdc1395d-6c07-490f-a916-b927dc66a36e",
 CellID->474639983],
Cell[1712014, 41681, 11087, 278, 43, "BottomCell",ExpressionUUID->"521146e0-43f1-4fc8-9077-44a49dfc65f2",
 CellID->1519929323]
}, Open  ]],
Cell[CellGroupData[{
Cell[1723138, 41964, 232, 4, 49, "VerificationTest",ExpressionUUID->"74becbd5-8883-4a43-ae99-98289a13e9f7",
 CellID->933193033],
Cell[1723373, 41970, 776, 12, 41, "ExpectedOutput",ExpressionUUID->"bb562782-72a8-4e52-af65-b4e66e815f51",
 CellID->394912443],
Cell[1724152, 41984, 10182, 239, 26, "TestSuccess",ExpressionUUID->"e41a559f-7509-4ce7-87e7-abfbfaec9b4c",
 CellID->1134150596],
Cell[1734337, 42225, 11086, 278, 43, "BottomCell",ExpressionUUID->"b64dad2c-3c13-4936-8e5b-9b088b267887",
 CellID->604216200]
}, Open  ]],
Cell[CellGroupData[{
Cell[1745460, 42508, 231, 4, 49, "VerificationTest",ExpressionUUID->"d6a09c86-653b-4d10-a515-4a8d39d2483a",
 CellID->2137365557],
Cell[1745694, 42514, 418, 9, 41, "ExpectedOutput",ExpressionUUID->"01cf3a58-ae38-413e-8402-d3bdd1f888d1",
 CellID->1511248044],
Cell[1746115, 42525, 10182, 239, 26, "TestSuccess",ExpressionUUID->"72c6c92a-aaea-4655-b703-c6bcaf9ed4b5",
 CellID->1758990384],
Cell[1756300, 42766, 11087, 278, 43, "BottomCell",ExpressionUUID->"2aaafcf1-655f-43c4-814f-2099144d6142",
 CellID->1091499286]
}, Open  ]],
Cell[CellGroupData[{
Cell[1767424, 43049, 234, 4, 49, "VerificationTest",ExpressionUUID->"eebd459d-90d4-4aa2-be50-4e428f38a256",
 CellID->216790256],
Cell[1767661, 43055, 385, 8, 41, "ExpectedOutput",ExpressionUUID->"3836fc7b-ef83-42cd-b49c-a8a440887be2",
 CellID->6159029],
Cell[1768049, 43065, 10182, 239, 26, "TestSuccess",ExpressionUUID->"6fe12ad7-c2a1-4fbf-bd1c-e6ba78e634ec",
 CellID->1023187128],
Cell[1778234, 43306, 11087, 278, 43, "BottomCell",ExpressionUUID->"8b1e53c7-ba28-47fd-8e90-75e89f767020",
 CellID->1804498767]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1789382, 43591, 747, 10, 67, "Section",ExpressionUUID->"8986f361-795b-4672-8cc8-1691b8edc5b7",
 CellID->1096616352],
Cell[1790132, 43603, 726, 10, 35, "Text",ExpressionUUID->"5fcc21d2-da68-49fc-8b86-522d6f130c0a",
 CellID->1902021877],
Cell[1790861, 43615, 4257, 96, 577, "Input",ExpressionUUID->"c637c1c6-e88a-4103-ab53-35b2ad6318d7",
 CellID->357937628],
Cell[1795121, 43713, 276, 4, 35, "Text",ExpressionUUID->"0a8df0e2-ba09-4195-b74e-ecad786ad991",
 CellID->121022972],
Cell[CellGroupData[{
Cell[1795422, 43721, 2140, 39, 136, "Input",ExpressionUUID->"68066fb4-1ad4-493f-91b1-8734c26cc9f6",
 CellID->105684621],
Cell[1797565, 43762, 2781, 64, 82, "Output",ExpressionUUID->"c35e0eac-5256-4c07-8dac-c55192ebf9dd",
 CellID->1446714035]
}, Open  ]],
Cell[CellGroupData[{
Cell[1800383, 43831, 1206, 27, 94, "Input",ExpressionUUID->"d82981d4-ac7f-4c3d-8c47-ed095dd5c1e7",
 CellID->616518542],
Cell[1801592, 43860, 1968, 40, 52, "Output",ExpressionUUID->"b1faf17d-7e50-42d0-85b5-96e4cb636cb7",
 CellID->1112934911]
}, Open  ]],
Cell[1803575, 43903, 378, 6, 35, "Text",ExpressionUUID->"8282dafb-d47b-48d5-b278-a5272977d2eb",
 CellID->978931082],
Cell[CellGroupData[{
Cell[1803978, 43913, 2291, 65, 220, "Input",ExpressionUUID->"c0d80b8e-c54c-46bc-84bb-18986e6214aa",
 CellID->1022475507],
Cell[CellGroupData[{
Cell[1806294, 43982, 1479, 38, 58, "Print",ExpressionUUID->"b24b8d24-c14d-4546-8118-39cc532ba222",
 CellID->514483807],
Cell[1807776, 44022, 1146, 29, 48, "Print",ExpressionUUID->"af939f8a-dd6e-4cfe-9c56-660e7e5b6d2f",
 CellID->1160181427],
Cell[1808925, 44053, 1211, 30, 48, "Print",ExpressionUUID->"c1766e43-51b0-45e8-a560-a06bdae297e2",
 CellID->17728829],
Cell[1810139, 44085, 1137, 28, 31, "Print",ExpressionUUID->"0bc73975-c378-4815-8c44-fccd36225158",
 CellID->1615685717],
Cell[1811279, 44115, 1081, 27, 25, "Print",ExpressionUUID->"2130fdf5-c96b-4f1d-87b3-6027c43ccdb5",
 CellID->2046612951],
Cell[1812363, 44144, 1084, 27, 25, "Print",ExpressionUUID->"652722c9-0870-4f92-a538-c567a2b5313c",
 CellID->1178293458]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1813496, 44177, 170, 2, 54, "Subsection",ExpressionUUID->"2d2eda25-aeea-4da8-aa69-aa042949e495",
 CellID->1751331159],
Cell[CellGroupData[{
Cell[1813691, 44183, 456, 8, 49, "VerificationTest",ExpressionUUID->"c5728201-f5f7-493b-818c-20366c0c2a16",
 CellID->588808452],
Cell[1814150, 44193, 1727, 34, 127, "ExpectedOutput",ExpressionUUID->"1b92329b-1960-4032-b437-ed9ceca3a0fe",
 CellID->562980888],
Cell[1815880, 44229, 11705, 262, 26, "TestSuccess",ExpressionUUID->"313a115e-8bd9-450e-aecf-3d785589c4d6",
 CellID->1631439619],
Cell[1827588, 44493, 11086, 278, 70, "BottomCell",ExpressionUUID->"b6bdcea1-7014-4e80-84ae-1863f1612009",
 CellID->534471637]
}, Open  ]],
Cell[CellGroupData[{
Cell[1838711, 44776, 259, 5, 49, "VerificationTest",ExpressionUUID->"91321dbc-07cc-4fbe-89f4-6123e25ec130",
 CellID->957893331],
Cell[1838973, 44783, 1098, 18, 84, "ExpectedOutput",ExpressionUUID->"6f3aaac6-3cec-4bb2-b17e-2fe95e736aa1",
 CellID->1140297004],
Cell[1840074, 44803, 10515, 244, 26, "TestSuccess",ExpressionUUID->"af88012a-1b43-4dc9-a05d-23b93d94533a",
 CellID->2088191305],
Cell[1850592, 45049, 11087, 278, 43, "BottomCell",ExpressionUUID->"54c041b8-4760-405a-a352-50d1219fb963",
 CellID->2053503861]
}, Open  ]],
Cell[CellGroupData[{
Cell[1861716, 45332, 232, 4, 49, "VerificationTest",ExpressionUUID->"ad2652b6-7217-4304-b7fd-7dab75f1ba63",
 CellID->504061400],
Cell[1861951, 45338, 850, 16, 41, "ExpectedOutput",ExpressionUUID->"c30e64a9-e64f-4e9a-98c8-a97734c6862a",
 CellID->1378897368],
Cell[1862804, 45356, 10407, 244, 26, "TestSuccess",ExpressionUUID->"05ede1fe-41ab-4266-a2ce-7e119b65665a",
 CellID->1029700890],
Cell[1873214, 45602, 11087, 278, 43, "BottomCell",ExpressionUUID->"ce91ca55-a0b7-4e01-9f09-d602c99c6f97",
 CellID->1759630704]
}, Open  ]],
Cell[CellGroupData[{
Cell[1884338, 45885, 233, 4, 49, "VerificationTest",ExpressionUUID->"74fde9b6-e0bc-4663-ae50-ff7d62e24915",
 CellID->1385056397],
Cell[1884574, 45891, 776, 12, 41, "ExpectedOutput",ExpressionUUID->"f18b20d3-9fb7-4fe8-b2ee-535ddc4b770b",
 CellID->213045481],
Cell[1885353, 45905, 10182, 239, 26, "TestSuccess",ExpressionUUID->"4466569d-736e-4fb8-8e76-c38c1450506b",
 CellID->1115939291],
Cell[1895538, 46146, 11087, 278, 43, "BottomCell",ExpressionUUID->"c2ec19c7-5f5f-4fe6-9d7b-c986821db4ce",
 CellID->1616974586]
}, Open  ]],
Cell[CellGroupData[{
Cell[1906662, 46429, 230, 4, 49, "VerificationTest",ExpressionUUID->"2bb6bcfb-a837-4a8f-9d45-c144e3c3177e",
 CellID->998811706],
Cell[1906895, 46435, 559, 11, 114, "ExpectedOutput",ExpressionUUID->"31632860-7d4e-4b3e-b1a5-57be4cb99e46",
 CellID->1710988442],
Cell[1907457, 46448, 10661, 246, 26, "TestSuccess",ExpressionUUID->"374823bc-59b6-421d-8d96-ff19e0590914",
 CellID->86314117],
Cell[1918121, 46696, 11087, 278, 43, "BottomCell",ExpressionUUID->"cf056a31-c492-4d6c-bc0f-fe9ed5689209",
 CellID->1129902694]
}, Open  ]],
Cell[CellGroupData[{
Cell[1929245, 46979, 235, 4, 49, "VerificationTest",ExpressionUUID->"95188a96-ce16-4077-8356-13b9c525ad69",
 CellID->2037882370],
Cell[1929483, 46985, 388, 8, 41, "ExpectedOutput",ExpressionUUID->"6dda51af-3fc7-4470-a4b0-fe25b52e2b9d",
 CellID->1744104550],
Cell[1929874, 46995, 10180, 239, 26, "TestSuccess",ExpressionUUID->"dbec0e3d-b67c-42bf-a7ab-4fffbdcbdb93",
 CellID->76687637],
Cell[1940057, 47236, 11086, 278, 43, "BottomCell",ExpressionUUID->"131088cb-cf5c-4e70-b339-3cba1d1b2368",
 CellID->398926859]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1951204, 47521, 747, 10, 67, "Section",ExpressionUUID->"505fc513-ecd1-489f-a4fe-e2460401b3b3",
 CellID->1139115897],
Cell[CellGroupData[{
Cell[1951976, 47535, 175, 2, 54, "Subsection",ExpressionUUID->"6513dd28-ea30-498a-9972-4de7a5e35114",
 CellID->1279425610],
Cell[1952154, 47539, 727, 10, 35, "Text",ExpressionUUID->"f944b4a8-b8b8-49b7-b744-7453515b2eca",
 CellID->1912467664],
Cell[1952884, 47551, 3189, 69, 413, "Input",ExpressionUUID->"37d107b7-936e-4815-829f-4d0f00f2b12a",
 CellID->2002840320],
Cell[1956076, 47622, 277, 4, 35, "Text",ExpressionUUID->"fea9afb7-bdd0-47d0-8a40-cd594735f426",
 CellID->1289745999],
Cell[CellGroupData[{
Cell[1956378, 47630, 2140, 39, 136, "Input",ExpressionUUID->"e023fd88-99a1-4350-9529-89887306e1fd",
 CellID->1123096216],
Cell[1958521, 47671, 2304, 49, 56, "Output",ExpressionUUID->"554657fb-3d16-4947-a450-f49981fe8fc1",
 CellID->319773279]
}, Open  ]],
Cell[CellGroupData[{
Cell[1960862, 47725, 1206, 27, 94, "Input",ExpressionUUID->"6c3371a8-305c-40df-9c0a-82d4cf9bf5df",
 CellID->267575760],
Cell[1962071, 47754, 1939, 39, 46, "Output",ExpressionUUID->"061d4705-97ab-4993-a2bf-76c54f489e74",
 CellID->1425415359]
}, Open  ]],
Cell[1964025, 47796, 379, 6, 35, "Text",ExpressionUUID->"da0337f3-8edf-4403-aa15-588c4731212b",
 CellID->1826710506],
Cell[CellGroupData[{
Cell[1964429, 47806, 2536, 71, 241, "Input",ExpressionUUID->"422aa9a5-c3ea-405c-8be8-3af48ca7a6a0",
 CellID->1097256830],
Cell[CellGroupData[{
Cell[1966990, 47881, 1213, 31, 32, "Print",ExpressionUUID->"d23d0825-32c8-4bf4-b91d-eff165640e1b",
 CellID->1775856428],
Cell[1968206, 47914, 1140, 29, 31, "Print",ExpressionUUID->"cce6ca03-de3b-4e63-85f2-936561e42b6f",
 CellID->1091259390],
Cell[1969349, 47945, 1022, 26, 25, "Print",ExpressionUUID->"5e320302-e36e-467b-bae2-9ac96dfc6b3f",
 CellID->1286222350],
Cell[1970374, 47973, 1014, 26, 25, "Print",ExpressionUUID->"49da9ba6-e88a-460b-acb1-54bd1c7649f5",
 CellID->968645748],
Cell[1971391, 48001, 1025, 26, 25, "Print",ExpressionUUID->"ffd8e5da-cb95-425e-8b7b-12d5f8a76a18",
 CellID->2103042376],
Cell[1972419, 48029, 1022, 26, 25, "Print",ExpressionUUID->"b61df08f-96d6-4c3c-aaa0-776494e2553b",
 CellID->399867459]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1973502, 48062, 169, 2, 54, "Subsection",ExpressionUUID->"f3769dd1-49fe-4994-9114-b8b74feb4d96",
 CellID->979410698],
Cell[CellGroupData[{
Cell[1973696, 48068, 456, 8, 49, "VerificationTest",ExpressionUUID->"567fa777-2cc5-4286-afb2-1b7964e5e9b8",
 CellID->415536027],
Cell[1974155, 48078, 1568, 26, 41, "ExpectedOutput",ExpressionUUID->"c0270aab-d017-4ac9-96d0-241f0c5bd49f",
 CellID->854168379],
Cell[1975726, 48106, 10715, 248, 26, "TestSuccess",ExpressionUUID->"945fd796-5bc3-46b9-b05c-5f47492fe0c7",
 CellID->1096051950],
Cell[1986444, 48356, 11086, 278, 43, "BottomCell",ExpressionUUID->"1e85fd1a-8228-44b1-8d1d-c586b86b033e",
 CellID->230399684]
}, Open  ]],
Cell[CellGroupData[{
Cell[1997567, 48639, 260, 5, 49, "VerificationTest",ExpressionUUID->"69d3df47-e6dd-4bb6-afd6-6d06298766fb",
 CellID->1172406000],
Cell[1997830, 48646, 1071, 20, 41, "ExpectedOutput",ExpressionUUID->"ac85f684-9b6a-4955-8e45-de64002633e3",
 CellID->558656035],
Cell[1998904, 48668, 10566, 244, 26, "TestSuccess",ExpressionUUID->"7fb64312-bac8-4b89-865a-5a8765a13a27",
 CellID->414473447],
Cell[2009473, 48914, 11087, 278, 43, "BottomCell",ExpressionUUID->"ce82bdd5-d9ea-491a-aa25-3c5c0e86eb4b",
 CellID->1765756508]
}, Open  ]],
Cell[CellGroupData[{
Cell[2020597, 49197, 232, 4, 49, "VerificationTest",ExpressionUUID->"82713b47-a0c8-4827-b2e0-90b6f5f3c50c",
 CellID->535896717],
Cell[2020832, 49203, 745, 12, 41, "ExpectedOutput",ExpressionUUID->"90658f04-35bc-4614-9832-86dfa63c93b7",
 CellID->1711570411],
Cell[2021580, 49217, 10181, 239, 26, "TestSuccess",ExpressionUUID->"03806c21-acd3-4038-9798-2ff7bf4bb5a5",
 CellID->993112063],
Cell[2031764, 49458, 11086, 278, 43, "BottomCell",ExpressionUUID->"4061618b-e968-4aa0-bf44-12bd785dffbf",
 CellID->991538357]
}, Open  ]],
Cell[CellGroupData[{
Cell[2042887, 49741, 233, 4, 49, "VerificationTest",ExpressionUUID->"1ff12343-5068-45bf-9ed9-a566a6b9612b",
 CellID->1655180484],
Cell[2043123, 49747, 857, 15, 41, "ExpectedOutput",ExpressionUUID->"80a3712f-28e0-4806-9176-2cb663c91c9d",
 CellID->1700890378],
Cell[2043983, 49764, 10304, 240, 26, "TestSuccess",ExpressionUUID->"5dbfa084-e3e8-44a0-97b7-235b81b69d17",
 CellID->312065379],
Cell[2054290, 50006, 11086, 278, 43, "BottomCell",ExpressionUUID->"f2defc92-76a8-40cb-95f8-f3a500084543",
 CellID->727758879]
}, Open  ]],
Cell[CellGroupData[{
Cell[2065413, 50289, 230, 4, 49, "VerificationTest",ExpressionUUID->"2e99e9a8-561f-4020-9e03-4f5c061f90e4",
 CellID->732625942],
Cell[2065646, 50295, 418, 9, 41, "ExpectedOutput",ExpressionUUID->"a91ac2e3-0fca-4770-8b2f-22cec7b3c3c9",
 CellID->1615736382],
Cell[2066067, 50306, 10305, 240, 26, "TestSuccess",ExpressionUUID->"258df9f6-eea6-4bdb-af51-9fdf52951225",
 CellID->1524109688],
Cell[2076375, 50548, 11086, 278, 43, "BottomCell",ExpressionUUID->"d58fac2a-9900-4f39-a794-3393f1f86da6",
 CellID->526584800]
}, Open  ]],
Cell[CellGroupData[{
Cell[2087498, 50831, 235, 4, 49, "VerificationTest",ExpressionUUID->"ffdb40ab-cab3-4895-a613-4e441cd701b0",
 CellID->1996553637],
Cell[2087736, 50837, 388, 8, 41, "ExpectedOutput",ExpressionUUID->"6d9932f3-24a0-4b5e-a053-1701b71d6e4b",
 CellID->1831110570],
Cell[2088127, 50847, 10306, 240, 26, "TestSuccess",ExpressionUUID->"267d64be-576a-439b-9350-876192a09979",
 CellID->530624313],
Cell[2098436, 51089, 11087, 278, 43, "BottomCell",ExpressionUUID->"fe11ebc9-5efd-4fd7-ada5-6704611b9f1f",
 CellID->1850726247]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2109584, 51374, 796, 11, 67, "Section",ExpressionUUID->"7966df63-b9bb-443a-856d-c07e0fad677c",
 CellID->832889734],
Cell[CellGroupData[{
Cell[2110405, 51389, 176, 2, 54, "Subsection",ExpressionUUID->"0e394ac4-0dc5-4bf8-8cc8-55b9a43ac107",
 CellID->1953520599],
Cell[2110584, 51393, 774, 10, 35, "Text",ExpressionUUID->"f05e4cd9-816f-4bae-b1cf-5349a77050f3",
 CellID->829028169],
Cell[2111361, 51405, 3788, 80, 451, "Input",ExpressionUUID->"cd812325-885e-481f-97ce-758d98bae930",
 CellID->1961085994],
Cell[2115152, 51487, 277, 4, 35, "Text",ExpressionUUID->"d33f0036-1046-4519-8a19-b8da3bbc0f50",
 CellID->1427259116],
Cell[CellGroupData[{
Cell[2115454, 51495, 2145, 39, 136, "Input",ExpressionUUID->"b1114a8a-2f1e-46a9-8418-8a5a450e4b30",
 CellID->1403872895],
Cell[2117602, 51536, 2552, 56, 70, "Output",ExpressionUUID->"9d52ed99-5d7f-4b56-a332-96b6c85e51a7",
 CellID->1002890181]
}, Open  ]],
Cell[CellGroupData[{
Cell[2120191, 51597, 1206, 27, 94, "Input",ExpressionUUID->"e284c537-b15a-4330-919f-479d79119670",
 CellID->950140110],
Cell[2121400, 51626, 1936, 39, 46, "Output",ExpressionUUID->"1d5f0e46-a83f-42f5-9465-bfa10ab6202f",
 CellID->2123610411]
}, Open  ]],
Cell[2123351, 51668, 378, 6, 35, "Text",ExpressionUUID->"6e18c79d-a17d-472b-9601-64536113e951",
 CellID->649946168],
Cell[CellGroupData[{
Cell[2123754, 51678, 2390, 67, 220, "Input",ExpressionUUID->"9ccd4963-fcd2-4b12-a82b-abb913e2a636",
 CellID->1543416934],
Cell[CellGroupData[{
Cell[2126169, 51749, 1477, 35, 48, "Print",ExpressionUUID->"e0bdb08d-4458-41c7-bb1f-92558a31ebbb",
 CellID->341964537],
Cell[2127649, 51786, 1196, 29, 48, "Print",ExpressionUUID->"5aea90a1-a3a1-450b-84c2-2c69c14c9c75",
 CellID->731733987],
Cell[2128848, 51817, 1154, 28, 40, "Print",ExpressionUUID->"b916ffa1-b4dd-495f-83f8-f88489ffb4f2",
 CellID->1761756787],
Cell[2130005, 51847, 1142, 27, 25, "Print",ExpressionUUID->"766a849c-ab16-4128-bfa0-ef7f1be509b3",
 CellID->341794273],
Cell[2131150, 51876, 1131, 27, 25, "Print",ExpressionUUID->"2a56e506-b948-4403-b738-922890525471",
 CellID->17590586],
Cell[2132284, 51905, 1133, 27, 25, "Print",ExpressionUUID->"fb7cf764-10b6-4c15-9a96-e803a2898a2f",
 CellID->1439719263]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2133478, 51939, 169, 2, 54, "Subsection",ExpressionUUID->"45cc41e3-c81a-45ec-bb4f-4603d11f2862",
 CellID->684980417],
Cell[CellGroupData[{
Cell[2133672, 51945, 457, 8, 49, "VerificationTest",ExpressionUUID->"0ed21042-7bef-49a1-839a-0653b1b507be",
 CellID->1939507788],
Cell[2134132, 51955, 1749, 32, 84, "ExpectedOutput",ExpressionUUID->"309ea178-0a20-4420-a127-efb29cecd485",
 CellID->998988119],
Cell[2135884, 51989, 10995, 252, 70, "TestSuccess",ExpressionUUID->"3142ce90-1248-431c-a5f3-2a0271f74a2b",
 CellID->1663402492],
Cell[2146882, 52243, 11086, 278, 70, "BottomCell",ExpressionUUID->"c5da7af2-98f9-4d64-800d-de3f6c2f6bd5",
 CellID->863566398]
}, Open  ]],
Cell[CellGroupData[{
Cell[2158005, 52526, 259, 5, 49, "VerificationTest",ExpressionUUID->"b20d7061-2831-45d0-8074-9d54ffcc0030",
 CellID->900191581],
Cell[2158267, 52533, 1146, 19, 84, "ExpectedOutput",ExpressionUUID->"be7e9477-ec71-4fb6-9925-fba372493bff",
 CellID->78056813],
Cell[2159416, 52554, 10515, 244, 26, "TestSuccess",ExpressionUUID->"5c1b05db-94a5-42d9-b9c2-a9b063090111",
 CellID->1265964760],
Cell[2169934, 52800, 11087, 278, 43, "BottomCell",ExpressionUUID->"b10458f5-b508-4b10-94f5-709df15f6fbb",
 CellID->1949230491]
}, Open  ]],
Cell[CellGroupData[{
Cell[2181058, 53083, 233, 4, 49, "VerificationTest",ExpressionUUID->"62774966-6c3d-4759-94a7-81977a728541",
 CellID->1364419805],
Cell[2181294, 53089, 821, 15, 41, "ExpectedOutput",ExpressionUUID->"e8043c59-3f22-42fb-b981-a36540778724",
 CellID->361639652],
Cell[2182118, 53106, 10306, 240, 26, "TestSuccess",ExpressionUUID->"6a9b9953-740b-49a7-8faf-a121193cb4f8",
 CellID->853827252],
Cell[2192427, 53348, 11086, 278, 43, "BottomCell",ExpressionUUID->"bae4bdad-c89e-4304-aae6-fff727568a16",
 CellID->788895110]
}, Open  ]],
Cell[CellGroupData[{
Cell[2203550, 53631, 233, 4, 49, "VerificationTest",ExpressionUUID->"161288f5-025a-40e5-88e9-7ada59fd8836",
 CellID->1539302137],
Cell[2203786, 53637, 880, 14, 41, "ExpectedOutput",ExpressionUUID->"e8c5a2da-cc99-41d6-807a-b040e65c1255",
 CellID->455133749],
Cell[2204669, 53653, 10179, 239, 26, "TestSuccess",ExpressionUUID->"0b502ca3-469b-4037-b227-2185833e621d",
 CellID->396077192],
Cell[2214851, 53894, 11087, 278, 43, "BottomCell",ExpressionUUID->"078bafca-9d99-4aa2-89c9-bb739581602f",
 CellID->1817543891]
}, Open  ]],
Cell[CellGroupData[{
Cell[2225975, 54177, 231, 4, 49, "VerificationTest",ExpressionUUID->"6cf47e5a-0381-497c-9717-5f6841ba5933",
 CellID->1696140808],
Cell[2226209, 54183, 418, 9, 41, "ExpectedOutput",ExpressionUUID->"ba2d8ec1-6b8b-4dad-945e-1666def89c93",
 CellID->1341373379],
Cell[2226630, 54194, 10423, 244, 26, "TestSuccess",ExpressionUUID->"be964880-0aa6-4d37-ae43-d8be572d108a",
 CellID->1652781109],
Cell[2237056, 54440, 11086, 278, 43, "BottomCell",ExpressionUUID->"12094d8a-e003-47b0-8f42-4b5a4c3e4d47",
 CellID->591125018]
}, Open  ]],
Cell[CellGroupData[{
Cell[2248179, 54723, 234, 4, 49, "VerificationTest",ExpressionUUID->"9067967d-8797-4a89-b36c-a8ebf0d3baff",
 CellID->336697932],
Cell[2248416, 54729, 387, 8, 41, "ExpectedOutput",ExpressionUUID->"bc14ea51-4d1c-4afa-8db5-5382f122db12",
 CellID->269137595],
Cell[2248806, 54739, 10181, 239, 26, "TestSuccess",ExpressionUUID->"612edee9-4c71-496c-a6fc-be7a37d19818",
 CellID->778826504],
Cell[2258990, 54980, 11086, 278, 43, "BottomCell",ExpressionUUID->"e8d4da6f-59df-4181-af4a-7815e7adf78d",
 CellID->824224263]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2270137, 55265, 843, 11, 67, "Section",ExpressionUUID->"95af2603-e0b6-4a16-b052-c7e7d371e1cb",
 CellID->1617962669],
Cell[CellGroupData[{
Cell[2271005, 55280, 175, 2, 54, "Subsection",ExpressionUUID->"9d3127c8-f981-48fc-8df9-946b24929c92",
 CellID->693269198],
Cell[2271183, 55284, 826, 11, 35, "Text",ExpressionUUID->"835eef9d-5225-458a-9151-f5f21e8cd031",
 CellID->1619415724],
Cell[2272012, 55297, 4736, 107, 577, "Input",ExpressionUUID->"a58c814e-bfe8-4a2f-84d0-1183249acc04",
 CellID->1563337662],
Cell[2276751, 55406, 277, 4, 35, "Text",ExpressionUUID->"1f6133ff-5c2a-468e-9795-f8fe1c7abe18",
 CellID->1827694738],
Cell[CellGroupData[{
Cell[2277053, 55414, 2140, 39, 136, "Input",ExpressionUUID->"3fd1bdc4-2bd7-4045-bbf1-ff2b0d18e290",
 CellID->206947660],
Cell[2279196, 55455, 3016, 70, 90, "Output",ExpressionUUID->"94baadbc-dce0-4101-bf21-40c24a2a6671",
 CellID->1467665091]
}, Open  ]],
Cell[CellGroupData[{
Cell[2282249, 55530, 1206, 27, 94, "Input",ExpressionUUID->"eb48b425-124b-469c-9074-48d5e9043274",
 CellID->983126601],
Cell[2283458, 55559, 516, 10, 24, "Message",ExpressionUUID->"b92f5396-13f8-4d0f-89ef-e3ba97b16c0c",
 CellID->1050014995],
Cell[2283977, 55571, 2106, 44, 62, "Output",ExpressionUUID->"58ef52e1-1879-48fe-853a-70c51c3fd442",
 CellID->1728893566]
}, Open  ]],
Cell[2286098, 55618, 378, 6, 35, "Text",ExpressionUUID->"f963f4aa-f87c-44c6-b197-95514e3edc4b",
 CellID->852590568],
Cell[CellGroupData[{
Cell[2286501, 55628, 2390, 67, 220, "Input",ExpressionUUID->"dcd13ef4-01c1-4709-83e0-c9aabfc7ef6a",
 CellID->1478783592],
Cell[2288894, 55697, 436, 9, 43, "Message",ExpressionUUID->"3d45b353-1ff3-4471-b932-99a961bf2ce8",
 CellID->2060419852],
Cell[2289333, 55708, 621, 12, 24, "Message",ExpressionUUID->"b6214a96-cbac-47d5-b6e2-738793844f04",
 CellID->1302644689],
Cell[CellGroupData[{
Cell[2289979, 55724, 1194, 29, 48, "Print",ExpressionUUID->"03a722cc-4b5f-493b-b9e6-b9bfc57ec8e4",
 CellID->2100990505],
Cell[2291176, 55755, 1157, 29, 48, "Print",ExpressionUUID->"bc12edd8-5c60-48ea-8134-e14dc182d42a",
 CellID->273809914],
Cell[2292336, 55786, 1106, 28, 40, "Print",ExpressionUUID->"328754f8-c4cd-454b-962e-73e97359e5f8",
 CellID->2013252724],
Cell[2293445, 55816, 1122, 28, 40, "Print",ExpressionUUID->"4f3f8842-f708-4c0d-b6f2-562f922f9e06",
 CellID->986190136],
Cell[2294570, 55846, 1108, 28, 40, "Print",ExpressionUUID->"be260fd0-1d14-4b6a-af5a-50e6adc1e33f",
 CellID->618828206],
Cell[2295681, 55876, 1106, 28, 40, "Print",ExpressionUUID->"1b975545-e61b-4370-8689-e045b2f1c048",
 CellID->382355821]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2296848, 55911, 170, 2, 54, "Subsection",ExpressionUUID->"a70c0d82-c6f2-4b6c-b6a6-6d01170dda43",
 CellID->1180942566],
Cell[CellGroupData[{
Cell[2297043, 55917, 643, 10, 49, "VerificationTest",ExpressionUUID->"cb6e3548-141e-4561-b1b2-deec08b719ea",
 CellID->1154292932],
Cell[2297689, 55929, 2570, 52, 104, "ExpectedOutput",ExpressionUUID->"a563cbb8-a1a7-4ee4-b97b-116e06ac41a0",
 CellID->860464999],
Cell[2300262, 55983, 11824, 264, 26, "TestSuccess",ExpressionUUID->"e1ad2932-2a8d-47dd-94b7-b14d28bbf024",
 CellID->983211723],
Cell[2312089, 56249, 11087, 278, 43, "BottomCell",ExpressionUUID->"2be9d602-b4e9-41f5-82b6-c7661a29b792",
 CellID->2100248443]
}, Open  ]],
Cell[CellGroupData[{
Cell[2323213, 56532, 233, 4, 49, "VerificationTest",ExpressionUUID->"6d49f2ef-c7d2-41cf-9e41-d486b5e2a5fd",
 CellID->1942943384],
Cell[2323449, 56538, 993, 17, 84, "ExpectedOutput",ExpressionUUID->"4ad98e61-0b3a-42cc-8f7f-2192fc74b03b",
 CellID->456156699],
Cell[2324445, 56557, 10650, 246, 26, "TestSuccess",ExpressionUUID->"1945fe92-ab2d-4af6-a1c3-7b6f7e4c4534",
 CellID->686875762],
Cell[2335098, 56805, 11087, 278, 43, "BottomCell",ExpressionUUID->"0d3ed146-1683-451c-aa30-f4eb66ce2370",
 CellID->1596329309]
}, Open  ]],
Cell[CellGroupData[{
Cell[2346222, 57088, 232, 4, 49, "VerificationTest",ExpressionUUID->"c0d29612-b95e-45d1-b20c-68e59a4ec656",
 CellID->193004571],
Cell[2346457, 57094, 1029, 16, 84, "ExpectedOutput",ExpressionUUID->"3d7cac27-569a-46a5-bbe3-07b116304c2b",
 CellID->2081689028],
Cell[2347489, 57112, 10424, 244, 26, "TestSuccess",ExpressionUUID->"b86e33de-71be-4ba1-a339-a905a2963213",
 CellID->993494392],
Cell[2357916, 57358, 11086, 278, 43, "BottomCell",ExpressionUUID->"0e170a59-5ad7-4235-917b-b4ef8ce81135",
 CellID->974890919]
}, Open  ]],
Cell[CellGroupData[{
Cell[2369039, 57641, 235, 4, 49, "VerificationTest",ExpressionUUID->"78623ef6-2ce0-4aaf-ac6b-69fc0391d872",
 CellID->1160542593],
Cell[2369277, 57647, 388, 8, 41, "ExpectedOutput",ExpressionUUID->"7e3b0d4e-1f43-452e-b9e6-eeb36640d8b9",
 CellID->2117812846],
Cell[2369668, 57657, 10427, 244, 26, "TestSuccess",ExpressionUUID->"57e50527-9531-4858-bcea-edb33960f7d5",
 CellID->1838932670],
Cell[2380098, 57903, 11086, 278, 43, "BottomCell",ExpressionUUID->"b6ecfdc9-469a-4a29-92b5-788c96ef2c6e",
 CellID->356737066]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

